Panel_RadarRealLine =
{
--	panel = UI.createPanel("RaderBackground", Defines.UIGroup.PAGameUIGroup_Widget),
	--panel,
	panel = nil,
	mapImage = {},
}

--Panel_RadarRealLine.panel:RegisterShowEventFunc( true, 'Panel_Radar_ShowAni()' )
--Panel_RadarRealLine.panel:RegisterShowEventFunc( false, 'Panel_Radar_HideAni()' )

function Panel_Radar_ShowAni()
end
function Panel_Radar_HideAni()
end

local const =
{
	imageSize = 256,
	size = 5, --홀수만 해야함.
}
local currentPosition = int3(0,0,0)
local currentRate = 0
local currentSelfPos = { x = 0, y = 0 }



function RadarMap_Init()
	Panel_RadarRealLine.panel = Panel_Radar;

--	Panel_RadarRealLine.panel:SetPosX(1247)
--	Panel_RadarRealLine.panel:SetPosY(-95)
--	Panel_RadarRealLine.panel:SetShow(true)
--	Panel_RadarRealLine.panel:SetSize( const.imageSRadarMap_Initize * const.size / 2, const.imageSize * const.size / 2)
--	Panel_RadarRealLine.panel:SetColor(defines.color.c_00ffffff )
--	Panel_RadarRealLine.panel = UI.getChildControl( Panel_Radar, "rader_background" )
--	Panel_RadarRealLine.panel:ChangeSpecialTextureInfoName("New_UI_Common_forLua/Widget/Rader/Minimap_Mask.dds")
--	Panel_RadarRealLine.panesl:setMaskingChild(true)
	
	
	for index = 0, const.size * const.size -1 do
		Panel_RadarRealLine.mapImage[index] = UI.createControl( CppEnums.PA_UI_CONTROL_TYPE.PA_UI_CONTROL_STATIC, Panel_Radar, "Static_minimap_Image_".. index )
		Panel_RadarRealLine.mapImage[index]:SetShow(true)
		Panel_RadarRealLine.mapImage[index]:SetSize( const.imageSize , const.imageSize )
		Panel_RadarRealLine.mapImage[index]:SetIgnore(true)
		Panel_RadarRealLine.mapImage[index]:SetPosX( index % const.size * const.imageSize )
		Panel_RadarRealLine.mapImage[index]:SetPosY( math.floor(index / const.size) * const.imageSize )
		Panel_RadarRealLine.mapImage[index]:SetColor(Defines.Color.C_FFFFFFFF)
		Panel_RadarRealLine.panel:SetChildIndex( Panel_RadarRealLine.mapImage[index]:GetKey(), index )
	end
--	Panel_RadarRealLine.panel:RegisterUpdateFunc("RaderBackground_updatePerFrame")
end

local updatePanel = function()
--	Panel_RadarRealLine.panel:SetSize( Panel_Radar:GetSizeX(), Panel_Radar:GetSizeY() )
--	Panel_RadarRealLine.panel:SetPosX( Panel_Radar:GetPosX() )
--	Panel_RadarRealLine.panel:SetPosY( Panel_Radar:GetPosY() )
	
	if getEnableSimpleUI() then
		local isUiMode = (CppEnums.EProcessorInputMode.eProcessorInputMode_UiMode == getInputMode() or CppEnums.EProcessorInputMode.eProcessorInputMode_ChattingInputMode == getInputMode());
		
		local IsMouseOver = 	Panel_Radar:GetPosX() < getMousePosX() and getMousePosX() < Panel_Radar:GetPosX() + Panel_Radar:GetSizeX() and
								Panel_Radar:GetPosY() < getMousePosY() and getMousePosY() < Panel_Radar:GetPosY() + Panel_Radar:GetSizeY();	
		
		if isUiMode then
			isUiMode = IsMouseOver;
		end
		
		if isUiMode then
			for index = 0, const.size * const.size -1 do
				Panel_RadarRealLine.mapImage[index]:SetAlpha(1.0);
			end
		else
			for index = 0, const.size * const.size -1 do
				Panel_RadarRealLine.mapImage[index]:SetAlpha(0.9);
			end
		end
	end
end

local updateMapImage = function( position )
	if ( position.x == currentPosition.x ) and ( position.z == currentPosition.z ) and ( currentRate == RaderMap_GetDistanceToPixelRate() ) and ( currentSelfPos.x == RaderMap_GetSelfPosInRader().x ) and ( currentSelfPos.y == RaderMap_GetSelfPosInRader().y ) then
		return
	end
	currentSelfPos = { x = RaderMap_GetSelfPosInRader().x , y = RaderMap_GetSelfPosInRader().y }

	currentRate = RaderMap_GetDistanceToPixelRate()
	const.imageSize =  math.floor(currentRate * 256)

	currentPosition = position
	local currentSector = convertPosToSector(currentPosition)
	int3Value.y = 0 --y축 쓰지않음
	local inSectorPos = convertPosToInSectorPos(currentPosition)

	local startX = math.floor( -( (inSectorPos.x / 100 ) * currentRate ) * 2 - const.imageSize * 2 + currentSelfPos.x  )
	local startY = math.floor( ( inSectorPos.z / 100 * currentRate ) * 2 - const.imageSize * 3 + currentSelfPos.y )
	
	for index = 0, const.size * const.size - 1 do
		local filePath = ToClient_getRadarPath() .. "Rader_" .. currentSector.x -( math.floor(const.size / 2) ) + ( index % const.size ) .. "_" .. currentSector.z +math.floor(const.size / 2) - math.floor(index / const.size ) .. ".dds"		
		Panel_RadarRealLine.mapImage[index]:ChangeTextureInfoName(filePath)
		
		Panel_RadarRealLine.mapImage[index]:SetPosX( startX + index % const.size * const.imageSize )		
		Panel_RadarRealLine.mapImage[index]:SetPosY( startY + math.floor( index / const.size) * const.imageSize )
		Panel_RadarRealLine.mapImage[index]:SetSize( const.imageSize, const.imageSize)		
	end
end

function RaderBackground_updatePerFrame( deltaTime )
	local selfPlayer = getSelfPlayer()
	if ( nil == selfPlayer ) then
		return
	end

	updatePanel()
	updateMapImage(selfPlayer:get():getPosition())
end

function RaderBackground_Show()
	Panel_RadarRealLine.panel:SetShow(true)
end

function RaderBackground_Hide()
	Panel_RadarRealLine.panel:SetShow(false)
end

function RaderMapBG_SetAlphaValue( alpha )
--	local alphaValue = math.max( 0.7 , alpha  )
--	_PA_LOG("최대호", tostring( alphaValue ) )
	for index = 0, const.size * const.size -1 do
		Panel_RadarRealLine.mapImage[index]:SetAlpha( alpha );
	end
end

function RadarMapBG_EnableSimpleUI_Force_Over()
	RadarMapBG_EnableSimpleUI( true );
end
function RadarMapBG_EnableSimpleUI_Force_Out()
	RadarMapBG_EnableSimpleUI( false );
end
registerEvent( "EventSimpleUIEnable",			"RadarMapBG_EnableSimpleUI_Force_Over")
registerEvent( "EventSimpleUIDisable",			"RadarMapBG_EnableSimpleUI_Force_Out")
function RadarMapBG_EnableSimpleUI(isEnable)
	if isEnable then
		for index = 0, const.size * const.size -1 do
			Panel_RadarRealLine.mapImage[index]:SetAlpha(0.9);
		end
	else
		for index = 0, const.size * const.size -1 do
			Panel_RadarRealLine.mapImage[index]:SetAlpha(1.0);
		end
	end
	
	cacheSimpleUI_ShowButton = true;
end
--if getEnableSimpleUI() then
--	RadarMapBG_EnableSimpleUI(true);
--end

