local UI_TM			= CppEnums.TextMode
local VCK			= CppEnums.VirtualKeyCode
local UI_color 		= Defines.Color
local UI_classType	= CppEnums.ClassType
local IM			= CppEnums.EProcessorInputMode
-- 퀘스트 번호 정리
	-- 1 : 이동 튜토리얼
	-- 2 : 전투 튜토리얼


-----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
-----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

local ui = 
{
		_obsidian 				= UI.getChildControl ( Panel_Tutorial, "Static_Obsidian" ),
		_obsidian_B 			= UI.getChildControl ( Panel_Tutorial, "Static_Obsidian_B" ),
		_obsidian_B_Left 		= UI.getChildControl ( Panel_Tutorial, "Static_Obsidian_B_Left" ),
		_obsidian_Text 			= UI.getChildControl ( Panel_Tutorial, "StaticText_Obsidian_B" ),
		_obsidian_Text_2		= UI.getChildControl ( Panel_Tutorial, "StaticText_Obsidian_B_2" ),

		_purposeText 			= UI.getChildControl ( Panel_Tutorial, "StaticText_Purpose" ),
		_nextStep_1 			= UI.getChildControl ( Panel_Tutorial, "StaticText_Step_1" ),
		_nextStep_2 			= UI.getChildControl ( Panel_Tutorial, "StaticText_Step_2" ),
		_nextStep_3 			= UI.getChildControl ( Panel_Tutorial, "StaticText_Step_3" ),
		_nextStep_4 			= UI.getChildControl ( Panel_Tutorial, "StaticText_Step_4" ),
		_nextArrow_0 			= UI.getChildControl ( Panel_Tutorial, "Static_NextArrow_0" ),
		_nextArrow_1 			= UI.getChildControl ( Panel_Tutorial, "Static_NextArrow_1" ),
		_nextArrow_2 			= UI.getChildControl ( Panel_Tutorial, "Static_NextArrow_2" ),

		_button_Q 				= UI.getChildControl ( Panel_Tutorial, "StaticText_Btn_Q" ),
		_button_W 				= UI.getChildControl ( Panel_Tutorial, "StaticText_Btn_W" ),
		_button_A 				= UI.getChildControl ( Panel_Tutorial, "StaticText_Btn_A" ),
		_button_S				= UI.getChildControl ( Panel_Tutorial, "StaticText_Btn_S" ),
		_button_D 				= UI.getChildControl ( Panel_Tutorial, "StaticText_Btn_D" ),

		_button_E 				= UI.getChildControl ( Panel_Tutorial, "StaticText_Btn_E" ),
		_button_F 				= UI.getChildControl ( Panel_Tutorial, "StaticText_Btn_F" ),
		_button_T 				= UI.getChildControl ( Panel_Tutorial, "StaticText_Btn_T" ),

		_button_Tab 			= UI.getChildControl ( Panel_Tutorial, "StaticText_Btn_Tab" ),
		_button_Shift 			= UI.getChildControl ( Panel_Tutorial, "StaticText_Btn_Shift" ),
		_button_Space 			= UI.getChildControl ( Panel_Tutorial, "StaticText_Btn_Space" ),
		
		_button_Ctrl 			= UI.getChildControl ( Panel_Tutorial, "StaticText_Btn_Ctrl" ),

		_m0 					= UI.getChildControl ( Panel_Tutorial, "StaticText_M0" ),
		_m1 					= UI.getChildControl ( Panel_Tutorial, "StaticText_M1" ),
		_mBody 					= UI.getChildControl ( Panel_Tutorial, "StaticText_Mouse_Body" ),

		_buttonLock 			= UI.getChildControl ( Panel_Tutorial, "StaticText_Button_Lock" ),
		_m0_Lock 				= UI.getChildControl ( Panel_Tutorial, "StaticText_M0_Lock" ),
		_m1_Lock 				= UI.getChildControl ( Panel_Tutorial, "StaticText_M1_Lock" ),

		_clearStep_1 			= UI.getChildControl ( Panel_Tutorial, "Static_Clear_Step1" ),
		_clearStep_2 			= UI.getChildControl ( Panel_Tutorial, "Static_Clear_Step2" ),
		_clearStep_3 			= UI.getChildControl ( Panel_Tutorial, "Static_Clear_Step3" ),
		_clearStep_4 			= UI.getChildControl ( Panel_Tutorial, "Static_Clear_Step4" ),
		
		_bubbleKey_W			= UI.getChildControl ( Panel_Tutorial, "Static_BubbleKey_W" ),
		_bubbleKey_A			= UI.getChildControl ( Panel_Tutorial, "Static_BubbleKey_A" ),
		_bubbleKey_S			= UI.getChildControl ( Panel_Tutorial, "Static_BubbleKey_S" ),
		_bubbleKey_D			= UI.getChildControl ( Panel_Tutorial, "Static_BubbleKey_D" ),
		_bubbleKey_I			= UI.getChildControl ( Panel_Tutorial, "Static_BubbleKey_I" ),
		_bubbleKey_R			= UI.getChildControl ( Panel_Tutorial, "Static_BubbleKey_R" ),
		_bubbleKey_T			= UI.getChildControl ( Panel_Tutorial, "Static_BubbleKey_T" ),
		_bubbleKey_Shift		= UI.getChildControl ( Panel_Tutorial, "Static_BubbleKey_Shift" ),
		_bubbleKey_Ctrl			= UI.getChildControl ( Panel_Tutorial, "Static_BubbleKey_Ctrl" ),
}

local uvSet = 
{
		_button_Q 				= { on = { 1, 1, 63, 65 } , 	click = { 63, 0, 126, 65 }, 	off = { 127, 1, 189, 65 }},
		_button_W 				= { on = { 1, 1, 63, 65 } , 	click = { 63, 0, 126, 65 }, 	off = { 127, 1, 189, 65 }},
		_button_A 				= { on = { 1, 1, 63, 65 } , 	click = { 63, 0, 126, 65 }, 	off = { 127, 1, 189, 65 }},
		_button_S				= { on = { 1, 1, 63, 65 } , 	click = { 63, 0, 126, 65 }, 	off = { 127, 1, 189, 65 }},
		_button_D 				= { on = { 1, 1, 63, 65 } , 	click = { 63, 0, 126, 65 }, 	off = { 127, 1, 189, 65 }},
		_button_E 				= { on = { 1, 1, 63, 65 } , 	click = { 63, 0, 126, 65 }, 	off = { 127, 1, 189, 65 }},
		_button_F 				= { on = { 1, 1, 63, 65 } , 	click = { 63, 0, 126, 65 }, 	off = { 127, 1, 189, 65 }},
		_button_T				= { on = { 1, 1, 63, 65 } , 	click = { 63, 0, 126, 65 }, 	off = { 127, 1, 189, 65 }},
		_button_Tab 			= { on = { 1, 1, 63, 65 } , 	click = { 63, 0, 126, 65 }, 	off = { 127, 1, 189, 65 }},
		_button_Shift 			= { on = { 1, 1, 63, 65 } , 	click = { 63, 0, 126, 65 }, 	off = { 127, 1, 189, 65 }},
		_button_Space 			= { on = { 1, 1, 63, 65 } , 	click = { 63, 0, 126, 65 }, 	off = { 127, 1, 189, 65 }},
		_button_Ctrl 			= { on = { 1, 1, 63, 65 } , 	click = { 63, 0, 126, 65 }, 	off = { 127, 1, 189, 65 }},
		_m0 					= { on = { 1, 66, 74, 143 } , 	click = { 75, 65, 148, 143 }, 	off = { 149, 66, 222, 143 }},
		_m1 					= { on = { 1, 144, 74, 221 } , 	click = { 75, 143, 148, 221 }, 	off = { 149, 144, 222, 221 }},
}

local keyIndexSet = 
{
		_m0 					= ( 4 )		,
		_m1 					= ( 5 )		,
		_button_Q 				= ( 12 )	,
		_button_W 				= ( 0 )		,
		_button_A 				= ( 2 )		,
		_button_S				= ( 1 )		,
		_button_D 				= ( 3 )		,
		_button_E 				= ( 13 )	,
		_button_F 				= ( 14 )	,
		_button_T 				= ( 9 )		,
		_button_Tab 			= ( 10 )	,
		_button_Shift 			= ( 6 )		,
		_button_Space 			= ( 7 )		,
		_button_Ctrl 			= ( 99 )	,

		-- _m0 					= 0,
		-- _m1 					= 1,
		-- _button_Q 			= 6,
		-- _button_W 			= 2,
		-- _button_A 			= 3,
		-- _button_S			= 4,
		-- _button_D 			= 5,
		-- _button_E 			= 7,
		-- _button_F 			= 9,
		-- _button_T 			= 17,
		-- _button_Tab 			= 16,
		-- _button_Shift 		= 14,
		-- _button_Space 		= 15,
		-- _button_Ctrl 		= 0,
		
		-- 0 : M0
		-- 1 : M1
		-- 2 : W
		-- 3 : A
		-- 4 : S
		-- 5 : D
		-- 6 : Q
		-- 7 : E
		-- 8 : R
		-- 9 : F
		-- 10 : Z
		-- 11 : X
		-- 12 : C
		-- 13 : V
		-- 14 : Shift
		-- 15 : Space
		-- 16 : Tab
		-- 17 : T
}

local keyToVirtualKey = 
{
		_m0 					= ( 4 )		,
		_m1 					= ( 5 )		,
		_button_Q 				= ( 12 )	,
		_button_W 				= ( 0 )		,
		_button_A 				= ( 2 )		,
		_button_S				= ( 1 )		,
		_button_D 				= ( 3 )		,
		_button_E 				= ( 13 )	,
		_button_F 				= ( 14 )	,
		_button_T 				= ( 9 )		,
		_button_Tab 			= ( 10 )	,
		_button_Shift 			= ( 6 )		,
		_button_Space 			= ( 7 )		,
		_button_Ctrl 			= ( 99 )	,
		_button_R				= ( 8 )
}

-- 튜토리얼 시 사용할 마스킹 패널 로드
local _maskBg_Quest				= UI.getChildControl( Panel_Masking_Tutorial, "Static_MaskBg_Quest" )
local _maskBg_SelfExpGuage		= UI.getChildControl( Panel_Masking_Tutorial, "Static_MaskBg_SelfExpGauge" )
local _maskBg_Spirit			= UI.getChildControl( Panel_Masking_Tutorial, "Static_MaskBg_Spirit" )
_maskBg_Quest			:SetShow( false )
_maskBg_SelfExpGuage	:SetShow( false )
_maskBg_Spirit			:SetShow( false )

local prevUsingKey = {}

local _updateTime = 0
local _pushed_time = 0
local _stepNo = 0
local isBattleTutorialComplete = false
Panel_Tutorial_NaviCtrl_IsNaviDone = true

-- 0 : nil
-- 1 : 기본 이동 스텝 1
-- 2 : 기본 이동 스텝 2
-- 3 : 기본 이동 스텝 3
-- 4 : 기본 이동 스텝 종료 딜레이
-- 5 : 전투 스텝 1 ( TAB키 )
-- 6 : 전투 스텝 2 ( 좌클릭, 우클릭 )
-- 7 : 전투 스텝 3 ( E 를 이용해서 보조 공격 )
-- 8 : 전투 스텝 3 ( E 를 이용해서 보조 공격 )
-- 9 : 전투 스텝 3 ( E 를 이용해서 보조 공격 )
-- 10 : 전투 스텝 4 ( F 를 이용해서 보조 공격 )
-- 11 : 전투 스텝 종료 딜레이
-- 96 : 인벤토리를 열어라
-- 97 : 물약을 먹어라
-- 98 : 인벤토리 튜토리얼 종료 딜레이
-- 99 : 완전 처음 시작해라!

local bubbleKey_Hide = function()
	ui._bubbleKey_W		:SetShow( false )
	ui._bubbleKey_A		:SetShow( false )
	ui._bubbleKey_S		:SetShow( false )
	ui._bubbleKey_D		:SetShow( false )
	ui._bubbleKey_I		:SetShow( false )
	ui._bubbleKey_R		:SetShow( false )
	ui._bubbleKey_T		:SetShow( false )
	ui._bubbleKey_Shift	:SetShow( false )
	ui._bubbleKey_Ctrl	:SetShow( false )
end

local classType = nil
local get_ClsaaType = function()
	local selfPlayer = getSelfPlayer()
	if nil ~= selfPlayer then
		classType = selfPlayer:getClassType()
	end
end
get_ClsaaType()

local welcomeToTheWorld = false
local isFirstTime_CtrlNavi = false	-- 길찾기 이펙트를 한 번 만 뿌리기 위해
local _isTutorialEnd = true
local isInteractionForTutorial = false

function FGlobal_GetFirstTutorialState()
	if true == welcomeToTheWorld then
		return true
	end
	
	return false
end

-----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
-----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

-- 화면 리사이즈
function Tutorial_ScreenRePosition()
	local scrX = getScreenSizeX()
	local scrY = getScreenSizeY()

	Panel_Tutorial:SetSize ( scrX, scrY )
	Panel_Tutorial:SetPosX(0)
	Panel_Tutorial:SetPosY(0)

	-- ui 안에 놈들 알아서 정렬
	for key, value in pairs(ui) do
		value:ComputePos()
	end
end

-----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
-----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
-- 공용 : 버튼 눌렀을 때 색 바꿔주기!!
-----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
-----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
local index = 0
local ButtonToggle = function( key, isOn )
	local aUI = ui[key]
	local keyName = "on"
	
	if ( false == isOn ) then
		keyName = "off"
	else
		if ( true == prevUsingKey[key] ) then
			aUI:SetFontColor ( UI_color.C_FFC4BEBE )
		else
			aUI:SetFontColor ( UI_color.C_FF00C0D7 )
		end
	end
	
	if ( key == "_button_Ctrl" ) then
		if ( true == isOn ) and ( keyCustom_IsPressed_Ui ( 0 ) ) then
			keyName = "click"
			aUI:SetFontColor ( UI_color.C_FFFFCE22 )
		end
	else
		if ( true == isOn ) and ( keyCustom_IsPressed_Action ( keyToVirtualKey[key] ) ) then
			keyName = "click"
			aUI:SetFontColor ( UI_color.C_FFFFCE22 )
		end
	end

	local textureUV = uvSet[key][keyName]
	aUI:ChangeTextureInfoName( "new_ui_common_forlua/widget/tutorial/tutorial_00.dds" )
	local x1, y1, x2, y2 = setTextureUV_Func( aUI, textureUV[1], textureUV[2], textureUV[3], textureUV[4] )
	aUI:getBaseTexture():setUV(  x1, y1, x2, y2  )
	aUI:setRenderTexture(aUI:getBaseTexture())
	if ( isOn ) then
		if ( "_m0" == key ) then
			aUI:SetText("L")
		elseif ( "_m1" == key ) then
			aUI:SetText("R")
		elseif ( "_button_Ctrl" == key ) then
			local actionString = "";
			if getGamePadEnable() then
				actionString = keyCustom_GetString_UiPad( 0 );
			else
				actionString = keyCustom_GetString_UiKey( 0 );
			end
			aUI:SetText( actionString )
		else
			local actionString = "";
			if getGamePadEnable() then
				actionString = keyCustom_GetString_ActionPad( keyIndexSet[key] );
			else
				actionString = keyCustom_GetString_ActionKey( keyIndexSet[key] );
			end
			aUI:SetText( actionString )
		end
	else
		aUI:SetText(" ")
	end
end

local ButtonToggleAll = function(isOn)
	for key, value in pairs(uvSet) do
		ButtonToggle(key, isOn)
	end
end

local ChattingPanel_Hide = function()
	local chattingPanelCount = ToClient_getChattingPanelCount()
	for panelIndex = 0, chattingPanelCount - 1, 1 do
		local chatPanel		= ToClient_getChattingPanel( panelIndex )
		if ( chatPanel:isOpen() ) then
			local chatPanelUI	= FGlobal_getChattingPanel( panelIndex )
			chatPanelUI:SetShow(false)
		end
	end
end

-----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
-----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
-- 기본 이동 튜토리얼
-----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
-----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
function Panel_WelcomeToTheWorld_Start()
	Panel_ChallengeReward_Alert	:SetShow( false )
	Panel_SpecialReward_Alert	:SetShow( false )
	Panel_Adrenallin:SetShow( false )
	UI.Set_ProcessorInputMode(IM.eProcessorInputMode_GameMode)
	
	ui._nextStep_4:SetShow(false)
	ui._nextArrow_2:SetShow(false)
	ui._clearStep_4:SetShow(false)

	-- Panel_Win_Npc_Quest_List:SetShow( false )
	Panel_MainStatus_User_Bar:SetShow( false )
	Panel_SelfPlayerExpGage:SetShow( false )
	
	Panel_QuickSlot:SetShow( false )
	Panel_UIMain:SetShow( false )
	Panel_Radar:SetShow( false )
	Panel_RadarRealLine.panel:SetShow( false )
	Panel_SkillCommand:SetShow( false )
	Panel_TimeBar:SetShow( false )
	Panel_ClassResource:SetShow(false)
	Panel_MyHouseNavi:SetShow( false )
	Panel_GameTips:SetShow( false )
	Panel_GameTipMask:SetShow( false )
	knowledgeList[0]._panel:SetShow( false )
	knowledgeList[1]._panel:SetShow( false )
	-- Panel_NewKnowledge:SetShow( false )
	Panel_NewEquip:SetShow( false )
	Panel_MovieGuideButton:SetShow( false )
	Panel_Widget_TownNpcNavi:SetShow( false )
	Panel_Window_PetControl:SetShow( false )
	Panel_RecentMemory:SetShow( false )
	Panel_Window_NoPetIcon:SetShow( false )
	
	-- 채팅창
	ChattingPanel_Hide()

	-- 새 흑정령 퀘스트 알림 끄기
	Panel_CheckedQuest:SetShow( false )
	Panel_NewEventProduct_Alarm:SetShow( false )

	-- 생산 레벨 위젯 끄기
	CraftLevInfo_Hide()
	PotenGradeInfo_Hide()
	
	_isTutorialEnd = false

	-- ui._m0:ResetVertexAni()
	-- ui._m1:ResetVertexAni()
	-- ui._button_W:ResetVertexAni()
	-- ui._button_A:ResetVertexAni()
	-- ui._button_S:ResetVertexAni()
	-- ui._button_D:ResetVertexAni()
	-- ui._button_E:ResetVertexAni()
	-- ui._button_F:ResetVertexAni()
	-- ui._button_Tab:ResetVertexAni()
	-- ui._button_Shift:ResetVertexAni()
	-- ui._button_Space:ResetVertexAni()
	-- ui._mBody:ResetVertexAni()

	Panel_Tutorial_BtnHide()

	ui._obsidian:EraseAllEffect()
	ui._obsidian:AddEffect ( "fUI_DarkSpirit_Tutorial", true, 0, 0 )
	ui._obsidian_B:SetShow ( false )
	ui._obsidian_B_Left:SetShow ( false )
	ui._obsidian_Text:SetShow ( false )

	Panel_Tutorial:SetShow( true, false )
	_stepNo = 99
	welcomeToTheWorld = true
	
	bubbleKey_Hide()
	
	local selfPlayer = getSelfPlayer()
	if nil ~= selfPlayer then		
		getSelfPlayer():setActionChart("TUTORIAL_WAIT_STEP1")
	end
end

function Panel_WelcomeToTheWorld_End()
	isTutorialStart = false
	bubbleKey_Hide()
	
	Panel_Tutorial:SetShow( false, false )
	Panel_SelfPlayerExpGage:SetShow( true )
	Panel_UIMain:SetShow( true )
	
	--[[Panel_CheckedQuest:SetShow( true )
	Panel_MainStatus_User_Bar:SetShow( true )
	Panel_SelfPlayerExpGage:SetShow( true )
	Panel_QuickSlot:SetShow( true )
	Panel_Radar:SetShow( true )
	Panel_RadarRealLine.panel:SetShow( true )
	Panel_MovieGuideButton:SetShow( true )
	Panel_Widget_TownNpcNavi:SetShow( true, true )
	FGlobal_PetControl_CheckUnSealPet()
	
	if isPvpEnable() then	-- PVP버튼 활성 조건을 만족해야 켠다.
		Panel_PvpMode:SetShow( true )
	else
		Panel_PvpMode:SetShow( false )
	end

	if CppEnums.ClassType.ClassType_Sorcerer== classType then -- 소서러만 어둠의 조각 카운트 UI를 켜줌
		Panel_ClassResource:SetShow( true  )
	else
		Panel_ClassResource:SetShow( false )
	end

	-- 채팅창
	local chattingPanelCount = ToClient_getChattingPanelCount()
	for panelIndex = 0, chattingPanelCount - 1, 1 do
		local chatPanel		= ToClient_getChattingPanel( panelIndex )
		if ( chatPanel:isOpen() ) then
			local chatPanelUI	= FGlobal_getChattingPanel( panelIndex )
			chatPanelUI:SetShow(true)
		end
	end
	
	-- Panel_NewQuest:SetShow( true )
	Panel_SkillCommand:SetShow( true )
	Panel_TimeBar:SetShow( true )
	Panel_MyHouseNavi:SetShow( true )
	-- Panel_NewKnowledge:SetShow( true )
	Panel_GameTips:SetShow( true )
	Panel_GameTipMask:SetShow( true )

	-- 생산 정보 위젝 켜기
	CraftLevInfo_Show()
	PotenGradeInfo_Show()
	--]]

	welcomeToTheWorld = false
	UpdateLuaEvent(1)			-- 흑정령을 강제로 띄우는 것
	request_clearMiniGame(1)	-- 미니게임 클리어 체크
	getSelfPlayer():setActionChart("TUTORIAL_END")
	
	local chattingPanelCount = ToClient_getChattingPanelCount()
	for panelIndex = 0, chattingPanelCount - 1, 1 do
		local chatPanel		= ToClient_getChattingPanel( panelIndex )
		if ( chatPanel:isOpen() ) then
			local chatPanelUI	= FGlobal_getChattingPanel( panelIndex )
			chatPanelUI:SetShow(false)
		end
	end
	
	isInteractionForTutorial = true
	
	--[[FromClient_CompleteBenefitReward()			-- 특별 선물 알림 체크
	FromClient_CompleteChallengeReward()		-- 도전과제 보상 알림을 체크한다.
	check_CashShop_PossibleBuyEventItem()		-- 새 신상이 있으면 켠다.
	--]]
end

function Panel_Tutorial_BtnShow()
	-- ui._purposeText:SetShow(true)
	-- ui._nextStep_1:SetShow(true)
	-- ui._nextStep_2:SetShow(true)
	-- ui._nextStep_3:SetShow(true)
	-- ui._nextArrow_0:SetShow(true)
	-- ui._nextArrow_1:SetShow(true)
	ui._button_Q:SetShow(true)
	ui._button_W:SetShow(true)
	ui._button_A:SetShow(true)
	ui._button_S:SetShow(true)
	ui._button_D:SetShow(true)
	ui._button_E:SetShow(true)
	ui._button_F:SetShow(true)
	ui._button_T:SetShow(false)
	ui._button_Tab:SetShow(true)
	ui._button_Shift:SetShow(true)
	ui._button_Space:SetShow(true)
	ui._button_Ctrl:SetShow(false)
	ui._m0:SetShow(true)
	ui._m1:SetShow(true)
	ui._mBody:SetShow(true)
	
	ui._purposeText:SetAlpha(1)
	ui._nextStep_1:SetAlpha(1)
	ui._nextStep_2:SetAlpha(1)
	ui._nextStep_3:SetAlpha(1)
	ui._nextArrow_0:SetAlpha(1)
	ui._nextArrow_1:SetAlpha(1)
	ui._button_Q:SetAlpha(1)
	ui._button_W:SetAlpha(1)
	ui._button_A:SetAlpha(1)
	ui._button_S:SetAlpha(1)
	ui._button_D:SetAlpha(1)
	ui._button_E:SetAlpha(1)
	ui._button_F:SetAlpha(1)
	ui._button_T:SetAlpha(0)
	ui._button_Tab:SetAlpha(1)
	ui._button_Shift:SetAlpha(1)
	ui._button_Space:SetAlpha(1)
	ui._button_Ctrl:SetAlpha(0)
	ui._m0:SetAlpha(1)
	ui._m1:SetAlpha(1)
	ui._mBody:SetAlpha(1)
end
function Panel_Tutorial_BtnHide()
	ui._purposeText:SetShow(false)
	ui._nextStep_1:SetShow(false)
	ui._nextStep_2:SetShow(false)
	ui._nextStep_3:SetShow(false)
	ui._nextArrow_0:SetShow(false)
	ui._nextArrow_1:SetShow(false)
	ui._button_Q:SetShow(false)
	ui._button_W:SetShow(false)
	ui._button_A:SetShow(false)
	ui._button_S:SetShow(false)
	ui._button_D:SetShow(false)
	ui._button_E:SetShow(false)
	ui._button_F:SetShow(false)
	ui._button_T:SetShow(false)
	ui._button_Tab:SetShow(false)
	ui._button_Shift:SetShow(false)
	ui._button_Space:SetShow(false)
	ui._button_Ctrl:SetShow(false)
	ui._m0:SetShow(false)
	ui._m1:SetShow(false)
	ui._mBody:SetShow(false)
	ui._bubbleKey_W:SetShow(false)
	ui._bubbleKey_A:SetShow(false)
	ui._bubbleKey_S:SetShow(false)
	ui._bubbleKey_D:SetShow(false)
	ui._bubbleKey_I:SetShow(false)
	ui._bubbleKey_R:SetShow(false)
	ui._bubbleKey_Shift:SetShow(false)
	
	ui._purposeText:SetAlpha(0)
	ui._nextStep_1:SetAlpha(0)
	ui._nextStep_2:SetAlpha(0)
	ui._nextStep_3:SetAlpha(0)
	ui._nextArrow_0:SetAlpha(0)
	ui._nextArrow_1:SetAlpha(0)
	ui._button_Q:SetAlpha(0)
	ui._button_W:SetAlpha(0)
	ui._button_A:SetAlpha(0)
	ui._button_S:SetAlpha(0)
	ui._button_D:SetAlpha(0)
	ui._button_E:SetAlpha(0)
	ui._button_F:SetAlpha(0)
	ui._button_T:SetAlpha(0)
	ui._button_Tab:SetAlpha(0)
	ui._button_Shift:SetAlpha(0)
	ui._button_Space:SetAlpha(0)
	ui._button_Ctrl:SetAlpha(0)
	ui._m0:SetAlpha(0)
	ui._m1:SetAlpha(0)
	ui._mBody:SetAlpha(0)
end


function FirstTime_Tutorial()
	local scrX = getScreenSizeX()
	local scrY = getScreenSizeY()
	
	ui._obsidian:SetPosX( scrX * 0.5 - 20 )
	ui._obsidian:SetPosY( scrY * 0.5 - 300 )
	ui._obsidian_B:SetPosX( scrX * 0.5 + 50 )
	ui._obsidian_B:SetPosY( scrY * 0.5 - 250 )
	ui._obsidian_Text:SetPosX( scrX * 0.5 + 53 )
	ui._obsidian_Text:SetPosY( scrY * 0.5 - 225 )
	ui._obsidian_Text_2:SetPosX( scrX * 0.5 + 53 )
		
	ui._obsidian:SetShow(true)
	ui._obsidian_B:SetShow(true)
	ui._obsidian_B_Left:SetShow(false)
	ui._obsidian_Text:SetShow(true)
	ui._obsidian_Text_2:SetShow(false)
end

local startTutorial_comment1 = false
local startTutorial_comment2 = false
local startTutorial_comment3 = false
function updateDeltaTime_StartTutorial( deltaTime )
	knowledgeList[0]._panel:SetShow( false )
	knowledgeList[1]._panel:SetShow( false )
	
	_updateTime = _updateTime + deltaTime
	ui._obsidian_B:SetShow ( true )
	ui._obsidian_Text:SetShow ( true )

	FirstTime_Tutorial()

	----------
	-- 강제로 흐느적 상태 만들기
	-- if ( 0 < _updateTime ) and ( 0.5 > _updateTime ) then
		-- getSelfPlayer():setActionChart("TUTORIAL_WAIT_STEP1")	
	-- end
	
	----------------------------------------------------------------------
	-- 워리어
	if ( 0 < _updateTime ) and ( UI_classType.ClassType_Warrior == classType ) then
		ui._obsidian_Text:SetText ( PAGetString( Defines.StringSheet_GAME, "TUTORIAL_MOVE_WARRIOR_TALK1" ))		--이제 조금 정신이 들어?
		
		if false == startTutorial_comment1 then
			chatting_sendMessage( "", ui._obsidian_Text:GetText() , CppEnums.ChatType.System )
			startTutorial_comment1 = true
		end

		local textSizeX = ui._obsidian_Text:GetTextSizeX()
		local textSizeY = ui._obsidian_Text:GetTextSizeY()
		ui._obsidian_B:SetSize( textSizeX + 15 ,textSizeY + 32 )
		ui._obsidian_Text:SetSize( textSizeX, textSizeY )
	end
	if ( 4 < _updateTime ) and ( UI_classType.ClassType_Warrior == classType )  then
		ui._obsidian_Text:SetText ( PAGetString( Defines.StringSheet_GAME, "TUTORIAL_MOVE_WARRIOR_TALK2" ))		--드디어 해방이야.\n네가 깨어나길 한참을 기다렸어.
		
		if false == startTutorial_comment2 then
			chatting_sendMessage( "", ui._obsidian_Text:GetText() , CppEnums.ChatType.System )
			startTutorial_comment2 = true
		end

		local textSizeX = ui._obsidian_Text:GetTextSizeX()
		local textSizeY = ui._obsidian_Text:GetTextSizeY()
		ui._obsidian_B:SetSize( textSizeX + 15 ,textSizeY + 32 )
		ui._obsidian_Text:SetSize( textSizeX, textSizeY )
	end
	if ( 8 < _updateTime ) and ( UI_classType.ClassType_Warrior == classType )  then
		ui._obsidian_Text:SetText ( PAGetString( Defines.StringSheet_GAME, "TUTORIAL_MOVE_WARRIOR_TALK3" ))		--도와줄 테니 움직여 보는 게 어때? \n설마 계약을 잊은 건 아니겠지?
		
		if false == startTutorial_comment3 then
			chatting_sendMessage( "", ui._obsidian_Text:GetText() , CppEnums.ChatType.System )
			startTutorial_comment3 = true
		end

		local textSizeX = ui._obsidian_Text:GetTextSizeX()
		local textSizeY = ui._obsidian_Text:GetTextSizeY()
		ui._obsidian_B:SetSize( textSizeX + 15 ,textSizeY + 32 )
		ui._obsidian_Text:SetSize( textSizeX, textSizeY )
	end
	if ( 13 < _updateTime ) and ( UI_classType.ClassType_Warrior == classType )  then
		Panel_Tutorial_BtnShow()
		_updateTime = 0
		_stepNo = 1
	end

	----------------------------------------------------------------------
	-- 레인저
	if ( 0 < _updateTime ) and ( UI_classType.ClassType_Ranger == classType ) then
		ui._obsidian_Text:SetText ( PAGetString( Defines.StringSheet_GAME, "TUTORIAL_MOVE_RANGER_TALK1" ))		--이제야 정신이 들었네.\n네가 자는 동안 여길 몇 번이나 맴돌았어.

		if false == startTutorial_comment1 then
			chatting_sendMessage( "", ui._obsidian_Text:GetText() , CppEnums.ChatType.System )
			startTutorial_comment1 = true
		end

		local textSizeX = ui._obsidian_Text:GetTextSizeX()
		local textSizeY = ui._obsidian_Text:GetTextSizeY()		
		ui._obsidian_B:SetSize( textSizeX + 15 ,textSizeY + 32 )
		ui._obsidian_Text:SetSize( textSizeX, textSizeY )	
	end
	if ( 4 < _updateTime ) and ( UI_classType.ClassType_Ranger == classType )  then
		ui._obsidian_Text:SetText ( PAGetString( Defines.StringSheet_GAME, "TUTORIAL_MOVE_RANGER_TALK2" ))		--한참.. 한참을 말이야.\n깨어나서 다행이야.

		if false == startTutorial_comment2 then
			chatting_sendMessage( "", ui._obsidian_Text:GetText() , CppEnums.ChatType.System )
			startTutorial_comment2 = true
		end

		local textSizeX = ui._obsidian_Text:GetTextSizeX()
		local textSizeY = ui._obsidian_Text:GetTextSizeY()		
		ui._obsidian_B:SetSize( textSizeX + 15 ,textSizeY + 32 )
		ui._obsidian_Text:SetSize( textSizeX, textSizeY )
	end
	if ( 8 < _updateTime ) and ( UI_classType.ClassType_Ranger == classType )  then
		ui._obsidian_Text:SetText ( PAGetString( Defines.StringSheet_GAME, "TUTORIAL_MOVE_RANGER_TALK3" ))		--몸을 움직이면 괜찮아질 거야.\n설마 우리의 계약을 잊은 건 아니겠지?
	
		if false == startTutorial_comment3 then
			chatting_sendMessage( "", ui._obsidian_Text:GetText() , CppEnums.ChatType.System )
			startTutorial_comment3 = true
		end

		local textSizeX = ui._obsidian_Text:GetTextSizeX()
		local textSizeY = ui._obsidian_Text:GetTextSizeY()
		ui._obsidian_B:SetSize( textSizeX + 15 ,textSizeY + 32 )
		ui._obsidian_Text:SetSize( textSizeX, textSizeY )
	end
	if ( 13 < _updateTime ) and ( UI_classType.ClassType_Ranger == classType )  then
		Panel_Tutorial_BtnShow()
		_updateTime = 0
		_stepNo = 1
	end

	----------------------------------------------------------------------
	-- 소서러
	if ( 0 < _updateTime ) and ( UI_classType.ClassType_Sorcerer == classType ) then
		ui._obsidian_Text:SetText ( PAGetString( Defines.StringSheet_GAME, "TUTORIAL_MOVE_SORCERER_TALK1" ))		--여긴 어디야.\n하마터면 무너질 뻔했어.

		if false == startTutorial_comment1 then
			chatting_sendMessage( "", ui._obsidian_Text:GetText() , CppEnums.ChatType.System )
			startTutorial_comment1 = true
		end

		local textSizeX = ui._obsidian_Text:GetTextSizeX()
		local textSizeY = ui._obsidian_Text:GetTextSizeY()	
		ui._obsidian_B:SetSize( textSizeX + 15 ,textSizeY + 32 )
		ui._obsidian_Text:SetSize( textSizeX, textSizeY )
	end
	if ( 5 < _updateTime ) and ( UI_classType.ClassType_Sorcerer == classType )  then
		ui._obsidian_Text:SetText ( PAGetString( Defines.StringSheet_GAME, "TUTORIAL_MOVE_SORCERER_TALK2" ))		--인간의 생존력은 대단해.\n하지만 아직 정신은 돌아오진 않는 모양이네.

		if false == startTutorial_comment2 then
			chatting_sendMessage( "", ui._obsidian_Text:GetText() , CppEnums.ChatType.System )
			startTutorial_comment2 = true
		end

		local textSizeX = ui._obsidian_Text:GetTextSizeX()
		local textSizeY = ui._obsidian_Text:GetTextSizeY()
		ui._obsidian_B:SetSize( textSizeX + 15 ,textSizeY + 32 )
		ui._obsidian_Text:SetSize( textSizeX, textSizeY )
	end
	if ( 9 < _updateTime ) and ( UI_classType.ClassType_Sorcerer == classType )  then
		ui._obsidian_Text:SetText ( PAGetString( Defines.StringSheet_GAME, "TUTORIAL_MOVE_SORCERER_TALK3" ))		--도와줄 테니 몸을 움직여봐.\n벌써 계약을 잊은 건 아니지?
		
		if false == startTutorial_comment3 then
			chatting_sendMessage( "", ui._obsidian_Text:GetText() , CppEnums.ChatType.System )
			startTutorial_comment3 = true
		end

		local textSizeX = ui._obsidian_Text:GetTextSizeX()
		local textSizeY = ui._obsidian_Text:GetTextSizeY()		
		
		ui._obsidian_B:SetSize( textSizeX + 15 ,textSizeY + 32 )
		ui._obsidian_Text:SetSize( textSizeX, textSizeY )
	end
	if ( 13 < _updateTime ) and ( UI_classType.ClassType_Sorcerer == classType )  then
		Panel_Tutorial_BtnShow()
		_updateTime = 0
		_stepNo = 1
	end

	----------------------------------------------------------------------
	-- 자이언트
	if ( 0 < _updateTime ) and ( UI_classType.ClassType_Giant == classType ) then
		ui._obsidian_Text:SetText ( PAGetString( Defines.StringSheet_GAME, "TUTORIAL_MOVE_GIANT_TALK1" ))		--그래. 이제 깰 때가 됐지.\n여기가 어딘지 궁금해?
		
		if false == startTutorial_comment1 then
			chatting_sendMessage( "", ui._obsidian_Text:GetText() , CppEnums.ChatType.System )
			startTutorial_comment1 = true
		end

		local textSizeX = ui._obsidian_Text:GetTextSizeX()
		local textSizeY = ui._obsidian_Text:GetTextSizeY()		
		
		ui._obsidian_B:SetSize( textSizeX + 15 ,textSizeY + 32 )
		ui._obsidian_Text:SetSize( textSizeX, textSizeY )
	end
	if ( 4 < _updateTime ) and ( UI_classType.ClassType_Giant == classType )  then
		ui._obsidian_Text:SetText ( PAGetString( Defines.StringSheet_GAME, "TUTORIAL_MOVE_GIANT_TALK2" ))		--나도 잘 모르겠어...\n일단 정신부터 차리는 게 어때?
		
		if false == startTutorial_comment2 then
			chatting_sendMessage( "", ui._obsidian_Text:GetText() , CppEnums.ChatType.System )
			startTutorial_comment2 = true
		end

		local textSizeX = ui._obsidian_Text:GetTextSizeX()
		local textSizeY = ui._obsidian_Text:GetTextSizeY()
		
		ui._obsidian_B:SetSize( textSizeX + 15 ,textSizeY + 32 )
		ui._obsidian_Text:SetSize( textSizeX, textSizeY )
	end
	if ( 9 < _updateTime ) and ( UI_classType.ClassType_Giant == classType )  then
		ui._obsidian_Text:SetText ( PAGetString( Defines.StringSheet_GAME, "TUTORIAL_MOVE_GIANT_TALK3" ))		--도와줄 테니 움직여 봐. \n우리의 계약을 잊은 건 아니겠지?
		
		if false == startTutorial_comment3 then
			chatting_sendMessage( "", ui._obsidian_Text:GetText() , CppEnums.ChatType.System )
			startTutorial_comment3 = true
		end

		local textSizeX = ui._obsidian_Text:GetTextSizeX()
		local textSizeY = ui._obsidian_Text:GetTextSizeY()
		
		ui._obsidian_B:SetSize( textSizeX + 15 ,textSizeY + 32 )
		ui._obsidian_Text:SetSize( textSizeX, textSizeY )
	end
	if ( 12 < _updateTime ) and ( UI_classType.ClassType_Giant == classType )  then
		Panel_Tutorial_BtnShow()
		_updateTime = 0
		ButtonToggleAll(false)
		ButtonToggle("_button_W", true)
		_stepNo = 1
	end

	----------------------------------------------------------------------
	-- 테이머
	if ( 0 < _updateTime ) and ( UI_classType.ClassType_Tamer == classType ) then
		ui._obsidian_Text:SetText (PAGetString(Defines.StringSheet_GAME, "LUA_TUTORIAL_MOVE_TAMER_TALK1"))
		
		if false == startTutorial_comment1 then
			chatting_sendMessage( "", ui._obsidian_Text:GetText() , CppEnums.ChatType.System )
			startTutorial_comment1 = true
		end

		local textSizeX = ui._obsidian_Text:GetTextSizeX()
		local textSizeY = ui._obsidian_Text:GetTextSizeY()		
		
		ui._obsidian_B:SetSize( textSizeX + 15 ,textSizeY + 32 )
		ui._obsidian_Text:SetSize( textSizeX, textSizeY )
	end
	if ( 4 < _updateTime ) and ( UI_classType.ClassType_Tamer == classType )  then
		ui._obsidian_Text:SetText ( PAGetString( Defines.StringSheet_GAME, "LUA_TUTORIAL_MOVE_TAMER_TALK2" ))
		
		if false == startTutorial_comment2 then
			chatting_sendMessage( "", ui._obsidian_Text:GetText() , CppEnums.ChatType.System )
			startTutorial_comment2 = true
		end

		local textSizeX = ui._obsidian_Text:GetTextSizeX()
		local textSizeY = ui._obsidian_Text:GetTextSizeY()
		
		ui._obsidian_B:SetSize( textSizeX + 15 ,textSizeY + 32 )
		ui._obsidian_Text:SetSize( textSizeX, textSizeY )
	end
	if ( 9 < _updateTime ) and ( UI_classType.ClassType_Tamer == classType )  then
		ui._obsidian_Text:SetText ( PAGetString( Defines.StringSheet_GAME, "LUA_TUTORIAL_MOVE_TAMER_TALK2" ))
		
		if false == startTutorial_comment3 then
			chatting_sendMessage( "", ui._obsidian_Text:GetText() , CppEnums.ChatType.System )
			startTutorial_comment3 = true
		end

		local textSizeX = ui._obsidian_Text:GetTextSizeX()
		local textSizeY = ui._obsidian_Text:GetTextSizeY()
		
		ui._obsidian_B:SetSize( textSizeX + 15 ,textSizeY + 32 )
		ui._obsidian_Text:SetSize( textSizeX, textSizeY )
	end
	if ( 12 < _updateTime ) and ( UI_classType.ClassType_Tamer == classType )  then
		Panel_Tutorial_BtnShow()
		_updateTime = 0
		ButtonToggleAll(false)
		ButtonToggle("_button_W", true)
		_stepNo = 1
	end

	----------------------------------------------------------------------
	-- 무사
	if ( 0 < _updateTime ) and ( UI_classType.ClassType_BladeMaster == classType ) then
		ui._obsidian_Text:SetText (PAGetString(Defines.StringSheet_GAME, "LUA_TUTORIAL_MOVE_BLADEMASTER_TALK1"))
		
		if false == startTutorial_comment1 then
			chatting_sendMessage( "", ui._obsidian_Text:GetText() , CppEnums.ChatType.System )
			startTutorial_comment1 = true
		end

		local textSizeX = ui._obsidian_Text:GetTextSizeX()
		local textSizeY = ui._obsidian_Text:GetTextSizeY()		
		
		ui._obsidian_B:SetSize( textSizeX + 15 ,textSizeY + 32 )
		ui._obsidian_Text:SetSize( textSizeX, textSizeY )
	end
	if ( 4 < _updateTime ) and ( UI_classType.ClassType_BladeMaster == classType )  then
		ui._obsidian_Text:SetText ( PAGetString( Defines.StringSheet_GAME, "LUA_TUTORIAL_MOVE_BLADEMASTER_TALK2" ))
		
		if false == startTutorial_comment2 then
			chatting_sendMessage( "", ui._obsidian_Text:GetText() , CppEnums.ChatType.System )
			startTutorial_comment2 = true
		end

		local textSizeX = ui._obsidian_Text:GetTextSizeX()
		local textSizeY = ui._obsidian_Text:GetTextSizeY()
		
		ui._obsidian_B:SetSize( textSizeX + 15 ,textSizeY + 32 )
		ui._obsidian_Text:SetSize( textSizeX, textSizeY )
	end
	if ( 9 < _updateTime ) and ( UI_classType.ClassType_BladeMaster == classType )  then
		ui._obsidian_Text:SetText ( PAGetString( Defines.StringSheet_GAME, "LUA_TUTORIAL_MOVE_BLADEMASTER_TALK3" ))
		
		if false == startTutorial_comment3 then
			chatting_sendMessage( "", ui._obsidian_Text:GetText() , CppEnums.ChatType.System )
			startTutorial_comment3 = true
		end

		local textSizeX = ui._obsidian_Text:GetTextSizeX()
		local textSizeY = ui._obsidian_Text:GetTextSizeY()
		
		ui._obsidian_B:SetSize( textSizeX + 15 ,textSizeY + 32 )
		ui._obsidian_Text:SetSize( textSizeX, textSizeY )
	end
	if ( 13 < _updateTime ) and ( UI_classType.ClassType_BladeMaster == classType )  then
		Panel_Tutorial_BtnShow()
		_updateTime = 0
		ButtonToggleAll(false)
		ButtonToggle("_button_W", true)
		_stepNo = 1
	end
end

local sendChat_tutorial_Step1 = false
local updateDeltaTime_Step1 = function( deltaTime )
	Tutorial_ScreenRePosition()
	
	local srtingValue = PAGetString(Defines.StringSheet_GAME, "TUTORIAL_PURPOSE_STEP1")
	-- ui._purposeText:SetText( srtingValue )
	if false == sendChat_tutorial_Step1 then
		chatting_sendMessage( "", srtingValue , CppEnums.ChatType.System )
		sendChat_tutorial_Step1 = true
	end

	local scrX = getScreenSizeX()
	local scrY = getScreenSizeY()
	
	ui._obsidian:SetPosX( scrX * 0.5 - 20 )
	ui._obsidian:SetPosY( scrY * 0.5 - 300 )

	ui._obsidian_Text:SetText( "도와줄 테니 움직여 보는 게 어때? \n설마 계약을 잊은 건 아니겠지?")
	ui._obsidian_Text_2:SetText( "<W>키를 눌러 앞으로 이동해봐~" )

	ui._bubbleKey_W:SetShow( true )

	local obsidianX = ui._obsidian:GetPosX()
	local obsidianY = ui._obsidian:GetPosY()
	
	ui._obsidian_B:SetPosX( getScreenSizeX()/2 + 50 )
	ui._obsidian_B:SetPosY( getScreenSizeY()/2 - 250 )
	
	local obsidianB_X = ui._obsidian_B:GetPosX()
	local obsidianB_Y = ui._obsidian_B:GetPosY()
	
	ui._obsidian_Text:SetPosX( obsidianB_X + 3 )
	ui._obsidian_Text:SetPosY( obsidianB_Y + 25 )

	local textSizeX = ui._obsidian_Text:GetTextSizeX()
	local textSizeY = ui._obsidian_Text:GetTextSizeY()
	-- ui._obsidian_B:SetSize( textSizeX + 15 ,textSizeY + 32 )
	
	ui._obsidian_Text_2:SetPosX( obsidianB_X + 3 )
	ui._obsidian_Text_2:SetPosY( ui._obsidian_Text:GetPosY() + textSizeY + 5 )
	ui._obsidian_Text_2:SetShow( true )

	ui._bubbleKey_W:SetPosX( ui._obsidian_Text_2:GetPosX() + ui._obsidian_Text_2:GetTextSizeX() + 20 )
	ui._bubbleKey_W:SetPosY( ui._obsidian_Text:GetPosY() + textSizeY + 5 )
	
	ui._obsidian_B:SetSize( ui._bubbleKey_W:GetPosX() - ui._obsidian_Text_2:GetPosX() + ui._bubbleKey_W:GetSizeX() + 20, textSizeY + ui._obsidian_Text_2:GetTextSizeY() + 45 )
	ui._obsidian_Text:SetSize( textSizeX, textSizeY )

	-- ui._purposeText:SetText( PAGetString(Defines.StringSheet_GAME, "TUTORIAL_PURPOSE_STEP1") )
	local isPress = keyCustom_IsPressed_Action( 0 )
	if ( isPress ) then
		_updateTime = _updateTime + deltaTime
	end

	ButtonToggleAll(false)
	ButtonToggle("_button_W", true)

	if ( 1.5 < _updateTime ) then
		-- ♬ 체크가 되고, 키가 열릴 때 사운드 추가
		ui._obsidian_Text_2:SetShow( false )
	
		-- ui._purposeText:AddEffect( "fUI_Gauge_BigWhite", false, 0.0, 0.0 )
		-- ui._clearStep_1:SetShow(true)
		-- ui._clearStep_1:AddEffect( "fUI_Light", false, 0.0, 0.0 )
		-- ui._clearStep_1:AddEffect( "UI_Check01", false, -2.0, 0.0 )
		-- ui._clearStep_1:AddEffect( "fL_CheckSpark01", false, -2.0, 0.0 )
		ui._nextStep_1:SetFontColor( UI_color.C_FFF26A6A )
		audioPostEvent_SystemUi(04,12)

		-- ui._obsidian_Text:SetText ( PAGetString(Defines.StringSheet_GAME, "TUTORIAL_MOVE_STEP1_DARKSPIRIT" ) )	-- 내 기운이 느껴져?
		ui._obsidian_Text:SetText ( "내 기운이 느껴져?\n비틀거리지 말고 중심을 잡아봐." )
		local textSizeX = ui._obsidian_Text:GetTextSizeX()
		local textSizeY = ui._obsidian_Text:GetTextSizeY()

		ui._obsidian_Text_2:SetText( "<W>, <A>, <S>, <D>로 이동할 수 있어~." )
		ui._obsidian_Text_2:SetPosX( obsidianB_X + 3 )
		ui._obsidian_Text_2:SetPosY( ui._obsidian_Text:GetPosY() + textSizeY + 5 )
		ui._obsidian_Text_2:SetShow( true )
		
		bubbleKey_Hide()
		ui._bubbleKey_W:SetShow( true )
		ui._bubbleKey_A:SetShow( true )
		ui._bubbleKey_S:SetShow( true )
		ui._bubbleKey_D:SetShow( true )
		
		ui._bubbleKey_A:SetPosX( ui._obsidian_Text_2:GetPosX() + ui._obsidian_Text_2:GetTextSizeX() + 20 )
		ui._bubbleKey_A:SetPosY( ui._obsidian_Text_2:GetPosY() )
		ui._bubbleKey_S:SetPosX( ui._bubbleKey_A:GetPosX() + ui._bubbleKey_A:GetSizeX() + 5 )
		ui._bubbleKey_S:SetPosY( ui._obsidian_Text_2:GetPosY() )
		ui._bubbleKey_D:SetPosX( ui._bubbleKey_S:GetPosX() + ui._bubbleKey_S:GetSizeX() + 5 )
		ui._bubbleKey_D:SetPosY( ui._obsidian_Text_2:GetPosY() )
		ui._bubbleKey_W:SetPosX( ui._bubbleKey_A:GetPosX() + ui._bubbleKey_A:GetSizeX() + 5 )
		ui._bubbleKey_W:SetPosY( ui._bubbleKey_S:GetPosY() - ui._bubbleKey_S:GetSizeY() - 5 )
		
		ui._obsidian_B:SetSize( ui._bubbleKey_D:GetPosX() - ui._obsidian_Text_2:GetPosX() + ui._bubbleKey_D:GetSizeX() + 20, textSizeY + ui._obsidian_Text_2:GetTextSizeY() + 45 )
		ui._obsidian_Text:SetSize( textSizeX, textSizeY )


		-- ui._obsidian_B:SetSize( textSizeX + 15 ,textSizeY + 32 )
		-- ui._obsidian_Text:SetSize( textSizeX, textSizeY )
		
		-- ui._button_A:AddEffect("UI_ItemInstall", false, 0.0, 0.0 )
		-- ui._button_S:AddEffect("UI_ItemInstall", false, 0.0, 0.0 )
		-- ui._button_D:AddEffect("UI_ItemInstall", false, 0.0, 0.0 )
		local selfPlayer = getSelfPlayer()
		if nil ~= selfPlayer then		
			getSelfPlayer():setActionChart("TUTORIAL_WAIT_STEP2")
		end
		_updateTime = 0
		_stepNo = 2
		-- prevUsingKey._button_W = true
	end
end

local sendChat_tutorial_Step2 = false
local updateDeltaTime_Step2 = function( deltaTime )
	-- ui._purposeText:SetText( PAGetString(Defines.StringSheet_GAME, "TUTORIAL_PURPOSE_STEP2") )
	local srtingValue = PAGetString(Defines.StringSheet_GAME, "TUTORIAL_PURPOSE_STEP2")
	-- ui._purposeText:SetText( srtingValue )
	if false == sendChat_tutorial_Step2 then
		chatting_sendMessage( "", srtingValue , CppEnums.ChatType.System )
		sendChat_tutorial_Step2 = true
	end

	local isPress = keyCustom_IsPressed_Action( 0 ) or keyCustom_IsPressed_Action( 1 ) or keyCustom_IsPressed_Action( 2 ) or keyCustom_IsPressed_Action( 3 )
	if ( isPress ) then
		_updateTime = _updateTime + deltaTime
	end

	local obsidianB_X = ui._obsidian_B:GetPosX()
	local obsidianB_Y = ui._obsidian_B:GetPosY()

	ButtonToggleAll(false)
	ButtonToggle("_button_W", true)
	ButtonToggle("_button_A", true)
	ButtonToggle("_button_S", true)
	ButtonToggle("_button_D", true)

	if ( 2.0 < _updateTime ) then
		-- ♬ 체크가 되고, 키가 열릴 때 사운드 추가
		
		
		-- ui._purposeText:AddEffect( "fUI_Gauge_BigWhite", false, 0.0, 0.0 )
		-- ui._clearStep_2:SetShow(true)
		-- ui._clearStep_2:AddEffect( "fUI_Light", false, 0.0, 0.0 )
		-- ui._clearStep_2:AddEffect( "UI_Check01", false, -2.0, 0.0 )
		-- ui._clearStep_2:AddEffect( "fL_CheckSpark01", false, -2.0, 0.0 )
		-- ui._nextStep_2:SetFontColor( UI_color.C_FFF26A6A )
		audioPostEvent_SystemUi(04,12)

		ui._obsidian_Text:SetText ( PAGetString(Defines.StringSheet_GAME, "TUTORIAL_MOVE_STEP2_DARKSPIRIT" ) )		-- 점점 회복되고 있는 것 같아.\n역시 생각보다 빨라.
		-- local textSizeX = ui._obsidian_Text:GetTextSizeX()
		-- local textSizeY = ui._obsidian_Text:GetTextSizeY()
		-- ui._obsidian_B:SetSize( textSizeX + 15 ,textSizeY + 32 )
		-- ui._obsidian_Text:SetSize( textSizeX, textSizeY )

		ui._obsidian_Text_2:SetShow( true )

		bubbleKey_Hide()
		ui._bubbleKey_W:SetShow( true )
		ui._bubbleKey_Shift:SetShow( true )

		local textSizeX = ui._obsidian_Text:GetTextSizeX()
		local textSizeY = ui._obsidian_Text:GetTextSizeY()
		-- ui._obsidian_B:SetSize( textSizeX + 15 ,textSizeY + 32 )

		ui._obsidian_Text_2:SetText( "<SHIFT>와 <W>키를 누르면 달릴 수 있어." )
		ui._obsidian_Text_2:SetPosX( obsidianB_X + 3 )
		ui._obsidian_Text_2:SetPosY( ui._obsidian_Text:GetPosY() + textSizeY + 5 )

		ui._bubbleKey_Shift:SetPosX( ui._obsidian_Text_2:GetPosX() + ui._obsidian_Text_2:GetTextSizeX() + 20 )
		ui._bubbleKey_Shift:SetPosY( ui._obsidian_Text:GetPosY() + textSizeY + 5 )
		ui._bubbleKey_W:SetPosX( ui._bubbleKey_Shift:GetPosX() + ui._bubbleKey_Shift:GetSizeX() + 5 )
		ui._bubbleKey_W:SetPosY( ui._obsidian_Text:GetPosY() + textSizeY + 5 )

		ui._obsidian_B:SetSize( ui._bubbleKey_W:GetPosX() - ui._obsidian_Text_2:GetPosX() + ui._bubbleKey_W:GetSizeX() + 20, textSizeY + ui._obsidian_Text_2:GetTextSizeY() + 45 )
		ui._obsidian_Text:SetSize( textSizeX, textSizeY )

		-- ui._button_Shift:AddEffect("UI_ItemInstall", false, 0.0, 0.0 )
		local selfPlayer = getSelfPlayer()
		if nil ~= selfPlayer then		
			getSelfPlayer():setActionChart("TUTORIAL_WAIT_STEP3")
		end
		_updateTime = 0
		_stepNo = 3
		-- prevUsingKey._button_W = true
		prevUsingKey._button_A = true
		prevUsingKey._button_S = true
		prevUsingKey._button_D = true
	end
end

local sendChat_tutorial_Step3 = false
local updateDeltaTime_Step3 = function( deltaTime )
	local stringValue = PAGetString(Defines.StringSheet_GAME, "TUTORIAL_PURPOSE_STEP3")
	-- ui._purposeText:SetText( stringValue )
	if false == sendChat_tutorial_Step3 then
		chatting_sendMessage( "", stringValue , CppEnums.ChatType.System )
		sendChat_tutorial_Step3 = true
	end
	
	local isPress = keyCustom_IsPressed_Action( 0 ) and keyCustom_IsPressed_Action( 6 )
	if ( isPress ) then
		_updateTime = _updateTime + deltaTime
	end

	ButtonToggleAll(false)
	ButtonToggle("_button_W", true)
	ButtonToggle("_button_A", true)
	ButtonToggle("_button_S", true)
	ButtonToggle("_button_D", true)
	ButtonToggle("_button_Shift", true)

	if ( 2 < _updateTime ) then
		-- ♬ 체크가 되고, 키가 열릴 때 사운드 추가
		
		
		ui._purposeText:AddEffect( "fUI_Gauge_BigWhite", false, 0.0, 0.0 )
		-- UI.debugMessage("MOVE ENDEND")
		-- getSelfPlayer():setActionChart("WAIT")
		-- ui._clearStep_3:SetShow(true)
		ui._clearStep_3:AddEffect( "fUI_Light", false, 0.0, 0.0 )
		ui._clearStep_3:AddEffect( "UI_Check01", false, -2.0, 0.0 )
		ui._clearStep_3:AddEffect( "fL_CheckSpark01", false, -2.0, 0.0 )
		ui._nextStep_3:SetFontColor( UI_color.C_FFF26A6A )
		Panel_Tutorial_BtnsDisappear()
		audioPostEvent_SystemUi(04,12)

		ui._obsidian_Text:SetText ( PAGetString(Defines.StringSheet_GAME, "TUTORIAL_MOVE_STEP3_DARKSPIRIT" ) )			-- 이제 너와 난 하나라는 걸 잊지마.
		ui._obsidian_Text_2:SetShow(false)
		ui._bubbleKey_W:SetShow( false )
		ui._bubbleKey_Shift:SetShow( false )
		local textSizeX = ui._obsidian_Text:GetTextSizeX()
		local textSizeY = ui._obsidian_Text:GetTextSizeY()
		ui._obsidian_B:SetSize( textSizeX + 15 ,textSizeY + 32 )
		ui._obsidian_Text:SetSize( textSizeX, textSizeY )

		_updateTime = 0
		_stepNo = 4
	end
end

local sendChat_tutorial_Step4 = false
function updateDeltaTime_Step4( deltaTime )
	local srtingValue = PAGetString(Defines.StringSheet_GAME, "TUTORIAL_PURPOSE_STEP4")
	ui._purposeText:SetText( srtingValue )
	if false == sendChat_tutorial_Step4 then
		chatting_sendMessage( "", srtingValue , CppEnums.ChatType.System )
		sendChat_tutorial_Step4 = true
	end

	_updateTime = _updateTime + deltaTime
	
	if ( 0.5 >= _updateTime ) then
		local selfPlayer = getSelfPlayer()
		if nil ~= selfPlayer then		
			getSelfPlayer():setActionChart("TUTORIAL_END")
		end
	end
	
	if ( 2.0 < _updateTime ) then
		_updateTime = 0
		_stepNo = 0
		Panel_WelcomeToTheWorld_End( deltaTime )
	end
end



-----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
-----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
-- CTRL, NPC찾기 튜토리얼
-----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
-----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
local isNaviTutorial = false
local naviTutorialCount = -1
local naviCountCheck = false
function Panel_Tutorial_NaviCtrl_Start()
	Panel_Tutorial:SetShow( true, false )
	ui._purposeText:ComputePos()
	
	-- 기본적으로 애들을 꺼준다
	for _, v in pairs ( ui ) do
		v:SetShow( false )
	end
	
	ButtonToggleAll(false)
	Panel_Tutorial_BtnHide()
	FGlobal_Panel_LowLevelGuide_MovePlay_FindWay()
	
	naviCountCheck = false
	naviTutorialCount = naviTutorialCount + 1
	
	if 1 == naviTutorialCount then
		if( check_ShowWindow() ) then
			close_WindowPanelList()
		end
		UI.Set_ProcessorInputMode( IM.eProcessorInputMode_GameMode)
	end
	
	ui._obsidian:SetShow(true)
	ui._obsidian:EraseAllEffect()
	ui._obsidian:AddEffect ( "fUI_DarkSpirit_Tutorial", true, 0, 0 )

	_stepNo = 21
end

function Panel_Tutorial_NaviCtrl_End()
	_stepNo = 0
	isNaviTutorial = false
	Panel_Tutorial:SetShow( false, false )
end

local sendChat_NaviTutorial_Step1 = false
local updateDeltaTime_NaviCtrl_Step1 = function( deltaTime )
	if 2 < naviTutorialCount then
		ui._obsidian:SetShow(false)
		return
	end

	Panel_CheckedQuest:SetShow( true )
	Panel_Tutorial_NaviCtrl_IsNaviDone = true
	local isPress = keyCustom_IsDownOnce_Ui( 0 )
	-- ui._purposeText:SetShow( true )
	-- ui._purposeText:SetAlpha( 1 )
	-- ui._purposeText:SetPosY( 100 )
	-- ui._purposeText:SetText( PAGetString ( Defines.StringSheet_GAME, "TUTORIAL_FINDWAY_STEP1" )	)	-- <PAColor0xFFFFD649>'CTRL'<PAOldColor> 키를 눌러 마우스 포인트를 활성화하세요
	
	local srtingValue = PAGetString(Defines.StringSheet_GAME, "TUTORIAL_FINDWAY_STEP1")-- <PAColor0xFFFFD649>'CTRL'<PAOldColor> 키를 눌러 마우스 포인트를 활성화하세요
	ui._purposeText:SetText( srtingValue )
	if false == sendChat_NaviTutorial_Step1 then
		chatting_sendMessage( "", srtingValue , CppEnums.ChatType.System )
		sendChat_NaviTutorial_Step1 = true
	end

	ButtonToggleAll(false)
	-- ButtonToggle("_button_Ctrl", true)

	-- ui._button_Ctrl:SetShow( true )
	-- ui._button_Ctrl:SetAlpha( 1 )

	
	-- 흑정령 안내 부분 : <Ctrl> 키를 눌러봐~
	
	if 0 == naviTutorialCount and ( false == naviCountCheck ) then
	
		ui._obsidian_B_Left:SetShow(true)
		ui._obsidian_Text:SetShow(true)
		ui._obsidian_Text_2:SetShow( true )

		bubbleKey_Hide()
		ui._bubbleKey_T:SetShow( true )
		
		ui._obsidian:SetPosX( getScreenSizeX()/2 - 150 )
		ui._obsidian:SetPosY( getScreenSizeY()/2 )
		
		local obsidianX = ui._obsidian:GetPosX()
		local obsidianY = ui._obsidian:GetPosY()
		
		ui._obsidian_Text:SetText( "안내선을 따라가면 목적지로 갈 수 있어.\n자동 달리기를 이용하면 편하게 갈 수 있어.")
		ui._obsidian_Text_2:SetText( "<T>키를 눌러 이동해봐~" )
		local textSizeX = ui._obsidian_Text:GetTextSizeX()
		local textSizeY = ui._obsidian_Text:GetTextSizeY()

		ui._obsidian_B_Left:SetSize( textSizeX + 20, textSizeY + ui._obsidian_Text_2:GetTextSizeY() + 45 )
		ui._obsidian_B_Left:SetPosX( obsidianX - ui._obsidian_B_Left:GetSizeX() - 50)
		ui._obsidian_B_Left:SetPosY( obsidianY - 100 )
		ui._obsidian_Text:SetSize( textSizeX, textSizeY )

		local obsidianB_X = ui._obsidian_B_Left:GetPosX()
		local obsidianB_Y = ui._obsidian_B_Left:GetPosY()
		
		ui._obsidian_Text:SetPosX( obsidianB_X + 3 )
		ui._obsidian_Text:SetPosY( obsidianB_Y + 5 )

		ui._obsidian_Text_2:SetPosX( obsidianB_X + 3 )
		ui._obsidian_Text_2:SetPosY( ui._obsidian_Text:GetPosY() + textSizeY + 5 )
		
		ui._bubbleKey_T:SetPosX( ui._obsidian_Text_2:GetPosX() + ui._obsidian_Text_2:GetTextSizeX() + 10 )
		ui._bubbleKey_T:SetPosY( ui._obsidian_Text_2:GetPosY() )
		
		if false == naviCountCheck then
			naviCountCheck = true
			isInteractionForTutorial = true
		end
	
	elseif 1 == naviTutorialCount and false == naviCountCheck then

		ui._obsidian_B_Left:SetShow(true)
		ui._obsidian_Text:SetShow(true)
		ui._obsidian_Text_2:SetShow( true )

		bubbleKey_Hide()
		ui._bubbleKey_Ctrl:SetShow( true )
		
		ui._obsidian:SetPosX( getScreenSizeX()/2 - 150 )
		ui._obsidian:SetPosY( getScreenSizeY()/2 )
		
		local obsidianX = ui._obsidian:GetPosX()
		local obsidianY = ui._obsidian:GetPosY()
		
		ui._obsidian_Text:SetText( "안내선이 나왔을 때 <T>키 말고도\n마우스를 이용해 이동할 수 있어.")
		ui._obsidian_Text_2:SetText( "<CTRL>키를 눌러봐~" )
		local textSizeX = ui._obsidian_Text:GetTextSizeX()
		local textSizeY = ui._obsidian_Text:GetTextSizeY()

		ui._obsidian_B_Left:SetSize( textSizeX + 20, textSizeY + ui._obsidian_Text_2:GetTextSizeY() + 45 )
		ui._obsidian_B_Left:SetPosX( obsidianX - ui._obsidian_B_Left:GetSizeX() - 50)
		ui._obsidian_B_Left:SetPosY( obsidianY - 100 )
		ui._obsidian_Text:SetSize( textSizeX, textSizeY )

		local obsidianB_X = ui._obsidian_B_Left:GetPosX()
		local obsidianB_Y = ui._obsidian_B_Left:GetPosY()
		
		ui._obsidian_Text:SetPosX( obsidianB_X + 3 )
		ui._obsidian_Text:SetPosY( obsidianB_Y + 5 )

		ui._obsidian_Text_2:SetPosX( obsidianB_X + 3 )
		ui._obsidian_Text_2:SetPosY( ui._obsidian_Text:GetPosY() + textSizeY + 5 )
		
		ui._bubbleKey_Ctrl:SetPosX( ui._obsidian_Text_2:GetPosX() + ui._obsidian_Text_2:GetTextSizeX() + 10 )
		ui._bubbleKey_Ctrl:SetPosY( ui._obsidian_Text_2:GetPosY() )
		
		if false == naviCountCheck then
			naviCountCheck = true
		end

	elseif 1 < naviTutorialCount and false == naviCountCheck then
	
		bubbleKey_Hide()

		ui._obsidian_B_Left:SetShow(true)
		ui._obsidian_Text:SetShow(true)
		ui._obsidian_Text_2:SetShow( true )

		-- ui._bubbleKey_Ctrl:SetShow( true )
		
		ui._obsidian:SetPosX( getScreenSizeX()/2 - 150 )
		ui._obsidian:SetPosY( getScreenSizeY()/2 )
		
		local obsidianX = ui._obsidian:GetPosX()
		local obsidianY = ui._obsidian:GetPosY()
		
		ui._obsidian_Text:SetText( "이제 목적지까지 가는 법은 익숙해졌어?")
		ui._obsidian_Text_2:SetText( "<CTRL>키보단 <T>키가 편하긴 하지?" )

		local textSizeX = ui._obsidian_Text:GetTextSizeX()
		local textSizeY = ui._obsidian_Text:GetTextSizeY()

		ui._obsidian_B_Left:SetSize( ui._obsidian_Text_2:GetTextSizeX() + 20, textSizeY + ui._obsidian_Text_2:GetTextSizeY() + 45 )
		ui._obsidian_B_Left:SetPosX( obsidianX - ui._obsidian_B_Left:GetSizeX() - 50)
		ui._obsidian_B_Left:SetPosY( obsidianY - 100 )
		ui._obsidian_Text:SetSize( textSizeX, textSizeY )

		local obsidianB_X = ui._obsidian_B_Left:GetPosX()
		local obsidianB_Y = ui._obsidian_B_Left:GetPosY()
		
		ui._obsidian_Text:SetPosX( obsidianB_X + 3 )
		ui._obsidian_Text:SetPosY( obsidianB_Y + 5 )

		ui._obsidian_Text_2:SetPosX( obsidianB_X + 3 )
		ui._obsidian_Text_2:SetPosY( ui._obsidian_Text:GetPosY() + textSizeY + 5 )
		
		-- ui._bubbleKey_Ctrl:SetPosX( ui._obsidian_Text_2:GetPosX() + ui._obsidian_Text_2:GetTextSizeX() + 10 )
		-- ui._bubbleKey_Ctrl:SetPosY( ui._obsidian_Text_2:GetPosY() )
		_updateTime = _updateTime + deltaTime
		
		if ( 10.0 < _updateTime ) then
			_updateTime = 0
			bubbleKey_Hide()
			ui._obsidian:SetShow(false)
			ui._obsidian_B_Left:SetShow(false)
			ui._obsidian_Text:SetShow(false)
			ui._obsidian_Text_2:SetShow( false )
			_stepNo = 0
		end
	end
	
	if ( isPress ) and ( 1 == naviTutorialCount ) then
		-- ui._purposeText:AddEffect( "fUI_Gauge_BigWhite", false, 0.0, 0.0 )
		audioPostEvent_SystemUi(04,12)
		
		bubbleKey_Hide()

		ui._obsidian:SetShow(true)
		ui._obsidian_B_Left:SetShow(true)
		ui._obsidian_Text:SetShow(true)
		ui._obsidian_Text_2:SetShow( true )

		ui._button_Ctrl:SetShow( false )
		ui._button_Ctrl:SetAlpha( 0 )

		isNaviTutorial = true
		FromClient_QuestWidget_Update()
		
		ui._obsidian_Text:SetText( "아래의 반짝이는 노란색 버튼을 누르면\n<T>키를 누른 것처럼 자동 이동을 시작해.")
		ui._obsidian_Text_2:SetText( "노란색 버튼을 마우스로 클릭해봐~" )
		local textSizeX = ui._obsidian_Text:GetTextSizeX()
		local textSizeY = ui._obsidian_Text:GetTextSizeY()
		local textSizeX2 = ui._obsidian_Text_2:GetTextSizeX()
		local textSizeY2 = ui._obsidian_Text_2:GetTextSizeY()

		ui._obsidian:SetPosX( Panel_CheckedQuest:GetPosX() + Panel_CheckedQuest:GetSizeX() - 100 )
		ui._obsidian:SetPosY( Panel_CheckedQuest:GetPosY() - 100 )
		
		local obsidianX = ui._obsidian:GetPosX()
		local obsidianY = ui._obsidian:GetPosY()
		
		ui._obsidian_B_Left:SetSize( textSizeX2 + 20, textSizeY + textSizeY2 + 45 )
		ui._obsidian_Text:SetSize( textSizeX, textSizeY )

		ui._obsidian_B_Left:SetPosX( obsidianX - ui._obsidian_B_Left:GetSizeX() - 50)
		ui._obsidian_B_Left:SetPosY( obsidianY - 50 )

		local obsidianB_X = ui._obsidian_B_Left:GetPosX()
		local obsidianB_Y = ui._obsidian_B_Left:GetPosY()
		
		ui._obsidian_Text:SetPosX( obsidianB_X + 3 )
		ui._obsidian_Text:SetPosY( obsidianB_Y + 5 )

		ui._obsidian_Text_2:SetPosX( obsidianB_X + 3 )
		ui._obsidian_Text_2:SetPosY( ui._obsidian_Text:GetPosY() + textSizeY + 5 )
		
		
		ButtonToggleAll(false)
		Panel_CheckedQuest:AddEffect("UI_Tutorial_MouseMove", false, 140, -115 )
		
		if ( Panel_Tutorial_NaviCtrl_IsNaviDone == false ) then
			naviCountCheck = false
			_stepNo = 22
		end
	end
end

local sendChat_NaviTutorial_Step2 = false
local updateDeltaTime_NaviCtrl_Step2 = function( deltaTime )
	local srtingValue = PAGetString(Defines.StringSheet_GAME, "TUTORIAL_FINDWAY_STEP2")
		-- 마우스로 <PAColor0xFFFFD649>'빨간색'<PAOldColor> 또는 <PAColor0xFFFFD649>'노란색'<PAOldColor> 길 찾기 버튼을 누르세요
	ui._purposeText:SetText( srtingValue )
	if false == sendChat_NaviTutorial_Step2 then
		chatting_sendMessage( "", srtingValue , CppEnums.ChatType.System )
		sendChat_NaviTutorial_Step2 = true
	end
	
	bubbleKey_Hide()

	if ( Panel_Tutorial_NaviCtrl_IsNaviDone == false ) then
		-- ui._purposeText:AddEffect( "fUI_Gauge_BigWhite", false, 0.0, 0.0 )
		audioPostEvent_SystemUi(04,12)
		
		_stepNo = 23

		isNaviTutorial = false
		FromClient_QuestWidget_Update()
	end
end

local sendChat_NaviTutorial_Step3 = false
local updateDeltaTime_NaviCtrl_Step3 = function( deltaTime )
	FGlobal_Tutorial_QuestMasking_Hide()
	_updateTime = _updateTime + deltaTime

	local srtingValue = PAGetString(Defines.StringSheet_GAME, "TUTORIAL_FINDWAY_STEP3")	-- <PAColor0xFFFFD649>'빛 기둥'<PAOldColor> 을 찾아 해당 위치로 이동하세요
	ui._purposeText:SetText( srtingValue )
	if false == sendChat_NaviTutorial_Step3 then
		chatting_sendMessage( "", srtingValue , CppEnums.ChatType.System )
		sendChat_NaviTutorial_Step3 = true
	end
	
	if ( _updateTime >= 6 ) then
		ui._purposeText:AddEffect( "fUI_Gauge_BigWhite", false, 0.0, 0.0 )
		_updateTime = 0
		_stepNo = 24
	end

	isNaviTutorial = false
end

local sendChat_NaviTutorial_Step4 = false
local updateDeltaTime_NaviCtrl_Step4 = function( deltaTime )
	_updateTime = _updateTime + deltaTime
	local srtingValue = PAGetString(Defines.StringSheet_GAME, "TUTORIAL_FINDWAY_STEP4")	-- 마우스 커서 활성화 및 길 찾기 튜토리얼을 마칩니다
	ui._purposeText:SetText( srtingValue )
	if false == sendChat_NaviTutorial_Step4 then
		chatting_sendMessage( "", srtingValue , CppEnums.ChatType.System )
		sendChat_NaviTutorial_Step4 = true
	end
	
	if ( _updateTime >= 4 ) then
		Panel_Tutorial_NaviCtrl_End()
		_updateTime = 0
		isNaviTutorial = false
		FromClient_QuestWidget_Update()
		_stepNo = 0
	end
end

function IsNaviTutorial()
	return 	isNaviTutorial
end

-----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
-----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
-- 기본 공격 튜토리얼
-----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
-----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
function Panel_Tutorial_Battle_Start()
	Panel_Adrenallin:SetShow( false )
	ui._purposeText:ComputePos()
	
	ui._nextStep_1:SetShow(true)
	ui._nextStep_2:SetShow(true)
	ui._nextStep_3:SetShow(true)
	ui._nextStep_4:SetShow(true)
	
	ui._nextArrow_0:SetShow(true)
	ui._nextArrow_1:SetShow(true)
	ui._nextArrow_2:SetShow(true)

	ui._clearStep_1:SetShow(false)
	ui._clearStep_2:SetShow(false)
	ui._clearStep_3:SetShow(false)
	ui._nextStep_1:SetFontColor( UI_color.C_FFFFFFFF )
	ui._nextStep_2:SetFontColor( UI_color.C_FFFFFFFF )
	ui._nextStep_3:SetFontColor( UI_color.C_FFFFFFFF )
	
	-- Panel_Win_Npc_Quest_List:SetShow( false )
	Panel_MainStatus_User_Bar:SetShow( false )
	Panel_SelfPlayerExpGage:SetShow( false )
	Panel_Chat0:SetShow( false )
	Panel_QuickSlot:SetShow( false )
	Panel_Radar:SetShow( false )
	Panel_RadarRealLine.panel:SetShow( false )
	-- Panel_NewQuest:SetShow( false )
	Panel_SkillCommand:SetShow( false )
	Panel_TimeBar:SetShow( false )

	-- ui._m0:ResetVertexAni()
	-- ui._m1:ResetVertexAni()
	-- ui._button_W:ResetVertexAni()
	-- ui._button_A:ResetVertexAni()
	-- ui._button_S:ResetVertexAni()
	-- ui._button_D:ResetVertexAni()
	-- ui._button_E:ResetVertexAni()
	-- ui._button_F:ResetVertexAni()
	-- ui._button_Tab:ResetVertexAni()
	-- ui._button_Shift:ResetVertexAni()
	-- ui._button_Space:ResetVertexAni()
	-- ui._mBody:ResetVertexAni()
	
	-- ui._m0:SetAlpha(1)
	-- ui._m1:SetAlpha(1)
	-- ui._button_W:SetAlpha(1)
	-- ui._button_A:SetAlpha(1)
	-- ui._button_S:SetAlpha(1)
	-- ui._button_D:SetAlpha(1)
	-- ui._button_E:SetAlpha(1)
	-- ui._button_F:SetAlpha(1)
	-- ui._button_Tab:SetAlpha(1)
	-- ui._button_Shift:SetAlpha(1)
	-- ui._button_Space:SetAlpha(1)
	-- ui._mBody:SetAlpha(1)

	Panel_Tutorial_BtnHide()
	
	ui._obsidian:SetShow ( false )
	ui._obsidian_B:SetShow ( false )
	ui._obsidian_Text:SetShow ( false )

	Panel_Tutorial:SetShow( true, false )
	
	Panel_Tutorial_BtnShow()
	ui._purposeText:SetShow(true)
	ui._nextStep_1:SetShow(true)
	ui._nextStep_2:SetShow(true)
	ui._nextStep_3:SetShow(true)
	ui._nextArrow_0:SetShow(true)
	ui._nextArrow_1:SetShow(true)
	
	_stepNo = 5
	ButtonToggleAll(false)
	ButtonToggle("_button_Q", true)
	ButtonToggle("_button_W", true)
	ButtonToggle("_button_A", true)
	ButtonToggle("_button_S", true)
	ButtonToggle("_button_D", true)
	ButtonToggle("_button_Shift", true)
	
	prevUsingKey._button_Q = true
	prevUsingKey._button_W = true
	prevUsingKey._button_A = true
	prevUsingKey._button_S = true
	prevUsingKey._button_D = true
	prevUsingKey._button_Shift = true
	
	isNaviTutorial = false
end

function Panel_Tutorial_Battle_End()
	Panel_Adrenallin:SetShow( true )
	-- Panel_Win_Npc_Quest_List:SetShow( false )
	-- Panel_MainStatus_User_Bar:SetShow( true )
	FGlobal_Panel_MainStatus_User_Bar_Show()
	Panel_SelfPlayerExpGage:SetShow( true )
	-- Panel_Chat0:SetShow( true )
	-- Panel_QuickSlot:SetShow( true )
	-- Panel_UIMain:SetShow( false )
	-- Panel_Radar:SetShow( true )
	-- Panel_RadarRealLine.panel:SetShow( true )
	-- Panel_NewQuest:SetShow( true )
	Panel_SkillCommand:SetShow( false )
	-- GameOption_ShowSkillCmd()
	-- Panel_TimeBar:SetShow( true )
	
	FGlobal_MiniGame_Tutorial()
	-- getSelfPlayer():setActionChart("BT_WAIT")
	_stepNo = 0
	Panel_Tutorial:SetShow( false, false )

	_isTutorialEnd = true
	-- FGlobal_FirstLogin_Open()
	isBattleTutorialComplete = true
end
function FGlobal_BattleTutorial_CompleteCheck()
	return isBattleTutorialComplete
end


-- 키 입력을 체크하기 위한 변수
local isPressedTab = false
local isPressedMouse = false
local PressCount = -1
local isPressCountFirst = true

local sendChat_BattleTutorial_Step1 = false
local updateDeltaTime_Battle_Step1 = function( deltaTime )
	ui._purposeText:SetText( PAGetString(Defines.StringSheet_GAME, "TUTORIAL_PURPOSE_BATTLE_STEP1") )		-- [STEP 1] Tab 키 또는 좌클릭 하여 전투 자세와 비전투 자세로 변환해보세요
	local srtingValue = PAGetString(Defines.StringSheet_GAME, "TUTORIAL_PURPOSE_BATTLE_STEP1")	-- [STEP 1] Tab 키 또는 좌클릭 하여 전투 자세와 비전투 자세로 변환해보세요
	ui._purposeText:SetText( srtingValue )
	if false == sendChat_BattleTutorial_Step1 then
		chatting_sendMessage( "", srtingValue , CppEnums.ChatType.System )
		sendChat_BattleTutorial_Step1 = true
	end

	local isPressTab = keyCustom_IsDownOnce_Action( 10 )
	local isPressMouse = keyCustom_IsDownOnce_Action( 4 )
	
	if ( isPressTab ) then
		isPressedTab = true
	end
	
	if ( isPressMouse ) then
		isPressedMouse = true
	end
	
	ButtonToggleAll(false)
	-- ButtonToggle("_button_Q", true)
	ButtonToggle("_button_W", true)
	ButtonToggle("_button_A", true)
	ButtonToggle("_button_S", true)
	ButtonToggle("_button_D", true)
	ButtonToggle("_button_Shift", true)
	ButtonToggle("_m0", true)
	ButtonToggle("_button_Tab", true)

	if ( isPressedTab == true ) and ( isPressedMouse == true ) then
		-- ♬ 체크가 되고, 키가 열릴 때 사운드 추가
		
		
		ui._purposeText:AddEffect( "fUI_Gauge_BigWhite", false, 0.0, 0.0 )
		ui._clearStep_1:SetShow(true)
		ui._clearStep_1:AddEffect( "fUI_Light", false, 0.0, 0.0 )
		ui._clearStep_1:AddEffect( "UI_Check01", false, -2.0, 0.0 )
		ui._clearStep_1:AddEffect( "fL_CheckSpark01", false, -2.0, 0.0 )
		ui._nextStep_1:SetFontColor( UI_color.C_FFF26A6A )
		audioPostEvent_SystemUi(04,12)

		ui._m0:AddEffect("UI_ItemInstall", false, 0.0, 0.0 )
		ui._m1:AddEffect("UI_ItemInstall", false, 0.0, 0.0 )

		_updateTime = 0
		_stepNo = 6
		prevUsingKey._button_Q = true
		prevUsingKey._button_W = true
		prevUsingKey._button_A = true
		prevUsingKey._button_S = true
		prevUsingKey._button_D = true
		prevUsingKey._button_Shift = true
		prevUsingKey._button_Tab = true
	end
end

----------------------------------------------------------------------------
--				마우스를 마구 눌렀을 때 흑정령이 욕하는 곳
local updateDeltaTime_Battle_ForKeyPressed = function ( deltaTime )
	local isUp = keyCustom_IsUp_Action( 4 ) or keyCustom_IsUp_Action ( 5 )
	----------------------------------
	--		카운트를 누적시킨다..
	if ( isUp ) then
		PressCount = PressCount + 1
	end
	
	if ( PressCount == 3 ) and ( isPressCountFirst == true ) then
		isPressCountFirst = false
		local obsidianX = ui._obsidian:GetPosX()
		local obsidianY = ui._obsidian:GetPosY()
		
		ui._obsidian:SetShow( true )
		ui._obsidian_Text:SetShow( true )
		ui._obsidian_B:SetShow( true )
		ui._obsidian:EraseAllEffect()
		ui._obsidian:AddEffect ( "fUI_DarkSpirit_Tutorial", false, 0, 0 )
		
		ui._obsidian_B:SetPosX( obsidianX + 50 )
		ui._obsidian_B:SetPosY( obsidianY + 100 )
		
		local obsidianB_X = ui._obsidian_B:GetPosX()
		local obsidianB_Y = ui._obsidian_B:GetPosY()
		
		ui._obsidian_Text:SetText ( PAGetString( Defines.StringSheet_GAME, "TUTORIAL_PRESSEDKEY_DARKSPIRIT" ) )		-- 멍청아! 버튼을 계속 누르고 있는게\n더 효율적이라는 걸 왜 몰라!
		ui._obsidian_Text:SetPosX( obsidianB_X + 3 )
		ui._obsidian_Text:SetPosY( obsidianB_Y + 25 )
		
		local textSizeX = ui._obsidian_Text:GetTextSizeX()
		local textSizeY = ui._obsidian_Text:GetTextSizeY()
		ui._obsidian_B:SetSize( textSizeX + 15 ,textSizeY + 32 )
		ui._obsidian_Text:SetSize( textSizeX, textSizeY )
	end
end

local sendChat_BattleTutorial_Step2 = false
local updateDeltaTime_Battle_Step2 = function( deltaTime )
	local srtingValue = PAGetString(Defines.StringSheet_GAME, "TUTORIAL_PURPOSE_BATTLE_STEP2")	-- [STEP 1] Tab 키 또는 좌클릭 하여 전투 자세와 비전투 자세로 변환해보세요
	ui._purposeText:SetText( srtingValue )
	if false == sendChat_BattleTutorial_Step2 then
		chatting_sendMessage( "", srtingValue , CppEnums.ChatType.System )
		sendChat_BattleTutorial_Step2 = true
	end

	local isPress = keyCustom_IsPressed_Action( 4 ) or keyCustom_IsPressed_Action( 5 )
	
	if ( isPress ) then
		_updateTime = _updateTime + deltaTime
	end

	ButtonToggleAll(false)
	ButtonToggle("_button_W", true)
	ButtonToggle("_button_A", true)
	ButtonToggle("_button_S", true)
	ButtonToggle("_button_D", true)
	ButtonToggle("_button_Shift", true)
	ButtonToggle("_button_Tab", true)
	ButtonToggle("_m0", true)
	ButtonToggle("_m1", true)

	if ( 3 < _updateTime ) then
		-- ♬ 체크가 되고, 키가 열릴 때 사운드 추가
		
		
		ui._purposeText:AddEffect( "fUI_Gauge_BigWhite", false, 0.0, 0.0 )
		ui._clearStep_2:SetShow(true)
		ui._clearStep_2:AddEffect( "fUI_Light", false, 0.0, 0.0 )
		ui._clearStep_2:AddEffect( "UI_Check01", false, -2.0, 0.0 )
		ui._clearStep_2:AddEffect( "fL_CheckSpark01", false, -2.0, 0.0 )
		ui._nextStep_2:SetFontColor( UI_color.C_FFF26A6A )
		audioPostEvent_SystemUi(04,12)

		_updateTime = 0
		PressCount = -1
		

		-- prevUsingKey._button_Q = true
		prevUsingKey._button_W = true
		prevUsingKey._button_A = true
		prevUsingKey._button_S = true
		prevUsingKey._button_D = true
		prevUsingKey._button_Shift = true
		prevUsingKey._button_Tab = true
		prevUsingKey._m0 = true
		prevUsingKey._m1 = true
		
		-- 클래스 체크해서 PURPOSE 메시지 따로 출력해준다!
		if UI_classType.ClassType_Ranger == classType then
			prevUsingKey._button_Q = true
			prevUsingKey._button_S = false
			prevUsingKey._m0 = false
			_stepNo = 7
		elseif UI_classType.ClassType_Sorcerer== classType then
			prevUsingKey._button_Q = true
			_stepNo = 8
		elseif UI_classType.ClassType_Warrior == classType or UI_classType.ClassType_BladeMaster == classType then
			ui._button_Q:AddEffect("UI_ItemInstall", false, 0.0, 0.0 )
			prevUsingKey._button_Q = false
			_stepNo = 9
		elseif UI_classType.ClassType_Giant == classType then
			ui._button_E:AddEffect("UI_ItemInstall", false, 0.0, 0.0 )
			prevUsingKey._button_Q = true
			_stepNo = 10
		elseif UI_classType.ClassType_Tamer == classType then
			-- ui._button_E:AddEffect("UI_ItemInstall", false, 0.0, 0.0 )
			prevUsingKey._button_Q = true
			_stepNo = 13
		end

		ui._obsidian:SetShow( false )
		ui._obsidian_Text:SetShow( false )
		ui._obsidian_B:SetShow( false )
		
		ui._obsidian:EraseAllEffect()
	end
end

local sendChat_BattleTutorial_Step3_Ranger = false
local updateDeltaTime_Battle_Step3_Ranger = function( deltaTime )									-- 레인저
	local srtingValue = PAGetString(Defines.StringSheet_GAME, "TUTORIAL_PURPOSE_BATTLE_STEP3_Ranger")
	ui._purposeText:SetText( srtingValue )
	if false == sendChat_BattleTutorial_Step3_Ranger then
		chatting_sendMessage( "", srtingValue , CppEnums.ChatType.System )
		sendChat_BattleTutorial_Step3_Ranger = true
	end

	local isPress = keyCustom_IsPressed_Action( 1 ) and keyCustom_IsPressed_Action( 4 )

	ButtonToggleAll(false)
	-- ButtonToggle("_button_Q", true)
	ButtonToggle("_button_W", true)
	ButtonToggle("_button_A", true)
	ButtonToggle("_button_S", true)
	ButtonToggle("_button_D", true)
	ButtonToggle("_button_Shift", true)
	ButtonToggle("_button_Tab", true)
	-- ButtonToggle("_button_E", true)
	ButtonToggle("_m0", true)
	ButtonToggle("_m1", true)

	if ( isPress ) then
		_updateTime = _updateTime + deltaTime
	end

	if ( 1.0 < _updateTime ) then
		-- ♬ 체크가 되고, 키가 열릴 때 사운드 추가
		
		
		ui._purposeText:AddEffect( "fUI_Gauge_BigWhite", false, 0.0, 0.0 )
		ui._clearStep_3:SetShow(true)
		ui._clearStep_3:AddEffect( "fUI_Light", false, 0.0, 0.0 )
		ui._clearStep_3:AddEffect( "UI_Check01", false, -2.0, 0.0 )
		ui._clearStep_3:AddEffect( "fL_CheckSpark01", false, -2.0, 0.0 )
		ui._nextStep_3:SetFontColor( UI_color.C_FFF26A6A )
		audioPostEvent_SystemUi(04,12)

		ui._button_F:AddEffect("UI_ItemInstall", false, 0.0, 0.0 )

		_updateTime = 0
		_stepNo = 11
		-- prevUsingKey._button_Q = true
		prevUsingKey._button_W = true
		prevUsingKey._button_A = true
		prevUsingKey._button_S = true
		prevUsingKey._button_D = true
		prevUsingKey._button_Shift = true
		prevUsingKey._button_Tab = true
		prevUsingKey._button_E = true
		prevUsingKey._m0 = true
		prevUsingKey._m1 = true
	end
end

local sendChat_BattleTutorial_Step3_Sorcerer = false
local updateDeltaTime_Battle_Step3_Sorcerer = function( deltaTime )									-- 소서러
	local srtingValue = PAGetString(Defines.StringSheet_GAME, "TUTORIAL_PURPOSE_BATTLE_STEP3_Sorcerer")
	ui._purposeText:SetText( srtingValue )
	if false == sendChat_BattleTutorial_Step3_Sorcerer then
		chatting_sendMessage( "", srtingValue , CppEnums.ChatType.System )
		sendChat_BattleTutorial_Step3_Sorcerer = true
	end

	local isPress = keyCustom_IsPressed_Action( 1 ) and keyCustom_IsPressed_Action( 14 )

	ButtonToggleAll(false)
	-- ButtonToggle("_button_Q", true)
	ButtonToggle("_button_W", true)
	ButtonToggle("_button_A", true)
	ButtonToggle("_button_S", true)
	ButtonToggle("_button_D", true)
	ButtonToggle("_button_Shift", true)
	ButtonToggle("_button_Tab", true)
	ButtonToggle("_button_F", true)
	ButtonToggle("_m0", true)
	ButtonToggle("_m1", true)

	if ( isPress ) then
		_updateTime = _updateTime + deltaTime
	end

	if ( 1.0 < _updateTime ) then
		-- ♬ 체크가 되고, 키가 열릴 때 사운드 추가
		
		
		ui._purposeText:AddEffect( "fUI_Gauge_BigWhite", false, 0.0, 0.0 )
		ui._clearStep_3:SetShow(true)
		ui._clearStep_3:AddEffect( "fUI_Light", false, 0.0, 0.0 )
		ui._clearStep_3:AddEffect( "UI_Check01", false, -2.0, 0.0 )
		ui._clearStep_3:AddEffect( "fL_CheckSpark01", false, -2.0, 0.0 )
		ui._nextStep_3:SetFontColor( UI_color.C_FFF26A6A )
		audioPostEvent_SystemUi(04,12)

		ui._button_F:AddEffect("UI_ItemInstall", false, 0.0, 0.0 )

		_updateTime = 0
		_stepNo = 11
		-- prevUsingKey._button_Q = true
		prevUsingKey._button_W = true
		prevUsingKey._button_A = true
		prevUsingKey._button_S = true
		prevUsingKey._button_D = true
		prevUsingKey._button_Shift = true
		prevUsingKey._button_Tab = true
		prevUsingKey._button_F = true
		prevUsingKey._m0 = true
		prevUsingKey._m1 = true
	end
end

local sendChat_BattleTutorial_Step3_Warrior = false
local updateDeltaTime_Battle_Step3_Warrior = function( deltaTime ) 									-- 워리어
	local srtingValue = PAGetString(Defines.StringSheet_GAME, "TUTORIAL_PURPOSE_BATTLE_STEP3_War")
	ui._purposeText:SetText( srtingValue )
	if false == sendChat_BattleTutorial_Step3_Warrior then
		chatting_sendMessage( "", srtingValue , CppEnums.ChatType.System )
		sendChat_BattleTutorial_Step3_Warrior = true
	end

	local isPress = keyCustom_IsPressed_Action( 12 )

	ButtonToggleAll(false)
	ButtonToggle("_button_Q", true)
	ButtonToggle("_button_W", true)
	ButtonToggle("_button_A", true)
	ButtonToggle("_button_S", true)
	ButtonToggle("_button_D", true)
	ButtonToggle("_button_Shift", true)
	ButtonToggle("_button_Tab", true)
	-- ButtonToggle("_button_E", true)
	ButtonToggle("_m0", true)
	ButtonToggle("_m1", true)

	if ( isPress ) then
		_updateTime = _updateTime + deltaTime
	end

	if ( 1.0 < _updateTime ) then
		-- ♬ 체크가 되고, 키가 열릴 때 사운드 추가
		
		
		ui._purposeText:AddEffect( "fUI_Gauge_BigWhite", false, 0.0, 0.0 )
		ui._clearStep_3:SetShow(true)
		ui._clearStep_3:AddEffect( "fUI_Light", false, 0.0, 0.0 )
		ui._clearStep_3:AddEffect( "UI_Check01", false, -2.0, 0.0 )
		ui._clearStep_3:AddEffect( "fL_CheckSpark01", false, -2.0, 0.0 )
		ui._nextStep_3:SetFontColor( UI_color.C_FFF26A6A )
		audioPostEvent_SystemUi(04,12)

		ui._button_F:AddEffect("UI_ItemInstall", false, 0.0, 0.0 )

		_updateTime = 0
		_stepNo = 11
		prevUsingKey._button_Q = true
		prevUsingKey._button_W = true
		prevUsingKey._button_A = true
		prevUsingKey._button_S = true
		prevUsingKey._button_D = true
		prevUsingKey._button_Shift = true
		prevUsingKey._button_Tab = true
		-- prevUsingKey._button_E = true
		prevUsingKey._m0 = true
		prevUsingKey._m1 = true
	end
end

local sendChat_BattleTutorial_Step3_Giant = false
local updateDeltaTime_Battle_Step3_Giant = function( deltaTime )									-- 자이언트
	local srtingValue = PAGetString(Defines.StringSheet_GAME, "TUTORIAL_PURPOSE_BATTLE_STEP3_Giant")
	ui._purposeText:SetText( srtingValue )
	if false == sendChat_BattleTutorial_Step3_Giant then
		chatting_sendMessage( "", srtingValue , CppEnums.ChatType.System )
		sendChat_BattleTutorial_Step3_Giant = true
	end

	local isPress = keyCustom_IsPressed_Action( 13 )

	ButtonToggleAll(false)
	-- ButtonToggle("_button_Q", true)
	ButtonToggle("_button_W", true)
	ButtonToggle("_button_A", true)
	ButtonToggle("_button_S", true)
	ButtonToggle("_button_D", true)
	ButtonToggle("_button_Shift", true)
	ButtonToggle("_button_Tab", true)
	ButtonToggle("_button_E", true)
	ButtonToggle("_m0", true)
	ButtonToggle("_m1", true)

	if ( isPress ) then
		_updateTime = _updateTime + deltaTime
	end

	if ( 1.0 < _updateTime ) then
		-- ♬ 체크가 되고, 키가 열릴 때 사운드 추가
		ui._purposeText:AddEffect( "fUI_Gauge_BigWhite", false, 0.0, 0.0 )
		ui._clearStep_3:SetShow(true)
		ui._clearStep_3:AddEffect( "fUI_Light", false, 0.0, 0.0 )
		ui._clearStep_3:AddEffect( "UI_Check01", false, -2.0, 0.0 )
		ui._clearStep_3:AddEffect( "fL_CheckSpark01", false, -2.0, 0.0 )
		ui._nextStep_3:SetFontColor( UI_color.C_FFF26A6A )
		audioPostEvent_SystemUi(04,12)

		ui._button_F:AddEffect("UI_ItemInstall", false, 0.0, 0.0 )

		_updateTime = 0
		_stepNo = 11
		-- prevUsingKey._button_Q = true
		prevUsingKey._button_W = true
		prevUsingKey._button_A = true
		prevUsingKey._button_S = true
		prevUsingKey._button_D = true
		prevUsingKey._button_Shift = true
		prevUsingKey._button_Tab = true
		prevUsingKey._button_E = true
		prevUsingKey._m0 = true
		prevUsingKey._m1 = true
	end
end

local sendChat_BattleTutorial_Step3_Tamer = false
local updateDeltaTime_Battle_Step3_Tamer = function( deltaTime )									-- 금수랑
	local srtingValue = "[STEP 3] <PAColor0xFFFFD649>S + 우클릭<PAOldColor> 하여 공격해보세요"
	ui._purposeText:SetText( srtingValue )
	if false == sendChat_BattleTutorial_Step3_Tamer then
		chatting_sendMessage( "", srtingValue , CppEnums.ChatType.System )
		sendChat_BattleTutorial_Step3_Tamer = true
	end

	local isPress = keyCustom_IsPressed_Action( 1 ) and keyCustom_IsPressed_Action( 5 )

	ButtonToggleAll(false)
	-- ButtonToggle("_button_Q", true)
	ButtonToggle("_button_W", true)
	ButtonToggle("_button_A", true)
	ButtonToggle("_button_S", true)
	ButtonToggle("_button_D", true)
	ButtonToggle("_button_Shift", true)
	ButtonToggle("_button_Tab", true)
	-- ButtonToggle("_button_E", true)
	ButtonToggle("_m0", true)
	ButtonToggle("_m1", true)

	if ( isPress ) then
		_updateTime = _updateTime + deltaTime
	end

	if ( 0.5 < _updateTime ) then
		-- ♬ 체크가 되고, 키가 열릴 때 사운드 추가
		ui._purposeText:AddEffect( "fUI_Gauge_BigWhite", false, 0.0, 0.0 )
		ui._clearStep_3:SetShow(true)
		ui._clearStep_3:AddEffect( "fUI_Light", false, 0.0, 0.0 )
		ui._clearStep_3:AddEffect( "UI_Check01", false, -2.0, 0.0 )
		ui._clearStep_3:AddEffect( "fL_CheckSpark01", false, -2.0, 0.0 )
		ui._nextStep_3:SetFontColor( UI_color.C_FFF26A6A )
		audioPostEvent_SystemUi(04,12)

		ui._button_F:AddEffect("UI_ItemInstall", false, 0.0, 0.0 )

		_updateTime = 0
		_stepNo = 11
		-- prevUsingKey._button_Q = true
		prevUsingKey._button_W = true
		prevUsingKey._button_A = true
		prevUsingKey._button_S = true
		prevUsingKey._button_D = true
		prevUsingKey._button_Shift = true
		prevUsingKey._button_Tab = true
		prevUsingKey._button_E = true
		prevUsingKey._m0 = true
		prevUsingKey._m1 = true
	end
end

local sendChat_BattleTutorial_Step4 = false
local updateDeltaTime_Battle_Step4 = function( deltaTime )
	local srtingValue = PAGetString(Defines.StringSheet_GAME, "TUTORIAL_PURPOSE_BATTLE_STEP4")
	ui._purposeText:SetText( srtingValue )
	if false == sendChat_BattleTutorial_Step4 then
		chatting_sendMessage( "", srtingValue , CppEnums.ChatType.System )
		sendChat_BattleTutorial_Step4 = true
	end

	local isPress = keyCustom_IsPressed_Action( 14 )
	if ( isPress ) then
		_updateTime = _updateTime + deltaTime
	end

	ButtonToggleAll(false)
	ButtonToggle("_button_W", true)
	ButtonToggle("_button_A", true)
	ButtonToggle("_button_S", true)
	ButtonToggle("_button_D", true)
	ButtonToggle("_button_Shift", true)
	ButtonToggle("_button_Tab", true)
	ButtonToggle("_button_F", true)
	
	if UI_classType.ClassType_Ranger == classType then
		ButtonToggle("_button_E", false)
		ButtonToggle("_button_Q", false)
	elseif UI_classType.ClassType_Sorcerer== classType then
		ButtonToggle("_button_E", false)
		ButtonToggle("_button_Q", false)
	elseif UI_classType.ClassType_Warrior == classType then
		ButtonToggle("_button_E", false)
		ButtonToggle("_button_Q", true)
	elseif UI_classType.ClassType_Giant == classType then
		ButtonToggle("_button_E", true)
		ButtonToggle("_button_Q", false)
	end
	
	
	ButtonToggle("_m0", true)
	ButtonToggle("_m1", true)

	if ( 1.0 < _updateTime ) then
		-- ♬ 체크가 되고, 키가 열릴 때 사운드 추가
		
		
		ui._purposeText:AddEffect( "fUI_Gauge_BigWhite", false, 0.0, 0.0 )
		ui._clearStep_4:SetShow(true)
		ui._clearStep_4:AddEffect( "fUI_Light", false, 0.0, 0.0 )
		ui._clearStep_4:AddEffect( "UI_Check01", false, -2.0, 0.0 )
		ui._clearStep_4:AddEffect( "fL_CheckSpark01", false, -2.0, 0.0 )
		ui._nextStep_4:SetFontColor( UI_color.C_FFF26A6A )
		audioPostEvent_SystemUi(04,12)

		Panel_Tutorial_BtnsDisappear()

		_updateTime = 0
		_stepNo = 12
		prevUsingKey._button_Q = true
		prevUsingKey._button_W = true
		prevUsingKey._button_A = true
		prevUsingKey._button_S = true
		prevUsingKey._button_D = true
		prevUsingKey._button_Shift = true
		prevUsingKey._button_Tab = true
		prevUsingKey._button_F = true
		
		if UI_classType.ClassType_Ranger == classType then
		elseif UI_classType.ClassType_Sorcerer== classType then
		elseif UI_classType.ClassType_Warrior == classType then
		elseif UI_classType.ClassType_Giant == classType then
		end
	
		prevUsingKey._button_E = true
		prevUsingKey._m0 = true
		prevUsingKey._m1 = true
	end
end

local sendChat_BattleTutorial_Step5 = false
function updateDeltaTime_Battle_Step5( deltaTime )
	local srtingValue = PAGetString(Defines.StringSheet_GAME, "TUTORIAL_PURPOSE_BATTLE_STEP5")
	ui._purposeText:SetText( srtingValue )
	if false == sendChat_BattleTutorial_Step5 then
		chatting_sendMessage( "", srtingValue , CppEnums.ChatType.System )
		sendChat_BattleTutorial_Step5 = true
	end

	_updateTime = _updateTime + deltaTime

	if ( 1 < _updateTime ) then
		_updateTime = 0
		_stepNo = 0
		Panel_Tutorial_Battle_End()
	end
end



-----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
-----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
-- 인벤토리 열기 튜토리얼
-----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
-----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
local isFirstPotion = false
function Panel_Tutorial_OpenInventory_Start()
	-- Panel_MainStatus_User_Bar:SetShow( true )
	-- Panel_QuickSlot:SetShow( true )

	Panel_Tutorial:SetShow( true, false )
	
	-- 기본적으로 애들을 꺼준다
	for _, v in pairs ( ui ) do
		v:SetShow( false )
	end

	ui._obsidian:SetShow(true)
	ui._obsidian:EraseAllEffect()
	ui._obsidian:AddEffect ( "fUI_DarkSpirit_Tutorial", true, 0, 0 )
	ui._obsidian_B:SetShow(false)
	ui._obsidian_B_Left:SetShow(true)
	ui._obsidian_Text:SetShow(true)
	ui._obsidian_Text_2:SetShow( true )
	
	_stepNo = 96
	isFirstPotion = true
	
end

function Panel_Tutorial_OpenInventory_End()
	_stepNo = 0
	Panel_Tutorial:SetShow( false, false )
	isFirstPotion = false
end

function isFirstPotionTutorial()
	return isFirstPotion
end

--------------------------------------------------------------------
--				물약 먹기 튜토리얼용 변수 모음
local openInven_isPressed_I = false			-- i키를 눌렀는지 변수 체크
local openInven_isPressed_M1 = false		-- 마우스 우클릭을 눌렀는지 변수 체크

local sendChat_OpenInventory_Step1 = false
local updateDeltaTime_OpenInventory_Step1 = function( deltaTime )
	-- ui._purposeText:SetShow( true )
	-- ui._purposeText:SetPosY( 100 )
	-- ui._purposeText:SetText( PAGetString(Defines.StringSheet_GAME, "TUTORIAL_OPENINVENTORY_STEP1") )		-- 'i' 키를 눌러 가방을 열어 물약을 먹으세요
	local srtingValue = PAGetString(Defines.StringSheet_GAME, "TUTORIAL_OPENINVENTORY_STEP1")-- 'i' 키를 눌러 가방을 열어 물약을 먹으세요
	-- ui._purposeText:SetText( srtingValue )
	if false == sendChat_OpenInventory_Step1 then
		chatting_sendMessage( "", srtingValue , CppEnums.ChatType.System )
		sendChat_OpenInventory_Step1 = true
	end	
	
	bubbleKey_Hide()
	ui._bubbleKey_I:SetShow( true )

	ui._obsidian:SetPosX( getScreenSizeX()/2 - 150 )
	ui._obsidian:SetPosY( getScreenSizeY()/2 )
	
	local obsidianX = ui._obsidian:GetPosX()
	local obsidianY = ui._obsidian:GetPosY()
	
	ui._obsidian_Text:SetText( "가방을 열면 생명력 회복제가 있을 거야.")
	ui._obsidian_Text_2:SetText( "<i>키를 눌러 가방을 열어봐~" )
	
	local textSizeX = ui._obsidian_Text:GetTextSizeX()
	local textSizeY = ui._obsidian_Text:GetTextSizeY()

	-- ui._obsidian_B_Left:SetSize( ui._obsidian_Text:GetTextSizeX() + 20, textSizeY + ui._obsidian_Text_2:GetTextSizeY() + 45 )
	-- ui._obsidian_Text:SetSize( textSizeX, textSizeY )

	-- ui._obsidian_B_Left:SetPosX( obsidianX - ui._obsidian_B_Left:GetSizeX() - 50)
	-- ui._obsidian_B_Left:SetPosY( obsidianY - 100 )
	
	local obsidianB_X = ui._obsidian_B_Left:GetPosX()
	local obsidianB_Y = ui._obsidian_B_Left:GetPosY()
	
	ui._obsidian_Text:SetPosX( obsidianB_X + 3 )
	ui._obsidian_Text:SetPosY( obsidianB_Y + 5 )

	ui._obsidian_Text_2:SetPosX( obsidianB_X + 3 )
	ui._obsidian_Text_2:SetPosY( ui._obsidian_Text:GetPosY() + textSizeY + 5 )
	
	ui._bubbleKey_I:SetPosX( ui._obsidian_Text_2:GetPosX() + ui._obsidian_Text_2:GetTextSizeX() + 10 )
	ui._bubbleKey_I:SetPosY( ui._obsidian_Text_2:GetPosY() )
	
	ui._obsidian_B_Left:SetSize( textSizeX + 20, textSizeY + ui._obsidian_Text_2:GetTextSizeY() + 45 )
	ui._obsidian_B_Left:SetPosX( obsidianX - ui._obsidian_B_Left:GetSizeX() - 50)
	ui._obsidian_B_Left:SetPosY( obsidianY - 100 )
	ui._obsidian_Text:SetSize( textSizeX, textSizeY )

	local isPress_I = keyCustom_IsDownOnce_Ui( 3 ) 
	
	if ( isPress_I ) then
		openInven_isPressed_I = true
	end

	if ( openInven_isPressed_I == true ) then
		-- ♬ 클리어 사운드 추가
		audioPostEvent_SystemUi(04,12)
		-- ui._purposeText:AddEffect( "fUI_Gauge_BigWhite", false, 0.0, 0.0 )
		
		_updateTime = 0
		_stepNo = 97
	end
end

local sendChat_OpenInventory_Step2 = false
local updateDeltaTime_OpenInventory_Step2 = function( deltaTime )
	local srtingValue = PAGetString(Defines.StringSheet_GAME, "TUTORIAL_OPENINVENTORY_STEP2")-- 가방 안에 있는 물약을 '마우스 우클릭'을 이용해 먹어보세요
	ui._purposeText:SetText( srtingValue )
	if false == sendChat_OpenInventory_Step2 then
		chatting_sendMessage( "", srtingValue , CppEnums.ChatType.System )
		sendChat_OpenInventory_Step2 = true
	end

	local isPress_MouseRUp = keyCustom_IsDownOnce_Action( 5 ) 
	-- ui._purposeText:SetText( PAGetString(Defines.StringSheet_GAME, "TUTORIAL_OPENINVENTORY_STEP2") )		-- 가방 안에 있는 물약을 '마우스 우클릭'을 이용해 먹어보세요
	
	bubbleKey_Hide()
	ui._obsidian_B:SetShow(true)
	ui._obsidian_B_Left:SetShow(false)
	ui._obsidian_Text:SetShow( true )
	ui._obsidian_Text_2:SetShow( true )

	ui._obsidian_Text:SetText( "가방 안에서 빛나고 있는 생명력 회복제가 보여?")
	ui._obsidian_Text_2:SetText( "마우스 우클릭을 이용해 사용해봐." )
	
	local scrX = getScreenSizeX()
	local scrY = getScreenSizeY()
	
	ui._obsidian:SetPosX( Panel_Window_Inventory:GetPosX() - 20 )
	ui._obsidian:SetPosY( Panel_Window_Inventory:GetPosY() - 100 )

	local obsidianX = ui._obsidian:GetPosX()
	local obsidianY = ui._obsidian:GetPosY()
	
	ui._obsidian_B:SetPosX( obsidianX + 80 )
	ui._obsidian_B:SetPosY( obsidianY + 30 )
	
	local obsidianB_X = ui._obsidian_B:GetPosX()
	local obsidianB_Y = ui._obsidian_B:GetPosY()
	
	ui._obsidian_Text:SetPosX( obsidianB_X + 3 )
	ui._obsidian_Text:SetPosY( obsidianB_Y + 25 )

	local textSizeX = ui._obsidian_Text:GetTextSizeX()
	local textSizeY = ui._obsidian_Text:GetTextSizeY()

	ui._obsidian_Text_2:SetPosX( obsidianB_X + 3 )
	ui._obsidian_Text_2:SetPosY( ui._obsidian_Text:GetPosY() + textSizeY + 5 )
	
	ui._obsidian_B:SetSize( ui._obsidian_Text:GetTextSizeX() + 20, ui._obsidian_Text_2:GetTextSizeY() + textSizeY + 40 )
	ui._obsidian_Text:SetSize( textSizeX, textSizeY )
	
	if ( isPress_MouseRUp ) then
		openInven_isPressed_M1 = true
	end
	
	if ( openInven_isPressed_M1 == true ) then
		-- ♬ 클리어 사운드 추가
		audioPostEvent_SystemUi(04,12)
		ui._purposeText:AddEffect( "fUI_Gauge_BigWhite", false, 0.0, 0.0 )

		_updateTime = 0
		_stepNo = 98
		isFirstPotion = false
		FGlobal_Tutorial_QuestMasking_Hide()
	end
end

local sendChat_OpenInventory_Step3 = false
function updateDeltaTime_OpenInventory_Step3( deltaTime )
	local srtingValue = PAGetString(Defines.StringSheet_GAME, "TUTORIAL_OPENINVENTORY_STEP3")-- 물약을 건네준 NPC와 대화하여 퀘스트를 완료하세요
	ui._purposeText:SetText( srtingValue )
	if false == sendChat_OpenInventory_Step3 then
		chatting_sendMessage( "", srtingValue , CppEnums.ChatType.System )
		sendChat_OpenInventory_Step3 = true
	end
	-- ui._purposeText:SetText( PAGetString(Defines.StringSheet_GAME, "TUTORIAL_OPENINVENTORY_STEP3") )		-- 물약을 건네준 NPC와 대화하여 퀘스트를 완료하세요

	bubbleKey_Hide()
	ui._obsidian_Text_2:SetShow( false )
	
	ui._obsidian_Text:SetText( "잘 했어~. 이제 회복제를 준 녀석에게 <R>키로\n말을 걸면 의뢰가 완료될 거야. 어서 가봐~")
	local obsidianX = ui._obsidian:GetPosX()
	local obsidianY = ui._obsidian:GetPosY()
	
	ui._obsidian_B:SetPosX( obsidianX + 80 )
	ui._obsidian_B:SetPosY( obsidianY + 30 )
	
	local obsidianB_X = ui._obsidian_B:GetPosX()
	local obsidianB_Y = ui._obsidian_B:GetPosY()
	
	ui._obsidian_Text:SetPosX( obsidianB_X + 3 )
	ui._obsidian_Text:SetPosY( obsidianB_Y + 25 )

	local textSizeX = ui._obsidian_Text:GetTextSizeX()
	local textSizeY = ui._obsidian_Text:GetTextSizeY()

	-- ui._obsidian_Text_2:SetPosX( obsidianB_X + 3 )
	-- ui._obsidian_Text_2:SetPosY( ui._obsidian_Text:GetPosY() + textSizeY + 5 )
	-- ui._obsidian_Text_2:SetShow( true )
	ui._obsidian_B:SetSize( ui._obsidian_Text:GetTextSizeX() + 20, textSizeY + 30 )
	ui._obsidian_Text:SetSize( textSizeX, textSizeY )

	_updateTime = _updateTime + deltaTime

	if ( 5 < _updateTime ) then
		_updateTime = 0
		_stepNo = 0
		Panel_Tutorial_OpenInventory_End()
	end
end

--Panel_Tutorial_OpenInventory_Start()
-----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
-----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

--------------------------------------------------------------------
--				흑정령 소환 튜토리얼
--------------------------------------------------------------------
local updateDeltaTime_CallSpirit_Step1 = function( deltaTime )

	FGlobal_Tutorial_SpiritMasking_Show()
	
	-- local isPress = GlobalKeyBinder_CheckCustomKeyPressed( CppEnums.UiInputType.UiInputType_BlackSpirit )
	-- ui._purposeText:SetText( PAGetString(Defines.StringSheet_GAME, "TUTORIAL_OPENINVENTORY_STEP2") )		-- 가방 안에 있는 물약을 '마우스 우클릭'을 이용해 먹어보세요
	
	ui._obsidian:SetShow(true)
	ui._obsidian_B:SetShow(true)
	ui._obsidian_B_Left:SetShow(false)
	ui._obsidian_Text:SetShow( true )
	ui._obsidian_Text_2:SetShow( true )
	
	ui._obsidian_Text:SetText( "잘 했어. 역시 내 파트너야~. 이제 너에게 줄 것이 있어.")
	ui._obsidian_Text_2:SetText( "슬래시(/)키를 눌러 나를 소환해봐." )
	
	local scrX = getScreenSizeX()
	local scrY = getScreenSizeY()
	
	ui._obsidian:SetPosX( Panel_NewQuest_Alarm:GetPosX() - 200 )
	ui._obsidian:SetPosY( Panel_NewQuest_Alarm:GetPosY() - 180 )

	local obsidianX = ui._obsidian:GetPosX()
	local obsidianY = ui._obsidian:GetPosY()
	
	ui._obsidian_B:SetPosX( obsidianX + 80 )
	ui._obsidian_B:SetPosY( obsidianY + 30 )
	
	local obsidianB_X = ui._obsidian_B:GetPosX()
	local obsidianB_Y = ui._obsidian_B:GetPosY()
	
	ui._obsidian_Text:SetPosX( obsidianB_X + 3 )
	ui._obsidian_Text:SetPosY( obsidianB_Y + 25 )

	local textSizeX = ui._obsidian_Text:GetTextSizeX()
	local textSizeY = ui._obsidian_Text:GetTextSizeY()

	ui._obsidian_Text_2:SetPosX( obsidianB_X + 3 )
	ui._obsidian_Text_2:SetPosY( ui._obsidian_Text:GetPosY() + textSizeY + 5 )
	
	ui._obsidian_B:SetSize( ui._obsidian_Text:GetTextSizeX() + 20, ui._obsidian_Text_2:GetTextSizeY() + textSizeY + 40 )
	ui._obsidian_Text:SetSize( textSizeX, textSizeY )
	
	-- _PA_LOG("이문종", "ui._obsidian == " .. tostring(ui._obsidian:GetShow()))
	
	-- /를 눌렀거나 아이콘을 클릭했다면.
end

function FGlobal_Tutorial_Close()
	bubbleKey_Hide()
	for _, v in pairs ( ui ) do
		v:SetShow( false )
	end

	Panel_Tutorial:SetShow( false, false )
	FGlobal_Tutorial_QuestMasking_Hide()
	_stepNo = 0
end

local updateDeltaTime_CallSpirit_Step2 = function( deltaTime )
	-- _PA_LOG("이문종", "잘 탔다~")
	_stepNo = 0
	bubbleKey_Hide()
	for _, v in pairs ( ui ) do
		v:SetShow( false )
	end
	Panel_Tutorial:SetShow( false, false )
	
end

function FGlobal_InteractionTutorialShow()
	Panel_Tutorial_NaviCtrl_End()
	Panel_Tutorial:SetShow( true, false )
	
	-- 기본적으로 애들을 꺼준다
	for _, v in pairs ( ui ) do
		v:SetShow( false )
	end
	
	ui._obsidian:SetShow(true)
	ui._obsidian_B:SetShow(false)
	ui._obsidian_B_Left:SetShow(true)
	ui._obsidian_Text:SetShow(true)
	ui._obsidian_Text_2:SetShow(true)
	ui._obsidian:EraseAllEffect()
	ui._obsidian:AddEffect ( "fUI_DarkSpirit_Tutorial", true, 0, 0 )

	_stepNo = 31
end


local updateDeltaTime_Interaction_Step1 = function(deltaTime)
	if Panel_Masking_Tutorial:GetShow() then
		FGlobal_Tutorial_QuestMasking_Hide()
	end
	isInteractionForTutorial = false

	bubbleKey_Hide()

	ui._obsidian_Text:SetText("상호작용 창이 떴을 때 R키를 누르면\n사람들과 대화할 수 있어.")
	ui._obsidian_Text_2:SetText("<R>키로 말을 걸어봐. 도와줄지도 모르잖아?")

	local scrX = getScreenSizeX()
	local scrY = getScreenSizeY()
	
	ui._obsidian:SetPosX( scrX * 0.5 - 150 )
	ui._obsidian:SetPosY( scrY * 0.5 )
	
	local obsidianX = ui._obsidian:GetPosX()
	local obsidianY = ui._obsidian:GetPosY()
		
	local textSizeX = ui._obsidian_Text:GetTextSizeX()
	local textSizeY = ui._obsidian_Text:GetTextSizeY()

	ui._obsidian_Text:SetSize( textSizeX, textSizeY )

	ui._obsidian_B_Left:SetPosX( obsidianX - ui._obsidian_B_Left:GetSizeX() - 50)
	ui._obsidian_B_Left:SetPosY( obsidianY - 100 )
	
	local obsidianB_X = ui._obsidian_B_Left:GetPosX()
	local obsidianB_Y = ui._obsidian_B_Left:GetPosY()
	
	ui._obsidian_Text:SetPosX( obsidianB_X + 3 )
	ui._obsidian_Text:SetPosY( obsidianB_Y + 5 )

	ui._obsidian_Text_2:SetPosX( obsidianB_X + 3 )
	ui._obsidian_Text_2:SetPosY( ui._obsidian_Text:GetPosY() + textSizeY + 5 )
	
	ui._bubbleKey_R:SetPosX( ui._obsidian_Text_2:GetPosX() + ui._obsidian_Text_2:GetTextSizeX() + 20 )
	ui._bubbleKey_R:SetPosY( ui._obsidian_Text:GetPosY() + textSizeY + 5 )
	
	ui._obsidian_B_Left:SetSize( ui._bubbleKey_R:GetPosX() - ui._obsidian_Text_2:GetPosX() + ui._bubbleKey_R:GetSizeX() + 20, textSizeY + ui._obsidian_Text_2:GetTextSizeY() + 45 )
	
	isPress = keyCustom_IsPressed_Action( 8 )
	if (isPress) then
		_stepNo = 32
	end
end

local updateDeltaTime_Interaction_Step2 = function(deltaTime)
	Panel_Tutorial:SetShow( false, false )
	ui._obsidian:SetShow(false)
	ui._obsidian_B:SetShow(false)
	ui._obsidian_B_Left:SetShow(false)
	ui._obsidian_Text:SetShow(false)
	ui._obsidian_Text_2:SetShow(false)
	ui._bubbleKey_R:SetShow(false)
	
	naviCountCheck = false
	_stepNo = 0
end

-----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
-----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
function Panel_Tutorial_doStep( deltaTime )
	if ( welcomeToTheWorld ) then
		-- if not isPvpEnable() then
			Panel_PvpMode:SetShow( false )
		-- else
			-- Panel_PvpMode:SetShow( true )
		-- end
	end
	
	if 10 <= getSelfPlayer():get():getLevel() then
		Panel_Tutorial:SetShow( false, false )
		return
	end
	
	if ( 1 == _stepNo ) then				-- 기본 이동 스텝1
		updateDeltaTime_Step1(deltaTime)
	elseif ( 2 == _stepNo ) then			-- 기본 이동 스텝2
		updateDeltaTime_Step2(deltaTime)
	elseif ( 3 == _stepNo ) then			-- 기본 이동 스텝3
		updateDeltaTime_Step3(deltaTime)
	elseif ( 4 == _stepNo ) then			-- 기본 이동 종료
		updateDeltaTime_Step4(deltaTime)
	--------------------------------------------------------------
	elseif ( 5 == _stepNo ) then			-- 기본 공격 스텝1
		updateDeltaTime_Battle_Step1(deltaTime)
	elseif ( 6 == _stepNo ) then			-- 기본 공격 스텝2
		updateDeltaTime_Battle_Step2(deltaTime)
		updateDeltaTime_Battle_ForKeyPressed(deltaTime)
	--------------------------------------------------------------
	elseif ( 7 == _stepNo ) then			-- 기본 공격 스텝3 - 레인저 (↓ + 좌클릭)
		updateDeltaTime_Battle_Step3_Ranger(deltaTime)
	elseif ( 8 == _stepNo ) then			-- 기본 공격 스텝3 - 소서러 (우클릭)
		updateDeltaTime_Battle_Step3_Sorcerer(deltaTime)
	elseif ( 9 == _stepNo ) then			-- 기본 공격 스텝3 - 워리어 (가드)
		updateDeltaTime_Battle_Step3_Warrior(deltaTime)
	elseif ( 10 == _stepNo ) then			-- 기본 공격 스텝3 - 자이언트 (잡기)
		updateDeltaTime_Battle_Step3_Giant(deltaTime)
	elseif ( 13 == _stepNo ) then			-- 기본 공격 스텝3 - 테이머 (띄우기)
		updateDeltaTime_Battle_Step3_Tamer(deltaTime)
	--------------------------------------------------------------
	elseif ( 11 == _stepNo ) then			-- 기본 공격 스텝4
		updateDeltaTime_Battle_Step4(deltaTime)
	elseif ( 12 == _stepNo ) then			-- 기본 공격 종료
		updateDeltaTime_Battle_Step5(deltaTime)
	--------------------------------------------------------------
	elseif ( 21 == _stepNo ) then			-- 길찾기 튜토리얼 시작 CTRL 키를 눌러라
		updateDeltaTime_NaviCtrl_Step1(deltaTime)
	elseif ( 22 == _stepNo ) then			-- 길찾기 버튼을 눌러라
		updateDeltaTime_NaviCtrl_Step2(deltaTime)
	elseif ( 23 == _stepNo ) then			-- T를 눌러 자동이동 해봐라
		updateDeltaTime_NaviCtrl_Step3(deltaTime)
	elseif ( 24 == _stepNo ) then			-- 종료 한다
		updateDeltaTime_NaviCtrl_Step4(deltaTime)
	--------------------------------------------------------------	
	elseif ( 31 == _stepNo ) then			-- 첫 인터랙션 창 오픈
		updateDeltaTime_Interaction_Step1(deltaTime)
	elseif ( 32 == _stepNo ) then			-- 인터랙션 가이드 종료
		updateDeltaTime_Interaction_Step2(deltaTime)
	--------------------------------------------------------------	
	elseif ( 41 == _stepNo ) then			-- 흑정령 소환 튜토리얼
		updateDeltaTime_CallSpirit_Step1(deltaTime)
	elseif ( 42 == _stepNo ) then			-- 흑정령 소환 튜토리얼 종료
		updateDeltaTime_CallSpirit_Step2(deltaTime)
	--------------------------------------------------------------	
	elseif ( 96 == _stepNo ) then			-- 인벤토리 열기 튜토리얼 시작!
		updateDeltaTime_OpenInventory_Step1(deltaTime)
	elseif ( 97 == _stepNo ) then			-- 물약을 먹어라
		updateDeltaTime_OpenInventory_Step2(deltaTime)
	elseif ( 98 == _stepNo ) then			-- 종료 한다
		updateDeltaTime_OpenInventory_Step3(deltaTime)
	--------------------------------------------------------------
	elseif ( 99 == _stepNo ) then			-- 최초 튜토리얼 시작!
		updateDeltaTime_StartTutorial(deltaTime)
	end

end

function Panel_Tutorial_BtnsDisappear()
	ui._m0:ResetVertexAni()
	ui._m1:ResetVertexAni()
	ui._button_Q:ResetVertexAni()
	ui._button_W:ResetVertexAni()
	ui._button_A:ResetVertexAni()
	ui._button_S:ResetVertexAni()
	ui._button_D:ResetVertexAni()
	ui._button_E:ResetVertexAni()
	ui._button_F:ResetVertexAni()
	ui._button_Tab:ResetVertexAni()
	ui._button_Shift:ResetVertexAni()
	ui._button_Space:ResetVertexAni()
	ui._button_Ctrl:ResetVertexAni()
	ui._mBody:ResetVertexAni()

	ui._m0:SetVertexAniRun( "Ani_Color_Disappear", true )
	ui._m1:SetVertexAniRun( "Ani_Color_Disappear", true )
	ui._button_Q:SetVertexAniRun( "Ani_Color_Disappear", true )
	ui._button_W:SetVertexAniRun( "Ani_Color_Disappear", true )
	ui._button_A:SetVertexAniRun( "Ani_Color_Disappear", true )
	ui._button_S:SetVertexAniRun( "Ani_Color_Disappear", true )
	ui._button_D:SetVertexAniRun( "Ani_Color_Disappear", true )
	ui._button_E:SetVertexAniRun( "Ani_Color_Disappear", true )
	ui._button_F:SetVertexAniRun( "Ani_Color_Disappear", true )
	ui._button_Tab:SetVertexAniRun( "Ani_Color_Disappear", true )
	ui._button_Shift:SetVertexAniRun( "Ani_Color_Disappear", true )
	ui._button_Space:SetVertexAniRun( "Ani_Color_Disappear", true )
	ui._button_Ctrl:SetVertexAniRun( "Ani_Color_Disappear", true )
	ui._mBody:SetVertexAniRun( "Ani_Color_Disappear", true )
end

-- 길찾기 튜토리얼 마스크는 한 번만 안내되게 한다!
local naviTutorialMaskCheck = false
function FGlobal_Tutorial_QuestMasking_Show( posX, posY )
	if true == naviTutorialMaskCheck then
		return
	end
	naviTutorialMaskCheck = true
	Panel_Masking_Tutorial:SetShow( true )
	_maskBg_Quest			:SetShow( true )
	_maskBg_SelfExpGuage	:SetShow( false )
	_maskBg_Spirit			:SetShow( false )

	local _posX = Panel_CheckedQuest:GetPosX() + posX - 150
	local _posY = Panel_CheckedQuest:GetPosY() + posY - 120
	Panel_Masking_Tutorial:SetPosX( _posX )
	Panel_Masking_Tutorial:SetPosY( _posY )
end

local invenTutorialMaskCheck = false
function FGlobal_Tutorial_InventoryMasking_Show( posX, posY )
	if true == invenTutorialMaskCheck then
		return
	end
	invenTutorialMaskCheck = true
	Panel_Masking_Tutorial	:SetShow( true )
	_maskBg_Quest			:SetShow( true )
	_maskBg_SelfExpGuage	:SetShow( false )
	_maskBg_Spirit			:SetShow( false )

	local _posX = Panel_Window_Inventory:GetPosX() + posX - 130
	local _posY = Panel_Window_Inventory:GetPosY() + posY - 115
	Panel_Masking_Tutorial:SetPosX( _posX )
	Panel_Masking_Tutorial:SetPosY( _posY )
end

local spiritTutorialMaskCheck = false
function FGlobal_Tutorial_SpiritMasking_Show()
	if true == spiritTutorialMaskCheck then
		return
	end
	spiritTutorialMaskCheck = true
	Panel_Masking_Tutorial	:SetShow( true )
	_maskBg_Quest			:SetShow( false )
	_maskBg_SelfExpGuage	:SetShow( false )
	_maskBg_Spirit			:SetShow( true )

	local _posX = Panel_NewQuest_Alarm:GetPosX() - 100
	local _posY = Panel_NewQuest_Alarm:GetPosY() - 70
	Panel_Masking_Tutorial:SetPosX( _posX )
	Panel_Masking_Tutorial:SetPosY( _posY )
end

function FGlobal_Tutorial_QuestMasking_Hide()
	Panel_Masking_Tutorial	:SetShow( false )
	_maskBg_Quest			:SetShow( false )
	_maskBg_SelfExpGuage	:SetShow( false )
	_maskBg_Spirit			:SetShow( false )
end


local callSpiritTutorialCount = 0
function FGlobal_Tutorial_CallSpirit()
	if Panel_Npc_Dialog:GetShow() then
		return
	end
	
	if 1 < callSpiritTutorialCount then
		return
	end
	
	callSpiritTutorialCount = callSpiritTutorialCount + 1

	Panel_MovieTheater_LowLevel_WindowClose()
	Panel_Tutorial:SetShow( true, false )

	-- 기본적으로 애들을 꺼준다
	for _, v in pairs ( ui ) do
		v:SetShow( false )
	end
	
	ui._obsidian:SetShow(true)
	ui._obsidian_B:SetShow(false)
	ui._obsidian_B_Left:SetShow(true)
	ui._obsidian_Text:SetShow(true)
	ui._obsidian_Text_2:SetShow(true)
	ui._bubbleKey_R:SetShow(true)
	ui._obsidian:EraseAllEffect()
	ui._obsidian:AddEffect ( "fUI_DarkSpirit_Tutorial", true, 0, 0 )

	ButtonToggleAll(false)
	Panel_Tutorial_BtnHide()
	bubbleKey_Hide()
	-- FGlobal_Panel_LowLevelGuide_MovePlay_Battle:SetShow( false, false )
	_stepNo = 41
end

function isTutorialEnd()
	return _isTutorialEnd
end

function isInteractionTutorial()
	return isInteractionForTutorial
end

registerEvent("onScreenResize", "Tutorial_ScreenRePosition")
Panel_Tutorial:RegisterUpdateFunc("Panel_Tutorial_doStep")

-- Panel_WelcomeToTheWorld_Start()
-- Panel_Tutorial_Battle_Start()
-- Panel_Tutorial_NaviCtrl_Start()