local UI_TM			= CppEnums.TextMode
local UI_PUCT		= CppEnums.PA_UI_CONTROL_TYPE
local UI_color		= Defines.Color

Panel_Dye_New:SetShow( false )

local DyeNew = {
	panelTitle					= UI.getChildControl( Panel_Dye_New, "StaticText_Title"),
	leftBG						= UI.getChildControl( Panel_Dye_New, "Static_BG"),
	scroll						= UI.getChildControl( Panel_Dye_New, "Scroll_DyeNew"),
	targetCharacter				= {
		[0] = UI.getChildControl( Panel_Dye_New, "RadioButton_CharacterType_0"),
		UI.getChildControl( Panel_Dye_New, "RadioButton_CharacterType_1"),
		UI.getChildControl( Panel_Dye_New, "RadioButton_CharacterType_2"),
		UI.getChildControl( Panel_Dye_New, "RadioButton_CharacterType_3"),
		UI.getChildControl( Panel_Dye_New, "RadioButton_CharacterType_4"),
		UI.getChildControl( Panel_Dye_New, "RadioButton_CharacterType_5"),
		UI.getChildControl( Panel_Dye_New, "RadioButton_CharacterType_6"),
		},

	btn_Dodye					= UI.getChildControl( Panel_Dye_New, "Button_DoDye"),

	static_SetOptionBG			= UI.getChildControl( Panel_Dye_New, "Static_SetOptionBG"),
	txt_Endurance				= UI.getChildControl( Panel_Dye_New, "StaticText_Endurance"),
	btn_ShowUnderwear			= UI.getChildControl( Panel_Dye_New, "CheckButton_ShowUnderWear"),
	btn_HideAvatar				= UI.getChildControl( Panel_Dye_New, "CheckButton_HideAvatar"),
	btn_HairHide				= UI.getChildControl( Panel_Dye_New, "CheckButton_HideHair"),
	Slider_Endurance			= UI.getChildControl( Panel_Dye_New, "Slider_Endurance"),

	titleLineUIPool				= {},
	titleLineSting				= {
		[0] = PAGetString(Defines.StringSheet_GAME, "LUA_DYE_NEW_TITLELINESTRING_DESTINATION"),
		PAGetString(Defines.StringSheet_GAME, "LUA_DYE_NEW_TITLELINESTRING_ITEMSELECT"),
		PAGetString(Defines.StringSheet_GAME, "LUA_DYE_NEW_TITLELINESTRING_ITEMPARTSSELECT"),
		PAGetString(Defines.StringSheet_GAME, "LUA_DYE_NEW_TITLELINESTRING_DYESELECT"),
	},
	targetCharacterSlotCount	= 7,
	characterTypeUIPoll			= {},
	selected_characterType		= 0,

	targetEuipSlotCount			= 17,
	equipSlotUIPoll				= {},
	selectedEquipSlotNo			= 0,
	isSelectedEquipSlot			= false,

	partSlotMaxCount			= 4,
	partIdxMaxCount				= 3,
	partSlotUIPoll				= {},
	isPartClick					= false,
	selectedPart				= { slotId = -1, partId = -1, uiIdx = -1 },

	isHideAvatar				= false,
	isShowUnderwear				= false,

	nowInterval_Ampule			= 0,
	maxInterval_Ampule			= 0,
	ampouleSlotMaxCount			= 28,
	ampouleSlotBGUIPoll			= {},
	ampouleSlotUIPoll			= {},
	ampouleSlotConfig			= {	-- 일단 아이콘, 테두리, 카운트(숫자) 만 적용한다!
		createIcon		= true,
		createBorder	= false,
		createCount		= true,
		createCash		= true,
	},
	selectedAmpouleIdx			= -1,
	dyeStepCount				= 4,
}
DyeNew.scrollCTRLBTN			= UI.getChildControl( DyeNew.scroll, 			"Scroll_CtrlButton")
DyeNew.Endurance_SliderCtrlBTN	= UI.getChildControl( DyeNew.Slider_Endurance,	"Slider_Endurance_Button")

local Template = {
	titleLine		= UI.getChildControl( Panel_Dye_New, "Template_StaticText_DyeTarget_Title"),
	areaBG			= UI.getChildControl( Panel_Dye_New, "Template_Static_DyeTarget_BG"),
	slotBG			= UI.getChildControl( Panel_Dye_New, "Template_Static_SlotBG"),
	slotSelectBG	= UI.getChildControl( Panel_Dye_New, "Template_Static_SlotSelectBG"),
	slot			= UI.getChildControl( Panel_Dye_New, "Template_Static_Slot"),

	BTN_part		= UI.getChildControl( Panel_Dye_New, "Template_Radiobutton_PartColor"),
	BTN_resetPart	= UI.getChildControl( Panel_Dye_New, "Template_Button_PartSLotReset"),
	SlotPartBG		= UI.getChildControl( Panel_Dye_New, "Template_Static_SlotPartColorBG"),
	SlotPartName	= UI.getChildControl( Panel_Dye_New, "Template_Static_SlotPartColorName"),	
}

local equipSlotNo	= {
	[0] = {
		0,		-- 'Static_Slot_RightHand',
		1,		-- 'Static_Slot_LeftHand',
		3,		-- 'Static_Slot_Chest',
		4,		-- 'Static_Slot_Glove',
		5,		-- 'Static_Slot_Boots',
		6,		-- 'Static_Slot_Helm',
		7,		-- '',

		18,		-- 'Static_Slot_Avatar_RightHand',
		19,		-- 'Static_Slot_Avatar_LeftHand',
		14,		-- 'Static_Slot_Avatar_Chest',
		15,		-- 'Static_Slot_Avatar_Gloves',
		16,		-- 'Static_Slot_Avatar_Boots',
		17,		-- 'Static_Slot_Avatar_Helm',
		20,		-- 'Static_Slot_Avatar_UnderWear',
		21,		-- 'Static_Slot_Avatar_UnderWear',
		22,		-- 'Static_Slot_Avatar_UnderWear',
		23,		-- 'Static_Slot_Avatar_UnderWear',
	},
	{
		3,	-- 마갑
		4,	-- 등자
		5,	-- 안장
		6,	-- 마면
		12,	-- 편자.
		0,	-- 사용안함.
		1,	-- 사용안함.

		14,	-- 마갑
		15,	-- 등자
		16,	-- 안장
		17,	-- 마면
		18,	-- 사용안함.
		19,	-- 사용안함.
		20,	-- 사용안함.
	},
	{},
}
local equipSlotIcon = {
	[0] = {
		[0] = { 166, 123, 194, 151 },			-- 주무기
		[1] = { 197, 123, 225, 151 },			-- 보조무기
		[3] = { 42, 123, 70, 151 },				-- 갑옷
		[4] = { 135, 123, 163, 151 },			-- 장갑
		[5] = { 104, 123, 132, 151 },			-- 신발
		[6] = { 11, 123, 39, 151 },				-- 투구
		[7] = { 0, 0, 0, 0 },					-- 목걸이(안쓴다)

		[18] = { 166, 154, 194, 182 },			-- 주무기(아바타)
		[19] = { 197, 154, 225, 182 },			-- 보조무기(아바타)
		[14] = { 42, 154, 70, 182 },			-- 갑옷(아바타)
		[15] = { 135, 154, 163, 182 },			-- 장갑(아바타)
		[16] = { 104, 154, 132, 182 },			-- 신발(아바타)
		[17] = { 11, 154, 39, 182 },			-- 투구(아바타)
		[20] = { 73, 154, 101, 182 },			-- 속옷(아바타)

		[21] = { 228, 123, 256, 151 },			-- 얼굴 악세-상단(아바타)
		[22] = { 259, 154, 287, 182 },			-- 얼굴 악세-하단(아바타)
		[23] = { 228, 154, 256, 182 },			-- 얼굴 악세-귀(아바타)
	},
	{
		[3] = { 136,	147,	164,	175 },	-- 마갑
		[4] = { 105,	147,	133,	175 },	-- 등자
		[5] = { 198,	147,	226,	175 },	-- 안장
		[6] = { 74,		147,	102,	175 },	-- 마면
		[12] = { 167,	147,	195,	175 },	-- 편자.
		[0] = { 0, 0, 0, 0 },	-- 사용안함.
		[1] = { 0, 0, 0, 0 },	-- 사용안함.

		[14] = { 136,	177,	164,	205 },	-- 마갑
		[15] = { 105,	177,	133,	205 },	-- 등자
		[16] = { 198,	177,	226,	205 },	-- 안장
		[17] = { 74,	177,	102,	205 },	-- 마면
		[18] = { 0, 0, 0, 0 },	-- 사용안함.
		[19] = { 0, 0, 0, 0 },	-- 사용안함.
		[20] = { 0, 0, 0, 0 },	-- 사용안함.
	},
	{
		[0] = { 0, 0, 0, 0 },
		{ 0, 0, 0, 0 },
		{ 0, 0, 0, 0 },
		{ 0, 0, 0, 0 },
		{ 0, 0, 0, 0 },
		{ 0, 0, 0, 0 },
		{ 0, 0, 0, 0 },
	},
	{
		[0] = { 0, 0, 0, 0 },
		{ 0, 0, 0, 0 },
		{ 0, 0, 0, 0 },
		{ 0, 0, 0, 0 },
		{ 0, 0, 0, 0 },
		{ 0, 0, 0, 0 },
		{ 0, 0, 0, 0 },
	},
}
local equipSlotDyeInfo = {
	[0] = {
		[0]		= {},
		[1]		= {},
		[3]		= {},
		[4]		= {},
		[5]		= {},
		[6]		= {},
		[7]		= {},

		[18]	= {},
		[19]	= {},
		[14]	= {},
		[15]	= {},
		[16]	= {},
		[17]	= {},
		[20]	= {},
		[21]	= {},
		[22]	= {},
		[23]	= {},
	},
	{
		[3] = {},	-- 마갑
		[4] = {},	-- 등자
		[5] = {},	-- 안장
		[6] = {},	-- 마면
		[12] = {},	-- 편자
		[0] = {},	-- 사용안함.
		[1] = {},	-- 사용안함.

		[14] = {},	-- 마갑
		[15] = {},	-- 등자
		[16] = {},	-- 안장
		[17] = {},	-- 마면
		[18] = {},	-- 사용안함.
		[19] = {},	-- 사용안함.
		[20] = {},	-- 사용안함.
	},
}
local partSlotno = {
		[0] = 	{ [0] = { slotNo = -1, uiIdx = -1}, { slotNo = -1, uiIdx = -1}, { slotNo = -1, uiIdx = -1} },
				{ [0] = { slotNo = -1, uiIdx = -1}, { slotNo = -1, uiIdx = -1}, { slotNo = -1, uiIdx = -1} },
				{ [0] = { slotNo = -1, uiIdx = -1}, { slotNo = -1, uiIdx = -1}, { slotNo = -1, uiIdx = -1} },
				{ [0] = { slotNo = -1, uiIdx = -1}, { slotNo = -1, uiIdx = -1}, { slotNo = -1, uiIdx = -1} },
				{ [0] = { slotNo = -1, uiIdx = -1}, { slotNo = -1, uiIdx = -1}, { slotNo = -1, uiIdx = -1} },
				{ [0] = { slotNo = -1, uiIdx = -1}, { slotNo = -1, uiIdx = -1}, { slotNo = -1, uiIdx = -1} },
				{ [0] = { slotNo = -1, uiIdx = -1}, { slotNo = -1, uiIdx = -1}, { slotNo = -1, uiIdx = -1} },
				{ [0] = { slotNo = -1, uiIdx = -1}, { slotNo = -1, uiIdx = -1}, { slotNo = -1, uiIdx = -1} },
}

function DyeNew:Initialize()
	self:SetPosition()

	-- 타이틀 라인 생성
	local titleLineStartPosY = 5
	for title_Idx = 0, self.dyeStepCount - 1 do
		local tempArray = {}
		local created_TitleLine = UI.createControl( UI_PUCT.PA_UI_CONTROL_STATICTEXT, self.leftBG, 'Dye_New_TitleLine_' .. title_Idx )
		CopyBaseProperty( Template.titleLine, created_TitleLine )
		created_TitleLine:SetText( self.titleLineSting[title_Idx] )
		created_TitleLine:SetShow( false )
		tempArray.title = created_TitleLine

		local created_AreaBG = UI.createControl( UI_PUCT.PA_UI_CONTROL_STATIC, created_TitleLine, 'Dye_New_AreaBgByTitle_' .. title_Idx )
		CopyBaseProperty( Template.areaBG, created_AreaBG )
		created_AreaBG:SetPosX( 5 )
		created_AreaBG:SetPosY( created_TitleLine:GetSizeY() + 5 )
		created_AreaBG:SetShow( true )
		tempArray.AreaBG = created_AreaBG

		self.titleLineUIPool[title_Idx] = tempArray
	end

	-- 염색 대상 생성
	local dyeTargetSlot_StartPosX = 5
	for characterType_Idx = 0, self.targetCharacterSlotCount - 1 do
		local tempArray = {}
		local created_SlotBG = UI.createControl( UI_PUCT.PA_UI_CONTROL_STATIC, self.titleLineUIPool[0].AreaBG, 'Dye_New_characterTypeSlotBG_' .. characterType_Idx )
		CopyBaseProperty( Template.slotBG, created_SlotBG )
		created_SlotBG:SetShow( false )
		tempArray.SlotBG = created_SlotBG

		-- 미리 만들어 놓은 걸 연결함.
		created_SlotBG:AddChild( self.targetCharacter[characterType_Idx] )
		Panel_Dye_New:RemoveControl( self.targetCharacter[characterType_Idx] )
		local linked_SlotBTN = self.targetCharacter[characterType_Idx]
		linked_SlotBTN:SetShow( true )
		if 1 < characterType_Idx then	-- 우선 사람만 한다.
			-- 일단은 누를 수 없습니다!
			linked_SlotBTN:SetShow( false )
			linked_SlotBTN:SetMonoTone( true )
			linked_SlotBTN:SetEnable( false )
			linked_SlotBTN:SetIgnore( true )
		else
			linked_SlotBTN:SetMonoTone( false )
			linked_SlotBTN:SetEnable( true )
			linked_SlotBTN:SetIgnore( false )
		end
		linked_SlotBTN:SetPosX( 1 )
		linked_SlotBTN:SetPosY( 1 )
		linked_SlotBTN:addInputEvent("Mouse_LUp", "HandleClicked_DeyNew_SelectCharacterType( " .. characterType_Idx .. " )")
		tempArray.SlotBTN = linked_SlotBTN

		self.characterTypeUIPoll[characterType_Idx] = tempArray
	end

	-- 장비 선택 생성
	for equipSlot_Idx = 0, self.targetEuipSlotCount - 1 do
		local tempArray = {}
		local created_SlotBG = UI.createControl( UI_PUCT.PA_UI_CONTROL_STATIC, self.titleLineUIPool[1].AreaBG, 'Dye_New_equipSlotBG_' .. equipSlot_Idx )
		CopyBaseProperty( Template.slotBG, created_SlotBG )
		created_SlotBG:SetShow( false )
		tempArray.SlotBG = created_SlotBG

		local created_SlotIcon = UI.createControl( UI_PUCT.PA_UI_CONTROL_STATIC, created_SlotBG, 'Dye_New_equipSlotIcon_' .. equipSlot_Idx )
		CopyBaseProperty( Template.slot, created_SlotIcon )
		created_SlotIcon:SetSize( 28, 28 )
		created_SlotIcon:SetPosX( 8 )
		created_SlotIcon:SetPosY( 8 )
		created_SlotIcon:SetShow( true )
		tempArray.SlotIcon = created_SlotIcon

		local created_SlotSelectBG = UI.createControl( UI_PUCT.PA_UI_CONTROL_STATIC, created_SlotBG, 'Dye_New_equipSlotSelectBG_' .. equipSlot_Idx )
		CopyBaseProperty( Template.slotSelectBG, created_SlotSelectBG )
		created_SlotSelectBG:SetPosX( 0 )
		created_SlotSelectBG:SetPosY( 0 )
		created_SlotSelectBG:SetShow( false )
		tempArray.SlotSelectBG = created_SlotSelectBG

		local equipSlot = {}
		SlotItem.new( equipSlot, 'Dye_New_equipSlotItem_' .. equipSlot_Idx, 0, created_SlotBG, self.ampouleSlotConfig )
		equipSlot:createChild()
		equipSlot.icon	:SetPosX( 0 )
		equipSlot.icon	:SetPosY( 0 )
		equipSlot.icon	:SetShow( true )
		tempArray.SlotItem = equipSlot

		self.equipSlotUIPoll[equipSlot_Idx] = tempArray
	end

	-- 장비 부위 선택 생성
	local partSlotBGMaxCount	= 4

	local partSlotBGStartX		= 5
	local partSlotBGStartY		= 5
	local partSlotBGGapX		= 170
	local partSlotBGGapY		= 60
	local partSlotBGCols		= 2
	local partSlotBGRows		= ( partSlotBGMaxCount - 1 ) / partSlotBGCols
	for partSlot_idx = 0, self.partSlotMaxCount - 1 do
		local tempArray = {}

		local partSlotBGcol			= partSlot_idx % partSlotBGCols
		local partSlotBGrow			= math.floor( partSlot_idx / partSlotBGCols )
		local partSlotBGposX		= partSlotBGStartX + partSlotBGGapX * partSlotBGcol
		local partSlotBGposY		= partSlotBGStartY + partSlotBGGapY * partSlotBGrow

		local created_PartSlotBG = UI.createControl( UI_PUCT.PA_UI_CONTROL_STATIC, self.titleLineUIPool[2].AreaBG, 'Dye_New_partSlotBG_' .. partSlot_idx )
		CopyBaseProperty( Template.SlotPartBG, created_PartSlotBG )
		created_PartSlotBG:SetPosX( partSlotBGposX )
		created_PartSlotBG:SetPosY( partSlotBGposY )
		created_PartSlotBG:SetShow( false )
		tempArray.PartSlotBG	= created_PartSlotBG

		local partBTNPosX = 10
		tempArray.PartSlotBGElement	= {}
		for part_Idx = 0, self.partIdxMaxCount - 1 do
			local partArray	= {}
			local created_PartBTN = UI.createControl( UI_PUCT.PA_UI_CONTROL_RADIOBUTTON, created_PartSlotBG, 'Dye_New_partBTN_' .. partSlot_idx .. "_" .. part_Idx )
			CopyBaseProperty( Template.BTN_part, created_PartBTN )
			created_PartBTN:SetPosX( partBTNPosX )
			created_PartBTN:SetPosY( 2 )
			created_PartBTN:SetText( part_Idx + 1 )
			created_PartBTN:SetShow( false )
			created_PartBTN:SetAlphaIgnore( true )
			partArray.partBTN	= created_PartBTN

			local created_PartResetBTN = UI.createControl( UI_PUCT.PA_UI_CONTROL_BUTTON, created_PartSlotBG, 'Dye_New_partResetBTN_' .. partSlot_idx .. "_" .. part_Idx )
			CopyBaseProperty( Template.BTN_resetPart, created_PartResetBTN )
			created_PartResetBTN:SetPosX( partBTNPosX + 30 )
			created_PartResetBTN:SetPosY( 32 )
			created_PartResetBTN:SetShow( false )
			partArray.partResetBTN	= created_PartResetBTN		

			tempArray.PartSlotBGElement[part_Idx] = partArray

			partBTNPosX	= partBTNPosX + created_PartBTN:GetSizeX() -5
		end

		self.partSlotUIPoll[partSlot_idx] = tempArray
	end

	-- 염료 선택 생성
	local ampouleSlotStartX			= 5
	local ampouleSlotStartY			= 5
	local ampouleSlotGapX			= 47
	local ampouleSlotGapY			= 47
	local ampouleSlotCols			= 7
	local ampouleSlotRows			= (self.ampouleSlotMaxCount - 1) / ampouleSlotCols
	for ampouleSlot_Idx = 0, self.ampouleSlotMaxCount - 1 do
		local col		= ampouleSlot_Idx % ampouleSlotCols
		local row		= math.floor( ampouleSlot_Idx / ampouleSlotCols )
		local posX		= ampouleSlotStartX + ampouleSlotGapX * col
		local posY		= ampouleSlotStartY + ampouleSlotGapY * row

		local tempArray = {}
		local created_AmpouleSlotBG = UI.createControl( UI_PUCT.PA_UI_CONTROL_STATIC, self.titleLineUIPool[3].AreaBG, 'Dye_New_ampuleSlotBG_' .. ampouleSlot_Idx )
		CopyBaseProperty( Template.slotBG, created_AmpouleSlotBG )
		created_AmpouleSlotBG:SetPosX( posX )
		created_AmpouleSlotBG:SetPosY( posY )
		created_AmpouleSlotBG:SetShow( false )
		created_AmpouleSlotBG:addInputEvent("Mouse_DownScroll",	"dye_New_Ampule_ScrollUpdate( true )")
		created_AmpouleSlotBG:addInputEvent("Mouse_UpScroll",	"dye_New_Ampule_ScrollUpdate( false )")
		tempArray.SlotBG = created_AmpouleSlotBG

		local created_SlotSelectBG = UI.createControl( UI_PUCT.PA_UI_CONTROL_STATIC, created_AmpouleSlotBG, 'Dye_New_ampuleSlotSelectBG_' .. ampouleSlot_Idx )
		CopyBaseProperty( Template.slotSelectBG, created_SlotSelectBG )
		created_SlotSelectBG:SetPosX( 0 )
		created_SlotSelectBG:SetPosY( 0 )
		created_SlotSelectBG:SetShow( false )
		tempArray.SlotSelectBG = created_SlotSelectBG

		self.ampouleSlotBGUIPoll[ampouleSlot_Idx] = tempArray

		local slot = {}
		SlotItem.new( slot, 'Dye_New_ampuleSlot_' .. ampouleSlot_Idx, index, created_AmpouleSlotBG, self.ampouleSlotConfig )
		slot:createChild()
		slot.icon	:SetPosX( -2 )
		slot.icon	:SetPosY( -2 )
		slot.icon	:SetShow( true )
		slot.icon	:addInputEvent("Mouse_DownScroll",	"dye_New_Ampule_ScrollUpdate( true )")
		slot.icon	:addInputEvent("Mouse_UpScroll",	"dye_New_Ampule_ScrollUpdate( false )")

		self.ampouleSlotUIPoll[ampouleSlot_Idx] = slot
	end
	self.titleLineUIPool[3].AreaBG	:SetIgnore( false )
	self.titleLineUIPool[3].AreaBG	:addInputEvent("Mouse_DownScroll",	"dye_New_Ampule_ScrollUpdate( true )")
	self.titleLineUIPool[3].AreaBG	:addInputEvent("Mouse_UpScroll",	"dye_New_Ampule_ScrollUpdate( false )")

	self.titleLineUIPool[3].AreaBG	:AddChild( self.scroll )

	Panel_Dye_New					:RemoveControl( self.scroll )
	self.scroll						:SetControlTop()

	self.static_SetOptionBG			:AddChild( self.txt_Endurance )
	self.static_SetOptionBG			:AddChild( self.btn_ShowUnderwear )
	self.static_SetOptionBG			:AddChild( self.btn_HideAvatar )
	self.static_SetOptionBG			:AddChild( self.Slider_Endurance )
	self.static_SetOptionBG			:AddChild( self.btn_Dodye )
	self.static_SetOptionBG			:AddChild( self.btn_HairHide )
	Panel_Dye_New					:RemoveControl( self.txt_Endurance )
	Panel_Dye_New					:RemoveControl( self.btn_ShowUnderwear )
	Panel_Dye_New					:RemoveControl( self.btn_HideAvatar )
	Panel_Dye_New					:RemoveControl( self.Slider_Endurance )
	Panel_Dye_New					:RemoveControl( self.btn_Dodye )
	Panel_Dye_New					:RemoveControl( self.btn_HairHide )


	self.txt_Endurance				:SetPosX(25)
	self.txt_Endurance				:SetPosY(8)
	self.Slider_Endurance			:SetPosX( self.txt_Endurance:GetPosX() + self.txt_Endurance:GetSizeX() + 5 )
	self.Slider_Endurance			:SetPosY( 15 )
	self.btn_ShowUnderwear			:SetPosX( self.Slider_Endurance:GetPosX() + self.Slider_Endurance:GetSizeX() + 15 )
	self.btn_ShowUnderwear			:SetPosY( 3 )
	self.btn_HideAvatar				:SetPosX( self.btn_ShowUnderwear:GetPosX() + self.btn_ShowUnderwear:GetSizeX() )
	self.btn_HideAvatar				:SetPosY( 3 )
	self.btn_HairHide				:SetPosX( self.btn_HideAvatar:GetPosX() + self.btn_HideAvatar:GetSizeX() )
	self.btn_HairHide				:SetPosY( 3 )

	self.btn_Dodye					:SetPosX( 100 )
	self.btn_Dodye					:SetPosY( 40 )

	self.panelTitle					:ComputePos()
	self.Slider_Endurance			:SetInterval( 99 )
end

function DyeNew:UpdatePosition()
	-- 스텝 단위 타이틀/배경 켬
	for title_Idx = 0, self.dyeStepCount - 1 do
		local contentGroup = self.titleLineUIPool[title_Idx]
		contentGroup.title:SetPosX( 5 )
		contentGroup.title:SetShow( true )
	end
	----------------------------------------------------------------------------
	-- 염색 대상 타이틀 포지션
	----------------------------------------------------------------------------
	local characterTypeContentUI = self.titleLineUIPool[0]
	characterTypeContentUI.title:SetPosY( 5 )

	-- 염색 대상 켬
	local characterTypePosX			= 5
	local characterTypeContentPosY	= 0
	for characterType_Idx = 0, self.targetCharacterSlotCount - 1 do
		local areaBG = self.titleLineUIPool[0].AreaBG
		local UiBase = self.characterTypeUIPoll[characterType_Idx]
		UiBase.SlotBG:SetPosX( characterTypePosX )
		UiBase.SlotBG:SetPosY( 5 )
		UiBase.SlotBG:SetShow( true )
		UiBase.SlotBTN:SetCheck( false )
		if self.selected_characterType == characterType_Idx then
			UiBase.SlotBTN:SetCheck( true )
		end
		if 3 < characterType_Idx then
			UiBase.SlotBTN:SetShow( false )
		end
		characterTypePosX			= characterTypePosX + UiBase.SlotBG:GetSizeX() + 3
		characterTypeContentPosY	= UiBase.SlotBG:GetPosY() + UiBase.SlotBG:GetSizeY() +  5
	end
	characterTypeContentUI.AreaBG:SetSize( characterTypeContentUI.AreaBG:GetSizeX(), characterTypeContentPosY )

	-- 장비 선택
	----------------------------------------------------------------------------
	-- 장비 선택 타이틀 포지션
	----------------------------------------------------------------------------
	local equipSlotContentUI = self.titleLineUIPool[1]
	equipSlotContentUI.title:SetPosY( characterTypeContentUI.title:GetPosY() + characterTypeContentUI.title:GetSizeY() + 5 + characterTypeContentUI.AreaBG:GetSizeY() + 5 )
	-- 초기화
	for equipSlot_Idx = 0, self.targetEuipSlotCount - 1 do
		local UiBase = self.equipSlotUIPoll[equipSlot_Idx]
		UiBase.SlotBG:SetShow( false )
	end	

	local maxEquipSlotCount = 7
	if 0 == self.selected_characterType then
		maxEquipSlotCount = 14
	end

	local equipSlotStartX	= 5
	local equipSlotStartY	= 5
	local equipSlotGapX		= 47
	local equipSlotGapY		= 47
	local equipSlotCols		= 7
	local equipSlotRows		= (self.targetEuipSlotCount - 1) / equipSlotCols
	local equipContentPosY	= 0
	local tempSlotIdx	= 0
	for idx,value in pairs(equipSlotNo[self.selected_characterType]) do
		local col		= tempSlotIdx % equipSlotCols
		local row		= math.floor( tempSlotIdx / equipSlotCols )
		local posX		= equipSlotStartX + equipSlotGapX * col
		local posY		= equipSlotStartY + equipSlotGapY * row

		local UiBase = self.equipSlotUIPoll[tempSlotIdx]
		UiBase.SlotBG:SetPosX( posX )
		UiBase.SlotBG:SetPosY( posY )
		UiBase.SlotBG:SetShow( true )

		-- 아이콘을 변환시킴
		-- UiBase.SlotIcon:SetShow( true )
		_dye_ReplaceEquipBGIcon( value )

		equipContentPosY = posY + UiBase.SlotBG:GetSizeY() + 5
		tempSlotIdx = tempSlotIdx + 1
	end
	equipSlotContentUI.AreaBG:SetSize( equipSlotContentUI.AreaBG:GetSizeX(), equipContentPosY )

	----------------------------------------------------------------------------
	-- 장비 부위 선택
	----------------------------------------------------------------------------
	local equipPartsContentUI = self.titleLineUIPool[2]
	equipPartsContentUI.title:SetPosY( equipSlotContentUI.title:GetPosY() + equipSlotContentUI.title:GetSizeY() + 5 + equipSlotContentUI.AreaBG:GetSizeY() + 5 )

	local partSlotCount = 0
	for partSlot_idx = 0, self.partSlotMaxCount - 1 do
		local UiBase = self.partSlotUIPoll[partSlot_idx]
		if UiBase.PartSlotBG:GetShow() then
			partSlotCount = partSlotCount + 1
		end
	end
	equipPartsContentUI.AreaBG:SetSize( equipSlotContentUI.AreaBG:GetSizeX(), (self.partSlotUIPoll[0].PartSlotBG:GetSizeY() * 2) + 15 )


	----------------------------------------------------------------------------
	-- 염료 선택
	----------------------------------------------------------------------------
	local ampouleContentUI = self.titleLineUIPool[3]
	ampouleContentUI.title:SetPosY( equipPartsContentUI.title:GetPosY() + equipPartsContentUI.title:GetSizeY() + 5 + equipPartsContentUI.AreaBG:GetSizeY() + 5 )

	local ampouleSlotPosY = 0
	for ampouleSlot_Idx = 0, self.ampouleSlotMaxCount - 1 do
		local UiBase	= self.ampouleSlotBGUIPoll[ampouleSlot_Idx]
		UiBase.SlotBG:SetShow( true )
		local Slot		= self.ampouleSlotUIPoll[ampouleSlot_Idx]
		Slot.icon:SetShow( true )
		ampouleSlotPosY = (UiBase.SlotBG:GetSizeY() + 5) * ( self.ampouleSlotMaxCount / 7 ) + 5
	end
	ampouleContentUI.AreaBG:SetSize( equipSlotContentUI.AreaBG:GetSizeX(), ampouleSlotPosY )

	self.leftBG		:SetSize( self.leftBG:GetSizeX(), ampouleContentUI.title:GetPosY() + ampouleContentUI.AreaBG:GetPosY() + ampouleContentUI.AreaBG:GetSizeY() + 10 )
	self.panelTitle	:ComputePos()
end
function DyeNew:Update_EquipItem()
	local equipSlotNos = self.selectedEquipSlotNo

	-- 선택한 장비에 BG를 켠다.
	for idx,equipSlotIdx in pairs(equipSlotNo[self.selected_characterType]) do
		local UiBase = self.equipSlotUIPoll[idx-1]
		UiBase.SlotSelectBG:SetShow( false )
		if equipSlotNos == equipSlotIdx then
			UiBase.SlotSelectBG:SetShow( true )
		end
	end

	-- SlotIcon이 bg 아이콘이다. SlotItem

	----------------------------------------------------------------------------
	-- 아래부터는 장착 부위 쪽 설정을 위한 세팅.
	-- 초기화
	for UIPoolidx = 0, 3 do
		local UiBase = self.partSlotUIPoll[UIPoolidx]
		UiBase.PartSlotBG	:SetShow( false )
		for partSlot_Idx = 0, 2 do
			UiBase.PartSlotBGElement[partSlot_Idx].partBTN:SetShow( false )
			UiBase.PartSlotBGElement[partSlot_Idx].partBTN:addInputEvent( "Mouse_LUp", "" )
		end	
	end

	-- 파트 제어용.
	dye_resetPartSlotNoArray()	-- 배열에 저장된 파트 슬롯 넘버를 초기화 한다.

	-- 배열을 만든다.
	local tempUiIdx = 0
	for partIdx = 0, 7 do
		local partSlot = equipSlotDyeInfo[self.selected_characterType][equipSlotNos][partIdx]
		if nil ~= partSlot then
			local slotCount = ToClient_RequestGetPartDyeingSlotCount( equipSlotNos, partIdx )
			for partSlot_Idx = 0, slotCount - 1 do
				local clientSlotNo	= ToClient_RequestGetPartDyeingSlotNo( equipSlotNos, partIdx, partSlot_Idx)
				-- 배열에 저장한다.
				partSlotno[partIdx][partSlot_Idx].slotNo	= clientSlotNo
				partSlotno[partIdx][partSlot_Idx].uiIdx		= tempUiIdx
			end
			tempUiIdx = tempUiIdx + 1
		end
	end

	self:Update_Part()
	self:UpdatePosition()
end

function DyeNew:ResetPartArray()	-- 파트 배열 초기화
	-- 파트 제어용.
	dye_resetPartSlotNoArray()	-- 배열에 저장된 파트 슬롯 넘버를 초기화 한다.

	-- 배열을 만든다.
	local equipSlotNos = self.selectedEquipSlotNo
	local tempUiIdx = 0
	for partIdx = 0, 7 do
		local partSlot = equipSlotDyeInfo[self.selected_characterType][equipSlotNos][partIdx]
		if nil ~= partSlot then
			local slotCount = ToClient_RequestGetPartDyeingSlotCount( equipSlotNos, partIdx )
			for partSlot_Idx = 0, slotCount - 1 do
				local clientSlotNo	= ToClient_RequestGetPartDyeingSlotNo( equipSlotNos, partIdx, partSlot_Idx)
				-- 배열에 저장한다.
				partSlotno[partIdx][partSlot_Idx].slotNo	= clientSlotNo
				partSlotno[partIdx][partSlot_Idx].uiIdx		= tempUiIdx
			end
			tempUiIdx = tempUiIdx + 1
		end
	end
end

function DyeNew:Update_Part()
	local equipSlotNo	= self.selectedEquipSlotNo
	local partId		= self.selectedPart.partId
	local slotId		= self.selectedPart.slotId
	local uiIdx			= self.selectedPart.uiIdx

	-- 라디오 버튼 초기화.
	for UIPoolidx = 0, 3 do
		local UiBase = self.partSlotUIPoll[UIPoolidx]
		for partSlot_Idx = 0, 2 do
			UiBase.PartSlotBGElement[partSlot_Idx].partBTN:SetShow( false )
			UiBase.PartSlotBGElement[partSlot_Idx].partBTN:SetCheck(false)
			UiBase.PartSlotBGElement[partSlot_Idx].partResetBTN:SetShow( false )
		end	
	end

	-- 누른 것을 처리한다.
	if true == self.isPartClick then
		local UiBase = self.partSlotUIPoll[uiIdx]
		local partBTN = UiBase.PartSlotBGElement[slotId].partBTN
		partBTN:SetCheck( true )
		--partBTN:setRenderTexture( partBTN:getClickTexture() )
	end

	-- 정보를 세팅한다.
	local tempUiIdx = 0
	for partIdx = 0, 7 do
		local partSlot = equipSlotDyeInfo[self.selected_characterType][equipSlotNo][partIdx]
		if nil ~= partSlot then
			local UiBase = self.partSlotUIPoll[tempUiIdx]
			UiBase.PartSlotBG	:SetShow( true )

			-- 슬롯이 몇개가 있나?
			local slotCount = ToClient_RequestGetPartDyeingSlotCount( equipSlotNo, partIdx )	--가급적 안쓰는게 좋은데?
			for partSlot_Idx = 0, slotCount - 1 do
				local clientSlotNo	= ToClient_RequestGetPartDyeingSlotNo( equipSlotNo, partIdx, partSlot_Idx)
				UiBase.PartSlotBGElement[partSlot_Idx].partBTN:SetText( clientSlotNo )
				UiBase.PartSlotBGElement[partSlot_Idx].partBTN:SetShow( true )
				UiBase.PartSlotBGElement[partSlot_Idx].partBTN:addInputEvent( "Mouse_LUp", " dye_New_SelectPart( " .. partIdx .. ", " .. partSlot_Idx .. ", " .. tempUiIdx .. " )" )

				-- 컬러가 입혀져 있으면 나온다.
				local getColorInfo = ToClient_RequestGetUsedPartColor( equipSlotNo, partIdx, partSlot_Idx )
				UiBase.PartSlotBGElement[partSlot_Idx].partBTN:SetColor( getColorInfo )
				local isReset = ToClient_RequestIsResetDyeingPartSlot( equipSlotNo, partIdx, partSlot_Idx )
				if isReset then
					UiBase.PartSlotBGElement[partSlot_Idx].partResetBTN:SetShow( true )
					UiBase.PartSlotBGElement[partSlot_Idx].partResetBTN:addInputEvent( "Mouse_LUp", " dye_New_ResetPartColor( " .. equipSlotNo .. ", " .. partIdx .. ", " .. partSlot_Idx .. ", " .. tempUiIdx .. " )" )
				else
					UiBase.PartSlotBGElement[partSlot_Idx].partResetBTN:SetShow( false )
				end
			end
			tempUiIdx = tempUiIdx + 1
		end
	end

	if -1 == partId then
		return
	end
	-- 같은 slotNo를 쓰는 것을 찾기 위해
	local checkslotCount	= ToClient_RequestGetPartDyeingSlotCount( equipSlotNo, self.selected_characterType )	-- 정보가 없는 것을 필터하기 위해.	--가급적 안쓰는게 좋은데?
	local arraySlotNo		= partSlotno[partId][slotId].slotNo
	local selectedSlotNo	= ToClient_RequestGetPartDyeingSlotNo( equipSlotNo, partId, slotId)

	if -1 == arraySlotNo then
		if 0 == checkslotCount then
			-- _PA_ASSERT(false, "기본 파트 설정이 없다. 데이터 확인 필요함.")
		else
			-- _PA_ASSERT(false, "염색 정보 임시 배열에 저장된 값이 없다0!")
		end
		return
	end

	-- 슬롯 넘버가 같은 것을 체크 해줘야 한다.
	local tempUiIdx = 0
	for partIdx = 0, 7 do
		local partSlot = equipSlotDyeInfo[self.selected_characterType][equipSlotNo][partIdx]
		if nil ~= partSlot then
			local slotCount = ToClient_RequestGetPartDyeingSlotCount( equipSlotNo, partIdx )
			for partSlot_Idx = 0, slotCount - 1 do
				local savedUiIdx	= partSlotno[partIdx][partSlot_Idx].uiIdx
				local savedSlotNo	= partSlotno[partIdx][partSlot_Idx].slotNo
				if -1 == savedSlotNo or -1 == savedUiIdx then
					-- _PA_ASSERT(false, "염색 정보 임시 배열에 저장된 값이 없다1!")
					return
				end
				if selectedSlotNo == savedSlotNo and tempUiIdx == savedUiIdx then
					local UiBase	= self.partSlotUIPoll[tempUiIdx]
					UiBase.PartSlotBGElement[partSlot_Idx].partBTN:SetCheck( true )
				end
			end
			tempUiIdx = tempUiIdx + 1
		end
	end
end
function DyeNew:Update_AmpuleList( nowInterval_Ampule )
	local self = DyeNew
	local ampuleListCount = ToClient_RequestGetColorAmpuleListCount() -- 소유한 염색 수 반환.

	if ampuleListCount <= self.ampouleSlotMaxCount then
		self.scroll:SetShow( false )
	else
		self.scroll:SetShow( true )
	end

	for ampule_Idx = 0, self.ampouleSlotMaxCount - 1 do
		local Slot = self.ampouleSlotUIPoll[ampule_Idx]
		Slot:clearItem() 
		Slot.icon:addInputEvent( "Mouse_LUp",	"" )
		Slot.icon:addInputEvent( "Mouse_On",	"" )
		Slot.icon:addInputEvent( "Mouse_Out",	"" )
	end

	if nil == ampuleListCount or "" == ampuleListCount or 0 == ampuleListCount then
		return
	end

	for ampule_Idx = 0, self.ampouleSlotMaxCount - 1 do
		local dataIdx		= ( nowInterval_Ampule *( self.ampouleSlotMaxCount / ( self.ampouleSlotMaxCount / 7 )) ) + ampule_Idx
		local itemWrapper	= ToClient_RequestGetColorAmpuleItem( dataIdx )
		local Slot			= self.ampouleSlotUIPoll[ampule_Idx]
		Slot		:setItem( itemWrapper )
		Slot.icon	:SetShow( true )
		Slot.icon	:addInputEvent( "Mouse_LUp",	"dye_New_SelectAmpule( " .. dataIdx .. " )" )
		Slot.icon	:addInputEvent( "Mouse_On",		"dye_New_Ampule_ShowToolTip( true, " .. dataIdx .. ", " .. ampule_Idx .. " )" )
		Slot.icon	:addInputEvent( "Mouse_Out",	"dye_New_Ampule_ShowToolTip( false, " .. dataIdx .. ", " .. ampule_Idx .. " )" )

		if dataIdx == ampuleListCount - 1 then
			return
		end
	end
end

function DyeNew:SetPosition()
	self.panelTitle					:SetSize( Panel_Dye_New:GetSizeX(), self.panelTitle:GetSizeY() )
	self.leftBG						:SetPosX( 35 )
	self.leftBG						:SetPosY( 60 )
	self.static_SetOptionBG			:SetPosX( self.leftBG:GetPosX() + ((self.leftBG:GetSizeX()/2) - (self.static_SetOptionBG:GetSizeX()/2) )  )
	self.static_SetOptionBG			:SetPosY( self.leftBG:GetPosY() + self.leftBG:GetSizeY() + 10 )
	self.static_SetOptionBG			:SetSize( Panel_Dye_New:GetSizeX() - 50, self.static_SetOptionBG:GetSizeY() )
	Panel_Dye_New					:SetSize( Panel_Dye_New:GetSizeX(), self.leftBG:GetSizeY() + 165 )
end

function DyeNew:Open()
	-- 변수 초기화
	dye_resetPartSlotNoArray()
	dye_resetEquipDATAArray()

	self.selected_characterType	= 0
	self.selectedEquipSlotNo	= 0	-- !!!
	self.isPartClick			= false
	self.selectedPart.partId	= -1
	self.selectedPart.slotId	= -1
	self.selectedPart.uiIdx		= -1

	local isHairHide = ToClient_getFaceViewHair()
	self.btn_HairHide:SetCheck( isEyeSee )

	self.Slider_Endurance	:SetControlPos(100)
	self.btn_ShowUnderwear	:SetCheck(false)
	self.btn_HideAvatar		:SetCheck(false)

	ToClient_RequestSetTargetType( self.selected_characterType )
	ToClient_RequestPrepareDyeing()			-- 장비에 맞춰 세팅한다. 업데이트보다 나중에 해야 한다.

	self:Update_EquipItem()
	self:Update_Part()

	-- 앰플 리스트를 만들어야 한다.
	dye_New_AmpuleScrollSet()										-- 염료에 대한 스크롤을 세팅한다.
	self.nowInterval_Ampule = 0
	self.scroll:SetControlTop()
	self:Update_AmpuleList( self.nowInterval_Ampule )				-- 인벤에 있는 염료를 가져온다.

	self:UpdatePosition()
	Panel_Dye_New:SetShow( true )
	audioPostEvent_SystemUi(01,23)
end

function DyeNew:Close()
	audioPostEvent_SystemUi(01,23)
	FGlobal_MovieGuide_Reposition()
	Panel_Dye_New:SetShow( false )
end

function DyeNew:IsShow()
	return Panel_Dye_New:IsShow()
end



--------------------------------------------------------------------------------
-- 내부 함수
--------------------------------------------------------------------------------
function _dye_ReplaceEquipBGIcon( characterType )
	local self = DyeNew
	for equipSlot_Idx = 0, 13 do
		local UiBase = self.equipSlotUIPoll[equipSlot_Idx]
		UiBase.SlotIcon:ChangeTextureInfoName("")
	end

	-- local maxEquipSlotCount = 7
	-- if 0 == self.selected_characterType then
	-- 	maxEquipSlotCount = 14
	-- end

	-- for equipSlot_Idx = 0, maxEquipSlotCount - 1 do
	local slotIdx = 0
	for idx,equipSlotIdx in pairs(equipSlotNo[self.selected_characterType]) do
		local UiBase = self.equipSlotUIPoll[slotIdx]
		__dye_ReplaceEquipBGIcon( UiBase.SlotIcon, self.selected_characterType, equipSlotIdx  )
		slotIdx = slotIdx + 1
	end
end
function __dye_ReplaceEquipBGIcon( control, characterType, equipSlotIdx )
	if 0 == characterType then
		control:ChangeTextureInfoName ( "New_UI_Common_forLua/Window/Dye/Dye_New_00.dds" )
	elseif 1 == characterType then
		control:ChangeTextureInfoName ( "New_UI_Common_forLua/Window/Dye/Dye_New_01.dds" )
	end

	local x1, y1, x2, y2 = setTextureUV_Func( control, equipSlotIcon[characterType][equipSlotIdx][1], equipSlotIcon[characterType][equipSlotIdx][2], equipSlotIcon[characterType][equipSlotIdx][3], equipSlotIcon[characterType][equipSlotIdx][4] )
	control:getBaseTexture():setUV(  x1, y1, x2, y2  )
	control:setRenderTexture(control:getBaseTexture())
end

function dye_New_UpdateEquipSlot( equipSlotNo, itemWrapper, UiIdx )	-- 장비 슬롯을 세팅.
	local self		= DyeNew
	local UiBase	= self.equipSlotUIPoll[UiIdx]
	if nil ~= itemWrapper and itemWrapper:isDyeable() then
		UiBase.SlotItem:setItem( itemWrapper )
		UiBase.SlotItem.icon:addInputEvent( "Mouse_LUp",	"dye_New_SelectEquipItem( " .. equipSlotNo .. " )" )
		UiBase.SlotItem.icon:addInputEvent( "Mouse_RUp",	"dye_New_ClearEquipItem( " .. equipSlotNo .. " ) " )
		UiBase.SlotItem.icon:addInputEvent( "Mouse_On",		"dye_New_Equip_ShowToolTip( true, " .. equipSlotNo .. ", " .. UiIdx .. " )" )
		UiBase.SlotItem.icon:addInputEvent( "Mouse_Out",	"dye_New_Equip_ShowToolTip( false, " .. equipSlotNo .. ", " .. UiIdx .. " )" )
	else
		UiBase.SlotItem:clearItem()
		UiBase.SlotItem.icon:addInputEvent( "Mouse_LUp",	"" )
		UiBase.SlotItem.icon:addInputEvent( "Mouse_RUp",	"" )
		UiBase.SlotItem.icon:addInputEvent( "Mouse_On",		"" )
		UiBase.SlotItem.icon:addInputEvent( "Mouse_Out",	"" )
	end
end
function dye_resetPartSlotNoArray()
	partSlotno = {
		[0] = { [0] = { slotNo = -1, uiIdx = -1}, { slotNo = -1, uiIdx = -1}, { slotNo = -1, uiIdx = -1} },
		{ [0] = { slotNo = -1, uiIdx = -1}, { slotNo = -1, uiIdx = -1}, { slotNo = -1, uiIdx = -1} },
		{ [0] = { slotNo = -1, uiIdx = -1}, { slotNo = -1, uiIdx = -1}, { slotNo = -1, uiIdx = -1} },
		{ [0] = { slotNo = -1, uiIdx = -1}, { slotNo = -1, uiIdx = -1}, { slotNo = -1, uiIdx = -1} },
		{ [0] = { slotNo = -1, uiIdx = -1}, { slotNo = -1, uiIdx = -1}, { slotNo = -1, uiIdx = -1} },
		{ [0] = { slotNo = -1, uiIdx = -1}, { slotNo = -1, uiIdx = -1}, { slotNo = -1, uiIdx = -1} },
		{ [0] = { slotNo = -1, uiIdx = -1}, { slotNo = -1, uiIdx = -1}, { slotNo = -1, uiIdx = -1} },
		{ [0] = { slotNo = -1, uiIdx = -1}, { slotNo = -1, uiIdx = -1}, { slotNo = -1, uiIdx = -1} },
	}
end
function dye_resetEquipDATAArray()
	equipSlotDyeInfo = {
	[0] = {
		[0]		= {},
		[1]		= {},
		[3]		= {},
		[4]		= {},
		[5]		= {},
		[6]		= {},
		[7]		= {},
		
		[18]	= {},
		[19]	= {},
		[14]	= {},
		[15]	= {},
		[16]	= {},
		[17]	= {},
		[20]	= {},
		[21]	= {},
		[22]	= {},
		[23]	= {},
	},
	{
		[3] = {},	-- 마갑
		[4] = {},	-- 등자
		[5] = {},	-- 안장
		[6] = {},	-- 마면
		[12] = {},	-- 편자.
		[0] = {},	-- 사용안함.
		[1] = {},	-- 사용안함.

		[14] = {},	-- 마갑
		[15] = {},	-- 등자
		[16] = {},	-- 안장
		[17] = {},	-- 마면
		[18] = {},	-- 사용안함.
		[19] = {},	-- 사용안함.
		[20] = {},	-- 사용안함.
	}
}
end
function dye_New_Equip_ShowToolTip( isShow, equipSlotNo, UiIdx )
	local self			= DyeNew
	if true == isShow then
		local itemWrapper	= ToClient_RequestGetDyeingTargetItemWrapper( equipSlotNo )
		local SlotIcon		= self.equipSlotUIPoll[UiIdx].SlotItem.icon
		Panel_Tooltip_Item_Show( itemWrapper, SlotIcon, false, true )
	else
		Panel_Tooltip_Item_hideTooltip()
	end
end

function FromClient_NotifySelectedEquipSlotNo( equipSlotNo )
	dye_New_SelectEquipItem( equipSlotNo )
end


function dye_New_SelectEquipItem( equipSlotNos )
	local self			= DyeNew
	self.selectedEquipSlotNo = equipSlotNos
	self.isPartClick			= false
	self.selectedPart.partId	= 0
	self.selectedPart.slotId	= 0
	self.selectedPart.uiIdx		= 0
	self.isSelectedEquipSlot	= true

	self:Update_EquipItem()
	
	if 20 == equipSlotNos then
		self.btn_ShowUnderwear:SetCheck( true )
	else
		self.btn_ShowUnderwear:SetCheck( false )
	end
	
	if Dye_New_IsAvatar( equipSlotNos ) then
		self.btn_HideAvatar:SetCheck( false )
		self.isHideAvatar = false
	else
		self.btn_HideAvatar:SetCheck( true )
		self.isHideAvatar = true
	end
	
	ToClient_RequestSelectedEquipItem( equipSlotNos )
	dye_New_SelectPart(0, 0, 0)
	-- 속옷 여부를 알리는 함수를 넣어야 한다.
end

function dye_New_ClearEquipItem( equipSlotNo )
	Panel_Tooltip_Item_hideTooltip()
	ToClient_RequestClearDyeingTargetSlot( equipSlotNo )
end

function Dye_New_IsAvatar( equipSlotNo )
	local self = DyeNew
	if 0 == self.selected_characterType then
		if 14 == equipSlotNo or 15 == equipSlotNo or 16 == equipSlotNo or 17 == equipSlotNo or 18 == equipSlotNo or 19 == equipSlotNo then
			return true
		end
	elseif 1 == self.selected_characterType then
		if 14 == equipSlotNo or 15 == equipSlotNo or 16 == equipSlotNo or 17 == equipSlotNo then
			return true
		end
	end
	
	return false
end

function Dye_New_IsNormal( equipSlotNo )
	local self = DyeNew
	if 0 == self.selected_characterType then
		if 0 == equipSlotNo or 1 == equipSlotNo or 3 == equipSlotNo or 4 == equipSlotNo or 5 == equipSlotNo or 6 == equipSlotNo then
			return true
		end
	elseif 1 == self.selected_characterType then
		if 3 == equipSlotNo or 4 == equipSlotNo or 5 == equipSlotNo or 6 == equipSlotNo or 12 == equipSlotNo then
			return true
		end
	end
	
	return false
end

function FGlobal_Panel_DyeNew_InventoryFilter( InvenSlotNo, itemWrapper )
	local self = DyeNew

	if nil == itemWrapper then
		return true
	end
	
	local isServantUseable = itemWrapper:getStaticStatus():isUsableServant()
	if 0 == self.selected_characterType and isServantUseable then
		return true
	elseif 1 == self.selected_characterType and not isServantUseable then
		return true
	end

	local equipSlotNo = itemWrapper:getStaticStatus():getEquipSlotNo()
	if Dye_New_IsDyeableEquipment( equipSlotNo ) then
		return false
	end
	
	return true
end

function Dye_New_IsDyeableEquipment( equipSlotNo )
	local self = DyeNew
	if Dye_New_IsAvatar( equipSlotNo ) then -- 아바타 장비
		return true
	elseif Dye_New_IsNormal( equipSlotNo ) then -- 일반 장비
		return true
	elseif 20 == equipSlotNo and ( 0 == self.selected_characterType )  then -- 속옷, 사람만
		return true
	elseif (21 == equipSlotNo or 22 == equipSlotNo or 23 == equipSlotNo ) and ( 0 == self.selected_characterType ) then -- 얼굴 장착 슬롯, 사람만,
		return true
	end
	
	return false
end

function FGlobal_Panel_DyeNew_Interaction_FromInventory( invenSlotNo )
	ToClient_RequestSetDyeTargetSlotByInventorySlotNo( Inventory_GetCurrentInventoryType(), invenSlotNo )
end

function dye_New_SelectPart( partId, slotId, uiIdx )
	local self					= DyeNew
	self.isPartClick			= true
	self.selectedPart.partId	= partId
	self.selectedPart.slotId	= slotId
	self.selectedPart.uiIdx		= uiIdx
	
	ToClient_RequestSelectedDyeingPartSlot(self.selectedEquipSlotNo, partId, slotId)
	self:Update_Part()
end
function dye_New_ResetPartColor( equipSlotNo, partId, slotId, uiIdx )
	local self 				= DyeNew
	
	local UiBase = self.partSlotUIPoll[uiIdx]
	local resetBtn = UiBase.PartSlotBGElement[slotId].partBTN
	--resetBtn:setRenderTexture( resetBtn:getBaseTexture() )
	
	ToClient_RequestClearUsedColorAmpule( equipSlotNo, partId, slotId )
	self:Update_Part()
end

function dye_New_AmpuleScrollSet()	-- 염색 스크롤 세팅
	local self				= DyeNew
	local ampuleListCount	= ToClient_RequestGetColorAmpuleListCount() -- 소유한 염색 수 반환.
	local viewLineCount		= self.ampouleSlotMaxCount / 7
	local colsCount			= 7
	local totalLineCount	= math.ceil( ampuleListCount / colsCount )

	self.maxInterval_Ampule = (totalLineCount - viewLineCount)
	
	if self.maxInterval_Ampule < 0 then
		self.maxInterval_Ampule = 0
	end

	-- 버튼 사이즈
	local pagePercent		= ( viewLineCount / totalLineCount ) * 100
	local scrollSizeY		= self.scroll:GetSizeY()
	local btn_scrollSizeY	= ( ( scrollSizeY / 100 ) * pagePercent ) * 0.9

	if btn_scrollSizeY < 20 then
		btn_scrollSizeY = 20
	end

	if scrollSizeY - 5 < btn_scrollSizeY then
		btn_scrollSizeY = scrollSizeY - 5
	end

	self.scrollCTRLBTN:SetSize( self.scrollCTRLBTN:GetSizeX(), btn_scrollSizeY )
	-- 인터벌을 만든다.
	self.scroll:SetInterval( self.maxInterval_Ampule )
end
function dye_New_SelectAmpule( ampuleIdx )
	local self = DyeNew
	self.selectedAmpouleIdx	= ampuleIdx

	for ampouleSlot_Idx = 0, self.ampouleSlotMaxCount - 1 do
		local UiBase = self.ampouleSlotBGUIPoll[ampouleSlot_Idx]
		UiBase.SlotSelectBG:SetShow( false )
		if ampuleIdx == ampouleSlot_Idx then
			UiBase.SlotSelectBG:SetShow( true )
		end
	end

	ToClient_RequestSelectedColorAmpule( self.selectedEquipSlotNo, self.selectedAmpouleIdx, self.selectedPart.partId, self.selectedPart.slotId  )
	self:Update_Part()

	Panel_Tooltip_Item_hideTooltip()
end
function dye_New_Ampule_ScrollUpdate( isDown )
	local self	= DyeNew
	local max	= self.maxInterval_Ampule
	local now	= self.nowInterval_Ampule
	if true == isDown then
		-- 아래로 굴린다.
		if now < max then
			now			= now + 1
			self.scroll:ControlButtonDown()
			self:Update_AmpuleList( now )
		else
			return
		end
	else
		-- 위로 굴린다.
		if 0 < now then
			now			= now - 1
			self.scroll:ControlButtonUp()
			self:Update_AmpuleList( now )
		else
			return
		end
	end
	
	self.nowInterval_Ampule = now
end

function dye_New_Ampule_ShowToolTip( isShow, dataIdx, ampule_Idx )
	local self = DyeNew
	if true == isShow then
		local itemWrapper	= ToClient_RequestGetColorAmpuleItem( dataIdx )
		local SlotIcon		= self.ampouleSlotUIPoll[ampule_Idx].icon

		Panel_Tooltip_Item_Show( itemWrapper, SlotIcon, false, true )
	else
		Panel_Tooltip_Item_hideTooltip()
	end
end



function dye_setposition()
	DyeNew:UpdatePosition()
	DyeNew:SetPosition()
end

--------------------------------------------------------------------------------
-- 클릭 함수
--------------------------------------------------------------------------------
function HandleClicked_DeyNew_SelectCharacterType( idx )
	local self = DyeNew
	if 1 < idx then
		return
	end
	
	local bChangeSelectedCharacterType = ToClient_RequestSetTargetType( idx )
	if bChangeSelectedCharacterType then
		self.selected_characterType = idx
		
		if 0 == idx then
			self.selectedEquipSlotNo = 0
		elseif 1 == idx then
			self.selectedEquipSlotNo = 3
		end	
		
		Inventory_SetFunctor( FGlobal_Panel_DyeNew_InventoryFilter, FGlobal_Panel_DyeNew_Interaction_FromInventory, nil, nil )

		FromClient_updateDyeingTargetList()

		self:Update_EquipItem()
		self:Update_Part()

		-- 앰플 리스트를 만들어야 한다.
		dye_New_AmpuleScrollSet()										-- 염료에 대한 스크롤을 세팅한다.
		self.nowInterval_Ampule = 0
		self.scroll:SetControlTop()
		self:Update_AmpuleList( self.nowInterval_Ampule )				-- 인벤에 있는 염료를 가져온다.

		self:UpdatePosition()
	else
		self.targetCharacter[self.selected_characterType]:SetCheck( true )
		self.targetCharacter[idx]:SetCheck( false )
	end

	-- 포즈, 바라보기, 내구도, 속옷, 올림 머리 활성화
	_deyNew_AddonButtonSet_ByCharacterType( idx )

	self.btn_HideAvatar:SetCheck( false )	-- 꼬이지 않게! 초기화
	self.isHideAvatar = false	-- 꼬이지 않게! 초기화
	self.isSelectedEquipSlot = false
end

function _deyNew_AddonButtonSet_ByCharacterType( idx )
	-- 포즈, 바라보기, 내구도, 속옷, 올림 머리 활성화
	local self = DyeNew
	local setControl = function( set )
		self.btn_ShowUnderwear:SetEnable( set )
		self.btn_ShowUnderwear:SetMonoTone( not set )
		-- self.btn_HideAvatar:SetEnable( set )
		-- self.btn_HideAvatar:SetMonoTone( not set )
		self.btn_HairHide:SetEnable( set )
		self.btn_HairHide:SetMonoTone( not set )
		self.Slider_Endurance:SetEnable( set )
		self.Slider_Endurance:SetMonoTone( not set )
		self.Endurance_SliderCtrlBTN:SetEnable( set )
		self.Endurance_SliderCtrlBTN:SetMonoTone( not set )
	end
	if 0 == idx then
		setControl( true )
		FGlobal_DeyNew_CharacterController_AddonButtonSet_ByCharacterType( true )
	elseif 1 == idx then
		setControl( false )
		FGlobal_DeyNew_CharacterController_AddonButtonSet_ByCharacterType( false )
	end
end

function HandleClicked_DeyNew_DoDye()
	local self = DyeNew
	if -1 == self.selectedAmpouleIdx then
		Proc_ShowMessage_Ack("염색약을 먼저 선택해야 합니다.")
		return
	end

	ToClient_RequestDye()
	FGlobal_Panel_DyeNew_Hide()
end

function HandleClicked_DeyNew_SetCharacterRotate_BTN( isRight )
	if true == isRight then
		ToClient_RequestUpdateDyeVaryRotation( 0.1 , 0 )
	else
		ToClient_RequestUpdateDyeVaryRotation( -0.1 , 0 )
	end
end

function HandleClicked_dyeNew_SetFaceViewHair()
	local self = DyeNew
	ToClient_setFaceViewHair( self.btn_HairHide:IsCheck() )
end

function HandleClicked_DeyNew_SetShowUI()
	local self = DyeNew
	if Panel_Dye_New:GetShow() then
		Panel_Dye_New:SetShow( false )
		Panel_Window_Inventory:SetShow( false )
	else
		Panel_Dye_New:SetShow( true )
		Panel_Window_Inventory:SetShow( true )
	end
end

function HandleClicked_DeyNew_SetEndurance()
	local self		= DyeNew
	local index		= self.Slider_Endurance:GetSelectIndex()
	ToClient_RequestChangeEndurance(index)
end
function HandleClicked_DeyNew_SetShowUnderwear()
	local self		= DyeNew
	self.isShowUnderwear = not self.isShowUnderwear
	ToClient_RequestToggleShowUnderwear()
	-- 속옷을 보이게 한다.
end
function HandleClicked_DyeNew_SetHideAvatar()
	local self		= DyeNew
	self.isHideAvatar = not self.isHideAvatar
	ToClient_RequestToggleHideAvatar()

	-- 초기화
	if 0 == self.selected_characterType then
		if false == self.isHideAvatar then
			self.selectedEquipSlotNo	= 18
		else
			self.selectedEquipSlotNo	= 0
		end
	elseif 1 == self.selected_characterType then
		if false == self.isHideAvatar then
			self.selectedEquipSlotNo	= 14
		else
			self.selectedEquipSlotNo	= 3
		end
	end

	self.isPartClick			= false
	self.selectedPart.partId	= -1
	self.selectedPart.slotId	= -1
	self.selectedPart.uiIdx		= -1
	self.nowInterval_Ampule		= 0
	
	self:Update_EquipItem()
	self:Update_Part()
	dye_New_AmpuleScrollSet()										-- 염료에 대한 스크롤을 세팅한다.
	
	self.scroll:SetControlTop()
	self:Update_AmpuleList( self.nowInterval_Ampule )				-- 인벤에 있는 염료를 가져온다.
	self:UpdatePosition()
end
function HandleClicked_DeyNew_PressAmpuleScroll()
	local self		= DyeNew

	local posByIndex		= 1 / self.maxInterval_Ampule
	local currentIndex		= math.floor( self.scroll:GetControlPos() / posByIndex )

	self:Update_AmpuleList( currentIndex )
end


local isInventoryOpen = false
--------------------------------------------------------------------------------
-- 외부 함수
--------------------------------------------------------------------------------
function FGlobal_Panel_DyeNew_Show()
	if( isFlushedUI() ) then
		return
	end
	local isShow = ToClient_DyeingManagerIsShow()
	if ( true == isShow ) then
		return
	end

	local isShowable = ToClient_DyeingManagerIsShowable()
	if ( false == isShowable ) then
		return
	end
	
    if not IsSelfPlayerWaitAction() then
        Proc_ShowMessage_Ack( PAGetString(Defines.StringSheet_GAME, "LUA_CURRENTACTION_NOT_DYE") )
        return
    end

	isInventoryOpen = Panel_Window_Inventory:IsShow()
	SetUIMode(Defines.UIMode.eUIMode_DyeNew)
	UI.flushAndClearUI()

	-- UI Show 처리 추가하시면 되요.
	DyeNew:Open()
	ToClient_DyeingManagerShow()
	FGlobal_DyeNew_CharacterController_Open()
	
	Inventory_SetFunctor( FGlobal_Panel_DyeNew_InventoryFilter, FGlobal_Panel_DyeNew_Interaction_FromInventory, nil, nil )
	InventoryWindow_Show()
		
	return true
end
function FGlobal_Panel_DyeNew_Hide()
	local isShow = ToClient_DyeingManagerHide()
	if ( false == isShow ) then
		return
	end

	if false == Panel_Dye_New:GetShow() and false == Panel_DyeNew_CharacterController:GetShow() then
		return
	end
	
	if false == isInventoryOpen then
		InventoryWindow_Close()
	else
		Inventory_SetFunctor( nil, nil, nil, nil )
	end
	
	isInventoryOpen = false
	
	SetUIMode(Defines.UIMode.eUIMode_Default)
	UI.restoreFlushedUI()

	-- UI Hide 처리 추가하시면 되요.
	ToClient_DyeingManagerHide()
	FGlobal_DyeNew_CharacterController_Close()
	DyeNew:Close()
	return true
end

function FGlobal_Panel_DyeNew_Reset_SetFunctor()
	Inventory_SetFunctor( FGlobal_Panel_DyeNew_InventoryFilter, FGlobal_Panel_DyeNew_Interaction_FromInventory, nil, nil )
end
function FGlobal_Panel_DyeNew_updateColorAmpuleList()
	local self = DyeNew
	self:Update_AmpuleList( self.nowInterval_Ampule )
end
--------------------------------------------------------------------------------
--------------------------------------------------------------------------------
function FromClient_updateDyeingTargetList()
	local self = DyeNew
	local tempSlotIdx = 0
	
	dye_resetEquipDATAArray()
	local haveNormalEquip	= nil
	local haveAvartarEquip	= nil
	for idx, equipSlotNo in pairs(equipSlotNo[self.selected_characterType]) do
		-- 초기화
		local UiBase = self.equipSlotUIPoll[tempSlotIdx]
		-- UiBase.SlotItem:clearItem()

		local itemWrapper	= ToClient_RequestGetDyeingTargetItemWrapper( equipSlotNo )
		local isDyeAble 	= false

		if nil ~= itemWrapper then
			isDyeAble = itemWrapper:isDyeable()
		end

		dye_New_UpdateEquipSlot( equipSlotNo, itemWrapper, tempSlotIdx )
		if nil ~= itemWrapper and isDyeAble then
			UiBase.SlotIcon:SetShow( false )
			-- 여기에서 선택 기본 값을 구한다.
			haveNormalEquip, haveAvartarEquip = _haveFirstEquipNo( haveNormalEquip, haveAvartarEquip, equipSlotNo )

			for partIdx = 0, 7 do
				local isPart = ToClient_RequestIsPart(equipSlotNo, partIdx)
				if true == isPart then
					local partSlotCount = ToClient_RequestGetPartDyeingSlotCount( equipSlotNo, partIdx )
					equipSlotDyeInfo[self.selected_characterType][equipSlotNo][partIdx] = {}
					equipSlotDyeInfo[self.selected_characterType][equipSlotNo][partIdx].partSlotCount	= partSlotCount
					for partSlotIdx = 0, partSlotCount - 1 do
						local partSlotNo = ToClient_RequestGetPartDyeingSlotNo( equipSlotNo, partIdx, partSlotIdx)
						equipSlotDyeInfo[self.selected_characterType][equipSlotNo][partIdx][partSlotIdx]	= partSlotNo
					end
				end
			end
		elseif nil == itemWrapper then
			UiBase.SlotIcon:SetShow( true )
		else	-- nil이 아닌데, 염색을 할 수 없는 아이템.
			UiBase.SlotIcon:SetShow( true )
		end
		tempSlotIdx = tempSlotIdx + 1
	end

	if false == self.isSelectedEquipSlot then
		if (nil ~= haveNormalEquip and nil ~= haveAvartarEquip) or (nil == haveNormalEquip and nil ~= haveAvartarEquip) then
			self.selectedEquipSlotNo = haveAvartarEquip
		elseif nil == haveAvartarEquip or ( nil == haveNormalEquip and nil == haveAvartarEquip )then
			if 0 == self.selected_characterType then
				self.selectedEquipSlotNo = 0
			elseif 1 == self.selected_characterType then
				self.selectedEquipSlotNo = 3
			end
		else
			self.selectedEquipSlotNo = haveNormalEquip
		end
	end
	self:ResetPartArray()
	self:Update_Part()	-- 이건 맞는거 같은데;;
end

function _haveFirstEquipNo( haveNormalEquip, haveAvartarEquip, equipSlotNo )	-- 착용중인 장비를 판별하여 첫 번째를 구하는데 쓰임.
	local self = DyeNew
	if 0 == self.selected_characterType then
		if equipSlotNo <= 7 then
			if nil == haveNormalEquip then
				haveNormalEquip = equipSlotNo
			end
		elseif 7 < equipSlotNo and equipSlotNo < 20 then
			if nil == haveAvartarEquip then
				haveAvartarEquip = equipSlotNo
			end
		end
	elseif 1 == self.selected_characterType then
		if equipSlotNo <= 12 then
			if nil == haveNormalEquip then
				haveNormalEquip = equipSlotNo
			end
		else
			if nil == haveAvartarEquip then
				haveAvartarEquip = equipSlotNo
			end
		end
	end
	return	haveNormalEquip, haveAvartarEquip
end

function FromClient_updateColorAmpuleList()
	local self = DyeNew
	self:Update_AmpuleList( self.nowInterval_Ampule )
end
function FromClient_updateDyeingPartList()
	-- body
end
function FromClient_setTotalPage()
	-- body
end

function FromClient_Dyeing_AddDamage()
	FGlobal_Panel_DyeNew_Hide()
end


function DyeNew:registEventHandler()
	self.btn_Dodye					:addInputEvent("Mouse_LUp",			"HandleClicked_DeyNew_DoDye()")
	self.Slider_Endurance			:addInputEvent("Mouse_LUp",			"HandleClicked_DeyNew_SetEndurance()")
	self.Endurance_SliderCtrlBTN	:addInputEvent("Mouse_LPress",		"HandleClicked_DeyNew_SetEndurance()")
	self.btn_HairHide				:addInputEvent("Mouse_LUp",			"HandleClicked_dyeNew_SetFaceViewHair()")
	self.btn_ShowUnderwear			:addInputEvent("Mouse_LUp",			"HandleClicked_DeyNew_SetShowUnderwear()")
	self.btn_HideAvatar				:addInputEvent("Mouse_LUp",			"HandleClicked_DyeNew_SetHideAvatar()")
	self.scrollCTRLBTN				:addInputEvent("Mouse_LPress",		"HandleClicked_DeyNew_PressAmpuleScroll()")
	self.scroll						:addInputEvent("Mouse_LUp",			"HandleClicked_DeyNew_PressAmpuleScroll()")
end
function DyeNew:registMessageHandler()
	registerEvent("FromClient_updateDyeingTargetList",		"FromClient_updateDyeingTargetList")	-- 열 때, 장비를 리턴한다.
	registerEvent("FromClient_updateColorAmpuleList",		"FromClient_updateColorAmpuleList")		-- 염료 리스트 리턴.
	registerEvent("FromClient_updateDyeingPartList",		"FromClient_updateDyeingPartList")		-- 장비 부위 리턴.
	registerEvent("onScreenResize",							"dye_setposition")
	-- registerEvent("addDamage",								"FromClient_Dyeing_AddDamage")			-- 대미지를 받으면 염색창 꺼주자
	--registerEvent("FromClient_NotifySelectedEquipSlotNo",	"FromClient_NotifySelectedEquipSlotNo")			-- 인벤에서 
end


DyeNew:Initialize()
DyeNew:registEventHandler()
DyeNew:registMessageHandler()

-- ToClient_DyeingManagerShow			
-- ToClient_DyeingManagerHide			
-- ToClient_DyeingManagerIsShow		
-- ToClient_DyeingManagerIsShowable	
-- ToClient_RequestUpdateDyeVaryRotation			
-- ToClient_RequestUpdateDyeVaryZoom				
-- ToClient_RequestUpdateDyeVaryCameraPosition		
-- ToClient_RequestUpdateDyeSetEnableLight			
-- ToClient_RequestUpdateDyeGetEnableLight			
-- ToClient_RequestUpdateDyeSetCustomWeather		
-- ToClient_RequestUpdateDyeGetCustomWeatherTable	
-- ToClient_RequestUpdateDyeGetCustomWeatherTime


-- local isSuccessShow = ToClient_DyeingManagerShow()
-- local isSuccessHide = ToClient_DyeingManagerHide()
-- local isShow = ToClient_DyeingManagerIsShow()
-- local isShowable = ToClient_DyeingManagerIsShowable()
-- ToClient_RequestUpdateDyeVaryRotation( 0.3 )
-- ToClient_RequestUpdateDyeVaryZoom( 100 ~ 700 )
-- ToClient_RequestUpdateDyeVaryCameraPosition( x축, y 축 )
-- ToClient_RequestUpdateDyeVaryRotation( yaw , pitch )
-- ToClient_RequestUpdateDyeSetEnableLight( true or false )
-- local isEnableLight = ToClient_RequestUpdateDyeGetEnableLight()
-- ToClient_RequestUpdateDyeSetCustomWeather( weatherTable, weatherTime )
-- local weatherTable = ToClient_RequestUpdateDyeGetCustomWeatherTable()
-- local weatherTime = ToClient_RequestUpdateDyeGetCustomWeatherTime()



-- ToClient_RequestIsPart(equipSlotNo, partIndex)	-- upperbody 에서 돈다. 무조건. 파트 여부 리턴.
-- ePCI_lowerbody = 0,		-- partIndex
-- 	ePCI_shoulder,			-- 1
-- 	ePCI_hand,				-- 2
-- 	ePCI_foot,				-- 3
-- 	ePCI_helmet,			-- 4
-- 	ePCI_cloak,				-- 5
-- 	ePCI_underwear,			-- 6
-- 	ePCI_count				-- 7

-- ToClient_RequestGetPartDyeingSlotCount( equipSlotNo, partIndex)			-- 파트 슬롯 카운트.
-- ToClient_RequestGetPartDyeingSlotNo( equipSlotNo, partIndex, slotIndex) -- 슬롯 넘버 가져 옴.
-- ToClient_RequestSetDyeTargetSlotByInventorySlotNo(invenType, slotNo)