local UI_TM = CppEnums.TextMode

Panel_FirstLogin:SetShow( false )
Panel_FirstLogin:setGlassBackground(true)
Panel_FirstLogin:RegisterShowEventFunc( true, 'Panel_FirstLogin_ShowAni()' )
Panel_FirstLogin:RegisterShowEventFunc( false, 'Panel_FirstLogin_HideAni()' )

function Panel_FirstLogin_ShowAni()
	-- body
end
function Panel_FirstLogin_HideAni()
	-- body
end

local FirstLogin = {
	blockBG							= UI.getChildControl ( Panel_FirstLogin, "Static_blockBG" ),
	BTN_Next						= UI.getChildControl ( Panel_FirstLogin, "Button_Next" ),

	RecommendBG_Low					= UI.getChildControl ( Panel_FirstLogin, "Static_RecommendBG_Low" ),
	RecommendBG_Normal				= UI.getChildControl ( Panel_FirstLogin, "Static_RecommendBG_Normal" ),
	RecommendBG_High				= UI.getChildControl ( Panel_FirstLogin, "Static_RecommendBG_High" ),

	Slider_Control					= UI.getChildControl ( Panel_FirstLogin, "Slider_Control" ),
	Slider_0						= UI.getChildControl ( Panel_FirstLogin, "StaticText_Slider_0" ),
	Slider_50						= UI.getChildControl ( Panel_FirstLogin, "StaticText_Slider_50" ),
	Slider_100						= UI.getChildControl ( Panel_FirstLogin, "StaticText_Slider_100" ),
	Slider_DescBG					= UI.getChildControl ( Panel_FirstLogin, "Static_ContentBG" ),
	Slider_Desc						= UI.getChildControl ( Panel_FirstLogin, "StaticText_ContentDesc" ),
	
	Text_Title						= UI.getChildControl ( Panel_FirstLogin, "StaticText_ContentTitle" ),
	RadioBTN_AllRound				= UI.getChildControl ( Panel_FirstLogin, "RadioButton_Taste_AllRound" ),
	RadioBTN_Combat					= UI.getChildControl ( Panel_FirstLogin, "RadioButton_Taste_Combat" ),
	RadioBTN_Product				= UI.getChildControl ( Panel_FirstLogin, "RadioButton_Taste_Product" ),
	RadioBTN_Fishing				= UI.getChildControl ( Panel_FirstLogin, "RadioButton_Taste_Fishing" ),
	Text_RadioBTN_Title				= UI.getChildControl ( Panel_FirstLogin, "StaticText_Taste_All_Title" ),
	Text_RadioBTN_Desc				= UI.getChildControl ( Panel_FirstLogin, "StaticText_Taste_All_Desc" ),

	Step1							= false,
	Step2							= false,
	Step3							= false,
	characterSelect					= nil,

}
	FirstLogin.Slider_ControlBTN	= UI.getChildControl ( FirstLogin.Slider_Control, "Slider_Button" )
	FirstLogin._buttonQuestion		= UI.getChildControl ( Panel_FirstLogin, "Button_Question" )		-- 물음표 버튼
	FirstLogin._buttonQuestion		: SetShow( false )

function FirstLogin:initialize()
	self.BTN_Next				:SetShow( false )

	self.Text_Title				:SetShow( false )
	self.Slider_Desc			:SetShow( false )

	self.Slider_Control			:SetShow( false )
	self.Slider_0				:SetShow( false )
	self.Slider_50				:SetShow( false )
	self.Slider_100				:SetShow( false )
	self.Slider_DescBG			:SetShow( false )

	self.RecommendBG_Low		:SetShow( false )
	self.RecommendBG_Normal		:SetShow( false )
	self.RecommendBG_High		:SetShow( false )

	self.RadioBTN_AllRound		:SetShow( false )
	self.RadioBTN_Combat		:SetShow( false )
	self.RadioBTN_Product		:SetShow( false )
	self.RadioBTN_Fishing		:SetShow( false )
	self.Text_RadioBTN_Title	:SetShow( false )
	self.Text_RadioBTN_Desc		:SetShow( false )

	self.Text_RadioBTN_Desc		:SetTextMode( UI_TM.eTextMode_AutoWrap )
	self.Slider_Desc			:SetTextMode( UI_TM.eTextMode_AutoWrap )
end

function FirstLogin:SetStep1()
	self.blockBG:SetSize( getScreenSizeX(), getScreenSizeY() )
	self.blockBG:ComputePos()

	self.Step1	= true
	self.Step2	= false
	self.Step3	= false

	self.Text_Title	:SetText( PAGetString(Defines.StringSheet_GAME, "LUA_FIRSTLOGIN_STEPTITLE1") ) -- "[Step 1/2] 화면 떨림 효과를 설정합니다."
	self.Slider_Desc:SetText( PAGetString(Defines.StringSheet_GAME, "LUA_FIRSTLOGIN_STEPDESC1") ) -- - 전투시 타격감을 조절합니다.\n- 다양한 상황에서 타격 및 피격 효과를 극대화 합니다.\n(효과가 너무 과하면 어지러움 및 눈에 피로를 줄 수 있습니다.)
	self.Slider_Control			:SetControlPos(50)

	self.BTN_Next				:SetShow( true )

	self.Text_Title				:SetShow( true )
	self.Slider_Desc			:SetShow( true )

	self.Slider_Control			:SetShow( true )
	self.Slider_0				:SetShow( true )
	self.Slider_50				:SetShow( true )
	self.Slider_100				:SetShow( true )
	self.Slider_DescBG			:SetShow( true )

	self.RecommendBG_Low		:SetShow( true )
	self.RecommendBG_Normal		:SetShow( true )
	self.RecommendBG_High		:SetShow( true )

	self.RadioBTN_AllRound		:SetShow( false )
	self.RadioBTN_Combat		:SetShow( false )
	self.RadioBTN_Product		:SetShow( false )
	self.RadioBTN_Fishing		:SetShow( false )
	self.Text_RadioBTN_Title	:SetShow( false )
	self.Text_RadioBTN_Desc		:SetShow( false )
end
function FirstLogin:SetStep2()
	self.Step1	= false
	self.Step2	= true
	self.Step3	= false

	self.Text_Title	:SetText( PAGetString(Defines.StringSheet_GAME, "LUA_FIRSTLOGIN_STEPTITLE2") ) -- "[Step 2/2] 카메라 잔상 효과를 설정합니다."
	self.Slider_Desc:SetText( PAGetString(Defines.StringSheet_GAME, "LUA_FIRSTLOGIN_STEPDESC2") ) -- "- 화면 이동시 부드러운 시선 이동효과를 줍니다.\n- 캐릭터의 기술 및 연출 효과를 극대화 합니다.\n(효과가 너무 과하면 어지러움 및 눈에 피로를 줄 수 있습니다.)"
	self.BTN_Next				:SetText( PAGetString(Defines.StringSheet_GAME, "LUA_FIRSTLOGIN_CONFIRM") ) -- "완료"
	self.Slider_Control			:SetControlPos(50)

	self.BTN_Next				:SetShow( true )

	self.Text_Title				:SetShow( true )
	self.Slider_Desc			:SetShow( true )

	self.Slider_Control			:SetShow( true )
	self.Slider_0				:SetShow( true )
	self.Slider_50				:SetShow( true )
	self.Slider_100				:SetShow( true )
	self.Slider_DescBG			:SetShow( true )

	self.RecommendBG_Low		:SetShow( true )
	self.RecommendBG_Normal		:SetShow( true )
	self.RecommendBG_High		:SetShow( true )

	self.RadioBTN_AllRound		:SetShow( false )
	self.RadioBTN_Combat		:SetShow( false )
	self.RadioBTN_Product		:SetShow( false )
	self.RadioBTN_Fishing		:SetShow( false )
	self.Text_RadioBTN_Title	:SetShow( false )
	self.Text_RadioBTN_Desc		:SetShow( false )
end

function FirstLogin:SetStepEnd()
	self.Step1	= false
	self.Step2	= false
	self.Step3	= false

	local QuestListInfo = ToClient_GetQuestList()
	QuestListInfo:setQuestSelectType(0, true) -- 0은 무조건 선택
	QuestListInfo:setQuestSelectType(1, true)
	-- 패널을 끈다.
	Panel_FirstLogin:SetShow( false, false )
	selectCharacter( FirstLogin.characterSelect )
end

function FirstLogin:SetStep3()
	self.Step1	= false
	self.Step2	= false
	self.Step3	= true

	self.Text_Title				:SetText( PAGetString(Defines.StringSheet_GAME, "LUA_FIRSTLOGIN_STEPTITLE3") ) -- "앞으로 진행할 의뢰 종류를 선택해주세요."
	self.BTN_Next				:SetText( PAGetString(Defines.StringSheet_GAME, "LUA_FIRSTLOGIN_CONFIRM") ) -- "완료"
	
	FirstLogin_FavorQuestType( -1 )

	self.BTN_Next				:SetShow( true )

	self.Text_Title				:SetShow( true )
	self.Slider_Desc			:SetShow( false )

	self.Slider_Control			:SetShow( false )
	self.Slider_0				:SetShow( false )
	self.Slider_50				:SetShow( false )
	self.Slider_100				:SetShow( false )
	self.Slider_DescBG			:SetShow( true )

	self.RecommendBG_Low		:SetShow( false )
	self.RecommendBG_Normal		:SetShow( false )
	self.RecommendBG_High		:SetShow( false )

	self.RadioBTN_AllRound		:SetShow( true )
	self.RadioBTN_Combat		:SetShow( true )
	self.RadioBTN_Product		:SetShow( true )
	self.RadioBTN_Fishing		:SetShow( true )
	self.Text_RadioBTN_Title	:SetShow( true )
	self.Text_RadioBTN_Desc		:SetShow( true )
end

function FirstLogin:SetStep3End()
	self.Step1	= false
	self.Step2	= false
	self.Step3	= false
	
	-- 퀘스트 세팅 값을 저장한다.
	local selectType = -1
	if self.RadioBTN_AllRound:IsCheck() then
		selectType = 0
	elseif self.RadioBTN_Combat:IsCheck() then
		selectType = 1
	elseif self.RadioBTN_Product:IsCheck() then
		selectType = 2
	elseif self.RadioBTN_Fishing:IsCheck() then
		selectType = 3
	else
		Proc_ShowMessage_Ack( PAGetString(Defines.StringSheet_GAME, "LUA_FIRSTLOGIN_STEPTITLE3") )
		self:SetStep3()
		return
	end
	
	QuestWidget_ShowSelectQuestFavorType(selectType)
	
	-- 패널을 끈다.
	Panel_FirstLogin:SetShow( false, false )
end


function FirstLogin_SetStepData()
	local self = FirstLogin
	local step = nil
	if true == self.Step3 then
		step = 3
	elseif true == self.Step2 then
		step = 2
	elseif true == self.Step1 then
		step = 1
	end

	local volume = FirstLogin.Slider_Control:GetControlPos()

	if 1 == step then
		setCameraShakePower( volume )
		saveGameOption(false)
		FirstLogin:SetStep2()
	elseif 2 == step then
		setMotionBlurPower( volume )
		saveGameOption(false)
		FirstLogin:SetStepEnd()
	end
	
	if 3 == step then
		FirstLogin:SetStep3End()
	end
end

function FirstLogin_FavorQuestType( questType )
	local self	= FirstLogin
	local title = nil
	local desc	= nil
	if 0 == questType then
		title	= PAGetString(Defines.StringSheet_GAME, "LUA_FIRSTLOGIN_QUESTTYPE1") -- 전체
		desc	= PAGetString(Defines.StringSheet_GAME, "LUA_FIRSTLOGIN_QUESTTYPETITLE1") -- - 게임에서 제공하는 모든 의뢰를 진행할 수 있습니다.\n- 매우 천천히 자신만의 이야기를 만들어 나갈 모험가에게 추천합니다.
	elseif 1 == questType then
		title	= PAGetString(Defines.StringSheet_GAME, "LUA_FIRSTLOGIN_QUESTTYPE2") -- 전투
		desc	= PAGetString(Defines.StringSheet_GAME, "LUA_FIRSTLOGIN_QUESTTYPETITLE2") -- - 스토리, 필수, 사냥 의뢰를 중심으로 게임이 진행됩니다.\n- 빠른 성장을 좋아하는 모험가에게 추천합니다.
	elseif 2 == questType then
		title	= PAGetString(Defines.StringSheet_GAME, "LUA_FIRSTLOGIN_QUESTTYPE3") -- 채집과 제작
		desc	= PAGetString(Defines.StringSheet_GAME, "LUA_FIRSTLOGIN_QUESTTYPETITLE3") -- - 스토리, 필수, 채집, 가공, 요리, 제작 의뢰를 중심으로 게임이 진행됩니다.\n- 느긋하게 생활형 컨텐츠를 즐기고자 하는 모험가에게 추천합니다.
	elseif 3 == questType then
		title	= PAGetString(Defines.StringSheet_GAME, "LUA_FIRSTLOGIN_QUESTTYPE4") -- 낚시
		desc	= PAGetString(Defines.StringSheet_GAME, "LUA_FIRSTLOGIN_QUESTTYPETITLE4") -- - 스토리, 필수, 낚시 의뢰를 중심으로 게임이 진행됩니다.\n- 낚시를 좋아하는 인내심 있는 모험가에게 추천합니다.
	else
		title	= ""
		desc	= ""
	end

	desc	= PAGetStringParam1( Defines.StringSheet_GAME, "LUA_FIRSTLOGIN_QUESTTYPE_MSG", "desc", desc )
	self.Text_RadioBTN_Title	:SetText( title )
	self.Text_RadioBTN_Desc		:SetText( desc )
end

function FGlobal_FirstLogin_Open( characterSelect )
	FirstLogin.characterSelect = characterSelect
	FirstLogin:SetStep1()
	Panel_FirstLogin:SetShow( true, true )
end

function FGlobal_FirstLogin_InGameOpen( )
	FirstLogin:SetStep3()
	Panel_FirstLogin:SetShow( true, true )
end

function FGlobal_FirstLogin_InGameClose()
	QuestWidget_ShowSelectQuestFavorType(1)
	-- 패널을 끈다.
	Panel_FirstLogin:SetShow( false, false )
end

function FirstLogin:registEventHandler()
	self.BTN_Next			:addInputEvent("Mouse_LUp", "FirstLogin_SetStepData()")
	self.RadioBTN_AllRound	:addInputEvent("Mouse_LUp", "FirstLogin_FavorQuestType( " .. 0 .. " )")
	self.RadioBTN_Combat	:addInputEvent("Mouse_LUp", "FirstLogin_FavorQuestType( " .. 1 .. " )")
	self.RadioBTN_Product	:addInputEvent("Mouse_LUp", "FirstLogin_FavorQuestType( " .. 2 .. " )")
	self.RadioBTN_Fishing	:addInputEvent("Mouse_LUp", "FirstLogin_FavorQuestType( " .. 3 .. " )")

end

function FirstLogin:registMessageHandler()
end


FirstLogin:initialize()
FirstLogin:registEventHandler()
FirstLogin:registMessageHandler()