local UI_TM			= CppEnums.TextMode
local UI_PUCT		= CppEnums.PA_UI_CONTROL_TYPE
local UI_color		= Defines.Color
local UI_PLT		= CppEnums.CashPurchaseLimitType
local UI_CCC		= CppEnums.CashProductCategory

Panel_IngameCashShop_BuyOrGift:SetShow( false )
Panel_IngameCashShop_BuyOrGift:setGlassBackground( true )
Panel_IngameCashShop_BuyOrGift:ActiveMouseEventEffect( true )

local inGameShopBuy	= {
	_config	=
	{
		_slot	=
		{
			_startX		= 40,
			_startY		= 130,
			_gapY		= 37,
		},
		
		_buy	=
		{
			_startX		= 20,
			_startY		= 130,
			_gapY		= 40,
		},
		
		_sizeGift	= 35,
		_sizeBG		= 30,
		_sizePanel	= 85,
	},
	_panelTitle				= UI.getChildControl( Panel_IngameCashShop_BuyOrGift, "StaticText_Title"		),
	_static_LeftBG			= UI.getChildControl( Panel_IngameCashShop_BuyOrGift, "Static_LeftBG"			),
	-- 패키지 아이템
	_static_ItemIconBG		= UI.getChildControl( Panel_IngameCashShop_BuyOrGift, "Static_GoodsSlotBG"		),
	_static_ItemIcon		= UI.getChildControl( Panel_IngameCashShop_BuyOrGift, "Static_GoodsSlot"		),
	_static_ItemName		= UI.getChildControl( Panel_IngameCashShop_BuyOrGift, "StaticText_GoodsName"	),
	_static_PearlIcon		= UI.getChildControl( Panel_IngameCashShop_BuyOrGift, "Static_PearlIcon"	),
	
	_static_Gift			= UI.getChildControl( Panel_IngameCashShop_BuyOrGift, "StaticText_GiftTo"		),
	_edit_Gift				= UI.getChildControl( Panel_IngameCashShop_BuyOrGift, "Edit_GiftTo"				),
		
	_button_Close			= UI.getChildControl( Panel_IngameCashShop_BuyOrGift, "Button_Win_Close"		),
	_button_Confirm			= UI.getChildControl( Panel_IngameCashShop_BuyOrGift, "Button_Confirm"			),
	_button_Cancle			= UI.getChildControl( Panel_IngameCashShop_BuyOrGift, "Button_Cancle"			),

	_slotCount				= 20,
	_slots					= Array.new(),
	_needMoneyType			= -1,

	_productNoRaw			= nil,
	_isGift					= false,
	_byCart					= false,
}

function inGameShopBuy:init()
	local	slotConfig		= self._config._slot
	
	for	ii = 0, self._slotCount-1	do
		local	slot		= {}
		slot.iconBG	= UI.createAndCopyBasePropertyControl( Panel_IngameCashShop_BuyOrGift, "Static_SubItemSlotBG",		Panel_IngameCashShop_BuyOrGift,	"InGameShopBuy_Sub_"		.. ii )
		slot.icon	= UI.createAndCopyBasePropertyControl( Panel_IngameCashShop_BuyOrGift, "Static_SubItemSlot",		slot.iconBG,					"InGameShopBuy_Sub_Icon_"	.. ii )
		slot.name	= UI.createAndCopyBasePropertyControl( Panel_IngameCashShop_BuyOrGift, "StaticText_SubItemName",	slot.iconBG,					"InGameShopBuy_Sub_Name_"	.. ii )
		
		-- 좌표 설정.
		--{
			slot.iconBG:SetPosX( slotConfig._startX )
			slot.iconBG:SetPosY( slotConfig._startY + slotConfig._gapY * ii )
		--}
		
		self._slots[ii]	=	slot
	end

	-- 아이템 개수 및 가격
	--{
		self._static_BuyLineBG		= UI.createAndCopyBasePropertyControl( Panel_IngameCashShop_BuyOrGift, "Static_BuyLineBG",		Panel_IngameCashShop_BuyOrGift,	"InGameShopBuy_Buy"				)
		self._static_PearlIcon		= UI.createAndCopyBasePropertyControl( Panel_IngameCashShop_BuyOrGift, "Static_PearlIcon",		self._static_BuyLineBG,			"InGameShopBuy_Buy_Icon"		)
		self._static_Price			= UI.createAndCopyBasePropertyControl( Panel_IngameCashShop_BuyOrGift, "StaticText_GoodsPrice",	self._static_BuyLineBG,			"InGameShopBuy_Buy_Price"		)
		self._static_BuyCountTitle	= UI.createAndCopyBasePropertyControl( Panel_IngameCashShop_BuyOrGift, "StaticText_BuyCount",	self._static_BuyLineBG,			"InGameShopBuy_Buy_Count"		)
		self._edit_count			= UI.createAndCopyBasePropertyControl( Panel_IngameCashShop_BuyOrGift, "Edit_BuyCount",			self._static_BuyLineBG,			"InGameShopBuy_Buy_EditCount"	)
		self._button_CountUp		= UI.createAndCopyBasePropertyControl( Panel_IngameCashShop_BuyOrGift, "Button_CountPlus",		self._static_BuyLineBG,			"InGameShopBuy_Buy_ButtonPlus"	)
		self._button_CountDown		= UI.createAndCopyBasePropertyControl( Panel_IngameCashShop_BuyOrGift, "Button_CountMinus",		self._static_BuyLineBG,			"InGameShopBuy_Buy_Button_Minus")
		
		
		self._button_CountUp	:addInputEvent(	"Mouse_LUp",	"InGameShopBuy_Count( true )"	)
		self._button_CountUp	:SetAutoDisableTime(0)
		self._button_CountDown	:addInputEvent(	"Mouse_LUp",	"InGameShopBuy_Count( false )"	)
		self._button_CountDown	:SetAutoDisableTime(0)
		self._edit_count		:addInputEvent(	"Mouse_LUp",	"_InGameShopBuy_DontChangeCount()"	)	-- 직접 입력할 수 없다.
		self._edit_count		:SetEnable( false )
		
		self._edit_count:SetNumberMode( true )
		self._edit_count:SetEditText( 1, false)
	--}
end

function	inGameShopBuy:registMessageHandler()
	self._button_Close:addInputEvent(		"Mouse_LUp",	"InGameShopBuy_Close()"			)
	self._button_Confirm:addInputEvent(		"Mouse_LUp",	"InGameShopBuy_Confirm()"		)
	self._button_Cancle:addInputEvent(		"Mouse_LUp",	"InGameShopBuy_Close()"			)
end

function	inGameShopBuy:registEventHandler()
	registerEvent( "FromClient_NotifyCompleteBuyProduct",	"FromClient_NotifyCompleteBuyProduct"	) -- 구매가 잘 되었다. 여기에 머니 업데이트도 걸어야 한다.
end

function	inGameShopBuy:update()
	local	cashProduct	= getIngameCashMall():getCashProductStaticStatusByProductNoRaw( self._productNoRaw )
	if	( nil == cashProduct )	then
		return
	end
	
	self._static_ItemIcon:ChangeTextureInfoName( "Icon/" .. cashProduct:getIconPath() )
	self._static_ItemName:SetTextMode( UI_TM.eTextMode_AutoWrap )
	self._static_ItemName:SetText( cashProduct:getName() )
	self._static_Price:SetText( makeDotMoney(cashProduct:getPrice()) )

	-- 펄 아이콘 변경
	InGameShopBuy_ChangeMoneyIconTexture( cashProduct:getCategory() )
	
	for	ii = 0, self._slotCount-1	do
		local	slot	= self._slots[ii]
		slot.iconBG:SetShow(false)
	end
	
	local	itemCount	= cashProduct:getItemListCount()
	for ii = 0, itemCount - 1 do
		local	slot		= self._slots[ii]
		local	item		= cashProduct:getItemByIndex( ii )
		local	itemCount	= cashProduct:getItemCountByIndex( ii )
		local	itemGrade	= item:getGradeType()
		
		slot.name:SetFontColor( ConvertFromGradeToColor(itemGrade) )
		slot.name:SetText( item:getName() )
		slot.icon:ChangeTextureInfoName( "icon/" .. item:getIconPath() )
		slot.icon	:addInputEvent( "Mouse_On", "InGameShopBuy_ShowItemToolTip( true, " .. ii .. " )" )
		slot.icon	:addInputEvent( "Mouse_Out", "InGameShopBuy_ShowItemToolTip( false, " .. ii .. " )" )
		slot.icon:SetText( tostring(itemCount) )
		
		slot.iconBG:SetShow(true)
	end
	
	-- 선물하기
	--{
		local	giftGap	= 0
		self._static_Gift:SetShow(false)
			self._edit_Gift:SetShow(false)
		if	( self._isGift )	then
			self._static_Gift:SetShow(true)
			self._edit_Gift:SetShow(true)			
			self._edit_Gift:SetIgnore( false )
			self._edit_Gift:SetEnable( true )
			self._edit_Gift:SetDisableColor( false )
			giftGap	= self._config._sizeGift
		end
	--}
	
	-- 크기 및 사이즈 조절
	--{
		local	buyConfig		= self._config._buy
		self._static_BuyLineBG:SetPosX( buyConfig._startX )
		self._static_BuyLineBG:SetPosY( buyConfig._startY + itemCount * buyConfig._gapY )
		
		self._static_LeftBG:SetSize( self._static_LeftBG:GetSizeX(), buyConfig._startY + itemCount * buyConfig._gapY + self._config._sizeBG + giftGap)
		Panel_IngameCashShop_BuyOrGift:SetSize( Panel_IngameCashShop_BuyOrGift:GetSizeX(), buyConfig._startY + itemCount * buyConfig._gapY + self._config._sizePanel + giftGap )
		
		self._static_Gift:ComputePos()
		self._edit_Gift:ComputePos()
		self._button_Confirm:ComputePos()
		self._button_Cancle:ComputePos()
	--}
end

function	inGameShopBuy:defaultPosition()
	local scrSizeX		= getScreenSizeX()
	local scrSizeY		= getScreenSizeY()
	local panelSizeX 	= Panel_IngameCashShop_BuyOrGift:GetSizeX()
	local panelSizeY 	= Panel_IngameCashShop_BuyOrGift:GetSizeY()

	Panel_IngameCashShop_BuyOrGift:SetPosX( (scrSizeX / 2) - (panelSizeX / 2) )
	Panel_IngameCashShop_BuyOrGift:SetPosY( (scrSizeY / 2) - (panelSizeY / 2) )
end

----------------------------------------------------------------------------------------------------
-- Window Function
function	InGameShopBuy_Confirm()
	local	self		= inGameShopBuy
	local	cashProduct	= getIngameCashMall():getCashProductStaticStatusByProductNoRaw( self._productNoRaw )
	if	( nil == cashProduct )	then
		return
	end
	
	local	count	= self._edit_count:GetEditText()
	if	( not self._isGift )	then
		-- 먼저 돈이 있는지 체크
		local haveCash, havePearl, haveMileage = InGameShop_UpdateCash()
		local isEnoughMoney = false
		if UI_CCC.eCashProductCategory_Pearl == cashProduct:getCategory() then					-- 다음캐시가 필요함
			isEnoughMoney = ( cashProduct:getPrice()*toInt64(0, count) <= haveCash )
		elseif UI_CCC.eCashProductCategory_Mileage == cashProduct:getCategory() then			-- 마일리지가 필요함
			isEnoughMoney = ( cashProduct:getPrice()*toInt64(0, count) <= haveMileage )
		else																					-- 펄이 필요함
			isEnoughMoney = ( cashProduct:getPrice()*toInt64(0, count) <= havePearl )
		end

		if not isEnoughMoney then
			_InGameShopBuy_Confirm_LackMoney( cashProduct:getCategory() )
			audioPostEvent_SystemUi( 16, 01 )
		else
			_InGameShopBuy_Confirm_EnoughMoney()	-- 돈이 충분하다.
		end
	else
		local toCharacterName	= self._edit_Gift:GetEditText()
		if '' == toCharacterName or nil == toCharacterName then
			return
		elseif tonumber(count) <= 0 then
			return
		end

		local itemTotalCount = tonumber(count) * cashProduct:getItemListCount()
		if ( 20 <= itemTotalCount ) then
			Proc_ShowMessage_Ack( PAGetString(Defines.StringSheet_GAME, "LUA_INGAMECASHSHOP_BUYORGIFT_LIMITED") )
			return
		end	
		
		local haveCash, havePearl, haveMileage = InGameShop_UpdateCash()
		local isEnoughMoney = false
		if UI_CCC.eCashProductCategory_Pearl == cashProduct:getCategory() then					-- 다음캐시가 필요함
			isEnoughMoney = ( cashProduct:getPrice()*toInt64(0, count) <= haveCash )
		elseif UI_CCC.eCashProductCategory_Mileage == cashProduct:getCategory() then			-- 마일리지가 필요함
			isEnoughMoney = ( cashProduct:getPrice()*toInt64(0, count) <= haveMileage )
		else																					-- 펄이 필요함
			isEnoughMoney = ( cashProduct:getPrice()*toInt64(0, count) <= havePearl )
		end

		if not isEnoughMoney then
			_InGameShopBuy_Confirm_LackMoney( cashProduct:getCategory() )
			audioPostEvent_SystemUi( 16, 01 )
		else
			_InGameShopBuy_Confirm_EnoughMoneyForGift()	-- 돈이 충분하다.
		end		
	end
	
	InGameShopDetailInfo_Close()
	InGameShopBuy_Close()
end

function InGameShopBuy_GiftMyFriend()
	PaymentPassword( FGlobal_InGameShopBuy_Gift )
end

function _InGameShopBuy_Confirm_LackMoney( category )
	local	self	= inGameShopBuy
	if CppEnums.CashProductCategory.eCashProductCategory_Mileage == category then
		Proc_ShowMessage_Ack( PAGetString(Defines.StringSheet_GAME, "LUA_INGAMECASHSHOP_BUYORGIFT_LACKMONEY_ACK") )-- "마일리지가 부족합니다. 마일리지는 도전과제 보상으로 얻을 수 있습니다." )
		return
	end

	self._needMoneyType = category

	local	messageBoxTitle = PAGetString(Defines.StringSheet_GAME, "LUA_INGAMECASHSHOP_BUYORGIFT_ALERT") -- "알  림"
	local	messageBoxMemo	= ""
	local	moneyType		= ""

	if CppEnums.CashProductCategory.eCashProductCategory_Pearl == category then
		moneyType = PAGetString(Defines.StringSheet_GAME, "LUA_INGAMECASHSHOP_BUYORGIFT_DAUMCASH") -- "다음캐쉬"
	elseif CppEnums.CashProductCategory.eCashProductCategory_Mileage == category then
		moneyType = PAGetString(Defines.StringSheet_GAME, "LUA_INGAMECASHSHOP_BUYORGIFT_MILEAGE") -- "마일리지"
	else
		moneyType = PAGetString(Defines.StringSheet_GAME, "LUA_INGAMECASHSHOP_BUYORGIFT_PEARL") -- "펄"
	end
	messageBoxMemo	= PAGetStringParam2( Defines.StringSheet_GAME, "LUA_INGAMECASHSHOP_BUYORGIFT_CONFIRM_MSGBOX", "moneyType", moneyType, "moneyType2", moneyType ) -- moneyType .. "가 부족합니다. " .. moneyType .. " 구입 페이지로 이동하시겠습니까?"

	local	messageBoxData = { title = messageBoxTitle, content = messageBoxMemo, functionYes = _InGameShopBuy_BuyMoney, functionNo = _InGameShopBuy_Confirm_Cancel, priority = CppEnums.PAUIMB_PRIORITY.PAUIMB_PRIORITY_LOW}
	MessageBox.showMessageBox(messageBoxData)
end

function _InGameShopBuy_BuyMoney()
	local	self		= inGameShopBuy
	local	category	= self._needMoneyType

	if CppEnums.CashProductCategory.eCashProductCategory_Pearl == category then
		InGameShop_BuyDaumCash()
	elseif CppEnums.CashProductCategory.eCashProductCategory_Mileage == category then
		-- 마일리지를 얻을 수 있는 방법 나크메시지로.
		Proc_ShowMessage_Ack( PAGetString(Defines.StringSheet_GAME, "LUA_INGAMECASHSHOP_BUYORGIFT_CONFIRM_MILEAGE") )-- "마일리지가 부족합니다. 마일리지는 도전과제 보상으로 얻을 수 있습니다." )
	else
		InGameShop_BuyPearl()
	end
end

function _InGameShopBuy_Confirm_EnoughMoneyForGift()
	local	selfPlayerWrapper	= getSelfPlayer()
		local	selfPlayer			= selfPlayerWrapper:get()
		local	isCreatePasword		= selfPlayer:isPaymentPassword()

		if false == isCreatePasword then
			InGameShopBuy_GiftMyFriend()			
		else
			local	messageBoxMemo = PAGetString(Defines.StringSheet_GAME, "LUA_INGAMECASHSHOP_BUYORGIFT_GIFTMYFRIEND") -- "먼저 거래 비밀번호 설정을 해야합니다.\n설정 후 다시 시도해주세요."
			local	messageBoxData = { title = PAGetString( Defines.StringSheet_GAME, "LUA_WARNING"), content = messageBoxMemo, functionApply = InGameShopBuy_GiftMyFriend, priority = CppEnums.PAUIMB_PRIORITY.PAUIMB_PRIORITY_LOW}
			MessageBox.showMessageBox(messageBoxData)
		end
end

function _InGameShopBuy_Confirm_EnoughMoney()
	local	self		= inGameShopBuy
	local	cashProduct	= getIngameCashMall():getCashProductStaticStatusByProductNoRaw( self._productNoRaw )
	if	( nil == cashProduct )	then
		return
	end

	local limitType	= cashProduct:getCashPurchaseLimitType()
	if UI_PLT.None ~= limitType then
		local mylimitCount	= getIngameCashMall():getRemainingLimitCount( self._productNoRaw )
		if mylimitCount < 1 then
			Proc_ShowMessage_Ack( PAGetString(Defines.StringSheet_GAME, "LUA_INGAMECASHSHOP_BUYORGIFT_PURCHASELIMIT") )-- "구입 제한만큼 이미 구입하셨습니다. " )
			return
		end
	end
	
	local	count	= self._edit_count:GetEditText()

	local	messageBoxTitle = PAGetString(Defines.StringSheet_GAME, "LUA_INGAMECASHSHOP_BUYORGIFT_ALERT") -- "알  림"
	local	messageBoxMemo	= ""
	local	messageBoxData	= nil
	local	addPearlComment = PAGetString(Defines.StringSheet_GAME, "LUA_INGAMECASHSHOP_BUYORGIFT_CONFIRM_PURCHASELIMIT") -- "\n 본 상품은 구입 후 7일이 경과하거나, 상자를 개봉할 경우 쳥약 철회가 불가능한 상품입니다."

	-- 아이템이 클래스에 맞지 않는다면,
	

	-- local	item				= cashProduct:getItemByIndex( 0 )
	local	mathClass			= nil
	local	addmathClassString = ""
	if cashProduct:doHaveDisplayClass() and not cashProduct:isClassTypeUsable(getSelfPlayer():getClassType()) then
		mathClass = false
	else
		mathClass = true
	end

	if false == mathClass then
		addmathClassString = PAGetString(Defines.StringSheet_GAME, "LUA_INGAMECASHSHOP_BUYORGIFT_MATHCLASS") --"플레이어가 사용할 수 없는 아이템입니다.\n"
	end

	if UI_CCC.eCashProductCategory_Pearl == cashProduct:getCategory() then
		messageBoxMemo	= PAGetStringParam3( Defines.StringSheet_GAME, "LUA_INGAMECASHSHOP_BUYORGIFT_CONFIRM_REALBUY", "addmathClassString", addmathClassString, "getName", cashProduct:getName(), "count", count ) .. addPearlComment -- "<PAColor0xffd0ee68>[" .. addmathClassString .. cashProduct:getName() .. "] 상품<PAOldColor>\n" .. count .. "개를 정말 구입하시겠습니까?" .. addPearlComment
	else
		messageBoxMemo	= PAGetStringParam3( Defines.StringSheet_GAME, "LUA_INGAMECASHSHOP_BUYORGIFT_CONFIRM_REALBUY", "addmathClassString", addmathClassString, "getName", cashProduct:getName(), "count", count ) -- "<PAColor0xffd0ee68>[" .. addmathClassString .. cashProduct:getName() .. "] 상품<PAOldColor>\n" .. count .. "개를 정말 구입하시겠습니까?"
	end
	messageBoxData = { title = messageBoxTitle, content = messageBoxMemo, functionYes = InGameShopBuy_ConfirmDo, functionNo = _InGameShopBuy_Confirm_Cancel, priority = CppEnums.PAUIMB_PRIORITY.PAUIMB_PRIORITY_LOW}
	MessageBox.showMessageBox(messageBoxData)
end

function InGameShopBuy_ConfirmDo()
	audioPostEvent_SystemUi(16,00)

	local	self		= inGameShopBuy
	local	cashProduct	= getIngameCashMall():getCashProductStaticStatusByProductNoRaw( self._productNoRaw )
	if	( nil == cashProduct )	then
		return
	end
	local	count	= self._edit_count:GetEditText()
	getIngameCashMall():requestBuyItem( self._productNoRaw, count, cashProduct:getPrice(), CppEnums.BuyItemReqTrType.eBuyItemReqTrType_None )

end

function _InGameShopBuy_Confirm_Cancel()
	Proc_ShowMessage_Ack( PAGetString(Defines.StringSheet_GAME, "LUA_INGAMECASHSHOP_BUYORGIFT_BUYCANCEL") )-- "구입이 취소됐습니다" )
	InGameShopBuy_Close()
end

function FGlobal_InGameShopBuy_Gift()
	local	self		= inGameShopBuy
	local	cashProduct	= getIngameCashMall():getCashProductStaticStatusByProductNoRaw( self._productNoRaw )
	if nil == cashProduct then
		return
	end

	local	count		= self._edit_count:GetEditText()
	local	toName		= self._edit_Gift:GetEditText()
	
	
	if '' == toName then
		return
	elseif tonumber(count) <= 0 then
		return
	end
	
	getIngameCashMall():requestGiftItem( self._productNoRaw, count, cashProduct:getPrice(), CppEnums.BuyItemReqTrType.eBuyItemReqTrType_None, toName )
end

function	InGameShopBuy_Count( isUp )
	local	self		= inGameShopBuy
	local	count		= tonumber(self._edit_count:GetEditText())

	local	cashProduct	= getIngameCashMall():getCashProductStaticStatusByProductNoRaw( self._productNoRaw )
	if	( nil == cashProduct )	then
		return
	end

	local	price	= cashProduct:getPrice()
	
	if	( not isUp )	then
		if	( count <= 1 )	then
			return
		end
		
		count	= count - 1
	else
		count	= count + 1
	end

	-- UI.debugMessage(  .. "/" .. count )
	local sumPrice = Int64toInt32(price) * count
	self._static_Price:SetText( makeDotMoney( sumPrice ) )
	self._edit_count:SetEditText( tostring(count), false )
end

function InGameShopBuy_ChangeMoneyIconTexture( categoryIdx )
	local self	= inGameShopBuy
	local icon	= self._static_PearlIcon
	icon:ChangeTextureInfoName( "new_ui_common_forlua/window/ingamecashshop/cashshop_01.dds" )
	
	local x1, y1, x2, y2 = 0, 0, 0, 0
	if CppEnums.CashProductCategory.eCashProductCategory_Pearl == categoryIdx then
		x1, y1, x2, y2 = setTextureUV_Func( icon, 310, 479, 329, 498 )
	elseif CppEnums.CashProductCategory.eCashProductCategory_Mileage == categoryIdx then
		x1, y1, x2, y2 = setTextureUV_Func( icon, 333, 479, 351, 498 )
	else
		x1, y1, x2, y2 = setTextureUV_Func( icon, 287, 479, 307, 498 )
	end
	icon:getBaseTexture():setUV( x1, y1, x2, y2 )
	icon:setRenderTexture(icon:getBaseTexture())
end

function FromClient_NotifyCompleteBuyProduct( productNoRaw, isGift, toCharacterName )
	if isGift then
		Proc_ShowMessage_Ack( PAGetStringParam1(Defines.StringSheet_GAME, "LUA_INGAMECASHSHOP_BUYORGIFT_NOTIFYCOMPLETEBUYPRODUCT_GIFT", "toCharacterName", toCharacterName) )-- toCharacterName .. "님의 편지로 선물을 보냈습니다.")
	else
		local cashProduct	= getIngameCashMall():getCashProductStaticStatusByProductNoRaw( productNoRaw )
		local itemWrapper	= cashProduct:getItemByIndex( 0 )												-- 여러 개일 경우 첫번째 것만 검사
		Proc_ShowMessage_Ack( "구매해주셔서 감사합니다." ) -- PAGetString(Defines.StringSheet_GAME, "LUA_INGAMECASHSHOP_BUYORGIFT_BUYCOMPLETE") "구입이 완료됐습니다.")
		if itemWrapper:get():isCash() then
			Proc_ShowMessage_Ack( PAGetString(Defines.StringSheet_GAME, "LUA_INGAMECASHSHOP_BUYORGIFT_CONFIRM_PEARLBAG") ) -- "구입하신 상품은 펄 가방에서 확인할 수 있습니다.")
		else
			Proc_ShowMessage_Ack( PAGetString(Defines.StringSheet_GAME, "LUA_INGAMECASHSHOP_BUYORGIFT_CONFIRM_NORMALBAG") ) -- "구입하신 상품은 가방에서 확인할 수 있습니다.")
		end
	end

	InGameShop_UpdateCash()
	FGlobal_InGameShop_UpdateByBuy()
	InGameShopBuy_Close()
end

function _InGameShopBuy_DontChangeCount()
	ClearFocusEdit()
	Proc_ShowMessage_Ack( PAGetString(Defines.StringSheet_GAME, "LUA_INGAMECASHSHOP_BUYORGIFT_DONTCHANGECOUNT") )--"직접 입력을 지원하지 않습니다.")
	return
end

function InGameShopBuy_ShowItemToolTip( isShow, index )
	local self			= inGameShopBuy
	if true == isShow then
		local cashProduct	= getIngameCashMall():getCashProductStaticStatusByProductNoRaw( self._productNoRaw )
		local itemWrapper	= cashProduct:getItemByIndex( index )
		local slotIcon		= self._slots[index].icon
		Panel_Tooltip_Item_Show( itemWrapper, slotIcon, true, false, nil )
	else
		Panel_Tooltip_Item_hideTooltip()
	end
end

----------------------------------------------------------------------------------------------------
-- Window Open/Close
function	FGlobal_InGameShopBuy_Open( productNoRaw, isGift, byCart )
	local self			= inGameShopBuy
	self._productNoRaw	= productNoRaw
	self._isGift		= isGift
	self._byCart		= byCart

	self._edit_count:SetEditText( 1, false)

	if true == isGift then
		self._panelTitle		:SetText( PAGetString(Defines.StringSheet_GAME, "LUA_INGAMECASHSHOP_BUYORGIFT_DOGIFT") )-- "선물하기")
		self._button_Confirm	:SetText( PAGetString(Defines.StringSheet_GAME, "LUA_INGAMECASHSHOP_BUYORGIFT_GIFT") )--  "선물" )
	else
		self._panelTitle		:SetText( PAGetString(Defines.StringSheet_GAME, "LUA_INGAMECASHSHOP_BUYORGIFT_BUYPRODUCT") )-- "상품 구입")
		self._button_Confirm	:SetText( PAGetString(Defines.StringSheet_GAME, "LUA_INGAMECASHSHOP_BUYORGIFT_BUY") )--  "구입" )
	end

	self:update()
	self:defaultPosition()
	
	InGameShopBuy_Open()
end

function	InGameShopBuy_Open()
	if	( Panel_IngameCashShop_BuyOrGift:GetShow() )	then
		return
	end
	inGameShopBuy._edit_Gift:SetEditText("", true)
	Panel_IngameCashShop_BuyOrGift:SetShow(true)
end

function	InGameShopBuy_Close()
	if	( not Panel_IngameCashShop_BuyOrGift:GetShow() )	then
		return
	end
	ClearFocusEdit()
	Panel_IngameCashShop_BuyOrGift:SetShow( false )
end


----------------------------------------------------------------------------------------------------
-- Tooltip
--function cashShop_Buy_ShowTooltip( isShow, itemIdx )
--	local self		= inGameShopBuy
--	local cPSSW		= ToClient_GetCashProductStaticStatusWrapperByKeyRaw( self._productNoRaw )
--	if	( nil == cPSSW )	then
--		return
--	end
--	
--	local itemSSW	= cPSSW:getItemByIndex( itemIdx )
--	local itemUI	= self.PackingItemUIPool[itemIdx]
--	Panel_Tooltip_Item_Show( itemSSW, itemUI.Slot, true, false )
--end

----------------------------------------------------------------------------------------------------
-- Init
inGameShopBuy:init()
inGameShopBuy:registEventHandler()
inGameShopBuy:registMessageHandler()