local UI_TM			= CppEnums.TextMode
local UI_PUCT		= CppEnums.PA_UI_CONTROL_TYPE
local UI_color		= Defines.Color
local UI_ANI_ADV	= CppEnums.PAUI_ANIM_ADVANCE_TYPE

Panel_Window_ItemMarket_ItemSet:SetShow( false )
Panel_Window_ItemMarket_ItemSet:SetDragEnable( true )

Panel_Window_ItemMarket_ItemSet:RegisterShowEventFunc( true, 'ItemMarketItemSetShowAni()' )
Panel_Window_ItemMarket_ItemSet:RegisterShowEventFunc( false, 'ItemMarketItemSetHideAni()' )

function ItemMarketItemSetShowAni()
	-- 애니를 하면 위치가 틀어집니다.
	-- local aniInfo1 = Panel_Window_ItemMarket_ItemSet:addScaleAnimation( 0.0, 0.08, UI_ANI_ADV.PAUI_ANIM_ADVANCE_COS_HALF_PI)
	-- aniInfo1:SetStartScale(0.8)
	-- aniInfo1:SetEndScale(1.05)
	-- aniInfo1.AxisX = Panel_Window_ItemMarket_ItemSet:GetSizeX() / 2
	-- aniInfo1.AxisY = Panel_Window_ItemMarket_ItemSet:GetSizeY() / 2
	-- aniInfo1.ScaleType = 2
	-- aniInfo1.IsChangeChild = true
	
	-- local aniInfo2 = Panel_Window_ItemMarket_ItemSet:addScaleAnimation( 0.08, 0.15, UI_ANI_ADV.PAUI_ANIM_ADVANCE_COS_HALF_PI)
	-- aniInfo2:SetStartScale(1.05)
	-- aniInfo2:SetEndScale(1.0)
	-- aniInfo2.AxisX = Panel_Window_ItemMarket_ItemSet:GetSizeX() / 2
	-- aniInfo2.AxisY = Panel_Window_ItemMarket_ItemSet:GetSizeY() / 2
	-- aniInfo2.ScaleType = 2
	-- aniInfo2.IsChangeChild = true
end
function ItemMarketItemSetHideAni()
	-- local aniInfo1 = Panel_Window_ItemMarket_ItemSet:addColorAnimation( 0.0, 0.15, UI_ANI_ADV.PAUI_ANIM_ADVANCE_SIN_HALF_PI)
	-- aniInfo1:SetStartColor( UI_color.C_FFFFFFFF )
	-- aniInfo1:SetEndColor( UI_color.C_00FFFFFF )
	-- aniInfo1:SetStartIntensity( 3.0 )
	-- aniInfo1:SetEndIntensity( 1.0 )
	-- aniInfo1.IsChangeChild = true
	-- aniInfo1:SetHideAtEnd(true)
	-- aniInfo1:SetDisableWhileAni(true)
end

local ItemMarketItemSet 	= {
	panelBG					= UI.getChildControl( Panel_Window_ItemMarket_ItemSet,	"Static_PanelBG"),
	btn_Close				= UI.getChildControl( Panel_Window_ItemMarket_ItemSet,	"Button_Win_Close"),
	btn_Question			= UI.getChildControl( Panel_Window_ItemMarket_ItemSet,	"Button_Question"),
	btn_RegistItem			= UI.getChildControl( Panel_Window_ItemMarket_ItemSet,	"Button_RegistItem"),
	registItemCount			= UI.getChildControl( Panel_Window_ItemMarket_ItemSet,	"StaticText_RegistItemCount_Value"),
	saleItemCount			= UI.getChildControl( Panel_Window_ItemMarket_ItemSet,	"StaticText_SaleItemCount_Value"),
	RegistDelayNotify		= UI.getChildControl( Panel_Window_ItemMarket_ItemSet,	"StaticText_RegistDelayNotify"),
	waitingCount			= UI.getChildControl( Panel_Window_ItemMarket_ItemSet,	"StaticText_WaitingCount_Value"),

	-- 돈 지불 방법.
	invenMoney				= UI.getChildControl( Panel_Window_ItemMarket_ItemSet,	"Static_Text_Money"),
	warehouseMoney			= UI.getChildControl( Panel_Window_ItemMarket_ItemSet,	"Static_Text_Money2"),
	radioBtn_Inven			= UI.getChildControl( Panel_Window_ItemMarket_ItemSet,	"RadioButton_Inventory"),
	radioBtn_Warehouse		= UI.getChildControl( Panel_Window_ItemMarket_ItemSet,	"RadioButton_Warehouse"),
	static_Inven			= UI.getChildControl( Panel_Window_ItemMarket_ItemSet,	"StaticText_Icon_Money"),
	static_Warehouse		= UI.getChildControl( Panel_Window_ItemMarket_ItemSet,	"StaticText_Icon_Money2"),
	
	scroll					= UI.getChildControl( Panel_Window_ItemMarket_ItemSet,	"Scroll_ItemMarket_ItemSet"),
	scrollInverVal			= 0,

	startIdx				= 0,
	ItemListUiPool			= {},
	ItemListMaxCount		= 7,
	slotConfing			= {
		createIcon		= true,
		createBorder	= true,
		createCount		= true,
		createEnchant	= true,
		createCash		= true,
	},

	_buttonQuestion 		= UI.getChildControl( Panel_Window_ItemMarket_ItemSet, 	"Button_Question" ),		-- 물음표 버튼
}
ItemMarketItemSet.scrollCtrlBTN = UI.getChildControl( ItemMarketItemSet.scroll,		"Scroll_CtrlButton")

local bgTexture = {
	[0] =	{ [0] = {134, 2, 198, 60},		{110, 265, 174, 323},	{110, 325, 174, 383} }, -- 판매완료
			{ [0] = {1, 123, 65, 181},		{68, 123, 65, 181},		{134, 123, 198, 181} }, -- 중간정산
			{ [0] = {310, 440, 374, 498},	{377, 440, 441, 498},	{444, 440, 508, 498} }, -- 판매취소 및 등록대기
}

local Template				= {
	ItemBG					= UI.getChildControl( Panel_Window_ItemMarket_ItemSet,	"Template_Static_ItemBG"),
	SlotBG					= UI.getChildControl( Panel_Window_ItemMarket_ItemSet,	"Template_Static_SlotBG"),
	Slot					= UI.getChildControl( Panel_Window_ItemMarket_ItemSet,	"Template_Static_Slot"),
	ItemName				= UI.getChildControl( Panel_Window_ItemMarket_ItemSet,	"Template_StaticText_ItemName"),
	AveragePrice_Title		= UI.getChildControl( Panel_Window_ItemMarket_ItemSet,	"Template_Static_AveragePrice_TitleIcon"),
	AveragePrice_Value		= UI.getChildControl( Panel_Window_ItemMarket_ItemSet,	"Template_StaticText_AveragePrice_Value"),
	SoldOut					= UI.getChildControl( Panel_Window_ItemMarket_ItemSet,	"Template_StaticText_SoldOut"),
	RecentPrice_Title		= UI.getChildControl( Panel_Window_ItemMarket_ItemSet,	"Template_Static_RecentPrice_TitleIcon"),
	RecentPrice_Value		= UI.getChildControl( Panel_Window_ItemMarket_ItemSet,	"Template_StaticText_RecentPrice_Value"),
	SellPrice_Title			= UI.getChildControl( Panel_Window_ItemMarket_ItemSet,	"Template_Static_SellPrice_TitleIcon"),
	SellPrice_Value			= UI.getChildControl( Panel_Window_ItemMarket_ItemSet,	"Template_StaticText_SellPrice_Value"),
	RegistPeriod_Title		= UI.getChildControl( Panel_Window_ItemMarket_ItemSet,	"Template_Static_RegistPeriod_TitleIcon"),
	RegistPeriod_Value		= UI.getChildControl( Panel_Window_ItemMarket_ItemSet,	"Template_StaticText_RegistPeriod_Value"),
	BTN_RegistCancle		= UI.getChildControl( Panel_Window_ItemMarket_ItemSet,	"Template_Button_RegistCancle"),
	BTN_Withdrawals			= UI.getChildControl( Panel_Window_ItemMarket_ItemSet,	"Template_Button_Withdrawals"),
	BTN_Settlement			= UI.getChildControl( Panel_Window_ItemMarket_ItemSet,	"Templete_Button_Settlement"),
	RegistTerritoryText		= UI.getChildControl( Panel_Window_ItemMarket_ItemSet,	"MultilineText_RegistTerritoryText" ),
	SellCountIcon			= UI.getChildControl( Panel_Window_ItemMarket_ItemSet,	"Template_Static_SellCountIcon"),
	SellCountValue			= UI.getChildControl( Panel_Window_ItemMarket_ItemSet,	"Template_StaticText_SellCountValue"),
	SellCompleteIcon		= UI.getChildControl( Panel_Window_ItemMarket_ItemSet,	"Template_Static_SellCompleteIcon"),
	SellCompleteValue		= UI.getChildControl( Panel_Window_ItemMarket_ItemSet,	"Template_StaticText_SellCompleteValue"),
	DivisionLine1			= UI.getChildControl( Panel_Window_ItemMarket_ItemSet,	"Template_Static_Line_1"),
	DivisionLine2			= UI.getChildControl( Panel_Window_ItemMarket_ItemSet,	"Template_Static_Line_2"),
}

local territoryKey =
{
	[0]	= tostring(PAGetString(Defines.StringSheet_GAME, "LUA_TERRITORYAUTHORITY_KEY_0")),		-- 발레노스령
	[1] = tostring(PAGetString(Defines.StringSheet_GAME, "LUA_TERRITORYAUTHORITY_KEY_1")),		-- 세렌디아령
	[2] = tostring(PAGetString(Defines.StringSheet_GAME, "LUA_TERRITORYAUTHORITY_KEY_2")),		-- 칼페온령
	[3] = tostring(PAGetString(Defines.StringSheet_GAME, "LUA_TERRITORYAUTHORITY_KEY_3")),		-- 메디아령
}

function ItemMarketItemSet:Initialize()
	self.panelBG:setGlassBackground( true )
	self.panelBG:ActiveMouseEventEffect( true )
	-- 아이템 리스트 생성
	local itemList_PosY = 80
	for itemList_Idx = 0, self.ItemListMaxCount - 1 do
		local tempSlot = {}
		local Created_ItemBG = UI.createControl( UI_PUCT.PA_UI_CONTROL_STATIC, self.panelBG, 'ItemMarketSetItem_ItemBG_' .. itemList_Idx )
		CopyBaseProperty( Template.ItemBG, Created_ItemBG )
		Created_ItemBG:SetPosX( 10 )
		Created_ItemBG:SetPosY( itemList_PosY )
		Created_ItemBG:addInputEvent("Mouse_DownScroll",	"ItemMarketItemSet_ScrollUpdate( true )")
		Created_ItemBG:addInputEvent("Mouse_UpScroll",		"ItemMarketItemSet_ScrollUpdate( fasle )")
		Created_ItemBG:SetShow( false )
		tempSlot.itemBG = Created_ItemBG

		local Created_ItemSlotBG = UI.createControl( UI_PUCT.PA_UI_CONTROL_STATIC, Created_ItemBG, 'ItemMarketSetItem_SlotBG_' .. itemList_Idx )
		CopyBaseProperty( Template.SlotBG, Created_ItemSlotBG )
		Created_ItemSlotBG:SetPosX( 10 )
		Created_ItemSlotBG:SetPosY( 7 )
		Created_ItemSlotBG:SetShow( true )
		tempSlot.SlotBG = Created_ItemSlotBG

		local createSlot = {}
		SlotItem.new( createSlot, 'ItemMarketSetItem_SlotItem_' .. itemList_Idx, 0, Created_ItemSlotBG, self.slotConfing )
		createSlot:createChild()
		tempSlot.Slot = createSlot


		local Created_ItemName = UI.createControl( UI_PUCT.PA_UI_CONTROL_STATICTEXT, Created_ItemBG, 'ItemMarketSetItem_ItemName_' .. itemList_Idx )
		CopyBaseProperty( Template.ItemName, Created_ItemName )
		Created_ItemName:SetPosX( 60 )
		Created_ItemName:SetPosY( 7 )
		Created_ItemName:SetTextMode( UI_TM.eTextMode_AutoWrap )
		Created_ItemName:SetShow( true )
		tempSlot.itemName = Created_ItemName
		-- 평균 등록가 / 최근 등록가
		local Created_AveragePrice_Title = UI.createControl( UI_PUCT.PA_UI_CONTROL_STATIC, Created_ItemBG, 'ItemMarketSetItem_AveragePrice_Title_' .. itemList_Idx )
		CopyBaseProperty( Template.AveragePrice_Title, Created_AveragePrice_Title )
		Created_AveragePrice_Title:SetPosX( 210 )
		Created_AveragePrice_Title:SetPosY( 10 )
		Created_AveragePrice_Title:SetShow( true )
		tempSlot.averagePrice_Title = Created_AveragePrice_Title

		local Created_AveragePrice_Value = UI.createControl( UI_PUCT.PA_UI_CONTROL_STATICTEXT, Created_ItemBG, 'ItemMarketSetItem_AveragePrice_Value_' .. itemList_Idx )
		CopyBaseProperty( Template.AveragePrice_Value, Created_AveragePrice_Value )
		Created_AveragePrice_Value:SetPosX( 270 )
		Created_AveragePrice_Value:SetPosY( 10 )
		Created_AveragePrice_Value:SetShow( true )
		tempSlot.averagePrice_Value = Created_AveragePrice_Value

		local Created_SoldOut = UI.createControl( UI_PUCT.PA_UI_CONTROL_STATICTEXT, Created_ItemBG, 'ItemMarketSetItem_SoldOut_' .. itemList_Idx )
		CopyBaseProperty( Template.SoldOut, Created_SoldOut )
		Created_SoldOut:SetPosX( 245 )
		Created_SoldOut:SetPosY( 20 )
		Created_SoldOut:SetShow( true )
		tempSlot.SoldOut = Created_SoldOut

		local Created_RecentPrice_Title = UI.createControl( UI_PUCT.PA_UI_CONTROL_STATIC, Created_ItemBG, 'ItemMarketSetItem_RecentPrice_Title_' .. itemList_Idx )
		CopyBaseProperty( Template.RecentPrice_Title, Created_RecentPrice_Title )
		Created_RecentPrice_Title:SetPosX( 210 )
		Created_RecentPrice_Title:SetPosY( 32 )
		Created_RecentPrice_Title:SetShow( true )
		tempSlot.recentPrice_Title = Created_RecentPrice_Title

		local Created_RecentPrice_Value = UI.createControl( UI_PUCT.PA_UI_CONTROL_STATICTEXT, Created_ItemBG, 'ItemMarketSetItem_RecentPrice_Value_' .. itemList_Idx )
		CopyBaseProperty( Template.RecentPrice_Value, Created_RecentPrice_Value )
		Created_RecentPrice_Value:SetPosX( 270 )
		Created_RecentPrice_Value:SetPosY( 32 )
		Created_RecentPrice_Value:SetShow( true )
		tempSlot.recentPrice_Value = Created_RecentPrice_Value
		-- 구분 라인 1
		local Created_DivisionLine1 = UI.createControl( UI_PUCT.PA_UI_CONTROL_STATIC, Created_ItemBG, 'ItemMarketSetItem_Division_FirstLine_' .. itemList_Idx )
		CopyBaseProperty( Template.DivisionLine1, Created_DivisionLine1 )
		Created_DivisionLine1:SetPosX( 385 )
		Created_DivisionLine1:SetPosY( 12 )
		Created_DivisionLine1:SetShow( true )
		tempSlot.divisionLine1 = Created_DivisionLine1
		-- 판매 갯수 / 만료일
		local Created_SellCountIcon = UI.createControl( UI_PUCT.PA_UI_CONTROL_STATIC, Created_ItemBG, 'ItemMarketSetItem_SellCountIcon_' .. itemList_Idx )
		CopyBaseProperty( Template.SellCountIcon, Created_SellCountIcon )
		Created_SellCountIcon:SetPosX( 410 )
		Created_SellCountIcon:SetPosY( 8 )
		Created_SellCountIcon:SetShow( true )
		tempSlot.sellCountIcon = Created_SellCountIcon

		local Created_SellCountValue = UI.createControl( UI_PUCT.PA_UI_CONTROL_STATICTEXT, Created_ItemBG, 'ItemMarketSetItem_SellCountValue_' .. itemList_Idx )
		CopyBaseProperty( Template.SellCountValue, Created_SellCountValue )
		Created_SellCountValue:SetPosX( 430 )
		Created_SellCountValue:SetPosY( 8 )
		Created_SellCountValue:SetShow( true )
		tempSlot.sellCountValue = Created_SellCountValue

		local Created_RegistPeriod_Title = UI.createControl( UI_PUCT.PA_UI_CONTROL_STATIC, Created_ItemBG, 'ItemMarketSetItem_RegistPeriod_Title_' .. itemList_Idx )
		CopyBaseProperty( Template.RegistPeriod_Title, Created_RegistPeriod_Title )
		Created_RegistPeriod_Title:SetPosX( 410 )
		Created_RegistPeriod_Title:SetPosY( 31 )
		Created_RegistPeriod_Title:SetShow( true )
		tempSlot.registPeriod_Title = Created_RegistPeriod_Title

		local Created_RegistPeriod_Value = UI.createControl( UI_PUCT.PA_UI_CONTROL_STATICTEXT, Created_ItemBG, 'ItemMarketSetItem_RegistPeriod_Value_' .. itemList_Idx )
		CopyBaseProperty( Template.RegistPeriod_Value, Created_RegistPeriod_Value )
		Created_RegistPeriod_Value:SetPosX( 430 )
		Created_RegistPeriod_Value:SetPosY( 30 )
		Created_RegistPeriod_Value:SetShow( true )
		tempSlot.registPeriod_Value = Created_RegistPeriod_Value
		-- 구분 라인 2
		local Created_DivisionLine2 = UI.createControl( UI_PUCT.PA_UI_CONTROL_STATIC, Created_ItemBG, 'ItemMarketSetItem_Division_SecondLine_' .. itemList_Idx )
		CopyBaseProperty( Template.DivisionLine2, Created_DivisionLine2 )
		Created_DivisionLine2:SetPosX( 540 )
		Created_DivisionLine2:SetPosY( 12 )
		Created_DivisionLine2:SetShow( true )
		tempSlot.divisionLine2 = Created_DivisionLine2
		--판매 등록가 / 판매 완료가
		local Created_SellPrice_Title = UI.createControl( UI_PUCT.PA_UI_CONTROL_STATIC, Created_ItemBG, 'ItemMarketSetItem_SellPrice_Title_' .. itemList_Idx )
		CopyBaseProperty( Template.SellPrice_Title, Created_SellPrice_Title )
		Created_SellPrice_Title:SetPosX( 560 )
		Created_SellPrice_Title:SetPosY( 10 )
		Created_SellPrice_Title:SetShow( true )
		tempSlot.sellPrice_Title = Created_SellPrice_Title

		local Created_SellPrice_Value = UI.createControl( UI_PUCT.PA_UI_CONTROL_STATICTEXT, Created_ItemBG, 'ItemMarketSetItem_SellPrice_Value_' .. itemList_Idx )
		CopyBaseProperty( Template.SellPrice_Value, Created_SellPrice_Value )
		Created_SellPrice_Value:SetPosX( 620 )
		Created_SellPrice_Value:SetPosY( 8 )
		Created_SellPrice_Value:SetShow( true )
		tempSlot.sellPrice_Value = Created_SellPrice_Value

		local Created_SellCompleteIcon = UI.createControl( UI_PUCT.PA_UI_CONTROL_STATIC, Created_ItemBG, 'ItemMarketSetItem_SellCompleteIcon_' .. itemList_Idx )
		CopyBaseProperty( Template.SellCompleteIcon, Created_SellCompleteIcon )
		Created_SellCompleteIcon:SetPosX( 560 )
		Created_SellCompleteIcon:SetPosY( 31 )
		Created_SellCompleteIcon:SetShow( true )
		tempSlot.sellCompleteIcon = Created_SellCompleteIcon

		local Created_SellCompleteValue = UI.createControl( UI_PUCT.PA_UI_CONTROL_STATICTEXT, Created_ItemBG, 'ItemMarketSetItem_SellCompleteValue_' .. itemList_Idx )
		CopyBaseProperty( Template.SellCompleteValue, Created_SellCompleteValue )
		Created_SellCompleteValue:SetPosX( 620 )
		Created_SellCompleteValue:SetPosY( 30 )
		Created_SellCompleteValue:SetShow( true )
		tempSlot.sellCompleteValue = Created_SellCompleteValue
		-----버튼
		local Created_CancleBTN = UI.createControl( UI_PUCT.PA_UI_CONTROL_BUTTON, Created_ItemBG, 'ItemMarketSetItem_BTN_Cancle_' .. itemList_Idx )
		CopyBaseProperty( Template.BTN_RegistCancle, Created_CancleBTN )
		Created_CancleBTN:SetPosX( 730 )
		Created_CancleBTN:SetPosY( 9 )
		Created_CancleBTN:SetShow( true )
		tempSlot.BTN_Cancle = Created_CancleBTN

		local Created_WithdrawalsBTN = UI.createControl( UI_PUCT.PA_UI_CONTROL_BUTTON, Created_ItemBG, 'ItemMarketSetItem_BTN_Withdrawals_' .. itemList_Idx )
		CopyBaseProperty( Template.BTN_Withdrawals, Created_WithdrawalsBTN )
		Created_WithdrawalsBTN:SetPosX( 730 )
		Created_WithdrawalsBTN:SetPosY( 9 )
		Created_WithdrawalsBTN:SetShow( true )
		tempSlot.BTN_Withdrawals = Created_WithdrawalsBTN

		local Created_SettlementBTN = UI.createControl( UI_PUCT.PA_UI_CONTROL_BUTTON, Created_ItemBG, 'ItemMarketSetItem_BTN_Settlement_' .. itemList_Idx )
		CopyBaseProperty( Template.BTN_Settlement, Created_SettlementBTN )
		Created_SettlementBTN:SetPosX( 730 )
		Created_SettlementBTN:SetPosY( 9 )
		Created_SettlementBTN:SetShow( true )
		tempSlot.BTN_Settlement = Created_SettlementBTN
		-- 영지명 출력
		local Created_RegistTerrText = UI.createControl( UI_PUCT.PA_UI_CONTROL_MULTILINETEXT, Created_ItemBG, 'ItemMarketSetItem_RegistTerritory_' .. itemList_Idx )
		CopyBaseProperty( Template.RegistTerritoryText, Created_RegistTerrText )
		Created_RegistTerrText:SetPosX( 750 )
		Created_RegistTerrText:SetPosY( 12 )
		Created_RegistTerrText:SetShow( true )
		tempSlot.RegistTerritoryText = Created_RegistTerrText

		itemList_PosY	= itemList_PosY + Created_ItemBG:GetSizeY() + 2
		self.ItemListUiPool[itemList_Idx] = tempSlot
	end
end

function ItemMarketItemSet:SetPosition()
	local scrSizeX		= getScreenSizeX()
	local scrSizeY		= getScreenSizeY()
	local panelSizeX 	= Panel_Window_ItemMarket_ItemSet:GetSizeX()
	local panelSizeY 	= Panel_Window_ItemMarket_ItemSet:GetSizeY()

	Panel_Window_ItemMarket_ItemSet:SetPosX( (scrSizeX / 2) - (panelSizeX / 2) )
	Panel_Window_ItemMarket_ItemSet:SetPosY( (scrSizeY / 2) - (panelSizeY / 2) )
end

function ItemMarketItemSet_ScrollUpdate( isDown )
	local self	= ItemMarketItemSet
	local index	= self.startIdx
	if true == isDown then
		if index < self.scrollInverVal then
			self.scroll:ControlButtonDown()
			index = index + 1
		else
			return
		end
	else
		if 0 < index then
			self.scroll:ControlButtonUp()
			index = index - 1
		else
			return
		end
	end
	self.startIdx = index
	self:Update( index )
end

function ItemMarketItemSet:SetScroll()
	local itemCount = getItemMarketMyItemsCount();

	local interval = ( itemCount - self.ItemListMaxCount)
	if interval < 0 then
		interval = 0
		self.scroll:SetShow(false)
		return
	else
		self.scroll:SetShow(true)
	end

	self.scroll:SetInterval( self.scrollInverVal )

	local dataCount			= itemCount + 1
	local viewCount			= self.ItemListMaxCount
	local pagePercent		= (viewCount / dataCount) * 100
	local scrollSizeY		= self.scroll:GetSizeY()
	local btn_scrollSizeY	= ( scrollSizeY / 100 ) * pagePercent

	if btn_scrollSizeY < 20 then
		btn_scrollSizeY = 20
	elseif scrollSizeY - 5 < btn_scrollSizeY then
		btn_scrollSizeY = scrollSizeY - 10
	end

	self.scrollCtrlBTN:SetSize( self.scrollCtrlBTN:GetSizeX(), btn_scrollSizeY )
	
	self.scrollInverVal	= interval
	self.scroll:SetInterval( self.scrollInverVal )
end

local currentMyTerritoryKey = function()
	local selfPlayer = getSelfPlayer();
	local regionInfoWrapper = getRegionInfoWrapper(selfPlayer:getRegionKeyRaw())
	if (nil == regionInfoWrapper) then
		return -1
	end	
	return regionInfoWrapper:getTerritoryKeyRaw()
end

function ItemMarketItemSet:Update( startIdx )
	local currentTerritoryKey = currentMyTerritoryKey()
	local itemCount = getItemMarketMyItemsCount();
	self.registItemCount	:SetText( PAGetStringParam1( Defines.StringSheet_GAME, "LUA_ITEMMARKET_ITEMSET_REGISTITEMCOUNT", "itemCount", itemCount ) ) -- " "..itemCount.. " 건"
	self.RegistDelayNotify	:SetText("아이템 등록시 일정 시간 이후 거래소에 등록됩니다.\nPC방 접속 시 수령액의 " .. requestGetRefundPercentForPcRoom() .. "%를 추가로 받을 수 있습니다.")

	for ui_Idx = 0, self.ItemListMaxCount-1 do
		local UiBase = self.ItemListUiPool[ui_Idx]
		UiBase.itemBG:SetShow( false )
	end
	
	-- 판매 중 건수
	local saleCount = 0;
	local totalCount = getItemMarketMyItemsCount();
	for idx = 0, totalCount-1 do
		local myItemInfo = getItemMarketMyItemByIndex( idx );
		if( nil ~= myItemInfo ) then
			if myItemInfo:isTraded() and (0 == Int64toInt32( myItemInfo:getTotalPrice() )) then
				saleCount = saleCount+1
			end
		end
	end

	--판매 대기 건수
	local waitingCount = 0
	for idx = 0, totalCount-1 do
		local myItemInfo = getItemMarketMyItemByIndex( idx )
		if ( nil ~= myItemInfo ) then
			if myItemInfo:isWaiting() == true then
				waitingCount = waitingCount + 1
			end
		end
	end
	self.saleItemCount:SetText( PAGetStringParam1(Defines.StringSheet_GAME, "LUA_ITEMMARKET_ITEMSET_REGISTITEMCOUNT", "itemCount", tostring(saleCount)) ); -- tostring(saleCount).." 건"
	self.waitingCount:SetText( PAGetStringParam1(Defines.StringSheet_GAME, "LUA_ITEMMARKET_ITEMSET_REGISTITEMCOUNT", "itemCount", tostring(waitingCount)) )
	
	for ui_Idx = 0, self.ItemListMaxCount-1 do
		itemMarketSummaryInfo = getItemMarketSummaryInClientByIndex( self.curItemClassify, ui_Idx )
		local UiBase = self.ItemListUiPool[ui_Idx]
			
		local itemList_Idx = startIdx + ui_Idx
		local myItemInfo = getItemMarketMyItemByIndex( itemList_Idx );
		if( nil ~= myItemInfo ) then
			
			UiBase.itemBG:SetShow( true )
					
			local iess = myItemInfo:getItemEnchantStaticStatusWrapper()
			_PA_ASSERT( nil ~= iess, "myItemInfo 아이템 고정정보가 꼭 있어야합니다")
			
			local nameColorGrade	= iess:getGradeType()
			local nameColor			= nil
			if ( 0 == nameColorGrade ) then
				nameColor = UI_color.C_FFEFEFEF
			elseif ( 1 == nameColorGrade ) then
				nameColor = 4284350320
			elseif ( 2 == nameColorGrade ) then
				nameColor = 4283144191
			elseif ( 3 == nameColorGrade ) then
				nameColor = 4294953010
			elseif ( 4 == nameColorGrade ) then
				nameColor = 4294929408
			else
				nameColor = UI_color.C_FFFFFFFF
			end
			UiBase.itemName:SetFontColor( nameColor )
			UiBase.itemName:SetText( iess:getName() )
			--UiBase.itemName:SetText( "성공하는 사람들의\n다양한 습관 모음집" )
			
			UiBase.Slot					:setItemByStaticStatus( iess, myItemInfo:getCount(), -1, false  )
			UiBase.Slot.icon			:addInputEvent("Mouse_On",	"_ItemMarketItemSet_ShowToolTip( " .. ui_Idx .. " )")
			UiBase.Slot.icon			:addInputEvent("Mouse_Out",	"_ItemMarketItemSet_HideToolTip()")
			UiBase.averagePrice_Title	:addInputEvent("Mouse_On",	"ItemMarketItemSet_ToolTip( true, " .. ui_Idx .. ", 0 )")
			UiBase.averagePrice_Title	:addInputEvent("Mouse_Out",	"ItemMarketItemSet_ToolTip( false )")
			UiBase.recentPrice_Title	:addInputEvent("Mouse_On",	"ItemMarketItemSet_ToolTip( true, " .. ui_Idx .. ", 1 )")
			UiBase.recentPrice_Title	:addInputEvent("Mouse_Out",	"ItemMarketItemSet_ToolTip( false )")
			UiBase.sellPrice_Title		:addInputEvent("Mouse_On",	"ItemMarketItemSet_ToolTip( true, " .. ui_Idx .. ", 2 )")
			UiBase.sellPrice_Title		:addInputEvent("Mouse_Out",	"ItemMarketItemSet_ToolTip( false )")
			UiBase.registPeriod_Title	:addInputEvent("Mouse_On",	"ItemMarketItemSet_ToolTip( true, " .. ui_Idx .. ", 3 )")
			UiBase.registPeriod_Title	:addInputEvent("Mouse_Out",	"ItemMarketItemSet_ToolTip( false )")
			UiBase.sellCountIcon		:addInputEvent("Mouse_On",	"ItemMarketItemSet_ToolTip( true, " .. ui_Idx .. ", 4 )")
			UiBase.sellCountIcon		:addInputEvent("Mouse_Out",	"ItemMarketItemSet_ToolTip(false)")
			UiBase.sellCompleteIcon		:addInputEvent("Mouse_On",	"ItemMarketItemSet_ToolTip( true, " .. ui_Idx .. ", 5 )")
			UiBase.sellCompleteIcon		:addInputEvent("Mouse_Out",	"ItemMarketItemSet_ToolTip( false )")

			UiBase.BTN_Withdrawals		:addInputEvent("Mouse_LUp", "HandleClicked_ItemMarketItemSet_ItemWithdrawals( " ..iess:get()._key:get()..",".. itemList_Idx .. " )")
			-- UiBase.registPeriod_Title	:SetText( PAGetString(Defines.StringSheet_GAME, "LUA_ITEMMARKET_ITEMSET_TEXT_REGISTPERIOD") ) -- "만료일"
			UiBase.SoldOut				:SetShow( PAGetString(Defines.StringSheet_GAME, "LUA_ITEMMARKET_ITEMSET_TEXT_SOLDOUT") ) -- "판매완료"
			UiBase.registPeriod_Value	:SetText( converStringFromLeftDateTime( myItemInfo:getDisplayedEndDate() ) )
			UiBase.sellCountValue		:SetText( Int64toInt32( myItemInfo:getTotalCount() ) )
			UiBase.sellCompleteValue	:SetText( makeDotMoney( myItemInfo:getTradedTotalPrice() ) )
			UiBase.BTN_Cancle			:addInputEvent("Mouse_LUp", "HandleClicked_ItemMarketItemSet_RegistCancle( " ..iess:get()._key:get()..",".. itemList_Idx .. " )")
			UiBase.BTN_Settlement		:addInputEvent("Mouse_LUp", "HandleClicked_ItemMarketItemSet_ItemSettlement( " ..iess:get()._key:get()..",".. itemList_Idx .. " )")

			local leftBeginDate_s64	= getLeftSecond_TTime64( myItemInfo:getDisplayedBeginDate() )
			if myItemInfo:isTraded() and (0 == Int64toInt32( myItemInfo:getTotalPrice() )) then -- 판매완료 -- myItemInfo:isTraded() and 0 == Int64toInt32( myItemInfo:getTradedTotalPrice() ) then
				_ItemMarketItemSet_ChangeBgTexture( 1, ui_Idx ) -- 판매 완료 BG텍스쳐를 바꾼다.
				
				UiBase.BTN_Cancle			:SetShow( false )
				UiBase.BTN_Withdrawals		:SetShow( true )
				UiBase.BTN_Settlement		:SetShow( false )

				UiBase.BTN_Withdrawals:SetFontColor(UI_color.C_FF96D4FC)
			elseif myItemInfo:isTraded() and 0 < Int64toInt32( myItemInfo:getTradedTotalPrice() ) and 0 < Int64toInt32( myItemInfo:getTotalPrice() ) then -- 중간 정산
				_ItemMarketItemSet_ChangeBgTexture( 0, ui_Idx ) -- 중간 정산 BG텍스쳐를 바꾼다.

				UiBase.BTN_Settlement	:SetShow( true )
				UiBase.BTN_Cancle		:SetShow( false )
				UiBase.BTN_Withdrawals	:SetShow( false )

				UiBase.BTN_Settlement:SetFontColor(UI_color.C_FFFAE696)
			else -- 등록 취소, 등록 대기 취소
				_ItemMarketItemSet_ChangeBgTexture( 2, ui_Idx ) -- 등록 취소, 등록 대기 취소 BG텍스쳐를 바꾼다.

				UiBase.BTN_Cancle			:SetShow( true )
				UiBase.BTN_Withdrawals		:SetShow( false )
				UiBase.BTN_Settlement		:SetShow( false )

				if myItemInfo:isWaiting() == false then
					UiBase.BTN_Cancle:SetText( "등록 취소" )
					UiBase.BTN_Cancle:SetFontColor(UI_color.C_FFF03838)
				else
					UiBase.BTN_Cancle:SetText( "등록 대기 취소" )
					UiBase.BTN_Cancle:SetFontColor(UI_color.C_FFEF5378)
				end
			end
			
			local summaryInfo = getItemMarketSummaryInClientByItemEnchantKey( iess:get()._key:get() )
			_PA_ASSERT( nil ~= summaryInfo, "summaryInfo 정보가 꼭 있어야합니다")

			local replaceCount = function( num )
				local count = Int64toInt32( num )
				if 0 == count then
					count = "-"
				else
					count = makeDotMoney( num )
				end
				return count
			end

			UiBase.averagePrice_Value	:SetText( replaceCount( summaryInfo:getTradedAverageOnePrice() ) )
			UiBase.recentPrice_Value	:SetText( replaceCount( summaryInfo:getLastTradedOnePrice() ) )
			UiBase.sellPrice_Value		:SetText( replaceCount( myItemInfo:getTotalPrice()) )
			-- UiBase.sellCountValue		:SetText( makeDotMoney( summaryInfo:getDisplayedTotalAmount() ) )

			-- 월드맵에서 열었거나 등록지가 현재 있는 곳과 다를 경우 등록 취소 버튼 대신 등록지를 표시해준다!
			-- 거래소 통합으로 판매금 수령은 어디서든 가능하게 20150122 - 정승철
			-- local _isSelfTerritory = true
			local _isSelfTerritory = false;
			local _territoryKey = myItemInfo:getTerritoryKey()
			
			if( currentTerritoryKey == _territoryKey ) then
				_isSelfTerritory = true
			end

			if ( true == ToClient_WorldMapIsShow() ) or ( false == _isSelfTerritory ) then
				UiBase.BTN_Cancle			:SetShow( false )	-- 등록 취소
				UiBase.BTN_Withdrawals		:SetShow( false )	-- 판매금 수령
				UiBase.BTN_Settlement		:SetShow( false )	-- 중간정산

				local _territoryKey = myItemInfo:getTerritoryKey()
				local registTerritoryName = nil
				registTerritoryName = ""
				
				for i = 0, 3 do
					if ( i == _territoryKey ) then
						registTerritoryName = PAGetStringParam1( Defines.StringSheet_GAME, "LUA_ITEMMARKET_ITEMSET_TEXT_REGISTTERRITORY", "territoryKey", territoryKey[i] ) -- territoryKey[i] .. " 등록품"
						-- registTerritoryName = "등록품"
					end
				end
				UiBase.RegistTerritoryText	:SetText( registTerritoryName )
				UiBase.RegistTerritoryText	:SetShow( true )

				if myItemInfo:isTraded() and (0 == Int64toInt32( myItemInfo:getTotalPrice() )) then	-- 판매 됐다면 버튼을 켠다.
					UiBase.RegistTerritoryText	:SetShow( false )
					UiBase.BTN_Withdrawals		:SetShow( true )
				end
			else
				UiBase.RegistTerritoryText	:SetShow( false )
			end
		end		
	end
ItemMarketItemSet:SetScroll()
	-- 스크롤바 보여주고 안보여주고
	if itemCount <= self.ItemListMaxCount then
		self.scroll:SetShow( false )
	else
		self.scroll:SetShow( true )
	end
end

function ItemMarketItemSet:Open()
	-- 자신의 물품 요청
	
	if( ToClient_WorldMapIsShow() ) then
		requestItemMarketMyItems( true )
	else
		requestItemMarketMyItems( false )
	end
		
	self.startIdx = 0
	self.scroll:SetControlTop()
	self:SetPosition()
	self:SetScroll()
	self:Update( self.startIdx )
	Panel_Window_ItemMarket_ItemSet:SetShow( true, true )
end

--------------------------------------------------------------------------------
-- 내부 이벤트
--------------------------------------------------------------------------------
function _ItemMarketItemSet_ShowToolTip( ui_Idx )
	local self				= ItemMarketItemSet
	local startIdx			= self.startIdx
	local itemList_Idx		= startIdx + ui_Idx
	local myItemInfo 		= getItemMarketMyItemByIndex( itemList_Idx )
	local UiBase			= self.ItemListUiPool[ui_Idx].Slot.icon
	local itemWrapper		= nil
	if myItemInfo:isTraded() then
		itemWrapper = getItemMarketMyItemByIndex( itemList_Idx ):getItemEnchantStaticStatusWrapper()
		Panel_Tooltip_Item_Show( itemWrapper, UiBase, true, false, nil )
	else
		itemWrapper = getItemMarketMyItemByIndex( itemList_Idx ):getItemWrapper()
		Panel_Tooltip_Item_Show( itemWrapper, UiBase, false, true, nil )
	end
end
function _ItemMarketItemSet_HideToolTip()
	Panel_Tooltip_Item_hideTooltip()
	ItemMarketItemSet_ToolTip( false )
end

--------------------------------------------------------------------------------
-- 물품 리스트 BG텍스쳐 변경
--------------------------------------------------------------------------------
function _ItemMarketItemSet_ChangeBgTexture( bgType, ui_Idx )
	local self		= ItemMarketItemSet
	local control	= self.ItemListUiPool[ui_Idx]

	control.itemBG:ChangeTextureInfoName( "New_UI_Common_forLua/Window/ItemMarket/ItemMarket_00.dds" )
	control.itemBG:ChangeOnTextureInfoName( "New_UI_Common_forLua/Window/ItemMarket/ItemMarket_00.dds" )
	control.itemBG:ChangeClickTextureInfoName( "New_UI_Common_forLua/Window/ItemMarket/ItemMarket_00.dds" )

	local x1, y1, x2, y2 = setTextureUV_Func( control.itemBG, bgTexture[bgType][0][1], bgTexture[bgType][0][2], bgTexture[bgType][0][3], bgTexture[bgType][0][4] )
	control.itemBG:getBaseTexture():setUV(  x1, y1, x2, y2  )
	control.itemBG:setRenderTexture( control.itemBG:getBaseTexture() )

	local x1, y1, x2, y2 = setTextureUV_Func( control.itemBG, bgTexture[bgType][1][1], bgTexture[bgType][1][2], bgTexture[bgType][1][3], bgTexture[bgType][1][4] )
	control.itemBG:getOnTexture():setUV(  x1, y1, x2, y2  )

	local x1, y1, x2, y2 = setTextureUV_Func( control.itemBG, bgTexture[bgType][2][1], bgTexture[bgType][2][2], bgTexture[bgType][2][3], bgTexture[bgType][2][4] )
	control.itemBG:getClickTexture():setUV(  x1, y1, x2, y2  )
end

--------------------------------------------------------------------------------
-- 클릭 이벤트
--------------------------------------------------------------------------------
function HandleClicked_ItemMarketItemSet_RegistCancle( itemEnchantKeyRaw, index )	-- 거래서 물품 등록취소 - 확인창 추가 20150122 정승철
	local doCancel = function()
		requestCancelMyRegistedItemForItemMarket( itemEnchantKeyRaw, index)
		ItemMarketItemSet:SetScroll()
		return
	end

	local	messageBoxTitle	= "알 림"
	local	messageBoxMemo	= "등록을 취소하시겠습니까?"
	local	messageBoxData	= { title = messageBoxTitle, content = messageBoxMemo, functionYes = doCancel, functionNo = MessageBox_Empty_function, priority = CppEnums.PAUIMB_PRIORITY.PAUIMB_PRIORITY_LOW}
	MessageBox.showMessageBox(messageBoxData, "middle")
end

local withdrawalsItemKey	= -1
local withdrawalsIndex		= -1
function HandleClicked_ItemMarketItemSet_ItemWithdrawals( itemEnchantKeyRaw, index )
	local	self			= ItemMarketItemSet
	local	temporaryWrapper= getTemporaryInformationWrapper()
	local	isPcRoom		= temporaryWrapper:isPcRoom()

	withdrawalsItemKey	= itemEnchantKeyRaw
	withdrawalsIndex	= index
	if isPcRoom == false then
		local	messageBoxTitle	= "알 림"
		local	messageBoxMemo	= "<PAColor0xffff4b4b>프리미엄 PC방에서 수령하실 때에는<PAOldColor>\n<PAColor0xffff4b4b>수령액의 " .. requestGetRefundPercentForPcRoom() .. "%가 추가로 지급됩니다.<PAOldColor>\n\n<PAColor0xffddcd82>지금 판매금 수령을 하시겠습니까?<PAOldColor>"
		local	messageBoxData	= { title = messageBoxTitle, content = messageBoxMemo, functionYes = ItemMarketSetItem_ItemWithdrawalsExecute, functionNo = MessageBox_Empty_function, priority = CppEnums.PAUIMB_PRIORITY.PAUIMB_PRIORITY_LOW}
		MessageBox.showMessageBox(messageBoxData, "middle")
	else
		local	toWhereType	= CppEnums.ItemWhereType.eInventory
		if( self.radioBtn_Warehouse:IsCheck() )	then
			toWhereType	= CppEnums.ItemWhereType.eWarehouse
		end
	
		requestWithdrawSellingItemMoneyForItemMarket( itemEnchantKeyRaw, index, toWhereType )
		withdrawalsItemKey	= -1
		withdrawalsIndex	= -1
	end
end

function ItemMarketSetItem_ItemWithdrawalsExecute()
	local	self		= ItemMarketItemSet
	local	toWhereType	= CppEnums.ItemWhereType.eInventory
	if( self.radioBtn_Warehouse:IsCheck() )	then
		toWhereType	= CppEnums.ItemWhereType.eWarehouse
	end
	
	requestWithdrawSellingItemMoneyForItemMarket( withdrawalsItemKey, withdrawalsIndex, toWhereType )
	withdrawalsItemKey	= -1
	withdrawalsIndex	= -1

	ItemMarketItemSet:SetScroll()
end

function HandleClicked_ItemMarketItemSet_ItemSettlement( itemEnchantKeyRaw, index )
	local	self		= ItemMarketItemSet
	local	toWhereType	= CppEnums.ItemWhereType.eInventory
	if( self.radioBtn_Warehouse:IsCheck() )	then
		toWhereType	= CppEnums.ItemWhereType.eWarehouse
	end

	requestCancelRegistedItemAndWithdrawMoneyForItemMarket( itemEnchantKeyRaw, index, toWhereType )
end
function HandleClicked_ItemMarketRegistItem_Open()
	FGlobal_ItemMarketRegistItem_Open()
end
function HandleClicked_ItemMarketItemSet_Close()
	
	FGlobal_ItemMarketItemSet_Close()
	
end
function HandleClicked_ItemMarketItemSet_SetScrollIndexByLClick()
	local self				= ItemMarketItemSet
	local maxInterval		= self.scrollInverVal
	local posByInterval		= 1 / maxInterval

	local currentInterval	= math.floor( (self.scroll:GetControlPos() / posByInterval) + 0.5 )
	self.startIdx		= currentInterval
	self:Update( self.startIdx )
end

function ItemMarketItemSet_ToolTip( isShow, ui_Idx, iconType )
	local name = ""
	local desc = ""
	local uiControl = nil
	local UiBase = ItemMarketItemSet.ItemListUiPool[ui_Idx]

	if 0 == iconType then
		name = "평균 거래가"
		desc = "해당 물품의 평균 거래가격입니다."
		uiControl = UiBase.averagePrice_Title
	elseif 1 == iconType then
		name = "최근 거래가"
		desc = "해당 물품의 최근 거래가격입니다."
		uiControl = UiBase.recentPrice_Title
	elseif 2 == iconType then
		name = "남은 판매가"
		desc = "남아 있는 물품이 팔렸을 때 받을 수 있는 금액입니다."
		uiControl = UiBase.sellPrice_Title
	elseif 3 == iconType then
		name = "만료일"
		desc = "해당 물품의 판매가 끝나기까지 남은 시간입니다."
		uiControl = UiBase.registPeriod_Title
	elseif 4 == iconType then
		name = "판매 등록 개수"
		desc = "처음 등록한 물품의 개수입니다."
		uiControl = UiBase.sellCountIcon
	elseif 5 == iconType then
		name = "판매된 물품 가격"
		desc = "중간 정산으로 수령할 수 있는 금액입니다."
		uiControl = UiBase.sellCompleteIcon
	end

	if true == isShow then
		TooltipSimple_Show( uiControl, name, desc )
	else
		TooltipSimple_Hide()
	end	
end

--------------------------------------------------------------------------------
-- 글로벌 이벤트
--------------------------------------------------------------------------------
function FGlobal_ItemMarketMyItems_Update()
	local self = ItemMarketItemSet
	self.startIdx = 0
	self:SetPosition()
	self:SetScroll()
	self.scroll:SetControlTop()
	self.scroll:SetControlPos(0)
	self:Update( self.startIdx )
end

function FGlobal_ItemMarketItemSet_Open()
	local	self	= ItemMarketItemSet
	if Panel_Window_ItemMarket_ItemSet:GetShow() then
		return
	end
	
	if Panel_Window_ItemMarket:GetShow() then
		FGolbal_ItemMarket_Close()
	end
	
	if Panel_Window_ItemMarket_BuyConfirm:GetShow() then
		FGlobal_ItemMarket_BuyConfirm_Close()
	end

	if Panel_Window_ItemMarket_RegistItem:GetShow() then
		FGlobal_ItemMarketRegistItem_Close()
	end
	
	--{
		self.invenMoney:SetShow(true)
		self.warehouseMoney:SetShow(true)
		self.radioBtn_Inven:SetShow(true)
		self.radioBtn_Warehouse:SetShow(true)
		self.static_Inven:SetShow(true)
		self.static_Warehouse:SetShow(true)
		
		self.radioBtn_Inven:SetCheck(true)
		self.radioBtn_Warehouse:SetCheck(false)
	--}
	
	self.btn_RegistItem:SetShow(true)
	
	self:SetPosition()
	self:Open()
end

function FGlobal_ItemMarketItemSet_Open_ForWorldMap()
	local	self	= ItemMarketItemSet
	if Panel_Window_ItemMarket_ItemSet:GetShow() then
		return
	end
	
	if Panel_Window_ItemMarket:GetShow() then
		FGolbal_ItemMarket_Close()
	end
	
	if Panel_Window_ItemMarket_BuyConfirm:GetShow() then
		FGlobal_ItemMarket_BuyConfirm_Close()
	end
	
	--{
		self.invenMoney:SetShow(false)
		self.warehouseMoney:SetShow(false)
		self.radioBtn_Inven:SetShow(false)
		self.radioBtn_Warehouse:SetShow(false)
		self.static_Inven:SetShow(false)
		self.static_Warehouse:SetShow(false)
	--}
	
	self.btn_RegistItem:SetShow(false)

	self:SetPosition()
	self:Open()
end

function FGlobal_ItemMarketItemSet_Close()
	_ItemMarketItemSet_HideToolTip()
	Panel_Window_ItemMarket_ItemSet:SetShow( false, false )
end

function	ItemMarketItemSet_UpdateMoney()
	-- 창욱씨 추가해주세요.!
	Proc_ShowMessage_Ack( "판매금은 창고로 송금되었습니다." )
end

function	ItemMarketItemSet_UpdateMoneyByWarehouse()
	local	self	= ItemMarketItemSet
	
	self.invenMoney:SetText( ": " .. makeDotMoney(getSelfPlayer():get():getInventory():getMoney_s64()) )
	self.warehouseMoney:SetText( "창고에 보유하고 있는 금액" )
	self.warehouseMoney:SetText( ": " .. makeDotMoney(warehouse_moneyFromNpcShop_s64()) )
end

function ItemMarketItemSet:registEventHandler()
	self.btn_Close			:addInputEvent("Mouse_LUp",			"HandleClicked_ItemMarketItemSet_Close()")
	self.btn_RegistItem		:addInputEvent("Mouse_LUp",			"HandleClicked_ItemMarketRegistItem_Open()")
	self.panelBG			:addInputEvent("Mouse_DownScroll",	"ItemMarketItemSet_ScrollUpdate( true )")
	self.panelBG			:addInputEvent("Mouse_UpScroll",	"ItemMarketItemSet_ScrollUpdate( fasle )")
	self.scroll				:addInputEvent("Mouse_DownScroll",	"ItemMarketItemSet_ScrollUpdate( true )")
	self.scroll				:addInputEvent("Mouse_UpScroll",	"ItemMarketItemSet_ScrollUpdate( fasle )")
	self.scroll				:addInputEvent("Mouse_LUp",			"HandleClicked_ItemMarketItemSet_SetScrollIndexByLClick()")
	self.scrollCtrlBTN		:addInputEvent("Mouse_LPress",		"HandleClicked_ItemMarketItemSet_SetScrollIndexByLClick()")

	self._buttonQuestion	:addInputEvent( "Mouse_LUp",		"Panel_WebHelper_ShowToggle( \"ItemMarket\" )" )								-- 물음표 좌클릭
	self._buttonQuestion	:addInputEvent( "Mouse_On",			"HelpMessageQuestion_Show( \"ItemMarket\", \"true\")" )				-- 물음표 마우스오버
	self._buttonQuestion	:addInputEvent( "Mouse_Out",		"HelpMessageQuestion_Show( \"ItemMarket\", \"false\")" )			-- 물음표 마우스오버

end
function ItemMarketItemSet:registMessageHandler()
	registerEvent("FromClient_InventoryUpdate",			"ItemMarketItemSet_UpdateMoneyByWarehouse")
	registerEvent("EventWarehouseUpdate",				"ItemMarketItemSet_UpdateMoneyByWarehouse")
	registerEvent("FromClient_WarehousePushMoney",		"ItemMarketItemSet_UpdateMoney")
end

ItemMarketItemSet:Initialize()
ItemMarketItemSet:registEventHandler()
ItemMarketItemSet:registMessageHandler()