local IM = CppEnums.EProcessorInputMode

local petNaming			= UI.getChildControl( Panel_Window_PetRegister, "Edit_Naming" )
local petRegister		= UI.getChildControl( Panel_Window_PetRegister, "Button_Yes" )
local petRegisterCancel	= UI.getChildControl( Panel_Window_PetRegister, "Button_No" )
local petIcon			= UI.getChildControl( Panel_Window_PetRegister, "Static_Icon" )

local tempFromWhereType = nil
local tempFromSlotNo	= nil

function petRegister_init()
	petNaming:SetEditText(PAGetString(Defines.StringSheet_GAME, "LUA_STABLEINFO_EDITBOX_COMMENT"), true)
end

function petRegister_Close()
	if	( not Panel_Window_PetRegister:GetShow() )	then
		return
	end
	UI.Set_ProcessorInputMode(IM.eProcessorInputMode_UiMode)
	Panel_Window_PetRegister:SetShow( false )
end

function FromClient_InputPetName( fromWhereType, fromSlotNo )
	tempFromWhereType	= fromWhereType
	tempFromSlotNo		= fromSlotNo

	local petName		= petNaming:GetEditText()
	local	itemWrapper = getInventoryItemByType( fromWhereType, fromSlotNo )
	if	nil == itemWrapper	then
		return
	end
	characterKey			= itemWrapper:getStaticStatus():get()._contentsEventParam1

	local petRegisterPSS	= ToClient_getPetStaticStatus( characterKey )
	local petIconPath		= petRegisterPSS:getIconPath()
	petIcon:ChangeTextureInfoName( petIconPath )

	petNaming:SetEditText( "", true )
	petNaming:SetMaxInput( 10 )
	ClearFocusEdit( petNaming )

	Panel_Window_PetRegister:SetShow( true )
end

function HandleClicked_PetRegister_Register()
	local fromWhereType	= tempFromWhereType
	local fromSlotNo	= tempFromSlotNo
	local petName		= petNaming:GetEditText()

	ToClient_requestPetRegister( petName, fromWhereType, fromSlotNo )
	UI.Set_ProcessorInputMode(IM.eProcessorInputMode_UiMode)
	petRegister_Close()
end

function FromClient_PetAddSealedList( petNo, reason )
	if reason == nil then
		return
	end
	
	if reason == 1 then
		FGlobal_PetListNew_Open()
		-- FGlobal_PetListNew_RegistOpen()
	end
end

function HandleClicked_PetRegister_Close()
	petRegister_Close()
end

function HandleClicked_PetRegister_ClearEdit()
	UI.Set_ProcessorInputMode(IM.eProcessorInputMode_ChattingInputMode)
	petNaming:SetEditText( "", false )
	SetFocusEdit( petNaming )
end

function FGlobal_PetRegister_Close()
	UI.Set_ProcessorInputMode(IM.eProcessorInputMode_UiMode)
	Panel_Window_PetRegister:SetShow( false )
end

function petRegister_registEventHandler()
	petRegister			:addInputEvent(	"Mouse_LUp",	"HandleClicked_PetRegister_Register()" )
	petRegisterCancel	:addInputEvent(	"Mouse_LUp",	"HandleClicked_PetRegister_Close()" )
	petNaming			:addInputEvent(	"Mouse_LUp",	"HandleClicked_PetRegister_ClearEdit()" )	
end

function petRegister_registMessageHandler()
	registerEvent("FromClient_InputPetName",		"FromClient_InputPetName")
	registerEvent("FromClient_PetAddSealedList",	"FromClient_PetAddSealedList")
end


petRegister_init()
petRegister_registEventHandler()
petRegister_registMessageHandler()
-- UI.Set_ProcessorInputMode(IM.eProcessorInputMode_ChattingInputMode)
-- 