Panel_HorseHp:SetShow(false, false)

local	servantHpBar	= {
	_staticBar		= UI.getChildControl( Panel_HorseHp, "HorseHpBar" ),
	_staticText		= UI.getChildControl( Panel_HorseHp, "StaticText_Hp" ),
	_actorKeyRaw	= 0
}

function HorseHP_init()
	Panel_HorseHp	:ComputePos()
end

function HorseHP_Update()
	local	self			= servantHpBar
	local	temporaryWrapper= getTemporaryInformationWrapper()
	
	local	unsealCacheData	= temporaryWrapper:getUnsealVehicleByActorKeyRaw( self._actorKeyRaw )
	if	(nil == unsealCacheData)	then
		return
	end
	
	-- local	landVehicleWrapper	= temporaryWrapper:getUnsealVehicle( CppEnums.ServantType.Type_Vehicle )
	
	-- -- nil Check를 반드시 합시다..
	-- if( nil == landVehicleWrapper ) then
	-- 	return;
	-- end

	--[[local	vehicleWrapper		= getVehicleActor( landVehicleWrapper:getActorKeyRaw() )
	
	-- 마차면 getVehicleType()==9
	if (landVehicleWrapper:getVehicleType() == CppEnums.VehicleType.Type_Carriage or landVehicleWrapper:getVehicleType() == CppEnums.VehicleType.Type_CowCarriage) then
		HorseHP_Close()
		return
	end--]]

	self._staticBar	:SetProgressRate( unsealCacheData:getHp() / unsealCacheData:getMaxHp() * 100 )	
	self._staticText:SetText( tostring(unsealCacheData:getHp()) .. "/" .. tostring(unsealCacheData:getMaxHp()) )
end

servantHpBar._staticBar:addInputEvent("Mouse_On",			"HandleOn_HorseHp_Bar()")
servantHpBar._staticBar:addInputEvent("Mouse_Out",			"HandleOut_HorseHp_Bar()")

function	HandleOn_HorseHp_Bar()
	servantHpBar._staticText:SetShow(true)
end

function	HandleOut_HorseHp_Bar()
	servantHpBar._staticText:SetShow(false)
end

function	HorseHP_OpenByInteraction()
	local	self			= servantHpBar
	local	selfPlayer		= getSelfPlayer()
	local	selfProxy		= selfPlayer:get()
	local	actorKeyRaw		= selfProxy:getRideVehicleActorKeyRaw()
	local	temporaryWrapper= getTemporaryInformationWrapper()
	local	servantInfo		= temporaryWrapper:getUnsealVehicleByActorKeyRaw( actorKeyRaw )
	if	( nil == servantInfo )	then
		return
	end
	
	self._actorKeyRaw	= actorKeyRaw
	
	HorseHP_Open()
end

function	HorseHP_Open()
	if	( Panel_HorseHp:GetShow() ) then
		return
	end
	Panel_HorseHp:SetShow( true )
	HorseHP_Update()
end

function	HorseHP_Close()
	if	( not Panel_HorseHp:GetShow() ) then
		return
	end
	Panel_HorseHp:SetShow( false )
end

registerEvent("EventSelfServantUpdate",			"HorseHP_Update"			)
registerEvent("EventSelfPlayerRideOff",			"HorseHP_Close"				)
registerEvent("EventSelfPlayerRideOn",			"HorseHP_OpenByInteraction"	)
HorseHP_init()