Panel_Window_StableRegister:SetShow(false, false)
Panel_Window_StableRegister:setMaskingChild(true)
Panel_Window_StableRegister:ActiveMouseEventEffect(true)
--Panel_Window_StableRegister:setGlassBackground(true)
--Panel_Window_StableRegister:RegisterShowEventFunc( true, '' )
--Panel_Window_StableRegister:RegisterShowEventFunc( false, '' )

local UI_ANI_ADV 	= CppEnums.PAUI_ANIM_ADVANCE_TYPE
local UI_color 		= Defines.Color

local	stableRegister	= {	
	config	=
	{
		skillIconX			= 40,
		skillIconY			= 170,
		skillTextX			= 35,
		skillTextY			= 205,
		skillGapX			= 70,
		
		skillCount			= 5
	},
	-- 마패, 등록증 부분.
	_staticIcon					= UI.getChildControl( Panel_Window_StableRegister, 	"Static_Icon" ),
			
	_staticHp					= UI.getChildControl( Panel_Window_StableRegister, 	"Static_Hp" ),
	_staticHpValue				= UI.getChildControl( Panel_Window_StableRegister, 	"Static_HpValue" ),
	_staticMp					= UI.getChildControl( Panel_Window_StableRegister, 	"Static_Stamina" ),
	_staticMpValue				= UI.getChildControl( Panel_Window_StableRegister, 	"Static_StaminaValue" ),
	_staticWeight				= UI.getChildControl( Panel_Window_StableRegister, 	"Static_Weight" ),
	_staticWeightValue			= UI.getChildControl( Panel_Window_StableRegister, 	"Static_WeightValue" ),
	_staticLife					= UI.getChildControl( Panel_Window_StableRegister, 	"Static_Life" ),
	_staticLifeValue			= UI.getChildControl( Panel_Window_StableRegister, 	"Static_LifeValue" ),
	
	_staticMaxMoveSpeed			= UI.getChildControl( Panel_Window_StableRegister, 	"Static_MaxMoveSpeed" ),
	_staticMaxMoveSpeedValue	= UI.getChildControl( Panel_Window_StableRegister, 	"Static_MaxMoveSpeedValue" ),
	_staticAcceleration			= UI.getChildControl( Panel_Window_StableRegister, 	"Static_Acceleration" ),
	_staticAccelerationValue	= UI.getChildControl( Panel_Window_StableRegister, 	"Static_AccelerationValue" ),
	_staticCorneringSpeed		= UI.getChildControl( Panel_Window_StableRegister, 	"Static_CorneringSpeed" ),
	_staticCorneringSpeedValue	= UI.getChildControl( Panel_Window_StableRegister, 	"Static_CorneringSpeedValue" ),
	_staticBrakeSpeed			= UI.getChildControl( Panel_Window_StableRegister, 	"Static_BrakeSpeed" ),
	_staticBrakeSpeedValue		= UI.getChildControl( Panel_Window_StableRegister, 	"Static_BrakeSpeedValue" ),
	
	-- 시장 등록
	_staticMarketIcon					= UI.getChildControl( Panel_Servant_Market_Input, 	"Static_Icon" ),
			
	_staticMarketHp						= UI.getChildControl( Panel_Servant_Market_Input, 	"Static_Hp" ),
	_staticMarketHpValue				= UI.getChildControl( Panel_Servant_Market_Input, 	"Static_HpValue" ),
	_staticMarketMp						= UI.getChildControl( Panel_Servant_Market_Input, 	"Static_Stamina" ),
	_staticMarketMpValue				= UI.getChildControl( Panel_Servant_Market_Input, 	"Static_StaminaValue" ),
	_staticMarketWeight					= UI.getChildControl( Panel_Servant_Market_Input, 	"Static_Weight" ),
	_staticMarketWeightValue			= UI.getChildControl( Panel_Servant_Market_Input, 	"Static_WeightValue" ),
	_staticMarketLife					= UI.getChildControl( Panel_Servant_Market_Input, 	"Static_Life" ),
	_staticMarketLifeValue				= UI.getChildControl( Panel_Servant_Market_Input, 	"Static_LifeValue" ),
	
	_staticMarketMaxMoveSpeed			= UI.getChildControl( Panel_Servant_Market_Input, 	"Static_MaxMoveSpeed" ),
	_staticMarketMaxMoveSpeedValue		= UI.getChildControl( Panel_Servant_Market_Input, 	"Static_MaxMoveSpeedValue" ),
	_staticMarketAcceleration			= UI.getChildControl( Panel_Servant_Market_Input, 	"Static_Acceleration" ),
	_staticMarketAccelerationValue		= UI.getChildControl( Panel_Servant_Market_Input, 	"Static_AccelerationValue" ),
	_staticMarketCorneringSpeed			= UI.getChildControl( Panel_Servant_Market_Input, 	"Static_CorneringSpeed" ),
	_staticMarketCorneringSpeedValue	= UI.getChildControl( Panel_Servant_Market_Input, 	"Static_CorneringSpeedValue"),
	_staticMarketBrakeSpeed				= UI.getChildControl( Panel_Servant_Market_Input, 	"Static_BrakeSpeed" ),
	_staticMarketBrakeSpeedValue		= UI.getChildControl( Panel_Servant_Market_Input, 	"Static_BrakeSpeedValue" ),

	_editEditName				= UI.getChildControl( Panel_Window_StableRegister,	"Edit_Naming"),
	_buttonOk					= UI.getChildControl( Panel_Window_StableRegister,	"Button_Yes"),
	_buttonClose				= UI.getChildControl( Panel_Window_StableRegister,	"Button_No"),
	
	_buttonQuestion				= UI.getChildControl( Panel_Servant_Market_Input,	"Button_Question" ),			-- 물음표 버튼

	_textMinPriceValue			= UI.getChildControl( Panel_Servant_Market_Input, 	"StaticText_MinPriceValue"),
	_textMaxPriceValue			= UI.getChildControl( Panel_Servant_Market_Input, 	"StaticText_MaxPriceValue"),
	_buttonMarketOk				= UI.getChildControl( Panel_Servant_Market_Input,	"Button_Yes"),
	_buttonMarketClose			= UI.getChildControl( Panel_Servant_Market_Input,	"Button_No"),
	_editEditMarketName			= UI.getChildControl( Panel_Servant_Market_Input,	"Edit_Naming"),

	_inventoryType				= nil,
	_inventorySlotNo			= nil,
	_characterKey				= nil,
	_level						= nil,
	_type						= nil,
	_minPrice					= nil,
	_maxPrice					= nil,
}

----------------------------------------------------------------------------------------------------
-- Init Function
function	stableRegister:init()
	self._editEditName:SetMaxInput( getNameSize() )
	
	self._staticIcon:SetShow(true)
	self._staticHp:SetShow(true)
	self._staticHpValue:SetShow(true)
	self._staticMp:SetShow(true)
	self._staticMpValue:SetShow(true)
	self._staticWeight:SetShow(true)
	self._staticWeightValue:SetShow(true)	
	self._staticLife:SetShow(true)
	self._staticLifeValue:SetShow(true)
	
	self._staticMaxMoveSpeed:SetShow(true)
	self._staticMaxMoveSpeedValue:SetShow(true)
	self._staticAcceleration:SetShow(true)
	self._staticAccelerationValue:SetShow(true)
	self._staticCorneringSpeed:SetShow(true)
	self._staticCorneringSpeedValue:SetShow(true)
	self._staticBrakeSpeed:SetShow(true)
	self._staticBrakeSpeedValue:SetShow(true)	
	
	self._editEditName:SetShow(true)
	self._buttonOk:SetShow(true)
	self._buttonClose:SetShow(true)



end

function	stableRegister:update()
	local	servantInfo	= nil
	if	( CppEnums.ServantRegist.eEventType_RegisterMating == self._type ) or ( CppEnums.ServantRegist.eEventType_RegisterMarket == self._type )	then
		servantInfo	= stable_getServant( StableList_SelectSlotNo() )
	else
		servantInfo	= stable_getServantByCharacterKey( self._characterKey, self._level )
	end
	if	( nil == servantInfo )	then
		return
	end
	
	-- local	index		= StableList_SelectSlotNo()
	-- local	servantInfo	= stable_getServant( index )
	-- if	nil == servantInfo	then
	-- 	return
	-- end
	local	vehicleType	= servantInfo:getVehicleType()

	if ( CppEnums.VehicleType.Type_Carriage == vehicleType ) or ( CppEnums.VehicleType.Type_CowCarriage == vehicleType ) then
		self._staticHp:SetText( "내구도" )
		self._staticMp:SetText( "수명")
		self._staticLife:SetText( "남은 기간" )
		self._staticMarketHp:SetText( "내구도" )
		self._staticMarketMp:SetText( "수명")
		self._staticMarketLife:SetText( "남은 기간" )
	else
		self._staticHp:SetText( "생명력" )
		self._staticMp:SetText( "지구력")
		self._staticLife:SetText( "남은 수명" )
		self._staticMarketHp:SetText( "생명력" )
		self._staticMarketMp:SetText( "지구력")
		self._staticMarketLife:SetText( "남은 수명" )
	end

	self._editEditName:SetEditText(PAGetString(Defines.StringSheet_GAME, "LUA_STABLEINFO_EDITBOX_COMMENT"), true)
	
	self._staticIcon				:ChangeTextureInfoName( servantInfo:getIconPath1() )
	self._staticHpValue				:SetText( makeDotMoney(servantInfo:getMaxHp()) )
	self._staticMpValue				:SetText( makeDotMoney(servantInfo:getMaxMp()) )
	self._staticWeightValue			:SetText( makeDotMoney(servantInfo:getMaxWeight_s64() / Defines.s64_const.s64_10000) )
	self._staticMaxMoveSpeedValue	:SetText(string.format( "%.1f",(servantInfo:getStat(CppEnums.ServantStatType.Type_MaxMoveSpeed)/10000)	)	.. "%"	)
	self._staticAccelerationValue	:SetText(string.format( "%.1f",(servantInfo:getStat(CppEnums.ServantStatType.Type_Acceleration)/10000)	)	.. "%"	)
	self._staticCorneringSpeedValue	:SetText(string.format( "%.1f",(servantInfo:getStat(CppEnums.ServantStatType.Type_CorneringSpeed)/10000)	)	.. "%"	)
	self._staticBrakeSpeedValue		:SetText(string.format( "%.1f",(servantInfo:getStat(CppEnums.ServantStatType.Type_BrakeSpeed)/10000)		)	.. "%"	)
	
	if	( servantInfo:isPeriodLimit() )	then
		self._staticLifeValue:SetText( (servantInfo:getStaticExpiredTime() / 60 / 60 / 24) .. PAGetString(Defines.StringSheet_RESOURCE, "STABLE_INFO_TEXT_LIFETIME") )
		self._staticMarketLifeValue:SetText( (servantInfo:getStaticExpiredTime() / 60 / 60 / 24) .. PAGetString(Defines.StringSheet_RESOURCE, "STABLE_INFO_TEXT_LIFETIME") )
	else
		self._staticLifeValue:SetText( PAGetString(Defines.StringSheet_RESOURCE, "STABLE_INFO_TEXT_LIFEVALUE") )
		self._staticMarketLifeValue:SetText( PAGetString(Defines.StringSheet_RESOURCE, "STABLE_INFO_TEXT_LIFEVALUE") )
	end	
	
	-- 가격 표시
	if	( (nil ~=self._minPrice) and (nil ~= self._maxPrice) )	then
		self._editEditMarketName:SetEditText( "가격을 입력해주세요." )
		self._editEditMarketName:SetNumberMode(true)
		self._textMinPriceValue:SetText( makeDotMoney(self._minPrice) )
		self._textMaxPriceValue:SetText( makeDotMoney(self._maxPrice) )

		self._staticMarketIcon					:ChangeTextureInfoName( servantInfo:getIconPath1() )
		self._staticMarketHpValue				:SetText( servantInfo:getMaxHp() )
		self._staticMarketMpValue				:SetText( servantInfo:getMaxMp() )
		self._staticMarketWeightValue			:SetText( tostring(servantInfo:getMaxWeight_s64() / Defines.s64_const.s64_10000) )
		self._staticMarketMaxMoveSpeedValue		:SetText(string.format( "%.1f",(servantInfo:getStat(CppEnums.ServantStatType.Type_MaxMoveSpeed)/10000)	)	.. "%"	)
		self._staticMarketAccelerationValue		:SetText(string.format( "%.1f",(servantInfo:getStat(CppEnums.ServantStatType.Type_Acceleration)/10000)	)	.. "%"	)
		self._staticMarketCorneringSpeedValue	:SetText(string.format( "%.1f",(servantInfo:getStat(CppEnums.ServantStatType.Type_CorneringSpeed)/10000)	)	.. "%"	)
		self._staticMarketBrakeSpeedValue		:SetText(string.format( "%.1f",(servantInfo:getStat(CppEnums.ServantStatType.Type_BrakeSpeed)/10000)		)	.. "%"	)

	else
		self._editEditName:SetEditText( PAGetString(Defines.StringSheet_GAME, "LUA_STABLEINFO_EDITBOX_COMMENT") )
	end
	
	
end

function	stableRegister:registEventHandler()
	self._buttonOk:addInputEvent(				"Mouse_LUp",	"StableRegister_Register()"		)
	self._buttonMarketOk:addInputEvent( 		"Mouse_LUp",	"StableRegister_MarketRegister()" 	)
	self._buttonClose:addInputEvent(			"Mouse_LUp",	"StableRegister_Close()"		)
	self._buttonMarketClose:addInputEvent(		"Mouse_LUp",	"StableMarketInput_Close()"		)
	self._editEditName:addInputEvent(			"Mouse_LUp",	"StableRegister_ClearEdit( 1 )"	)
	self._editEditMarketName:addInputEvent(		"Mouse_LUp",	"StableRegister_ClearEdit( 2 )"	)

	self._buttonQuestion:addInputEvent(	"Mouse_LUp",	"Panel_WebHelper_ShowToggle( \"PanelWindowStableRegister\" )"			)	--물음표 좌클릭
	self._buttonQuestion:addInputEvent(	"Mouse_On",		"HelpMessageQuestion_Show( \"PanelWindowStableRegister\", \"true\")"	)    --물음표 마우스오버
	self._buttonQuestion:addInputEvent(	"Mouse_Out",	"HelpMessageQuestion_Show( \"PanelWindowStableRegister\", \"false\")"	)    --물음표 마우스아웃
end

function	stableRegister:registMessageHandler()
	registerEvent("FromClient_ServantChildInfo",		"StableRegister_OpenByMating"	)	
	registerEvent("FromClient_ServantRegisterToAuction","StableRegister_Close"			)
	registerEvent("onScreenResize",						"StableRegister_Resize"			)	
end

function StableRegister_Resize()
	local	self	= stableRegister
	local	screenX = getScreenSizeX()
	local	screenY = getScreenSizeY()

	--Panel_Window_StableRegister:SetSize(screenX, screenY )
	Panel_Window_StableRegister:ComputePos()

	self._staticIcon:ComputePos()
	self._staticHp:ComputePos()
	self._staticHpValue:ComputePos()
	self._staticMp:ComputePos()
	self._staticMpValue:ComputePos()
	self._staticWeight:ComputePos()
	self._staticWeightValue:ComputePos()	
	self._staticLife:ComputePos()
	self._staticLifeValue:ComputePos()
	
	self._staticMaxMoveSpeed:ComputePos()
	self._staticMaxMoveSpeedValue:ComputePos()
	self._staticAcceleration:ComputePos()
	self._staticAccelerationValue:ComputePos()
	self._staticCorneringSpeed:ComputePos()
	self._staticCorneringSpeedValue:ComputePos()
	self._staticBrakeSpeed:ComputePos()
	self._staticBrakeSpeedValue:ComputePos()
end

----------------------------------------------------------------------------------------------------
-- Button Function
function	StableRegister_Register()
	-- ♬ 말을 등록한다.
	audioPostEvent_SystemUi(00,00)
	
	local	self		= stableRegister
	local	name		= self._editEditName:GetEditText()
	
	if	(CppEnums.ServantRegist.eEventType_Mating == self._type )	then
		stable_receiveServantMatingChild( StableList_SelectSlotNo(), name )
	elseif	( CppEnums.ServantRegist.eEventType_Taming == self._type )	then
		ServantIcon_TamingServant_Registed()
		stable_register( name )
	elseif	( CppEnums.ServantRegist.eEventType_Inventory == self._type )	then
		stable_registerByItem( self._inventoryType, self._inventorySlotNo, name )
	elseif	( CppEnums.ServantRegist.eEventType_ChangeName == self._type )	then
		stable_changeName( StableList_SelectSlotNo(), name )
	else
		UI.ASSERT( false, "에러!" )
	end
	
	self._editEditName:SetEditText("", true)
end

function StableRegister_MarketRegister()
	if type(tonumber(stableRegister._editEditMarketName:GetEditText())) ~= "number" then
		Proc_ShowMessage_Ack("탈 것의 가격을 입력해주세요.")
		return
	end

	-- ♬ 말을 등록한다.
	audioPostEvent_SystemUi(00,00)

	local	self		= stableRegister
	local	marketName	= self._editEditMarketName:GetEditText()

	if	( CppEnums.ServantRegist.eEventType_RegisterMarket == self._type )	then
		StableList_RegisterMarketXXXXXX( tonumber(marketName) )
		StableMarketInput_Close()
	elseif	( CppEnums.ServantRegist.eEventType_RegisterMating == self._type )	then
		StableList_RegisterMatingXXXXX( tonumber(marketName) )
		StableMarketInput_Close()
	else
		UI.ASSERT( false, "에러!" )
	end

	self._editEditMarketName:SetEditText("", true)
end

function	StableRegister_ClearEdit( clearIdx )
	local	self	= stableRegister
	
	if clearIdx == 1 then
		self._editEditName:SetEditText("", true)
		SetFocusEdit(self._editEditName)
	elseif clearIdx == 2 then
		self._editEditMarketName:SetEditText("", true)
		SetFocusEdit(self._editEditMarketName)
	end
end
----------------------------------------------------------------------------------------------------
--Window Open Function
function	StableRegister_OpenByMating( characterKey )
	if	( CppEnums.ServantType.Type_Vehicle ~= stable_getServantType() )	then
		return
	end
	
	local	self		= stableRegister
	
	self._type			= CppEnums.ServantRegist.eEventType_Mating
	self._characterKey	= characterKey
	self._level			= 1
	self._minPrice		= nil
	self._maxPrice		= nil
	StableRegister_Open()
end

function	StableRegister_OpenByTaming()
	local	self		= stableRegister
	local	characterKey= stable_getTamingServantCharacterKey()
	if	nil == characterKey	then
		return
	end
	
	self._type			= CppEnums.ServantRegist.eEventType_Taming
	self._characterKey	= characterKey
	self._level			= 1
	self._minPrice		= nil
	self._maxPrice		= nil
	StableRegister_Open()
end

function	StableRegister_OpenByInventory( inventoryType, inventorySlotNo )
	local	self		= stableRegister
	local	itemWrapper = getInventoryItemByType( inventoryType, inventorySlotNo )
	if	nil == itemWrapper	then
		return
	end
	self._type				= CppEnums.ServantRegist.eEventType_Inventory
	self._inventoryType		= inventoryType
	self._inventorySlotNo	= inventorySlotNo
	self._characterKey		= itemWrapper:getStaticStatus():getObjectKey()
	self._level				= 1
	self._minPrice			= nil
	self._maxPrice			= nil
	StableRegister_Open()
end

function	StableRegister_OpenByEventType( eventType )
	local	self		= stableRegister
	local	servantInfo	= stable_getServant( StableList_SelectSlotNo() )
	if	( nil == servantInfo )	then
		return
	end
	
	self._type			= eventType
	self._characterKey	= servantInfo:getCharacterKey()
	self._level			= servantInfo:getLevel()
	
	if	( CppEnums.ServantRegist.eEventType_RegisterMating == eventType )	then
		self._minPrice		= servantInfo:getMinRegisterMatingPrice_s64()
		self._maxPrice		= servantInfo:getMaxRegisterMatingPrice_s64()
		StableMarketInput_Open()
	elseif	( CppEnums.ServantRegist.eEventType_RegisterMarket == eventType )	then
		self._minPrice		= servantInfo:getMinRegisterMarketPrice_s64()
		self._maxPrice		= servantInfo:getMaxRegisterMarketPrice_s64()
		StableMarketInput_Open()
	else
		self._minPrice		= nil
		self._maxPrice		= nil
		StableRegister_Open()
	end
end

----------------------------------------------------------------------------------------------------
--Window Open/Close
function	StableRegister_Open()
	if	( Panel_Window_StableRegister:GetShow() )	then
		return
	end
	
	local	self	= stableRegister	
	self:update()
	
	Panel_Window_StableRegister:SetShow( true )
end

function	StableRegister_Close()
	audioPostEvent_SystemUi(00,00)
	
	if	( not Panel_Window_StableRegister:GetShow() )	then
		return
	end
	
	audioPostEvent_SystemUi(01,01)
	Panel_Window_StableRegister:SetShow( false )
end

function StableMarketInput_Open()
	if	( Panel_Servant_Market_Input:GetShow() )	then
		return
	end
	
	local	self	= stableRegister	
	self:update()
	
	Panel_Servant_Market_Input:SetShow( true )
end

function StableMarketInput_Close()
	audioPostEvent_SystemUi(00,00)
	
	if	( not Panel_Servant_Market_Input:GetShow() )	then
		return
	end
	
	audioPostEvent_SystemUi(01,01)
	Panel_Servant_Market_Input:SetShow( false )
end
----------------------------------------------------------------------------------------------------
-- Init

stableRegister:init()
stableRegister:registEventHandler()
stableRegister:registMessageHandler()

StableRegister_Resize()