--Made By Xennma
--Check sent string for translation in database
_G["GetEnStr"] = function(krStr)
	local str = _G["TransStrDB"][krStr]
	if str then
		return str
	else
		_G.LogNonTransStr(krStr)
		return krStr
	end
end
 
_G["TransStrDB"] = {}
for line in io.lines("C:\\Daum Games\\TranslationDB.txt") do
	local isKey = true
	local key = ""
	local val = ""
	local str = string.find(line, "@:@")
	key = string.sub(line, 0, str - 1)
	val = string.sub(line, str + 3)
	_G["TransStrDB"][key] = val
end

_G["NonTransStrDB"] = {}
for line in io.lines("C:\\Daum Games\\NoTranslationDB.txt") do
	_G["NonTransStrDB"][line] = true
end

--Write strings without translations to local file
_G["LogNonTransStr"] = function(krStr)
	if krStr ~= "" and krStr ~= " " then
		if string.find(krStr, '[ㄱ-쭌]') ~= nil then
			local str = _G["NonTransStrDB"][krStr]
			if str == nil then
				local fileOut = io.open("C:\\Daum Games\\NoTranslationDB.txt", "a")
				io.output(fileOut)
				io.write(krStr.."\n")
				io.close(fileOut)
				_G["NonTransStrDB"][krStr] = true
			end
		end
	end
end

-- Trying to be smart and hooking some functions
__PAUIStatic_SetText = PAUIStatic.SetText 

PAUIStatic.SetText = function (self, str)
	__PAUIStatic_SetText(self, GetEnStr(str))
end

__PAUIMultilineText_SetText = PAUIMultilineText.SetText 

PAUIMultilineText.SetText = function (self, str)
	__PAUIMultilineText_SetText(self, GetEnStr(str))
end

__PAUICombobox_SetText = PAUICombobox.SetText 

PAUICombobox.SetText = function (self, str)
	__PAUICombobox_SetText(self, GetEnStr(str))
end