local UI_TM 		= CppEnums.TextMode
local UI_PUCT 		= CppEnums.PA_UI_CONTROL_TYPE
local UI_ANI_ADV 	= CppEnums.PAUI_ANIM_ADVANCE_TYPE
local UI_PSFT 		= CppEnums.PAUI_SHOW_FADE_TYPE
local UI_color 		= Defines.Color

-- 사운드 추가 필요
Panel_SelfPlayerExpGage:SetShow( true, false )
Panel_SelfPlayerExpGage:SetIgnore(true)
Panel_SelfPlayerExpGage:ActiveMouseEventEffect(false)
Panel_SelfPlayerExpGage:RegisterShowEventFunc( true, 'SelfPlayerExpGageShowAni()' )
Panel_SelfPlayerExpGage:RegisterShowEventFunc( false, 'SelfPlayerExpGageHideAni()' )

local _levelBG 					= UI.getChildControl( Panel_SelfPlayerExpGage, "Static_LevelBG" )

local expGageBG 				= UI.getChildControl( Panel_SelfPlayerExpGage, "Static_SelfPlayerExpBG" )
local expGage 					= UI.getChildControl( Panel_SelfPlayerExpGage, "Progress2_ExpGage" )
local _expHead 					= UI.getChildControl( expGage, 					"Progress2_ExpGage_Head" )
local _staticLevel 				= UI.getChildControl( Panel_SelfPlayerExpGage, "StaticText_Level" )
local _staticLevelSub 			= UI.getChildControl( Panel_SelfPlayerExpGage, "StaticText_Level_Sub" )
local expText 					= UI.getChildControl( Panel_SelfPlayerExpGage, "StaticText_EXPText" )

local _skillGaugeBG 			= UI.getChildControl( Panel_SelfPlayerExpGage, "Static_SkillGauge_BG" )
local _staticSkillExp 			= UI.getChildControl( Panel_SelfPlayerExpGage, "CircularProgress_SkillExp" )
local _staticSkillExp_Head		= UI.getChildControl( _staticSkillExp, 			"Progress2_1_Bar_Head" )
local _staticSkillPoint 		= UI.getChildControl( Panel_SelfPlayerExpGage, "StaticText_Sp" )
local _staticSkillPointMain		= UI.getChildControl( Panel_SelfPlayerExpGage, "StaticText_Sp_Main" )
local _staticSkillPointSub 		= UI.getChildControl( Panel_SelfPlayerExpGage, "StaticText_Sp_Sub" )

local _wpGaugeBG 				= UI.getChildControl( Panel_SelfPlayerExpGage, "Static_WP_BG" )
local _Wp 						= UI.getChildControl( Panel_SelfPlayerExpGage, "StaticText_WP" )
local _Wp_Main					= UI.getChildControl( Panel_SelfPlayerExpGage, "StaticText_WP_Main" )
local _wpGauge 					= UI.getChildControl( Panel_SelfPlayerExpGage, "Progress2_WP" )
local _wpGauge_Head				= UI.getChildControl( _wpGauge, 				"Progress2_1_Bar_Head" )
local _WpHelpMSG 				= UI.getChildControl( Panel_SelfPlayerExpGage, "StaticText_WPHelp" )

local _contribute_BG 			= UI.getChildControl( Panel_SelfPlayerExpGage, "Static_Contribute_BG" )
local _contribute_progress		= UI.getChildControl( Panel_SelfPlayerExpGage, "Progress_Contribute" )
local _contribute_progress_Head	= UI.getChildControl( _contribute_progress, 	"Progress2_1_Bar_Head" )
local _contribute_txt 			= UI.getChildControl( Panel_SelfPlayerExpGage, "StaticText_ContributeP" )
local _contribute_Main 			= UI.getChildControl( Panel_SelfPlayerExpGage, "StaticText_Contribute_Main" )
local _contribute_helpMsg		= UI.getChildControl( Panel_SelfPlayerExpGage, "StaticText_ContributeHelpMsg" )

local _close_ExpGauge 			= UI.getChildControl( Panel_SelfPlayerExpGage, "Button_Win_Close" )

local _btn_NewSkill				= UI.getChildControl( Panel_SelfPlayerExpGage, "Button_NewSkill" )
local _txt_NewSkill				= UI.getChildControl( Panel_SelfPlayerExpGage, "StaticText_Number" )
local _txt_NewSkillDesc			= UI.getChildControl( Panel_SelfPlayerExpGage, "StaticText_NewSkillHelp" )

local _pcRoomIcon				= UI.getChildControl( Panel_SelfPlayerExpGage, "Static_PCRoom" )
local _starterPackage			= UI.getChildControl( Panel_SelfPlayerExpGage, "Static_StarterPackageIcon")
local _premiumPackage			= UI.getChildControl( Panel_SelfPlayerExpGage, "Static_PremiumPackageIcon")
local _pearlPackage				= UI.getChildControl( Panel_SelfPlayerExpGage, "Static_PearlPackageIcon")

local initPosX = Panel_SelfPlayerExpGage:GetPosX()
local initPosY = Panel_SelfPlayerExpGage:GetPosY()

_close_ExpGauge:SetShow( false )
_Wp:SetIgnore ( false )
_WpHelpMSG:SetAlpha(0)
_WpHelpMSG:SetFontAlpha(0)

local _reservedLearningSkillSlot = 
{
	iconBG 			= UI.getChildControl( Panel_SelfPlayerExpGage, "Static_IconBG" ),
	icon 			= UI.getChildControl( Panel_SelfPlayerExpGage, "Static_SkillIcon" ),
	circularBorder 	= UI.getChildControl( Panel_SelfPlayerExpGage, "CircularProgress_Active" ),
	point			= UI.getChildControl( Panel_SelfPlayerExpGage, "Static_ProgressHead" ),
}

_btn_NewSkill:ActiveMouseEventEffect( true )

_reservedLearningSkillSlot.iconBG:SetShow(false)
_reservedLearningSkillSlot.icon:SetShow(false)
_reservedLearningSkillSlot.circularBorder:SetShow(false)
_reservedLearningSkillSlot.point:SetShow(false)


-------------------------------------------------------------------------------------------------------------------------------------------------------------------------
-------------------------------------------------------------------------------------------------------------------------------------------------------------------------
function SelfPlayerExpGageShowAni()
	-- Panel_SelfPlayerExpGage:SetShowWithFade(UI_PSFT.PAUI_ANI_TYPE_FADE_IN)
		
	-- local PlayerEXPOpen_Alpha = Panel_SelfPlayerExpGage:addColorAnimation( 0.0, 0.35, UI_ANI_ADV.PAUI_ANIM_ADVANCE_SIN_HALF_PI)
	-- PlayerEXPOpen_Alpha:SetStartColor( UI_color.C_00FFFFFF )
	-- PlayerEXPOpen_Alpha:SetEndColor( UI_color.C_FFFFFFFF )
	-- PlayerEXPOpen_Alpha.IsChangeChild = true
	UIAni.AlphaAnimation( 1, Panel_SelfPlayerExpGage, 0.0, 0.2 )
end

function SelfPlayerExpGageHideAni()
	local aniInfo = UIAni.AlphaAnimation( 0, Panel_SelfPlayerExpGage, 0.0, 0.2 )
	aniInfo:SetHideAtEnd(true)
end

-- 화면 사이즈에 따라 리사이징 해준다!
function Panel_SelfPlayerExpGage_onScreenResize()
	local sizeX = getScreenSizeX()
	expGageBG:SetSize (sizeX, 4)
	expGage:SetSize (sizeX, 4)
	-- _levelBG:SetSize (sizeX, _levelBG:GetSizeY())
	expGage:SetProgressRate( 0 )
	FGlobal_PackageIconUpdate()
	ExpGauge_CharacterInfoUpdate_Reload()
end

local _selfExpSimpleUI_MouseOver = false;
function SelfExp_MouseOver( isOver )
	if not getEnableSimpleUI() then
		return;
	end
	SelfExp_MouseOver_Force( isOver );
end
function SelfExp_MouseOver_Force( isOver )
	_selfExpSimpleUI_MouseOver = isOver;
end
function SelfExp_MouseOver_Force_Over()
	SelfExp_MouseOver_Force( false );
end
function SelfExp_MouseOver_Force_Out()
	_levelBG:SetShow(true);
	_levelBG:SetAlpha(1.0);
	
	_skillGaugeBG:SetShow(true);
	_skillGaugeBG:SetAlpha(1.0);
	_staticSkillExp:SetShow(true);
	_staticSkillExp:SetAlpha(1.0);
	_staticSkillExp_Head:SetShow(true);
	_staticSkillExp_Head:SetAlpha(1.0);
	_staticSkillPoint:SetShow(true);
	_staticSkillPoint:SetFontAlpha(1.0);
	_staticSkillPointMain:SetShow(true);
	_staticSkillPointMain:SetFontAlpha(1.0);
	_staticSkillPointSub:SetShow(true);
	_staticSkillPointSub:SetFontAlpha(1.0);
	
	_wpGaugeBG:SetShow(true);
	_wpGaugeBG:SetAlpha(1.0);
	_wpGauge:SetShow(true);
	_wpGauge:SetAlpha(1.0);
	_wpGauge_Head:SetShow(true);
	_wpGauge_Head:SetAlpha(1.0);
	_Wp:SetShow(true);
	_Wp:SetFontAlpha(1.0);
	_Wp_Main:SetShow(true);
	_Wp_Main:SetFontAlpha(1.0);
	
	_contribute_BG:SetShow(true);
	_contribute_BG:SetAlpha(1.0);
	_contribute_progress:SetShow(true);
	_contribute_progress:SetAlpha(1.0);
	_contribute_progress_Head:SetShow(true);
	_contribute_progress_Head:SetAlpha(1.0);
	_contribute_txt:SetShow(true);
	_contribute_txt:SetFontAlpha(1.0);
	_contribute_Main:SetShow(true);
	_contribute_Main:SetFontAlpha(1.0);
end

if getEnableSimpleUI() then
	SelfExp_MouseOver_Force(false);
end

_levelBG:addInputEvent( "Mouse_On", 	"SelfExp_MouseOver( true )" )
_levelBG:addInputEvent( "Mouse_Out", 	"SelfExp_MouseOver( false )" )
registerEvent( "EventSimpleUIEnable",			"SelfExp_MouseOver_Force_Over")
registerEvent( "EventSimpleUIDisable",			"SelfExp_MouseOver_Force_Out")

function SelfExp_SimpleUIUpdatePerFrame( deltaTime )
	local tmpRaderAlphaValue = 0.65;
	local tmpRaderLessAlphaValue = 0.85;
	local tmpRaderMoreAlphaValue = 0.55;
	if _selfExpSimpleUI_MouseOver then
		tmpRaderAlphaValue = 1.0;
		tmpRaderLessAlphaValue = 1.0;
		tmpRaderMoreAlphaValue = 1.0;
	end

	UIAni.perFrameAlphaAnimation(tmpRaderAlphaValue, 	 _levelBG,						2.8 * deltaTime);
	
	UIAni.perFrameAlphaAnimation(tmpRaderMoreAlphaValue, _skillGaugeBG,					3.8 * deltaTime);
	UIAni.perFrameAlphaAnimation(tmpRaderMoreAlphaValue, _staticSkillExp,				3.8 * deltaTime);
	UIAni.perFrameAlphaAnimation(tmpRaderMoreAlphaValue, _staticSkillExp_Head,			3.8 * deltaTime);
	UIAni.perFrameFontAlphaAnimation(tmpRaderLessAlphaValue, _staticSkillPoint,			3.8 * deltaTime);
	UIAni.perFrameFontAlphaAnimation(tmpRaderLessAlphaValue, _staticSkillPointMain,		3.8 * deltaTime);
	UIAni.perFrameFontAlphaAnimation(tmpRaderLessAlphaValue, _staticSkillPointSub,		3.8 * deltaTime);
	UIAni.perFrameAlphaAnimation(tmpRaderMoreAlphaValue, _wpGaugeBG,					3.8 * deltaTime);
	UIAni.perFrameAlphaAnimation(tmpRaderMoreAlphaValue, _wpGauge,						3.8 * deltaTime);
	UIAni.perFrameAlphaAnimation(tmpRaderMoreAlphaValue, _wpGauge_Head,					3.8 * deltaTime);
	UIAni.perFrameFontAlphaAnimation(tmpRaderLessAlphaValue, _Wp,						3.8 * deltaTime);
	UIAni.perFrameFontAlphaAnimation(tmpRaderLessAlphaValue, _Wp_Main,					3.8 * deltaTime);
	UIAni.perFrameAlphaAnimation(tmpRaderMoreAlphaValue, _contribute_BG,				3.8 * deltaTime);
	UIAni.perFrameAlphaAnimation(tmpRaderMoreAlphaValue, _contribute_progress,			3.8 * deltaTime);
	UIAni.perFrameAlphaAnimation(tmpRaderMoreAlphaValue, _contribute_progress_Head,		3.8 * deltaTime);
	UIAni.perFrameFontAlphaAnimation(tmpRaderLessAlphaValue, _contribute_txt,			3.8 * deltaTime);
	UIAni.perFrameFontAlphaAnimation(tmpRaderLessAlphaValue, _contribute_Main,			3.8 * deltaTime);
end

registerEvent( "SimpleUI_UpdatePerFrame",		"SelfExp_SimpleUIUpdatePerFrame")
	

-------------------------------------------------------------------------------------------------------------------------------------------------------------------------
-------------------------------------------------------------------------------------------------------------------------------------------------------------------------

local registEventHandler = function()
	_reservedLearningSkillSlot.icon:addInputEvent( "Mouse_LUp", "ExpGauge_Skill_IconClick()" )
	_reservedLearningSkillSlot.icon:addInputEvent( "Mouse_On",  "ExpGauge_Skill_OverEvent(\"SkillBoxBottom\")" )
	_reservedLearningSkillSlot.icon:addInputEvent( "Mouse_Out", "ExpGauge_Skill_OverEventHide(\"SkillBoxBottom\")" )

	_btn_NewSkill:addInputEvent( "Mouse_LUp", "SkillWindow_OpenForLearn()" )
	_btn_NewSkill:addInputEvent( "Mouse_On", "Panel_SelfPlayer_EnableSkill_HelpDesc( true )" )
	_btn_NewSkill:addInputEvent( "Mouse_Out", "Panel_SelfPlayer_EnableSkill_HelpDesc( false )" )
	-- 기운 이벤트
	_Wp:addInputEvent( "Mouse_On", "wp_HelpMessage(true)" )
	_Wp:addInputEvent( "Mouse_Out", "wp_HelpMessage(false)" )
	_Wp_Main:addInputEvent( "Mouse_On", "wp_HelpMessage(true)" )
	_Wp_Main:addInputEvent( "Mouse_Out", "wp_HelpMessage(false)" )
	-- 공헌도 마우스 이벤트 ( 공헌도에 대한 설명을 적어넣는다! )
	_contribute_txt:addInputEvent("Mouse_On", "contribute_HelpMsg_ShowFunc( true )" )
	_contribute_txt:addInputEvent("Mouse_Out", "contribute_HelpMsg_ShowFunc( false )" )
	_contribute_Main:addInputEvent("Mouse_On", "contribute_HelpMsg_ShowFunc( true )" )
	_contribute_Main:addInputEvent("Mouse_Out", "contribute_HelpMsg_ShowFunc( false )" )
	-- 켜고 끄기 이벤트 함수~!
	_close_ExpGauge:addInputEvent( "Mouse_LUp", "SelfPlayerExpGauge_ShowToggle()" )
	Panel_SelfPlayerExpGage:addInputEvent( "Mouse_On", "ExpGauge_ChangeTexture_On()" )
	Panel_SelfPlayerExpGage:addInputEvent( "Mouse_Out", "ExpGauge_ChangeTexture_Off()" )
	Panel_SelfPlayerExpGage:addInputEvent( "Mouse_LUp", "ResetPos_WidgetButton()" )			--메인UI위젯 위치 초기화
	-- 버프 툴팁
	_pcRoomIcon			:addInputEvent( "Mouse_On",		"BuffIcon_ShowSimpleToolTip( true, 1 )" )
	_pcRoomIcon			:addInputEvent( "Mouse_Out",	"BuffIcon_ShowSimpleToolTip( false )" )
	_starterPackage		:addInputEvent( "Mouse_On",		"BuffIcon_ShowSimpleToolTip( true, 2)" )
	_starterPackage		:addInputEvent( "Mouse_Out",	"BuffIcon_ShowSimpleToolTip( false )" )
	_premiumPackage		:addInputEvent( "Mouse_On",		"BuffIcon_ShowSimpleToolTip( true, 3)" )
	_premiumPackage		:addInputEvent( "Mouse_Out",	"BuffIcon_ShowSimpleToolTip( false )" )
	_pearlPackage		:addInputEvent( "Mouse_On",		"BuffIcon_ShowSimpleToolTip( true, 4)" )
	_pearlPackage		:addInputEvent( "Mouse_Out",	"BuffIcon_ShowSimpleToolTip( false )" )
end
local registMessageHandler = function()
	registerEvent( "onScreenResize", 				"Panel_SelfPlayerExpGage_onScreenResize")
	registerEvent( "EventCharacterInfoUpdate", 		"ExpGauge_CharacterInfoUpdate_Reload")
	
	--registerEvent( "EventCharacterInfoUpdate", 		"Panel_SelfPlayer_EnableSkillCheck_Func")	-- 스킬 포인트가 오를 때,
	registerEvent( "FromClient_SelfPlayerCombatSkillPointChanged", 		"UserSkillPoint_Update") -- 스킬 포인트 혹은 경험치 변경 시 포인트 수치 및 경험치 게이지 표시
	registerEvent( "FromClient_SelfPlayerCombatSkillPointChanged", 		"Panel_SelfPlayer_EnableSkillCheck_Func")	-- 스킬 포인트가 오를 때, 배울 수 있는 스킬 아이콘 표시
	registerEvent( "FromClient_EnableSkillCheck", 	"Panel_SelfPlayer_EnableSkillCheck_Func")	-- 처음 실행될 때
	
	registerEvent("FromClient_SelfPlayerExpChanged", "Panel_SelfPlayerExpGage_CharacterInfoWindowUpdate")
	registerEvent("EventSelfPlayerLevelUp", "UserLevel_Update")
	registerEvent("FromClient_WpChanged", "wpPoint_UpdateFunc")
	registerEvent("FromClient_UpdateExplorePoint", "contributePoint_UpdateFunc")
	registerEvent("FromClient_UpdateCharge", "FromClient_PackageIconUpdate")		-- 주기적으로 온다.
	registerEvent("FromClient_LoadCompleteMsg", "FromClient_PackageIconUpdate")		-- 로딩이 발생했을 경우 한번 호출해 주자

	-- 차후 새로운 스킬이 있을 경우만 체크해야함
	-- Panel_SelfPlayerExpGage:RegisterUpdateFunc("Panel_SelfPlayer_EnableSkillCheck_Func")
	-- registerEvent("EventCharacterInfoUpdate", "Panel_User_ProductSkillPoint_Update")
end

local _lastSkillPoint = -1
local _lastWP = -1
local _lastEXP = -1
local _lastSkillExp = 0
local saved_maxWp = 0
local expHead_EffectKey = 0
local prevLevel = 0

function Panel_SelfPlayerExpGage_CharacterInfoWindowUpdate()
	local selfPlayer = getSelfPlayer()
	if nil == selfPlayer then
		return
	end
	local player = selfPlayer:get()
	local s64_needExp = player:getNeedExp_s64()
	local s64_exp = player:getExp_s64()

	-- int64 의 나누기 연산은 정수 나누기 이기 때문에, 이렇게 작업했다.
	local _const = Defines.s64_const
	local rate = 0
	local rateDisplay = 0
	
	if _const.s64_10000 < s64_needExp then
		rate = Int64toInt32( s64_exp / ( s64_needExp / _const.s64_100 ))
	elseif _const.s64_0 ~= s64_needExp then
		rate = Int64toInt32( (s64_exp * _const.s64_100) / s64_needExp )
	end
	
	if _lastEXP < Int64toInt32( s64_exp) and -1 ~= _lastEXP then
		if ( 0 ~= expHead_EffectKey ) then
			_expHead:EraseEffect(expHead_EffectKey)
		end
		expHead_EffectKey = _expHead:AddEffect("fUI_Gauge_Experience", false, 0.0, 0.0)
	end
	
	
	if 10 > rate then
		rateDisplay = ("0")..rate
	else
		rateDisplay = rate
	end
	
	--local refreshExp = false
	--if prevLevel ~= player:getLevel()  then
	--	prevLevel = player:getLevel()
	--	refreshExp = true
	--end
	
	--if _lastEXP < Int64toInt32( s64_exp ) or refreshExp then
		expGage:SetProgressRate( rate )		
		_lastEXP = Int64toInt32( s64_exp )
	--end

	_staticLevelSub:ComputePos()
	_staticLevelSub:SetText( "."..rateDisplay )

	local MaxLevQuestInfo = questList_isClearQuest( 151, 1 )

	if (49 == player:getLevel() ) and (99 <= rate) and not MaxLevQuestInfo then
		Proc_ShowMessage_Ack("'[협동] 쇠약해진 벨모른 처치' 의뢰를 완료해야 레벨업 할 수 있습니다.")
	end
	
	if 10 > player:getLevel() then
		_staticLevelSub:SetPosX(_staticLevel:GetPosX() + _staticLevel:GetTextSizeX() + 3)
	else
		_staticLevelSub:SetPosX(_staticLevel:GetPosX() + _staticLevel:GetTextSizeX() - 5)
	end
end

----------------------------------------------------------------------------------------------------------
-- 												스킬 포인트
----------------------------------------------------------------------------------------------------------
function UserSkillPoint_Update()
	local selfPlayer = getSelfPlayer()
	if nil == selfPlayer then
		return
	end
	
	local player = selfPlayer:get()
	local skillExpRate, skillPointNeedExp
	skillPointNeedExp = player:getSkillPointNeedExperience()
	if 0 ~= skillPointNeedExp then
		skillExpRate = player:getSkillPointExperience() / skillPointNeedExp
	else
		skillExpRate = 0
	end
	if _lastSkillPoint < player:getRemainSkillPoint() and -1 ~= _lastSkillPoint then
		-- ♬ 스킬 포인트가 올랐을 때 사운드 추가
		audioPostEvent_SystemUi(03,07)
		
		_staticSkillPointMain:EraseAllEffect()
		_staticSkillPointMain:AddEffect("UI_LevelUP_Skill", false, -5.0, 1.0)
		_staticSkillPointMain:AddEffect("fUI_LevelUP_Skill02", false, -5.0, 1.0)
		-- UIMain_SkillPointUpdate(player:getRemainSkillPoint() - _lastSkillPoint)
	end
	-- _staticSkillPoint:SetText( PAGetString( Defines.StringSheet_GAME,  "LUA_EXPGAUGE_SKILLPOINT") )
	_staticSkillPointMain:SetPosX ( _staticSkillPoint:GetSizeX() + _staticSkillPoint:GetPosX() + 5 )
	_staticSkillPointMain:SetText ( PAGetString( Defines.StringSheet_GAME,  "LUA_EXPGAUGE_SKILLPOINT") .. " " .. tostring( player:getRemainSkillPoint() ) )
	_staticSkillPointMain:SetSize ( _staticSkillPointMain:GetTextSizeX() + 5, _staticSkillPointMain:GetSizeY() )
	_staticSkillPointSub:SetPosX ( _staticSkillPointMain:GetSizeX() + _staticSkillPointMain:GetPosX() - 5 )
	_staticSkillExp:SetProgressRate( skillExpRate * 100 )	
	
	if ( _lastSkillExp ~= skillExpRate ) then
		_staticSkillExp:EraseAllEffect()
		_staticSkillExp_Head:EraseAllEffect()
		_staticSkillExp:AddEffect("UI_Gauge_Experience02", false, 0.0, 0.0)
		_staticSkillExp_Head:AddEffect("fUI_Repair01", false, 0.0, 0.0)
	end
	
	local _tempSkillPoint = skillExpRate * 100
	if 10 > _tempSkillPoint then
		_staticSkillPointSub:SetText(".0".. string.format("%.0f", _tempSkillPoint))
	else
		_staticSkillPointSub:SetText("." .. string.format("%.0f", _tempSkillPoint))
	end
	_lastSkillPoint = player:getRemainSkillPoint()
	_lastSkillExp = skillExpRate		-- 마지막 스킬포인트 경험치 저장
	
	if ( selfPlayer:get():getReservedLearningSkillKey():isDefined() ) then
		
		-- 안 보여지고 있었다면, 보여주게한다.
		if( false == _reservedLearningSkillSlot.iconBG:GetShow() ) then
			ExpGauge_SetReservedLearningSkill()
		end	
		-- 배우기 예약 스킬 원형 프로그래스 업데이트
		ExpGauge_UpdateReservedSkillCircularProgress()
	
	end
	
	enableSkill_UpdateData()
	
end


----------------------------------------------------------------------------------------------------------
--?
----------------------------------------------------------------------------------------------------------
local tooltipExpPanel = UI.createPanel( "tooltipExp", Defines.UIGroup.PAGameUIGroup_Windows )
tooltipExpPanel:SetShow( false, false )
local tooltipExpPanel_Static = UI.createControl( UI_PUCT.PA_UI_CONTROL_STATICTEXT, tooltipExpPanel, "tooltipExpStatic" )

tooltipExpPanel_Static:SetPosX( 10 )
tooltipExpPanel_Static:SetPosY( 10 )
tooltipExpPanel_Static:SetSize( 290, 90 )
tooltipExpPanel_Static:SetShow( true )

function Panel_SelfPlayerExpGage_OnMouse()
	local selfPlayer = getSelfPlayer()
	if nil == selfPlayer then
		return
	end
	local player = selfPlayer:get()
	
	tooltipExpPanel:SetSize( 300, 100 )
	tooltipExpPanel:SetPosX( getMousePosX() )
	positionY = getMousePosY()
	positionY = positionY - 100
	
	tooltipExpPanel:SetPosY( positionY )
	tooltipExpPanel:SetShow( true, false )
	tooltipExpPanel_Static:SetText( PAGetString( Defines.StringSheet_GAME,  "MAINSTATUS_EXP" )..tostring(player:getExp_s64()).."/"..tostring(player:getNeedExp_s64()) )
end

function Panel_SelfPlayerExpGage_OutMouse()
	tooltipExpPanel:SetShow( false, false )
end

local _lastLevel = 0
function UserLevel_Update()
	local player = getSelfPlayer()
	if nil == player then
		return
	end
	_staticLevel:SetText( tostring(player:get():getLevel()) )
	if _lastLevel < player:get():getLevel() and 0 ~= _lastLevel then
		-- ♬ 레벨업 할 때 사운드 추가
		_staticLevel:EraseAllEffect()
		_staticLevel:AddEffect("fUI_NewSkill01", false, 0.0, 0.0)
		_staticLevel:AddEffect("UI_NewSkill01", false, 0.0, 0.0)
		_staticLevel:AddEffect("UI_LevelUP_Main", false, -33.0, -43.0)
		_staticLevel:AddEffect("fUI_Gauge_LevelUp01", false, 80.0, -40.0)
	end
	_lastLevel = player:get():getLevel()
	
	--테스트용[who1310]	
	--_staticLifeExperienceLevel:SetText( tostring( player:get():getLifeExperienceLevel(0) ) )
	--_staticLifeExperienceCurrPoint:SetText( tostring( player:get():getCurrLifeExperiencePoint(0) ) )
	--_staticLifeExperienceMaxPoint:SetText( tostring( player:get():getDemandLifeExperiencePoint(0) ) )
	-- 0 채집 1 낚시 2 가공 3 요리 4 연금
end


----------------------------------------------------------------------------------------------------------
--												기운
----------------------------------------------------------------------------------------------------------
function wpPoint_UpdateFunc()
	local selfPlayer = getSelfPlayer()
	if nil == selfPlayer then
		return
	end	
	local Wp = selfPlayer:getWp()
	local maxWp = selfPlayer:getMaxWp()
	
	-- 저장해줬던 wp와 새로오는 wp가 다를경우 표시해준다!
	-- if ( Wp ~= _lastWP ) then
		local wpSetProgress = ( Wp / maxWp ) * 100
		
		if _lastWP < Wp and -1 ~= _lastWP then
			-- ♬ 기운 포인트가 올랐을 때 사운드 추가
			audioPostEvent_SystemUi(03,13)
			_Wp_Main:EraseAllEffect()

			_Wp_Main:AddEffect("UI_LevelUP_Skill", false, -22.0, 1.0)
			_Wp_Main:AddEffect("fUI_LevelUP_Skill02", false, -22.0, 1.0)

			_wpGauge:EraseAllEffect()
			_wpGauge_Head:EraseAllEffect()
			_wpGauge:AddEffect("UI_Gauge_Experience02", false, 0.0, 0.0)
			_wpGauge_Head:AddEffect("fUI_Repair01", false, 0.0, 0.0)
		end
		
		-- _Wp:SetText( PAGetString( Defines.StringSheet_GAME,  "MAINSTATUS_WP") )
		-- _Wp:SetSize ( _Wp:GetTextSizeX(), _Wp:GetSizeY() )
		_Wp_Main:SetPosX( _Wp:GetSizeX() + _Wp:GetPosX() + 5 )
		_Wp_Main:SetText( PAGetString( Defines.StringSheet_GAME,  "MAINSTATUS_WP") .. " " .. tostring(Wp).." / "..maxWp )
		_wpGauge:SetProgressRate( wpSetProgress )
		_Wp_Main:SetEnableArea( 0, 0, _Wp_Main:GetTextSizeX(), _Wp_Main:GetSizeY() )
		

		
		_lastWP = Wp
	-- end
end

-- 기운 도움말 풍선
function wp_HelpMessage(isShow)
	local mouse_posX = getMousePosX()
	local mouse_posY = getMousePosY()

	local panel_posX = Panel_SelfPlayerExpGage:GetPosX()
	local panel_posY = Panel_SelfPlayerExpGage:GetPosY()
	
	if ( isShow == true ) then		-- 켜준다
		-- ♬ 도움말 뜰 때 사운드 추가
		audioPostEvent_SystemUi(00,13)
	
		_WpHelpMSG:SetAutoResize( true )
		_WpHelpMSG:SetTextMode( UI_TM.eTextMode_AutoWrap )
		_WpHelpMSG:SetText( PAGetString( Defines.StringSheet_GAME,  "MAINSTATUS_DESC_WP" ) )
		_WpHelpMSG:SetSize( _WpHelpMSG:GetSizeX() + 5, _WpHelpMSG:GetSizeY() + 10 )
		
		_WpHelpMSG:SetPosX( mouse_posX - panel_posX  + 20 )
		_WpHelpMSG:SetPosY( mouse_posY - panel_posY  + 20 )
		
		local aniInfo = UIAni.AlphaAnimation( 1, _WpHelpMSG, 0.0, 0.2 )
		_WpHelpMSG:SetShow ( true )
	else
		local aniInfo = UIAni.AlphaAnimation( 0, _WpHelpMSG, 0.0, 0.2 )
		aniInfo:SetHideAtEnd(true)

	end
end
----------------------------------------------------------------------------------------------------------
-- 												공헌도
----------------------------------------------------------------------------------------------------------
local lastContRate = 0
local lastRemainExplorePoint = 0
local lastExplorePoint = 0
local isFirstExplore = false
Panel_Expgauge_MyContributeValue = 0

function contributePoint_UpdateFunc()
	local territoryKeyRaw 			= getDefaultTerritoryKey()
	local explorePoint				= getExplorePointByTerritoryRaw( territoryKeyRaw )
	if (nil == explorePoint) then
		_contribute_Main:SetText("")
		_contribute_progress:SetProgressRate(0)
		return
	end
	
	local s64_exploreRequireExp	= getRequireExperienceToExplorePointByTerritory_s64( territoryKeyRaw )
	local cont_expRate 			= Int64toInt32(explorePoint:getExperience_s64()) / Int64toInt32(getRequireExplorationExperience_s64()) 				-- 현재 공헌도 % 계산

	local nowRemainExpPoint 	= tostring(explorePoint:getRemainedPoint())
	local nowExpPoint				= tostring(explorePoint:getAquiredPoint())
		
	-- _contribute_txt:SetText( PAGetString( Defines.StringSheet_GAME,  "MAINSTATUS_CONTRIBUTE" ) )
	-- _contribute_txt:SetSize ( _contribute_txt:GetTextSizeX(), _contribute_txt:GetSizeY() )
	_contribute_Main:SetPosX ( _contribute_txt:GetSizeX() + _contribute_txt:GetPosX() + 5 )
	_contribute_Main:SetText ( PAGetString( Defines.StringSheet_GAME,  "MAINSTATUS_CONTRIBUTE" ) .. " " .. tostring(explorePoint:getRemainedPoint()) .." / " .. tostring(explorePoint:getAquiredPoint()) )
	_contribute_progress:SetProgressRate( cont_expRate * 100 )
	_contribute_Main:SetEnableArea( 0, 0, _contribute_Main:GetTextSizeX(), _contribute_Main:GetSizeY() )
	
	Panel_Expgauge_MyContributeValue = tostring(explorePoint:getRemainedPoint())	-- 현재 나의 공헌도를 저장한다.( Panel_Interaction, 집 구매버튼에서 사용 )

	-- 최초 값 세팅
	if ( isFirstExplore == false ) then
		lastRemainExplorePoint = 0
		lastExplorePoint = 0
		nowRemainExpPoint = 0
		nowExpPoint = 0
		isFirstExplore = true
	end
		
		-- 게이바에 이펙트!
	if ( lastContRate ~= cont_expRate ) then
		_contribute_progress:SetNotAbleMasking(true)
		_contribute_progress_Head:SetNotAbleMasking(true)
		_contribute_progress:EraseAllEffect()
		_contribute_progress_Head:EraseAllEffect()
		_contribute_progress:AddEffect("UI_Gauge_Experience02", false, 0.0, 0.0)
		_contribute_progress_Head:AddEffect("fUI_Repair01", false, 0.0, 0.0)
	end
		
	-- 현재 남은 공헌도에 이펙트!
	if ( lastRemainExplorePoint ~= nowRemainExpPoint ) and ( isFirstExplore == true ) then
		-- ♬ 공헌도 포인트에 변경점이 생겼을 때 사운드 추가
		audioPostEvent_SystemUi(03,07)
		
		_contribute_Main:EraseAllEffect()
		_contribute_Main:AddEffect("UI_LevelUP_Skill", false, 10.0, 1.0)
	end
		
	-- 현재 남은 공헌도에 이펙트!
	if ( lastExplorePoint ~= nowExpPoint ) and ( isFirstExplore == true ) then
		-- ♬ 공헌도 포인트에 변경점이 생겼을 때 사운드 추가
		audioPostEvent_SystemUi(03,07)
		
		_contribute_Main:EraseAllEffect()
		_contribute_Main:AddEffect("UI_LevelUP_Skill", false, -22.0, 1.0)
	end
		
	lastContRate = cont_expRate
	lastRemainExplorePoint = tostring(explorePoint:getRemainedPoint())
	lastExplorePoint = tostring(explorePoint:getAquiredPoint())
end

local _contributeUsePoint =
{
	[0] = PAGetString( Defines.StringSheet_GAME, "LUA_EXPGUAGE_CONTRIBUTE_VALUE_1" ),	--"집 구입",
	[1] = PAGetString( Defines.StringSheet_GAME, "LUA_EXPGUAGE_CONTRIBUTE_VALUE_2" ),	--"거점 투자",
	[2] = PAGetString( Defines.StringSheet_GAME, "LUA_EXPGUAGE_CONTRIBUTE_VALUE_3" )	--"아이템 대여"
}

-- 공헌도 도움말 풍선
function contribute_HelpMsg_ShowFunc( isShow )
	local mouse_posX = getMousePosX()
	local mouse_posY = getMousePosY()
	local panel_posX = Panel_SelfPlayerExpGage:GetPosX()
	local panel_posY = Panel_SelfPlayerExpGage:GetPosY()

	local _contributeBubbleText = ""
	for i = 0, 2 do
		if 0 < ToClient_UsedExplorePoint(i) then
			if ( "" == _contributeBubbleText ) then
				_contributeBubbleText = _contributeUsePoint[i] .. " " .. ToClient_UsedExplorePoint(i)
			else
				_contributeBubbleText = _contributeBubbleText .. " | " .. _contributeUsePoint[i] .. " " .. ToClient_UsedExplorePoint(i)
			end
		end
	end
	
	if ( "" == _contributeBubbleText ) then
		_contributeBubbleText = PAGetString( Defines.StringSheet_GAME, "LUA_EXPGUAGE_CONTRIBUTE_VALUE_4" )
	else
		_contributeBubbleText = PAGetStringParam1( Defines.StringSheet_GAME, "LUA_EXPGUAGE_CONTRIBUTE_VALUE_5", "_contributeBubbleText", _contributeBubbleText )
	end
	
	-- _contribute_txt:SetAlpha(0)
	if ( isShow == true ) then		-- 켜준다
		-- ♬ 도움말 뜰 때 사운드 추가
		audioPostEvent_SystemUi(00,13)
	
		_contribute_helpMsg:SetAutoResize( true )
		_contribute_helpMsg:SetTextMode( UI_TM.eTextMode_AutoWrap )
		_contribute_helpMsg:SetText( PAGetString( Defines.StringSheet_GAME,  "MAINSTATUS_DESC_EXPLORE" ) .. "\n" .. _contributeBubbleText )
		_contribute_helpMsg:SetSize ( _contribute_helpMsg:GetSizeX() + 5, _contribute_helpMsg:GetSizeY() + 10 )
		
		_contribute_helpMsg:SetPosX( mouse_posX - panel_posX  + 20 )
		_contribute_helpMsg:SetPosY( mouse_posY - panel_posY  + 20 )

		local aniInfo = UIAni.AlphaAnimation( 1, _contribute_helpMsg, 0.0, 0.2 )
		_contribute_helpMsg:SetShow(true)
	else
		local aniInfo = UIAni.AlphaAnimation( 0, _contribute_helpMsg, 0.0, 0.2 )
		aniInfo:SetHideAtEnd(true)
	end
end

function ExpGauge_ChangeTexture_On()
	_close_ExpGauge:SetShow(true)
	Panel_SelfPlayerExpGage:ChangeTextureInfoName("new_ui_common_forlua/default/window_sample_drag.dds")
	expText:SetText( PAGetString( Defines.StringSheet_GAME,  "MAINSTATUS_DRAG_SKILLEXP") )
end
function ExpGauge_ChangeTexture_Off()
	_close_ExpGauge:SetShow(false)
	Panel_SelfPlayerExpGage:ChangeTextureInfoName("new_ui_common_forlua/default/window_sample_isWidget.dds")
	expText:SetText( PAGetString( Defines.StringSheet_GAME,  "MAINSTATUS_SKILLEXP") )
end

function SelfPlayerExpGauge_ShowToggle()
	local isShow = Panel_SelfPlayerExpGage:IsShow()
	
	if isShow == true then
		
		ExpGague_ClearReservedLearningSkill()
		Panel_SelfPlayerExpGage:SetShow ( false, false )
		
	else
		Panel_SelfPlayerExpGage:SetPosX(initPosX)
		Panel_SelfPlayerExpGage:SetPosY(initPosY)
		Panel_SelfPlayerExpGage:SetShow ( true, true )
		ExpGauge_SetReservedLearningSkill()
	end
	
	-- widgetControlButtonFunction(1)
end


-- 생산 스킬 포인트
local _staticSkillExp_p = UI.getChildControl( Panel_SelfPlayerExpGage, "CircularProgress_SkillExp_p" )
local _staticSkillPoint_p = UI.getChildControl( Panel_SelfPlayerExpGage, "StaticText_SkillPoint_p" )
function Panel_User_ProductSkillPoint_Update()	
	local skillPointInfo = getSkillPointInfo( 2 )--생산스킬포인트(2번이니까)
	_staticSkillPoint_p:SetText( tostring(skillPointInfo._remainPoint ) )
	local skillExpRate_p = skillPointInfo._currentExp / skillPointInfo._nextLevelExp
	_staticSkillExp_p:SetProgressRate( skillExpRate_p * 100 )	
end

-- 배우기 예약 스킬 관련
function ExpGauge_Skill_IconClick()
	skillWindow_ClearReservedLearningSkill()
end


------------------------------------------------------------
--			스킬 아이콘에 마우스 올렸을 때 이벤트
------------------------------------------------------------
function ExpGauge_Skill_OverEvent( SlotType )
	local skillNo = 0
	local selfPlayer = getSelfPlayer()
	if nil == selfPlayer then
		return
	end
	if ( selfPlayer:get():getReservedLearningSkillKey():isDefined() ) then
		skillNo = selfPlayer:get():getReservedLearningSkillKey():getSkillNo()
	else
		return
	end
	
	Panel_SkillTooltip_SetPosition( skillNo, _reservedLearningSkillSlot.icon, "SkillBoxBottom" )
	Panel_SkillTooltip_Show(skillNo,false, SlotType, true)
end

function	ExpGauge_Skill_OverEventHide(SlotType)
	Panel_SkillTooltip_Hide()
end

function ExpGague_ClearReservedLearningSkill( )
	
	_reservedLearningSkillSlot.icon:ReleaseTexture()
	_reservedLearningSkillSlot.icon:ChangeTextureInfoName("")
	_reservedLearningSkillSlot.icon:SetAlpha(0)

	_reservedLearningSkillSlot.iconBG:SetShow(false)
	_reservedLearningSkillSlot.icon:SetShow(false)
	_reservedLearningSkillSlot.circularBorder:SetShow(false)
	_reservedLearningSkillSlot.point:SetShow(false)
	
	Panel_SkillTooltip_Hide()
end

function ExpGauge_SetReservedLearningSkill( )
	
	local skillNo = 0 
	local selfPlayer = getSelfPlayer()
	if nil == selfPlayer then
		return
	end
	if ( selfPlayer:get():getReservedLearningSkillKey():isDefined() ) then
		skillNo = selfPlayer:get():getReservedLearningSkillKey():getSkillNo()
	else
		return
	end
	
	local skillTypeStaticWrapper = getSkillTypeStaticStatus( skillNo )
	local skillTypeStatic = skillTypeStaticWrapper:get()
	
	-- 아이콘
	_reservedLearningSkillSlot.icon:ChangeTextureInfoName( "Icon/" .. skillTypeStaticWrapper:getIconPath() )
	_reservedLearningSkillSlot.icon:SetAlpha(1)

	-- 원형 프로그래스
	_reservedLearningSkillNo = skillNo
	ExpGauge_UpdateReservedSkillCircularProgress()
	
	-- 포인트 위치 설정
	
	-- 보여주기
	_reservedLearningSkillSlot.iconBG:SetShow(true)
	_reservedLearningSkillSlot.icon:SetShow(true)
	_reservedLearningSkillSlot.circularBorder:SetShow(true)
	_reservedLearningSkillSlot.point:SetShow(false)

end

function ExpGauge_UpdateReservedSkillCircularProgress()
	
	local skillNo = 0 
	local selfPlayer = getSelfPlayer()
	if nil == selfPlayer then
		return
	end
	if ( selfPlayer:get():getReservedLearningSkillKey():isDefined() ) then
		skillNo = selfPlayer:get():getReservedLearningSkillKey():getSkillNo()
	else
		return
	end
	
	local skillStaticWrapper = getSkillStaticStatus( skillNo, 1 ) -- 현재 스킬들의 레벨은 무조건 1이다.
	local needPoint = skillStaticWrapper:get()._needSkillPointForLearning
	
	if( 0 == needPoint ) then
		UI.ASSERT( false	,"제수가 0 이면 안된다.")
		return
	end
			
	local curSkillPoint = _lastSkillPoint + _lastSkillExp
	local progressRate = curSkillPoint / needPoint
	
	_reservedLearningSkillSlot.circularBorder:SetProgressRate( progressRate * 100)	
	
end

function ExpGauge_CharacterInfoUpdate_Reload()
	Panel_SelfPlayerExpGage_CharacterInfoWindowUpdate()
	UserSkillPoint_Update()
	UserLevel_Update()
	wpPoint_UpdateFunc()
	contributePoint_UpdateFunc()
end


----------------------------------------------------------------------------------------------------------
-- 									배울 수 있는 스킬이 있다!
----------------------------------------------------------------------------------------------------------
local isChecked_EnableSkill = false
function Panel_SelfPlayer_EnableSkillCheck_Func()
	local isLearnable = SkillWindow_PlayerLearnableSkill()
	local skillCount = FGlobal_EnableSkillReturn()

	if ( isLearnable ) then
		-- ♬ 배울 수 있는 스킬이 있네? 사운드!
		-- audioPostEvent_SystemUi(03, 13)

		-- 배울 수 있는 스킬이 있다.
		-- FGlobal_MessageHistory_InputMSG( 0, "배울 수 있는 스킬이 있습니다.", SkillWindow_OpenForLearn )
		
		-- _btn_NewSkill:AddEffect("UI_ButtonLineRight_Blue", true, 0, 0)
		_btn_NewSkill:SetShow( true )
		-- _btn_NewSkill:SetEnableArea ( -_btn_NewSkill:GetTextSizeX()-10, 0, _btn_NewSkill:GetSizeX(), _btn_NewSkill:GetSizeY() )
		_txt_NewSkill:SetShow( true )
		_txt_NewSkill:SetText( skillCount )
		_txt_NewSkill:SetPosX ( ( _btn_NewSkill:GetPosX() + _btn_NewSkill:GetSizeX() - _txt_NewSkill:GetSizeX() ) + 2 )
		_txt_NewSkill:SetPosY ( ( _btn_NewSkill:GetPosY() + _btn_NewSkill:GetSizeY() - _txt_NewSkill:GetSizeY() ) + 2 )
	else
		_btn_NewSkill:SetShow( false )
		_txt_NewSkill:SetShow( false )
	end
	FromClient_PackageIconUpdate()
end

function FGlobal_PackageIconUpdate()
	FromClient_PackageIconUpdate()
end

function FromClient_PackageIconUpdate()
	local temporaryPCRoomWrapper	= getTemporaryInformationWrapper()
	local isPremiumPcRoom			= temporaryPCRoomWrapper:isPremiumPcRoom()

	local selfPlayer = getSelfPlayer()
	if nil == selfPlayer then
		return
	end
	local player	= selfPlayer:get()
	local starter	= player:getStarterPackageTime()
	local premium	= player:getPremiumPackageTime()
	local pearl		= player:getPearlPackageTime()

	if isPremiumPcRoom == true then
		_pcRoomIcon:SetShow( true )
	else
		_pcRoomIcon:SetShow( false )
	end

	if 0 < starter then
		_starterPackage:SetShow( true )
	else
		_starterPackage:SetShow( false )
	end

	if 0 < premium then
		_premiumPackage:SetShow( true )
	else
		_premiumPackage:SetShow( false )
	end

	if 0 < pearl then
		_pearlPackage:SetShow( true )
	else
		_pearlPackage:SetShow( false )
	end

	local iconPosX = Panel_SelfPlayerExpGage:GetPosX() + Panel_SelfPlayerExpGage:GetSizeX()
	local iconPosY = 15
	local iconBackPosX = nil
	if _pcRoomIcon:GetShow() then
		_pcRoomIcon:SetPosX( iconPosX )
		iconPosX = iconPosX + _pcRoomIcon:GetSizeX() + 5
	end
	if _starterPackage:GetShow() then
		_starterPackage:SetPosX( iconPosX )
		_starterPackage:SetPosY( iconPosY )
		iconPosX = iconPosX + _starterPackage:GetSizeX() + 5
	end
	if _premiumPackage:GetShow() then
		_premiumPackage:SetPosX( iconPosX )
		_premiumPackage:SetPosY( iconPosY )
		iconPosX = iconPosX + _premiumPackage:GetSizeX() + 5
	end
	if _pearlPackage:GetShow() then
		_pearlPackage:SetPosX( iconPosX )
		_pearlPackage:SetPosY( iconPosY )
		iconPosX = iconPosX + _pearlPackage:GetSizeX() + 5
	end
	if _btn_NewSkill:GetShow() then
		_btn_NewSkill:SetPosX( iconPosX )
		iconPosX = iconPosX + _btn_NewSkill:GetSizeX() + 5
	end
	if _txt_NewSkill:GetShow() then
		_txt_NewSkill:SetPosX ( ( _btn_NewSkill:GetPosX() + _btn_NewSkill:GetSizeX() - _txt_NewSkill:GetSizeX() ) + 2 )
	end
	if Panel_NormalKnowledge:GetShow() then
		Panel_NormalKnowledge:SetPosX( iconPosX )
		iconPosX = iconPosX + Panel_NormalKnowledge:GetSizeX() + 5
	end
	if Panel_ImportantKnowledge:GetShow() then
		Panel_ImportantKnowledge:SetPosX( iconPosX )
		iconPosX = iconPosX + Panel_ImportantKnowledge:GetSizeX() + 5
	end

	-- iconPosX 지식 위치도 잡혀있음.
end

function BuffIcon_ShowSimpleToolTip( isShow, iconType )
	local leftTime = 0
	if iconType == 1 then
		name = PAGetString(Defines.StringSheet_GAME, "LUA_SELFPLAYEREXPGAGE_PCROOM_TITLE") -- "PC방 혜택"
		desc = PAGetString(Defines.StringSheet_GAME, "LUA_SELFPLAYEREXPGAGE_PCROOM_DESC") -- "채집 잠재력 +1\n낚시 잠재력 +1\n친밀도 획득 +20%\n말 경험치 획득 +20%\n가방 16칸 확장\n창고 16칸 확장\nPC방 상자 지급(30분 마다)\nPC방 NPC 상점 이용 가능\n거래소 수령액+20%"
		uiControl = _pcRoomIcon
	elseif iconType == 2 then
		name = PAGetString(Defines.StringSheet_GAME, "LUA_SELFPLAYEREXPGAGE_YAZBUFF_TITLE") -- "야즈의 축복"
		leftTime = "남은시간 : " .. convertStringFromDatetime( toInt64(0, getSelfPlayer():get():getStarterPackageTime()) )
		desc = leftTime .. "\n" .. PAGetString(Defines.StringSheet_GAME, "LUA_SELFPLAYEREXPGAGE_YAZBUFF_DESC") -- "HP 회복속도 +1 (1주)\n가방 확장 16칸 (1주)\n창고 확장 16칸 (1주)"
		uiControl = _starterPackage
	elseif iconType == 3 then
		name = PAGetString(Defines.StringSheet_GAME, "LUA_SELFPLAYEREXPGAGE_EILEENBUFF_TITLE") -- "에일린의 축복"
		leftTime = "남은시간 : " .. convertStringFromDatetime( toInt64(0, getSelfPlayer():get():getPremiumPackageTime()) )
		desc = leftTime .. "\n" .. PAGetString(Defines.StringSheet_GAME, "LUA_SELFPLAYEREXPGAGE_EILEENBUFF_DESC") -- "최대 기운 +20 (30일)\n가방 확장 16칸 (30일)\n창고 확장 16칸 (30일)\n경험치(생활 경험치) +5% (30일)\n원거리 거점 투자\n매일 선물 상자"
		uiControl = _premiumPackage
	elseif iconType == 4 then
		name = PAGetString(Defines.StringSheet_GAME, "LUA_SELFPLAYEREXPGAGE_PEARLBUFF_TITLE") -- "빛나는 진주의 축복"
		leftTime = "남은시간 : " .. convertStringFromDatetime( toInt64(0, getSelfPlayer():get():getPearlPackageTime()) )
		desc = leftTime .. "\n" .. PAGetString(Defines.StringSheet_GAME, "LUA_SELFPLAYEREXPGAGE_PEARLBUFF_DESC") -- "기운 회복 속도 +1\n아이템 획득 확률 +2.5%"
		uiControl = _pearlPackage
	end

	if true == isShow then
		TooltipSimple_Show( uiControl, name, desc )
	else
		TooltipSimple_Hide()
	end
end


function Panel_SelfPlayer_EnableSkill_HelpDesc( isOn )
	_txt_NewSkillDesc:SetText( PAGetString(Defines.StringSheet_GAME, "LUA_SELFPLAYEREXPGAGE_NewSkillDesc") )
	
	_txt_NewSkillDesc:SetPosX( _btn_NewSkill:GetPosX() + _btn_NewSkill:GetSizeX() - 30 )
	_txt_NewSkillDesc:SetPosY( _btn_NewSkill:GetPosY() + _btn_NewSkill:GetSizeY() +10 )
	_txt_NewSkillDesc:SetSize( 150, 25 )
	
	if ( isOn == true ) then
		_txt_NewSkillDesc:SetShow( true )
		_txt_NewSkillDesc:SetSize( _txt_NewSkillDesc:GetSizeX() + _txt_NewSkillDesc:GetSpanSize().x + 13, _txt_NewSkillDesc:GetSizeY() + _txt_NewSkillDesc:GetSpanSize().y + 5 )
	else
		_txt_NewSkillDesc:SetShow( false )
	end
end

UI.addRunPostRestorFunction( FGlobal_PackageIconUpdate )	-- 플러시를 나올 때, Show체크를 다시 해야 한다. 펄상점/뷰티샵에서 스케일 조정을 하기 때문.




----------------------------------------------------------------------------------------------------
----------------------------------------------------------------------------------------------------
contributePoint_UpdateFunc()
Panel_SelfPlayerExpGage_CharacterInfoWindowUpdate()
UserSkillPoint_Update()
registEventHandler()
registMessageHandler()

changePositionBySever(Panel_SelfPlayerExpGage, CppEnums.PAGameUIType.PAGameUIPanel_SelfPlayer_ExpGage, true, false, false)