local UI_TM			= CppEnums.TextMode
local UI_PUCT		= CppEnums.PA_UI_CONTROL_TYPE
local UI_color		= Defines.Color
local UI_ANI_ADV	= CppEnums.PAUI_ANIM_ADVANCE_TYPE
local ItemClassify	= CppEnums.ItemClassifyType
local IM 			= CppEnums.EProcessorInputMode

Panel_Window_ItemMarket:setGlassBackground( true )
Panel_Window_ItemMarket:ActiveMouseEventEffect( true )
Panel_Window_ItemMarket:SetShow( false )

Panel_Window_ItemMarket:RegisterShowEventFunc( true, 'ItemMarketShowAni()' )
Panel_Window_ItemMarket:RegisterShowEventFunc( false, 'ItemMarketHideAni()' )

local shopType = {
	eShopType_Potion	= 1,	-- 물약상인
	eShopType_Weapon	= 2,	-- 무기상인
	eShopType_Jewel		= 3,	-- 보석상인
	eShopType_Furniture = 4,	-- 가구상인
	eShopType_Collect 	= 5,	-- 재료상인
	eShopType_Cook		= 9,	-- 요리상인
	eShopType_PC		= 10,	-- pc방 상인
}


local ItemMarket = {
	panelTitle					= UI.getChildControl( Panel_Window_ItemMarket,	"StaticText_Title"),
	panelBG						= UI.getChildControl( Panel_Window_ItemMarket,	"Static_BG"),
	btn_Close					= UI.getChildControl( Panel_Window_ItemMarket,	"Button_Win_Close"),

	btn_Search					= UI.getChildControl( Panel_Window_ItemMarket,	"Button_Search"),
	txt_Sort_Parent				= UI.getChildControl( Panel_Window_ItemMarket,	"StaticText_SortTitle"),
	btn_Sort_ItemName			= UI.getChildControl( Panel_Window_ItemMarket,	"Button_SortItemName"),
	btn_Sort_RecentPrice		= UI.getChildControl( Panel_Window_ItemMarket,	"Button_SortRecentPrice"),
	btn_Sort_RegistItemCount	= UI.getChildControl( Panel_Window_ItemMarket,	"Button_SortRegistItemCount"),
	btn_Sort_AverageTradePrice	= UI.getChildControl( Panel_Window_ItemMarket,	"Button_SortAverageTradePrice"),
	btn_Sort_RecentRegistDate	= UI.getChildControl( Panel_Window_ItemMarket,	"Button_SortRecentRegistDate"),
	btn_MyList					= UI.getChildControl( Panel_Window_ItemMarket,	"Button_MyList"),

	static_ListHeadBG			= UI.getChildControl( Panel_Window_ItemMarket,	"Static_ListHeadBG"),
	static_SlotBg				= UI.getChildControl( Panel_Window_ItemMarket,	"Selected_Static_SlotBG"),
	static_Slot					= UI.getChildControl( Panel_Window_ItemMarket,	"Selected_Static_Slot"),
	selectSingleSlot			= {},

	txt_ItemName				= UI.getChildControl( Panel_Window_ItemMarket,	"Selected_StaticText_ItemName"),
	averagePrice_Title			= UI.getChildControl( Panel_Window_ItemMarket,	"Selected_StaticText_AveragePrice_Title"),
	txt_AveragePrice_Value		= UI.getChildControl( Panel_Window_ItemMarket,	"Selected_StaticText_AveragePrice_Value"),
	recentPrice_Title			= UI.getChildControl( Panel_Window_ItemMarket,	"Selected_StaticText_RecentPrice_Title"),
	txt_RecentPrice_Value		= UI.getChildControl( Panel_Window_ItemMarket,	"Selected_StaticText_RecentPrice_Value"),
	registHighPrice_Title		= UI.getChildControl( Panel_Window_ItemMarket,	"Selected_StaticText_RegistHighPrice_Title"),
	txt_RegistHighPrice_Value	= UI.getChildControl( Panel_Window_ItemMarket,	"Selected_StaticText_RegistHighPrice_Value"),
	registLowPrice_Title		= UI.getChildControl( Panel_Window_ItemMarket,	"Selected_StaticText_RegistLowPrice_Title"),
	txt_RegistLowPrice_Value	= UI.getChildControl( Panel_Window_ItemMarket,	"Selected_StaticText_RegistLowPrice_Value"),
	registListCount_Title		= UI.getChildControl( Panel_Window_ItemMarket,	"Selected_StaticText_RegistListCount_Title"),
	txt_RegistListCount_Value	= UI.getChildControl( Panel_Window_ItemMarket,	"Selected_StaticText_RegistListCount_Value"),
	registItemCount_Title		= UI.getChildControl( Panel_Window_ItemMarket,	"Selected_StaticText_RegistItemCount_Title"),
	txt_RegistItemCount_Value	= UI.getChildControl( Panel_Window_ItemMarket,	"Selected_StaticText_RegistItemCount_Value"),
	_txt_price_dash				= UI.getChildControl( Panel_Window_ItemMarket,	"Selected_StaticText_dash"),

	static_CategoryBG			= UI.getChildControl( Panel_Window_ItemMarket,	"Static_CategoryBG"),
	static_FilterBG				= UI.getChildControl( Panel_Window_ItemMarket,	"Static_FilterBG"),
	static_ItemListBG			= UI.getChildControl( Panel_Window_ItemMarket,	"Static_ItemListBG"),
	edit_ItemName				= UI.getChildControl( Panel_Window_ItemMarket,	"Edit_ItemName"),

	-- 돈 지불 방법.
	invenMoney					= UI.getChildControl( Panel_Window_ItemMarket,	"Static_Text_Money"),
	warehouseMoney				= UI.getChildControl( Panel_Window_ItemMarket,	"Static_Text_Money2"),
	radioBtn_Inven				= UI.getChildControl( Panel_Window_ItemMarket,	"RadioButton_Inventory"),
	radioBtn_Warehouse			= UI.getChildControl( Panel_Window_ItemMarket,	"RadioButton_Warehouse"),
	static_Inven				= UI.getChildControl( Panel_Window_ItemMarket_ItemSet,	"StaticText_Icon_Money"),
	static_Warehouse			= UI.getChildControl( Panel_Window_ItemMarket_ItemSet,	"StaticText_Icon_Money2"),

	iconTooltip					= nil,

	scroll						= UI.getChildControl( Panel_Window_ItemMarket,	"Scroll_ItemMarket"),
	scrollInverVal				= 0,
	nowStartIdx					= 0,
	
	curItemClassify				= ItemClassify.eItemClassify_Etc,
	curFilterIndex				= -1,
	curClassType				= -1,
	curServantType				= -1,

	categoryUiPool				= {},
	filterUiPool				= {},
	itemList_MaxCount			= 7,
	itemGroupUiPool				= {},	-- itemListUiPool
	itemSingleUiPool			= {},

	isGrouplist					= true,
	
	sellInfoItemEnchantKeyRaw	= 0,
	curSummaryItemIndex			= 0,
	curTerritoryKeyRaw			= 0,
	isWorldMapOpen				= false,

	isSort_ItemName				= true,
	isSort_RecentPrice			= true,
	isSort_RegistItemCount		= true,
	isSort_AverageTradePrice	= true,
	isSort_RecentRegistDate		= true,
	
	isChangeSort				= false,
	curSortTarget				= -1,
	curSortValue				= false,

	buyItemKeyraw				= 0,
	buyItemSlotidx				= 0,

	slotGroupConfing			= {
		createIcon			= true,
		createBorder		= true,
		createCount			= false,
		createEnchant		= true,
		createCash			= true,
		createClassEquipBG	= true,
	},
	slotSingleConfing			= {
		createIcon			= true,
		createBorder		= true,
		createCount			= true,
		createEnchant		= true,
		createCash			= true,
		createClassEquipBG	= true,
	},
	
	_buttonQuestion = UI.getChildControl( Panel_Window_ItemMarket, "Button_Question" ),		-- 물음표 버튼
	
}

ItemMarket.scrollCtrlBTN		= UI.getChildControl( ItemMarket.scroll,		"Scroll_CtrlButton")


local TemplateItemMarket = {
	btn_category				= UI.getChildControl( Panel_Window_ItemMarket,	"Template_RadioButton_Category"),
	btn_Filter					= UI.getChildControl( Panel_Window_ItemMarket,	"Template_RadioButton_Filter"),

	btn_ItemList				= UI.getChildControl( Panel_Window_ItemMarket,	"Template_Button_ItemList"),
	static_SlotBg				= UI.getChildControl( Panel_Window_ItemMarket,	"Template_Static_SlotBG"),
	static_Slot					= UI.getChildControl( Panel_Window_ItemMarket,	"Template_Static_Slot"),
	txt_ItemName				= UI.getChildControl( Panel_Window_ItemMarket,	"Template_StaticText_ItemName"),
	txt_AveragePrice_Title		= UI.getChildControl( Panel_Window_ItemMarket,	"Template_StaticText_AveragePrice_Title"),
	txt_AveragePrice_Value		= UI.getChildControl( Panel_Window_ItemMarket,	"Template_StaticText_AveragePrice_Value"),
	txt_RecentPrice_Title		= UI.getChildControl( Panel_Window_ItemMarket,	"Template_StaticText_RecentPrice_Title"),
	txt_RecentPrice_Value		= UI.getChildControl( Panel_Window_ItemMarket,	"Template_StaticText_RecentPrice_Value"),
	txt_RegistHighPrice_Title	= UI.getChildControl( Panel_Window_ItemMarket,	"Template_StaticText_RegistHighPrice_Title"),
	txt_RegistHighPrice_Value	= UI.getChildControl( Panel_Window_ItemMarket,	"Template_StaticText_RegistHighPrice_Value"),
	txt_RegistLowPrice_Title	= UI.getChildControl( Panel_Window_ItemMarket,	"Template_StaticText_RegistLowPrice_Title"),
	txt_RegistLowPrice_Value	= UI.getChildControl( Panel_Window_ItemMarket,	"Template_StaticText_RegistLowPrice_Value"),
	txt_RegistListCount_Title	= UI.getChildControl( Panel_Window_ItemMarket,	"Template_StaticText_RegistListCount_Title"),
	txt_RegistListCount_Value	= UI.getChildControl( Panel_Window_ItemMarket,	"Template_StaticText_RegistListCount_Value"),
	txt_RegistItemCount_Title	= UI.getChildControl( Panel_Window_ItemMarket,	"Template_StaticText_RegistItemCount_Title"),
	txt_RegistItemCount_Value	= UI.getChildControl( Panel_Window_ItemMarket,	"Template_StaticText_RegistItemCount_Value"),
	static_Line_1				= UI.getChildControl( Panel_Window_ItemMarket,	"Template_Static_Line_1" ),
	static_Line_2				= UI.getChildControl( Panel_Window_ItemMarket,	"Template_Static_Line_2" ),

	static_SingleSlotBg			= UI.getChildControl( Panel_Window_ItemMarket,	"Template_Static_SingleItemBG"),
	txt_SellPrice_Title			= UI.getChildControl( Panel_Window_ItemMarket,	"Template_StaticText_SellPrice_Title"),
	txt_SellPrice_Value			= UI.getChildControl( Panel_Window_ItemMarket,	"Template_StaticText_SellPrice_Value"),
	txt_RegistPeriod_Title		= UI.getChildControl( Panel_Window_ItemMarket,	"Template_StaticText_RegistPeriod_Title"),
	txt_RegistPeriod_Value		= UI.getChildControl( Panel_Window_ItemMarket,	"Template_StaticText_RegistPeriod_Value"),
	btn_BuyItem					= UI.getChildControl( Panel_Window_ItemMarket,	"Template_Button_BuyItem"),

	iconTooltip					= UI.getChildControl ( Panel_CheckedQuest, 		"StaticText_Notice_1")
}

--[[
CppEnums.ItemClassifyType =
{
	eItemClassify_Etc			=	0	,	-- 잡화
	eItemClassify_MainWeapon	=	1	,	-- 주무기
	eItemClassify_SubWeapon		=	2	,	-- 보조무기
	eItemClassify_Armor			=	3	,	-- 방어구
	eItemClassify_Accessory		=	4 	,	-- 악세사리
	eItemClassify_BlackStone	=	5	,	-- 블랙스톤
	eItemClassify_Jewel			=	6	,	-- 보석
	eItemClassify_Potion		=	7 	,	-- 물약
	eItemClassify_Cook			=	8	,	-- 요리
	eItemClassify_PearlGoods	=	9	,	-- 펄 상품
	eItemClassify_Housing		=	10	,	-- 하우징
	
	TypeCount			= 11,
}
]]--

local DummyData = {
	Category	= {
		[0] = "잡화",
		"주 무기",
		"보조 무기",
		"방어구",
		"악세사리",
		"블랙스톤",
		"보석",
		"물약",
		"요리",
		"펄 상품",
		"하우징",
		"탈것 / 펫",
	},
	Filter		= {
		[0] = "워리어",		--	0
		"레인저",			--  1
		"소서러",			--  2
		"자이언트",			--  3
		"금수랑",			--  4
		"말",				--  5
		"낙타",				--  6
		"당나귀",		    --  7
		"코끼리",           --  8
		"이륜마차",			--  9
		"사륜마차",			--  10
		"나룻배",			--  11				
		"고양이",			--  12
		"개",				--  13
		"산양",				--  14		
		"뗏목",             --  15
	}
}

local _categoryTexture = {
	[0] =	{ [0] = { 368, 100, 410, 142 },	{ 368, 241, 410, 283 },	{ 368, 382, 410, 424 } },	-- 잡화(임시)
			{ [0] = { 321, 6, 363, 48 },	{ 321, 147, 363, 189 },	{ 321, 288, 363, 330 } },	-- 주무기
			{ [0] = { 368, 6, 410, 48 },	{ 368, 147, 410, 189 },	{ 368, 288, 410, 330 } },	-- 보조무기
			{ [0] = { 415, 6, 457, 48 },	{ 415, 147, 457, 189 },	{ 415, 288, 457, 330 } 	},	-- 방어구
			{ [0] = { 463, 6, 505, 48 },	{ 463, 147, 505, 189 },	{ 463, 288, 505, 330 } },	-- 악세사리
			{ [0] = { 321, 53, 363, 95 },	{ 321, 194, 363, 236 },	{ 321, 335, 363, 377 } },	-- 블랙스톤
			{ [0] = { 368, 53, 410, 95 },	{ 368, 194, 410, 236 },	{ 368, 335, 410, 377 } },	-- 보석
			{ [0] = { 415, 53, 457, 95 },	{ 415, 194, 457, 236 },	{ 415, 335, 457, 377 } },	-- 물약
			{ [0] = { 463, 53, 505, 95 },	{ 463, 194, 505, 236 },	{ 463, 335, 505, 377 } },	-- 요리
			{ [0] = { 321, 100, 363, 142 },	{ 321, 241, 363, 283 },	{ 321, 382, 363, 424 } },	-- 펄 상품
			{ [0] = { 415, 100, 457, 142 },	{ 415, 241, 457, 283 },	{ 415, 382, 457, 424 } },	-- 하우징(임시)
			{ [0] = { 463, 100, 505, 142 },	{ 463, 241, 505, 283 }, { 463, 382, 505, 424 } },
}

local _sortTexture = {
	[0] = { -- 이름 정렬
		[0] = { 
			[0] = {57, 137, 111, 169}, 
			{57, 171, 111, 203},
			{57, 137, 111, 169} 
		},
		{ 
			[0] = {1, 137, 55, 169}, 
			{1, 171, 55, 203},
			{1, 137, 55, 169}
		}
	},
	{ 	-- 최근 거래가
		[0] = { 
			[0] = {57, 1, 111, 33}, 
			{57, 35, 111, 67},
			{57, 1, 111, 33}
		},
		{ 
			[0] = {1, 1, 55, 33}, 
			{1, 35, 55, 67},
			{1, 1, 55, 33}
		}
	},
	{ 	-- 등록 개수
		[0] = { 
			[0] = {169, 1, 223, 33}, 
			{169, 35, 223, 67},
			{169, 1, 223, 33}
		},
		{ 
			[0] = {113, 1, 167, 33}, 
			{113, 35, 167, 67},
			{113, 1, 167, 33}
		}
	},
	{ 	-- 평균 거래가
		[0] = { 
			[0] = {57, 69, 111, 101}, 
			{57, 103, 111, 135},
			{57, 69, 111, 101}
		},
		{ 
			[0] = {1, 69, 55, 101}, 
			{1, 103, 55, 135},
			{1, 69, 55, 101}
		}
	},
	{ 	-- 최근 등록일
		[0] = { 
			[0] = {169, 69, 223, 101}, 
			{169, 103, 223, 135},
			{169, 69, 223, 101}
		},
		{ 
			[0] = {113, 69, 167, 101}, 
			{113, 103, 167, 135},
			{113, 69, 167, 101}
		}
	},
}

local territoryKey =
{
	[0]	= tostring(PAGetString(Defines.StringSheet_GAME, "LUA_TERRITORYAUTHORITY_KEY_0")),		-- 발레노스령
	[1] = tostring(PAGetString(Defines.StringSheet_GAME, "LUA_TERRITORYAUTHORITY_KEY_1")),		-- 세렌디아령
	[2] = tostring(PAGetString(Defines.StringSheet_GAME, "LUA_TERRITORYAUTHORITY_KEY_2")),		-- 칼페온령
	[3] = tostring(PAGetString(Defines.StringSheet_GAME, "LUA_TERRITORYAUTHORITY_KEY_3")),		-- 메디아령
}
-- _sortTexture[sortId][isCheck][0]

function convertFilterIndexToClassType( filterIndex  )
	
	local temp = -1
	if( 0 == filterIndex ) then
		temp = CppEnums.ClassType.ClassType_Warrior
	elseif( 1 == filterIndex ) then
		temp = CppEnums.ClassType.ClassType_Ranger
	elseif( 2 == filterIndex ) then
		temp = CppEnums.ClassType.ClassType_Sorcerer
	elseif( 3 == filterIndex ) then
		temp = CppEnums.ClassType.ClassType_Giant
	elseif( 4 == filterIndex ) then
		temp = CppEnums.ClassType.ClassType_Tamer
	else	
		_PA_ASSERT(false, "클래스 추가되었다면 작업해주세요" )
	end
	
	return temp
end

function convertFilterIndexToServanType(  filterIndex  )
	
	--[[
	enum ServantKind	: byte
	{
		eServantKind_Horse	= 0,			// 말
		eServantKind_Camel,					// 낙타
		eServantKind_Donkey,				// 당나귀
		eServantKind_Elephant,				// 코끼리
		eServantKind_TwoWheelCarrage,		// 이륜 마차
		eServantKind_FourWheeledCarriage,	// 사륜 마차
		eServantKind_Ship,					// 배
		eServantKind_Cat,					// 고양이
		eServantKind_Dog,					// 개
		eServantKind_MountainGoat,			// 산양
		eServantKind_Raft,					// 뗏목
		eServantKind_Count,
	};
	]]--
	
	local temp = -1
	if( 15 < filterIndex ) then
		_PA_ASSERT(false, "servantKind 추가되었다면 작업해주세요" )
		return;
	end
	temp = filterIndex - 5 -- 위의 말번호
	return temp

end

function ItemMarketShowAni()
	local self = ItemMarket
	local aniInfo1 = Panel_Window_ItemMarket:addScaleAnimation( 0.0, 0.08, UI_ANI_ADV.PAUI_ANIM_ADVANCE_COS_HALF_PI)
	aniInfo1:SetStartScale(0.5)
	aniInfo1:SetEndScale(1.05)
	aniInfo1.AxisX = Panel_Window_ItemMarket:GetSizeX() / 2
	aniInfo1.AxisY = Panel_Window_ItemMarket:GetSizeY() / 2
	aniInfo1.ScaleType = 2
	aniInfo1.IsChangeChild = true
	
	local aniInfo2 = Panel_Window_ItemMarket:addScaleAnimation( 0.08, 0.15, UI_ANI_ADV.PAUI_ANIM_ADVANCE_COS_HALF_PI)
	aniInfo2:SetStartScale(1.05)
	aniInfo2:SetEndScale(1.0)
	aniInfo2.AxisX = Panel_Window_ItemMarket:GetSizeX() / 2
	aniInfo2.AxisY = Panel_Window_ItemMarket:GetSizeY() / 2
	aniInfo2.ScaleType = 2
	aniInfo2.IsChangeChild = true
end
function ItemMarketHideAni()
	local aniInfo1 = Panel_Window_ItemMarket:addColorAnimation( 0.0, 0.15, UI_ANI_ADV.PAUI_ANIM_ADVANCE_SIN_HALF_PI)
	aniInfo1:SetStartColor( UI_color.C_FFFFFFFF )
	aniInfo1:SetEndColor( UI_color.C_00FFFFFF )
	aniInfo1:SetStartIntensity( 3.0 )
	aniInfo1:SetEndIntensity( 1.0 )
	aniInfo1.IsChangeChild = true
	aniInfo1:SetHideAtEnd(true)
	aniInfo1:SetDisableWhileAni(true)
end

function ItemMarket_ScrollUpdate( isDown )
	local self	= ItemMarket
	
	local itemCount = 0;
	if( self.isGrouplist ) then
		itemCount = getItemMarketSummaryInClientCount();
	else
		itemCount = getItemMarketSellInfoInClientCount( self.curTerritoryKeyRaw , self.sellInfoItemEnchantKeyRaw )
	end
	
	local index	= self.nowStartIdx
	if true == isDown then
		if index < self.scrollInverVal then
			self.scroll:ControlButtonDown()
			index = index + 1
		else
			return
		end
	else
		if 0 < index then
			self.scroll:ControlButtonUp()
			index = index - 1
		else
			return
		end
	end
	
	self.nowStartIdx = index
	self:Update( index )
end
function ItemMarket:SetScroll()
	local itemCount = 0
	if( self.isGrouplist ) then
		itemCount = getItemMarketSummaryInClientCount()
	else
		itemCount = getItemMarketSellInfoInClientCount( self.curTerritoryKeyRaw , self.sellInfoItemEnchantKeyRaw )
	end

	local interval =  itemCount - self.itemList_MaxCount;

	if interval < 0 then
		interval = 0
		self.scroll:SetShow(false)
	else
		self.scroll:SetShow(true)
	end

	local dataCount			= itemCount
	local viewCount			= self.itemList_MaxCount
	local pagePercent		= (viewCount / dataCount) * 100
	local scrollSizeY		= self.scroll:GetSizeY()
	local btn_scrollSizeY	= ( scrollSizeY / 100 ) * pagePercent

	if btn_scrollSizeY < 20 then
		btn_scrollSizeY = 20
	end

	if scrollSizeY  < btn_scrollSizeY then
		btn_scrollSizeY = scrollSizeY
	end

	self.scrollCtrlBTN:SetSize( self.scrollCtrlBTN:GetSizeX(), btn_scrollSizeY )
	
	self.scrollInverVal	= interval
	self.scroll:SetInterval( self.scrollInverVal )

end
function ItemMarket:Initialize()
	self.panelBG:setGlassBackground( true )

	self.txt_Sort_Parent		:AddChild( self.btn_Sort_ItemName )
	self.txt_Sort_Parent		:AddChild( self.btn_Sort_RecentPrice )
	self.txt_Sort_Parent		:AddChild( self.btn_Sort_RegistItemCount )
	self.txt_Sort_Parent		:AddChild( self.btn_Sort_AverageTradePrice )
	self.txt_Sort_Parent		:AddChild( self.btn_Sort_RecentRegistDate )
	self.txt_Sort_Parent		:AddChild( self.btn_Search )
	self.txt_Sort_Parent		:AddChild( self.edit_ItemName )

	Panel_Window_ItemMarket		:RemoveControl( self.btn_Sort_ItemName )
	Panel_Window_ItemMarket		:RemoveControl( self.btn_Sort_RecentPrice )
	Panel_Window_ItemMarket		:RemoveControl( self.btn_Sort_RegistItemCount )
	Panel_Window_ItemMarket		:RemoveControl( self.btn_Sort_AverageTradePrice )
	Panel_Window_ItemMarket		:RemoveControl( self.btn_Sort_RecentRegistDate )
	Panel_Window_ItemMarket		:RemoveControl( self.btn_Search )
	Panel_Window_ItemMarket		:RemoveControl( self.edit_ItemName )
	self.txt_Sort_Parent			:SetShow( true )

	self.static_SlotBg			:AddChild( self.static_Slot )
	self.static_SlotBg			:AddChild( self.txt_ItemName )
	self.static_SlotBg			:AddChild( self.averagePrice_Title )
	self.static_SlotBg			:AddChild( self.txt_AveragePrice_Value )
	self.static_SlotBg			:AddChild( self.recentPrice_Title )
	self.static_SlotBg			:AddChild( self.txt_RecentPrice_Value )
	self.static_SlotBg			:AddChild( self.registHighPrice_Title )
	self.static_SlotBg			:AddChild( self.txt_RegistHighPrice_Value )
	self.static_SlotBg			:AddChild( self.registLowPrice_Title )
	self.static_SlotBg			:AddChild( self.txt_RegistLowPrice_Value )
	self.static_SlotBg			:AddChild( self.registListCount_Title )
	self.static_SlotBg			:AddChild( self.txt_RegistListCount_Value )
	self.static_SlotBg			:AddChild( self.registItemCount_Title )
	self.static_SlotBg			:AddChild( self.txt_RegistItemCount_Value )
	self.static_SlotBg			:AddChild( self._txt_price_dash )
	Panel_Window_ItemMarket		:RemoveControl( self.static_Slot )
	Panel_Window_ItemMarket		:RemoveControl( self.txt_ItemName )
	Panel_Window_ItemMarket		:RemoveControl( self.averagePrice_Title )
	Panel_Window_ItemMarket		:RemoveControl( self.txt_AveragePrice_Value )
	Panel_Window_ItemMarket		:RemoveControl( self.recentPrice_Title )
	Panel_Window_ItemMarket		:RemoveControl( self.txt_RecentPrice_Value )
	Panel_Window_ItemMarket		:RemoveControl( self.registHighPrice_Title )
	Panel_Window_ItemMarket		:RemoveControl( self.txt_RegistHighPrice_Value )
	Panel_Window_ItemMarket		:RemoveControl( self.registLowPrice_Title )
	Panel_Window_ItemMarket		:RemoveControl( self.txt_RegistLowPrice_Value )
	Panel_Window_ItemMarket		:RemoveControl( self.registListCount_Title )
	Panel_Window_ItemMarket		:RemoveControl( self.txt_RegistListCount_Value )
	Panel_Window_ItemMarket		:RemoveControl( self.registItemCount_Title )
	Panel_Window_ItemMarket		:RemoveControl( self.txt_RegistItemCount_Value )
	Panel_Window_ItemMarket		:RemoveControl( self._txt_price_dash )
	self.static_SlotBg			:SetShow( false )

	self.edit_ItemName			:SetEditText("아이템명", false)

	local createSingleSlot = {}
	SlotItem.new( createSingleSlot, 'ItemMarket_ItemSingleSlotItem', 0, self.static_SlotBg, self.slotGroupConfing )
	createSingleSlot:createChild()
	self.selectSingleSlot = createSingleSlot

	-- 카테고리 버튼 생성
	local btn_Category_PosX = 145
	for category_Idx = 0, #DummyData.Category do
		local CreatedCategoryBTN = UI.createControl( UI_PUCT.PA_UI_CONTROL_RADIOBUTTON, self.static_CategoryBG, 'ItemMarket_CategoryBTN_' .. category_Idx )
		CopyBaseProperty( TemplateItemMarket.btn_category, CreatedCategoryBTN )
		CreatedCategoryBTN:SetPosX( btn_Category_PosX )
		CreatedCategoryBTN:SetPosY( 4 )
		CreatedCategoryBTN:addInputEvent("Mouse_LUp", "HandleClicked_ItemMarket_SelectCategory( " .. category_Idx .. " )")
		CreatedCategoryBTN:addInputEvent( "Mouse_On", "ShowTooltip_ItemMarket_Category( true, " .. category_Idx .. ")" )
		CreatedCategoryBTN:addInputEvent( "Mouse_Out", "ShowTooltip_ItemMarket_Category( false )" )
		CreatedCategoryBTN:SetShow( true )

		if (9 == category_Idx) and ( not FGlobal_IsCommercialService() ) then		-- 유료 서비스 기간이 아니면, 펄 상점 탭 숨김.
			CreatedCategoryBTN:SetShow( false )
			btn_Category_PosX = btn_Category_PosX
		else
			btn_Category_PosX = btn_Category_PosX + CreatedCategoryBTN:GetSizeX() + 4
		end
		self.categoryUiPool[category_Idx] = CreatedCategoryBTN
		_itemMarket_ChangeTextureByCategory( category_Idx )	-- 텍스쳐를 바꾼다.
	end

	-- 필터 버튼 생성
	local btn_Filter_PosY = 40
	for filter_Idx = 0, #DummyData.Filter do
		local CreatedFilterBTN = UI.createControl( UI_PUCT.PA_UI_CONTROL_RADIOBUTTON, self.static_FilterBG, 'ItemMarket_FilterBTN_' .. filter_Idx )
		CopyBaseProperty( TemplateItemMarket.btn_Filter, CreatedFilterBTN )
		CreatedFilterBTN:SetPosX( 10 )
		CreatedFilterBTN:SetPosY( btn_Filter_PosY )
		CreatedFilterBTN:SetText( DummyData.Filter[filter_Idx] )
		CreatedFilterBTN:SetEnableArea( 0, 0, 100, CreatedFilterBTN:GetSizeY() )
		CreatedFilterBTN:addInputEvent("Mouse_LUp", "HandleClicked_ItemMarket_SelectFilter( " .. filter_Idx .. " )")
		
		if 6 == filter_Idx or 8 == filter_Idx or 12 == filter_Idx or 13 == filter_Idx or 14 == filter_Idx then
			CreatedFilterBTN:SetShow( false )
		else
			CreatedFilterBTN:SetShow( true )
			btn_Filter_PosY					= btn_Filter_PosY + CreatedFilterBTN:GetSizeY() + 4
		end
		self.filterUiPool[filter_Idx]	= CreatedFilterBTN
	end

	-- 아이템 리스트 생성.
	local itemList_PosY = 5
	for itemList_Idx = 0, self.itemList_MaxCount - 1 do
		------------------------------------------------------------------------
		-- 그룹 시작
		------------------------------------------------------------------------
		local tempGroupSlot ={}
		local Created_ItemListBTN = UI.createControl( UI_PUCT.PA_UI_CONTROL_BUTTON, self.static_ItemListBG, 'ItemMarket_ItemListBTN_' .. itemList_Idx )
		CopyBaseProperty( TemplateItemMarket.btn_ItemList, Created_ItemListBTN )
		Created_ItemListBTN:SetPosX( 5 )
		Created_ItemListBTN:SetPosY( itemList_PosY )
		Created_ItemListBTN:addInputEvent("Mouse_DownScroll",	"ItemMarket_ScrollUpdate( true )")
		Created_ItemListBTN:addInputEvent("Mouse_UpScroll",		"ItemMarket_ScrollUpdate( false )")
		Created_ItemListBTN:addInputEvent("Mouse_LUp",			"ItemMarket_ItemListBtnLUp( index )")	
		Created_ItemListBTN:SetShow( false )
		tempGroupSlot.itemBTN = Created_ItemListBTN

		local Created_ItemSlotBG = UI.createControl( UI_PUCT.PA_UI_CONTROL_STATIC, Created_ItemListBTN, 'ItemMarket_ItemListSlotBG_' .. itemList_Idx )
		CopyBaseProperty( TemplateItemMarket.static_SlotBg, Created_ItemSlotBG )
		Created_ItemSlotBG:SetPosX( 10 )
		Created_ItemSlotBG:SetPosY( 7 )
		Created_ItemSlotBG:SetShow( true )
		tempGroupSlot.itemSlotBG = Created_ItemSlotBG

		local createSlot = {}
		SlotItem.new( createSlot, 'ItemMarket_ItemGroupListSlotItem_' .. itemList_Idx, 0, Created_ItemSlotBG, self.slotGroupConfing )
		createSlot:createChild()
		tempGroupSlot.SlotItem = createSlot

		local Created_ItemName = UI.createControl( UI_PUCT.PA_UI_CONTROL_STATICTEXT, Created_ItemListBTN, 'ItemMarket_ItemListItemName_' .. itemList_Idx )
		CopyBaseProperty( TemplateItemMarket.txt_ItemName, Created_ItemName )
		Created_ItemName:SetPosX( 60 )
		Created_ItemName:SetPosY( 7 )
		Created_ItemName:SetTextMode( UI_TM.eTextMode_AutoWrap )
		Created_ItemName:SetShow( true )
		tempGroupSlot.itemName = Created_ItemName

		local Created_AveragePrice_Title = UI.createControl( UI_PUCT.PA_UI_CONTROL_STATICTEXT, Created_ItemListBTN, 'ItemMarket_ItemListAveragePrice_Title_' .. itemList_Idx )				-- 평균 거래가
		CopyBaseProperty( TemplateItemMarket.txt_AveragePrice_Title, Created_AveragePrice_Title )
		Created_AveragePrice_Title:SetPosX( 460 )
		Created_AveragePrice_Title:SetPosY( 10 )
		Created_AveragePrice_Title:SetShow( true )
		Created_AveragePrice_Title:SetEnableArea(0, 0, 100, Created_AveragePrice_Title:GetSizeY())
		Created_AveragePrice_Title:addInputEvent("Mouse_On", "_itemMarket_ShowIconToolTip( true, " .. 0 .. ", " .. 0 .. ", " .. itemList_Idx .. " )")
		Created_AveragePrice_Title:addInputEvent("Mouse_Out", "_itemMarket_ShowIconToolTip( false )")
		tempGroupSlot.averagePrice_Title = Created_AveragePrice_Title

		local Created_AveragePrice_Value = UI.createControl( UI_PUCT.PA_UI_CONTROL_STATICTEXT, Created_ItemListBTN, 'ItemMarket_ItemListAveragePrice_Value_' .. itemList_Idx )				-- 평균 거래가
		CopyBaseProperty( TemplateItemMarket.txt_AveragePrice_Value, Created_AveragePrice_Value )
		Created_AveragePrice_Value:SetPosX( 480 )
		Created_AveragePrice_Value:SetPosY( 8 )
		Created_AveragePrice_Value:SetShow( true )
		tempGroupSlot.averagePrice_Value = Created_AveragePrice_Value

		local Created_RecentPrice_Title = UI.createControl( UI_PUCT.PA_UI_CONTROL_STATICTEXT, Created_ItemListBTN, 'ItemMarket_ItemListRecentPrice_Title_' .. itemList_Idx )				-- 최근 거래가
		CopyBaseProperty( TemplateItemMarket.txt_RecentPrice_Title, Created_RecentPrice_Title )
		Created_RecentPrice_Title:SetPosX( 460 )
		Created_RecentPrice_Title:SetPosY( 32 )
		Created_RecentPrice_Title:SetShow( true )
		Created_RecentPrice_Title:SetEnableArea(0, 0, 100, Created_RecentPrice_Title:GetSizeY())
		Created_RecentPrice_Title:addInputEvent("Mouse_On", "_itemMarket_ShowIconToolTip( true, " .. 0 .. ", " .. 1 .. ", " .. itemList_Idx .. " )")
		Created_RecentPrice_Title:addInputEvent("Mouse_Out", "_itemMarket_ShowIconToolTip( false )")
		tempGroupSlot.recentPrice_Title = Created_RecentPrice_Title

		local Created_RecentPrice_Value = UI.createControl( UI_PUCT.PA_UI_CONTROL_STATICTEXT, Created_ItemListBTN, 'ItemMarket_ItemListRecentPrice_Value_' .. itemList_Idx )				-- 최근 거래가
		CopyBaseProperty( TemplateItemMarket.txt_RecentPrice_Value, Created_RecentPrice_Value )
		Created_RecentPrice_Value:SetPosX( 480 )
		Created_RecentPrice_Value:SetPosY( 30 )
		Created_RecentPrice_Value:SetShow( true )
		tempGroupSlot.recentPrice_Value = Created_RecentPrice_Value

		local Created_RegistHighPrice_Title = UI.createControl( UI_PUCT.PA_UI_CONTROL_STATICTEXT, Created_ItemListBTN, 'ItemMarket_ItemListRegistHighPrice_Title_' .. itemList_Idx )			-- 등록 최고가
		CopyBaseProperty( TemplateItemMarket.txt_RegistHighPrice_Title, Created_RegistHighPrice_Title )
		Created_RegistHighPrice_Title:SetPosX( 345 )
		Created_RegistHighPrice_Title:SetPosY( 7 )
		Created_RegistHighPrice_Title:SetShow( true )
		Created_RegistHighPrice_Title:SetText( "최고가" )
		Created_RegistHighPrice_Title:SetTextSpan( 30, 0 )
		Created_RegistHighPrice_Title:SetEnableArea( 0, 0, 70, Created_RegistHighPrice_Title:GetSizeY())
		Created_RegistHighPrice_Title:addInputEvent("Mouse_On", "_itemMarket_ShowIconToolTip( true, " .. 0 .. ", " .. 2 .. ", " .. itemList_Idx .. " )")
		Created_RegistHighPrice_Title:addInputEvent("Mouse_Out", "_itemMarket_ShowIconToolTip( false )")
		tempGroupSlot.registHighPrice_Title = Created_RegistHighPrice_Title

		local Created_RegistHighPrice_Value = UI.createControl( UI_PUCT.PA_UI_CONTROL_STATICTEXT, Created_ItemListBTN, 'ItemMarket_ItemListRegistHighPrice_Value_' .. itemList_Idx )			-- 등록 최고가
		CopyBaseProperty( TemplateItemMarket.txt_RegistHighPrice_Value, Created_RegistHighPrice_Value )
		Created_RegistHighPrice_Value:SetPosX( 345 )
		Created_RegistHighPrice_Value:SetPosY( 30 )
		Created_RegistHighPrice_Value:SetShow( true )
		Created_RegistHighPrice_Value:SetTextHorizonCenter()
		tempGroupSlot.registHighPrice_Value = Created_RegistHighPrice_Value

		local Created_RegistLowPrice_Title = UI.createControl( UI_PUCT.PA_UI_CONTROL_STATICTEXT, Created_ItemListBTN, 'ItemMarket_ItemListRegistLowPrice_Title_' .. itemList_Idx )				-- 등록 최저가
		CopyBaseProperty( TemplateItemMarket.txt_RegistLowPrice_Title, Created_RegistLowPrice_Title )
		Created_RegistLowPrice_Title:SetPosX( 225 )
		Created_RegistLowPrice_Title:SetPosY( 7 )
		Created_RegistLowPrice_Title:SetShow( true )
		Created_RegistLowPrice_Title:SetText( "최저가" )
		Created_RegistLowPrice_Title:SetTextSpan( 30, 0 )
		Created_RegistLowPrice_Title:SetEnableArea( 0, 0, 70, Created_RegistLowPrice_Title:GetSizeY())
		Created_RegistLowPrice_Title:addInputEvent("Mouse_On", "_itemMarket_ShowIconToolTip( true, " .. 0 .. ", " .. 3 .. ", " .. itemList_Idx .. " )")
		Created_RegistLowPrice_Title:addInputEvent("Mouse_Out", "_itemMarket_ShowIconToolTip( false )")
		tempGroupSlot.registLowPrice_Title = Created_RegistLowPrice_Title

		local Created_RegistLowPrice_Value = UI.createControl( UI_PUCT.PA_UI_CONTROL_STATICTEXT, Created_ItemListBTN, 'ItemMarket_ItemListRegistLowPrice_Value_' .. itemList_Idx )				-- 등록 최저가
		CopyBaseProperty( TemplateItemMarket.txt_RegistLowPrice_Value, Created_RegistLowPrice_Value )
		Created_RegistLowPrice_Value:SetPosX( 225 )
		Created_RegistLowPrice_Value:SetPosY( 30 )
		Created_RegistLowPrice_Value:SetShow( true )
		Created_RegistLowPrice_Value:SetTextHorizonCenter()
		tempGroupSlot.registLowPrice_Value = Created_RegistLowPrice_Value

		local Created_RegistListCount_Title = UI.createControl( UI_PUCT.PA_UI_CONTROL_STATICTEXT, Created_ItemListBTN, 'ItemMarket_ItemListRegistListCount_Title_' .. itemList_Idx )			-- 등록 건수
		CopyBaseProperty( TemplateItemMarket.txt_RegistListCount_Title, Created_RegistListCount_Title )
		Created_RegistListCount_Title:SetPosX( 600 )
		Created_RegistListCount_Title:SetPosY( 10 )
		Created_RegistListCount_Title:SetShow( true )
		Created_RegistListCount_Title:SetEnableArea( 0, 0, 60, Created_RegistListCount_Title:GetSizeY())
		Created_RegistListCount_Title:addInputEvent("Mouse_On", "_itemMarket_ShowIconToolTip( true, " .. 0 .. ", " .. 4 .. ", " .. itemList_Idx .. " )")
		Created_RegistListCount_Title:addInputEvent("Mouse_Out", "_itemMarket_ShowIconToolTip( false )")
		tempGroupSlot.registListCount_Title = Created_RegistListCount_Title

		local Created_RegistListCount_Value = UI.createControl( UI_PUCT.PA_UI_CONTROL_STATICTEXT, Created_ItemListBTN, 'ItemMarket_ItemListRegistListCount_Value_' .. itemList_Idx )			-- 누적 거래량
		CopyBaseProperty( TemplateItemMarket.txt_RegistListCount_Value, Created_RegistListCount_Value )
		Created_RegistListCount_Value:SetPosX( 585 )
		Created_RegistListCount_Value:SetPosY( 8 )
		Created_RegistListCount_Value:SetShow( true )
		tempGroupSlot.registListCount_Value = Created_RegistListCount_Value

		local Created_RegistItemCount_Title = UI.createControl( UI_PUCT.PA_UI_CONTROL_STATICTEXT, Created_ItemListBTN, 'ItemMarket_ItemListRegistItemCount_Title_' .. itemList_Idx )			-- 등록 개수
		CopyBaseProperty( TemplateItemMarket.txt_RegistItemCount_Title, Created_RegistItemCount_Title )
		Created_RegistItemCount_Title:SetPosX( 600 )
		Created_RegistItemCount_Title:SetPosY( 32 )
		Created_RegistItemCount_Title:SetShow( true )
		Created_RegistItemCount_Title:SetEnableArea( 0, 0, 60, Created_RegistItemCount_Title:GetSizeY())
		Created_RegistItemCount_Title:addInputEvent("Mouse_On", "_itemMarket_ShowIconToolTip( true, " .. 0 .. ", " .. 5 .. ", " .. itemList_Idx .. " )")
		Created_RegistItemCount_Title:addInputEvent("Mouse_Out", "_itemMarket_ShowIconToolTip( false )")
		tempGroupSlot.registItemCount_Title = Created_RegistItemCount_Title

		local Created_RegistItemCount_Value = UI.createControl( UI_PUCT.PA_UI_CONTROL_STATICTEXT, Created_ItemListBTN, 'ItemMarket_ItemListRegistItemCount_Value_' .. itemList_Idx )			-- 등록 개수
		CopyBaseProperty( TemplateItemMarket.txt_RegistItemCount_Value, Created_RegistItemCount_Value )
		Created_RegistItemCount_Value:SetPosX( 585 )
		Created_RegistItemCount_Value:SetPosY( 30 )
		Created_RegistItemCount_Value:SetShow( true )
		tempGroupSlot.registItemCount_Value = Created_RegistItemCount_Value

		local Created_Static_Line_1 = UI.createControl( UI_PUCT.PA_UI_CONTROL_STATIC, Created_ItemListBTN, 'ItemMarket_Static_Line_1_' .. itemList_Idx )
		CopyBaseProperty( TemplateItemMarket.static_Line_1, Created_Static_Line_1 )
		Created_Static_Line_1:SetPosX( 445 )
		Created_Static_Line_1:SetPosY( 10 )
		Created_Static_Line_1:SetShow( true )
		tempGroupSlot.registItem_Line_1 = Created_Static_Line_1

		local Created_Static_Line_2 = UI.createControl( UI_PUCT.PA_UI_CONTROL_STATIC, Created_ItemListBTN, 'ItemMarket_Static_Line_2_' .. itemList_Idx )
		CopyBaseProperty( TemplateItemMarket.static_Line_2, Created_Static_Line_2 )
		Created_Static_Line_2:SetPosX( 580 )
		Created_Static_Line_2:SetPosY( 10 )
		Created_Static_Line_2:SetShow( true )
		tempGroupSlot.registItem_Line_2 = Created_Static_Line_2
		
		local Created_Static_Dash = UI.createControl( UI_PUCT.PA_UI_CONTROL_STATICTEXT, Created_ItemListBTN, "ItemMarket_Static_Dash_" .. itemList_Idx )
		CopyBaseProperty( ItemMarket._txt_price_dash, Created_Static_Dash )
		Created_Static_Dash:SetPosX( 295 )
		Created_Static_Dash:SetPosY( 30 )
		Created_Static_Dash:SetShow( true )
		tempGroupSlot.static_Dash = Created_Static_Dash

		self.itemGroupUiPool[itemList_Idx]	= tempGroupSlot

		------------------------------------------------------------------------
		-- 싱글 시작
		------------------------------------------------------------------------

		local tempSingleSlot = {}
		local Created_SingleItemBG = UI.createControl( UI_PUCT.PA_UI_CONTROL_STATIC, self.static_ItemListBG, 'ItemMarket_SingleItemBG_' .. itemList_Idx )
		CopyBaseProperty( TemplateItemMarket.static_SingleSlotBg, Created_SingleItemBG )
		Created_SingleItemBG:SetPosX( 5 )
		Created_SingleItemBG:SetPosY( itemList_PosY )
		Created_SingleItemBG:addInputEvent("Mouse_DownScroll",	"ItemMarket_ScrollUpdate( true )")
		Created_SingleItemBG:addInputEvent("Mouse_UpScroll",	"ItemMarket_ScrollUpdate( false )")
		Created_SingleItemBG:SetShow( false )
		tempSingleSlot.itemBG = Created_SingleItemBG

		local Created_SingleItemSlotBG = UI.createControl( UI_PUCT.PA_UI_CONTROL_STATIC, Created_SingleItemBG, 'ItemMarket_SingleItemSlotBG_' .. itemList_Idx )
		CopyBaseProperty( TemplateItemMarket.static_SlotBg, Created_SingleItemSlotBG )
		Created_SingleItemSlotBG:SetPosX( 10 )
		Created_SingleItemSlotBG:SetPosY( 7 )
		Created_SingleItemSlotBG:SetShow( true )
		tempSingleSlot.itemSlotBG = Created_SingleItemSlotBG

		local createSlot = {}
		SlotItem.new( createSlot, 'ItemMarket_ItemSingleListSlotItem_' .. itemList_Idx, 0, Created_SingleItemSlotBG, self.slotSingleConfing )
		createSlot:createChild()
		tempSingleSlot.SlotItem = createSlot

		local Created_SingleItemName = UI.createControl( UI_PUCT.PA_UI_CONTROL_STATICTEXT, Created_SingleItemBG, 'ItemMarket_SingleItemName_' .. itemList_Idx )
		CopyBaseProperty( TemplateItemMarket.txt_ItemName, Created_SingleItemName )
		Created_SingleItemName:SetPosX( 60 )
		Created_SingleItemName:SetPosY( 7 )
		Created_SingleItemName:SetTextMode( UI_TM.eTextMode_AutoWrap )
		Created_SingleItemName:SetShow( true )
		tempSingleSlot.itemName = Created_SingleItemName

		local Created_SingleSellPrice_Title = UI.createControl( UI_PUCT.PA_UI_CONTROL_STATICTEXT, Created_SingleItemBG, 'ItemMarket_SingleSellPrice_Title_' .. itemList_Idx )
		CopyBaseProperty( TemplateItemMarket.txt_SellPrice_Title, Created_SingleSellPrice_Title )
		Created_SingleSellPrice_Title:SetPosX( 265 )
		Created_SingleSellPrice_Title:SetPosY( 20 )
		Created_SingleSellPrice_Title:SetShow( true )
		tempSingleSlot.singleSellPrice_Title = Created_SingleSellPrice_Title

		local Created_SingleSellPrice_Value = UI.createControl( UI_PUCT.PA_UI_CONTROL_STATICTEXT, Created_SingleItemBG, 'ItemMarket_SingleSellPrice_Value_' .. itemList_Idx )
		CopyBaseProperty( TemplateItemMarket.txt_SellPrice_Value, Created_SingleSellPrice_Value )
		Created_SingleSellPrice_Value:SetPosX( 310 )
		Created_SingleSellPrice_Value:SetPosY( 20 )
		Created_SingleSellPrice_Value:SetShow( true )
		tempSingleSlot.singleSellPrice_Value = Created_SingleSellPrice_Value

		local Created_SingleRegistPeriod_Title = UI.createControl( UI_PUCT.PA_UI_CONTROL_STATICTEXT, Created_SingleItemBG, 'ItemMarket_SingleRegistPeriod_Title_' .. itemList_Idx )
		CopyBaseProperty( TemplateItemMarket.txt_RegistPeriod_Title, Created_SingleRegistPeriod_Title )
		Created_SingleRegistPeriod_Title:SetPosX( 430 )
		Created_SingleRegistPeriod_Title:SetPosY( 20 )
		Created_SingleRegistPeriod_Title:SetShow( true )
		tempSingleSlot.singleRegistPeriod_Title = Created_SingleRegistPeriod_Title

		local Created_SingleRegistPeriod_Value = UI.createControl( UI_PUCT.PA_UI_CONTROL_STATICTEXT, Created_SingleItemBG, 'ItemMarket_SingleRegistPeriod_Value_' .. itemList_Idx )
		CopyBaseProperty( TemplateItemMarket.txt_RegistPeriod_Value, Created_SingleRegistPeriod_Value )
		Created_SingleRegistPeriod_Value:SetPosX( 500 )
		Created_SingleRegistPeriod_Value:SetPosY( 20 )
		Created_SingleRegistPeriod_Value:SetShow( true )
		tempSingleSlot.singleRegistPeriod_Value = Created_SingleRegistPeriod_Value

		local Created_SingleItemBuyItemBTN = UI.createControl( UI_PUCT.PA_UI_CONTROL_BUTTON, Created_SingleItemBG, 'ItemMarket_SingleItemBuyItemBTN_' .. itemList_Idx )
		CopyBaseProperty( TemplateItemMarket.btn_BuyItem, Created_SingleItemBuyItemBTN )
		Created_SingleItemBuyItemBTN:SetPosX( 620 )
		Created_SingleItemBuyItemBTN:SetPosY( 10 )
		Created_SingleItemBuyItemBTN:SetShow( true )
		tempSingleSlot.buyItemBTN = Created_SingleItemBuyItemBTN

		-- btn_BuyItem
		self.itemSingleUiPool[itemList_Idx]	= tempSingleSlot
		itemList_PosY	= itemList_PosY + Created_ItemListBTN:GetSizeY() + 2
	end

	local iconTooltips	= UI.createControl( UI_PUCT.PA_UI_CONTROL_STATICTEXT, Panel_Window_ItemMarket, "ItemMarket_PriceTitleToolTip" )
	CopyBaseProperty( TemplateItemMarket.iconTooltip, iconTooltips )
	iconTooltips:SetColor( ffffffff )
	iconTooltips:SetAlpha( 1.0 )
	iconTooltips:SetFontColor( UI_color.C_FFC4BEBE )
	iconTooltips:SetAutoResize( true )
	iconTooltips:SetSize( 120, iconTooltips:GetSizeY() )
	iconTooltips:SetTextMode( UI_TM.eTextMode_AutoWrap )
	iconTooltips:SetTextHorizonCenter()
	iconTooltips:SetShow( false )

	self.iconTooltip = iconTooltips
end

function ItemMarket:Update( startIndex )
	if nil == startIndex then
		startIndex = 0
	end

	if true == self.isGrouplist then
		self.txt_Sort_Parent:SetShow( true )
		self.static_SlotBg:SetShow( false )
	else
		self.txt_Sort_Parent:SetShow( false )
		self.static_SlotBg:SetShow( true )
	end

	--초기화
	for category_Idx = 0, #DummyData.Category do
		local categoryButton = self.categoryUiPool[category_Idx]
		categoryButton:SetShow( true )
		categoryButton:SetCheck( false )
	end
	self.categoryUiPool[self.curItemClassify]:SetCheck( true )
	for idx = 0, self.itemList_MaxCount - 1 do
		self.itemGroupUiPool[idx].SlotItem	:clearItem()
		self.itemSingleUiPool[idx].SlotItem	:clearItem()
		self.itemGroupUiPool[idx].itemBTN	:SetShow( false )
		self.itemSingleUiPool[idx].itemBG	:SetShow( false )
	end
	
	local itemInfoCount = 0;
	if( self.isGrouplist ) then
		itemInfoCount = getItemMarketSummaryInClientCount( self.curItemClassify )
	else
		itemInfoCount = getItemMarketSellInfoInClientCount( self.curTerritoryKeyRaw , self.sellInfoItemEnchantKeyRaw )
	end

	local	registPrice	=	""
	registPrice			=	self.edit_ItemName:GetEditText()
	self.edit_ItemName:SetEditText( registPrice, false )
	local replaceCount = function( num )
		local count = Int64toInt32( num )
		if 0 == count then
			count = "-"
		else
			count = makeDotMoney( num )
		end
		return count
	end

	-- 종합 정보 보기
	if self.isGrouplist then
		local uiPoolIdx = 0
		for ui_Idx = 0, self.itemList_MaxCount - 1 do	
			local item_idx = startIndex + ui_Idx	
			local itemMarketSummaryInfo = getItemMarketSummaryInClientByIndex( self.curItemClassify, item_idx )
			if( nil ~= itemMarketSummaryInfo ) then
				--if(0 < itemMarketSummaryInfo:getDisplayedTotalCount()) then
					local UiBase = self.itemGroupUiPool[uiPoolIdx]
					local iess = itemMarketSummaryInfo:getItemEnchantStaticStatusWrapper()
					_PA_ASSERT( nil ~= iess, "itemMarketSummaryInfo 아이템 고정정보가 꼭 있어야합니다")
					
					local enchantLevel = iess:get()._key:getEnchantLevel()
					local itemEnchantKeyRaw =	iess:get()._key:get()

					local nameColorGrade	= iess:getGradeType()
					local nameColor			= nil
					if ( 0 == nameColorGrade ) then
						nameColor = UI_color.C_FFFFFFFF
					elseif ( 1 == nameColorGrade ) then
						nameColor = 4284350320
					elseif ( 2 == nameColorGrade ) then
						nameColor = 4283144191
					elseif ( 3 == nameColorGrade ) then
						nameColor = 4294953010
					elseif ( 4 == nameColorGrade ) then
						nameColor = 4294929408
					else
						nameColor = UI_color.C_FFFFFFFF
					end
					UiBase.itemName:SetFontColor( nameColor )
					UiBase.itemName:SetText( iess:getName() )
					UiBase.SlotItem:setItemByStaticStatus( iess, 1, -1, false  )
					UiBase.SlotItem.icon:addInputEvent("Mouse_LUp", "HandleClicked_ItemMarket_GroupItem( " .. item_idx .. ",".. itemEnchantKeyRaw .." )" )
					UiBase.SlotItem.icon:addInputEvent("Mouse_On",	"_itemMarket_ShowToolTip( " .. item_idx .. ", " .. ui_Idx .. "  )")
					UiBase.SlotItem.icon:addInputEvent("Mouse_Out",	"_itemMarket_HideToolTip()")
					-- UiBase.itemSlot:ChangeTextureInfoName( "Icon/" .. iess:getIconPath() )
					
					--[[ itemMarketSummaryInfo 바인딩 함수
					gc::TPrice		getLastTradedOnePrice( void )
					gc::TPrice		getDisplayedTotalPrice( void )
					gc::TPrice		getDisplayedHighestOnePrice( void )
					gc::TPrice		getDisplayedLowestOnePrice( void )
					int32			getDisplayedTotalCount( void 
					gc::TStackCount	getDisplayedTotalAmount( void )
					gc::TPrice		getDisplayedAverageOnePrice( void )
					]]--

					UiBase.registHighPrice_Value	:SetText( replaceCount( itemMarketSummaryInfo:getDisplayedHighestOnePrice()  ) )
					UiBase.registLowPrice_Value		:SetText( replaceCount( itemMarketSummaryInfo:getDisplayedLowestOnePrice() ) )
					UiBase.averagePrice_Value		:SetText( replaceCount( itemMarketSummaryInfo:getTradedAverageOnePrice() ) )
					UiBase.recentPrice_Value		:SetText( replaceCount( itemMarketSummaryInfo:getLastTradedOnePrice() ) )
					UiBase.registListCount_Value	:SetText( replaceCount( itemMarketSummaryInfo:getTradedTotalAmount() ) )	 -- 누적 거래량
					UiBase.registItemCount_Value	:SetText( replaceCount( itemMarketSummaryInfo:getDisplayedTotalAmount() ) )
					
					UiBase.itemBTN:addInputEvent( "Mouse_LUp", "HandleClicked_ItemMarket_GroupItem( " .. item_idx .. ",".. itemEnchantKeyRaw .." )" )
					UiBase.itemBTN:SetShow( true )

					if 0 == Int64toInt32(itemMarketSummaryInfo:getDisplayedTotalAmount()) then
						UiBase.itemBTN:SetMonoTone( true )
					else
						UiBase.itemBTN:SetMonoTone( false )
					end
					
					uiPoolIdx = uiPoolIdx + 1
				--end	
			end		
		end
		
	else -- 구입 정보 보기
		-- 선택된 아이템의 종합정보
		local summaryInfo = getItemMarketSummaryInClientByIndex( self.curItemClassify, self.curSummaryItemIndex )
		if( nil == summaryInfo ) then
			_PA_ASSERT( false, "summaryInfo 아이템 종합정보가 꼭 있어야합니다")
			return;
		end
		
		local summaryIess = summaryInfo:getItemEnchantStaticStatusWrapper()
		_PA_ASSERT( nil ~= summaryIess, "summaryInfo 아이템 고정정보가 꼭 있어야합니다")
			
		local enchantLevel = summaryIess:get()._key:getEnchantLevel()

		local nameColorGrade	= summaryIess:getGradeType()
		local nameColor			= nil
		if ( 0 == nameColorGrade ) then
			nameColor = UI_color.C_FFFFFFFF
		elseif ( 1 == nameColorGrade ) then
			nameColor = 4284350320
		elseif ( 2 == nameColorGrade ) then
			nameColor = 4283144191
		elseif ( 3 == nameColorGrade ) then
			nameColor = 4294953010
		elseif ( 4 == nameColorGrade ) then
			nameColor = 4294929408
		else
			nameColor = UI_color.C_FFFFFFFF
		end

		self.txt_ItemName				:SetFontColor( nameColor )
		self.txt_ItemName				:SetText( summaryIess:getName()  )
		self.txt_ItemName				:SetTextMode( UI_TM.eTextMode_AutoWrap )
		self.selectSingleSlot			:setItemByStaticStatus( summaryIess, 1, -1, false )
		self.selectSingleSlot.icon		:addInputEvent("Mouse_On",	"_itemMarket_ShowToolTip( " .. 0 .. ", " .. 0 .. ", true )")
		self.selectSingleSlot.icon		:addInputEvent("Mouse_Out",	"_itemMarket_HideToolTip()")

		self.txt_AveragePrice_Value		:SetText( replaceCount( summaryInfo:getTradedAverageOnePrice() ) )
		self.txt_RecentPrice_Value		:SetText( replaceCount( summaryInfo:getLastTradedOnePrice() ) )
		self.txt_RegistHighPrice_Value	:SetText( replaceCount( summaryInfo:getDisplayedHighestOnePrice() ) )
		self.txt_RegistLowPrice_Value	:SetText( replaceCount( summaryInfo:getDisplayedLowestOnePrice() ) )
		self.txt_RegistListCount_Value	:SetText( replaceCount( summaryInfo:getTradedTotalAmount() ) )
		self.txt_RegistItemCount_Value	:SetText( replaceCount( summaryInfo:getDisplayedTotalAmount() ) )
		
		for ui_Idx = 0, self.itemList_MaxCount - 1 do
			local item_idx = startIndex + ui_Idx	
			-- 선택된 아이템의 sellList
			local sellInfo = getItemMarketSellInfoInClientByIndex( self.curTerritoryKeyRaw , self.sellInfoItemEnchantKeyRaw, item_idx )
			local itemAmount	= summaryInfo:getDisplayedTotalAmount()
			if( nil ~= sellInfo ) then
				
				local UiBase = self.itemSingleUiPool[ui_Idx]
				
				local iess = sellInfo:getItemEnchantStaticStatusWrapper()
				_PA_ASSERT( nil ~= iess, "sellInfo 아이템 고정정보가 꼭 있어야합니다")
			
				--[[
				TTime64								getDisplayedBeginDate( void )
				TTime64								getDisplayedEndDate( void )
				gc::TStackCount						getCount( void )
				gc::TPrice							getOnePrice( void )
				gc::TPrice							getTotalPrice( void )
				]]--
				
				local enchantLevel	= iess:get()._key:getEnchantLevel()
				local itemName		= iess:getName()

				UiBase.itemName:SetFontColor( nameColor )
				UiBase.itemName:SetText( itemName )
				
				-- _PA_LOG("luadebug", " ItemMarket:Update( " ..item_idx .. tostring(sellInfo:getCount())  );

				UiBase.SlotItem:setItemByStaticStatus( iess, sellInfo:getCount(), -1, false )
				UiBase.SlotItem.icon:addInputEvent("Mouse_On",	"_itemMarket_ShowToolTip( " .. item_idx .. ", " .. ui_Idx .. ", false  )")
				UiBase.SlotItem.icon:addInputEvent("Mouse_Out",	"_itemMarket_HideToolTip()")

				local itemEnchantKeyRaw =	iess:get()._key:get()
				
				UiBase.singleSellPrice_Value:SetText( makeDotMoney( Int64toInt32( sellInfo:getTotalPrice() )  ) )
				UiBase.singleRegistPeriod_Value:SetText( converStringFromLeftDateTime( sellInfo:getDisplayedEndDate() ) ) 
				
				if(  true == ToClient_WorldMapIsShow() ) then
					UiBase.buyItemBTN:SetShow(false)
				else
					UiBase.buyItemBTN:SetShow(true)
					UiBase.buyItemBTN:addInputEvent( "Mouse_LUp", "HandleClicked_ItemMarket_SingleItem( " .. item_idx ..",".. itemEnchantKeyRaw .. ")" )
				end
						
				UiBase.itemBG:SetShow( true )

			end
		end		
	end
	if itemInfoCount <= self.itemList_MaxCount then
		self.scroll:SetShow( false )
	else
		self.scroll:SetShow( true )
	end
end

function ItemMarket:ResetFilterBtn()

	self.curFilterIndex = -1;
	for filter_Idx = 0, #DummyData.Filter do
		ItemMarket.filterUiPool[filter_Idx]:SetCheck(false)
	end
end

function ItemMarket:SetPosition()
	local scrSizeX		= getScreenSizeX()
	local scrSizeY		= getScreenSizeY()
	local panelSizeX 	= Panel_Window_ItemMarket:GetSizeX()
	local panelSizeY 	= Panel_Window_ItemMarket:GetSizeY()

	Panel_Window_ItemMarket:SetPosX( (scrSizeX / 2) - (panelSizeX / 2) )
	Panel_Window_ItemMarket:SetPosY( (scrSizeY / 2) - (panelSizeY / 2) )
end

function _itemMarket_doSortList( sortTarget, sortValue, isResetScroll )
	local self = ItemMarket
	
	local isNum = 0;
	if( true == sortValue ) then
		isNum  = 1
	end
	sortFilteredVector( sortTarget, isNum )
	
	if nil == isResetScroll or isResetScroll then
		self.nowStartIdx = 0	
		self.scroll:SetControlTop()
	end
	
	self:SetScroll()
	self:Update( self.nowStartIdx )
end
function _itemMarket_ChangeTextureByCategory( categoryIdx )
	local self		= ItemMarket
	local control	= self.categoryUiPool[categoryIdx]
	control:ChangeTextureInfoName( "New_UI_Common_forLua/Window/ItemMarket/ItemMarket_00.dds" )
	local x1, y1, x2, y2 = setTextureUV_Func( control, _categoryTexture[categoryIdx][0][1], _categoryTexture[categoryIdx][0][2], _categoryTexture[categoryIdx][0][3], _categoryTexture[categoryIdx][0][4] )
	control:getBaseTexture():setUV(  x1, y1, x2, y2  )
	control:setRenderTexture( control:getBaseTexture() )

	local x1, y1, x2, y2 = setTextureUV_Func( control, _categoryTexture[categoryIdx][1][1], _categoryTexture[categoryIdx][1][2], _categoryTexture[categoryIdx][1][3], _categoryTexture[categoryIdx][1][4] )
	control:getOnTexture():setUV(  x1, y1, x2, y2  )

	local x1, y1, x2, y2 = setTextureUV_Func( control, _categoryTexture[categoryIdx][2][1], _categoryTexture[categoryIdx][2][2], _categoryTexture[categoryIdx][2][3], _categoryTexture[categoryIdx][2][4] )
	control:getClickTexture():setUV(  x1, y1, x2, y2  )
end
function _itemMarket_ChangeTextureBySort( control, sortTarget, sortValue )
	local self		= ItemMarket
	if true == sortValue then
		sortValue = 0
	else
		sortValue = 1
	end
	control:ChangeTextureInfoName( "New_UI_Common_forLua/Window/ItemMarket/ItemMarket_01.dds" )
	local x1, y1, x2, y2 = setTextureUV_Func( control, _sortTexture[sortTarget][sortValue][0][1], _sortTexture[sortTarget][sortValue][0][2], _sortTexture[sortTarget][sortValue][0][3], _sortTexture[sortTarget][sortValue][0][4] )
	control:getBaseTexture():setUV(  x1, y1, x2, y2  )
	control:setRenderTexture( control:getBaseTexture() )

	local x1, y1, x2, y2 = setTextureUV_Func( control, _sortTexture[sortTarget][sortValue][1][1], _sortTexture[sortTarget][sortValue][1][2], _sortTexture[sortTarget][sortValue][1][3], _sortTexture[sortTarget][sortValue][1][4] )
	control:getOnTexture():setUV(  x1, y1, x2, y2  )

	local x1, y1, x2, y2 = setTextureUV_Func( control, _sortTexture[sortTarget][sortValue][2][1], _sortTexture[sortTarget][sortValue][2][2], _sortTexture[sortTarget][sortValue][2][3], _sortTexture[sortTarget][sortValue][2][4] )
	control:getClickTexture():setUV(  x1, y1, x2, y2  )
end
function _itemMarket_ShowToolTip( item_idx, ui_Idx, isSelected )
	local self					= ItemMarket
	local itemStaticStatus		= nil
	local UiBase				= nil
	if nil == isSelected then
		local itemMarketSummaryInfo = getItemMarketSummaryInClientByIndex( self.curItemClassify, item_idx )
		itemStaticStatus			= itemMarketSummaryInfo:getItemEnchantStaticStatusWrapper()
		UiBase 						= self.itemGroupUiPool[ui_Idx].SlotItem.icon
		Panel_Tooltip_Item_Show( itemStaticStatus, UiBase, true, false, nil )
	elseif true == isSelected then
		local summaryInfo	= getItemMarketSummaryInClientByIndex( self.curItemClassify, self.curSummaryItemIndex )
		itemStaticStatus	= summaryInfo:getItemEnchantStaticStatusWrapper()
		UiBase 				= self.selectSingleSlot.icon
		Panel_Tooltip_Item_Show( itemStaticStatus, UiBase, true, false, nil )
	elseif false == isSelected then
		local sellInfo		= getItemMarketSellInfoInClientByIndex( self.curTerritoryKeyRaw , self.sellInfoItemEnchantKeyRaw, item_idx )
		itemWrapper			= sellInfo:getItemWrapper()
		UiBase				= self.itemSingleUiPool[ui_Idx].SlotItem.icon
		Panel_Tooltip_Item_Show( itemWrapper, UiBase, false, true, nil )
	end
end
function _itemMarket_HideToolTip()
	Panel_Tooltip_Item_hideTooltip()
end
function _itemMarket_ShowIconToolTip( isShow, listType, iconType, uiIdx )
	local self		= ItemMarket
	local UiBase	= nil

	if 0 == listType then
		UiBase = self.itemGroupUiPool[uiIdx]
	else
		UiBase = self
	end

	if iconType == 0 then
		name = "평균 거래가"
		desc = "해당 아이템의 평균 거래가격입니다."
		uiControl = UiBase.averagePrice_Title
	elseif iconType == 1 then
		name = "최근 거래가"
		desc = "해당 아이템의 최근 거래가격입니다."
		uiControl = UiBase.recentPrice_Title
	elseif iconType == 2 then
		name = "등록 최고가"
		desc = "해당 아이템이 거래된 최고가입니다."
		uiControl = UiBase.registHighPrice_Title
	elseif iconType == 3 then
		name = "등록 최저가"
		desc = "해당 아이템이 거래된 최저가입니다."
		uiControl = UiBase.registLowPrice_Title
	elseif iconType == 4 then
		name = "누적 거래량"
		desc = "해당 아이템의 누적된 거래량입니다."
		uiControl = UiBase.registListCount_Title
	elseif iconType == 5 then
		name = "등록 개수"
		desc = "해당 아이템이 현재 등록되어있는 수량입니다."
		uiControl = UiBase.registItemCount_Title
	end

	if isShow == true then
		TooltipSimple_Show( uiControl, name, desc )
	else
		TooltipSimple_Hide()
	end

	-- local comment, baseIcon = nil, nil
	-- if true == isShow then
	-- 	if 0 == listType then
	-- 		UiBase = self.itemGroupUiPool[uiIdx]
	-- 	else
	-- 		UiBase = self
	-- 	end

	-- 	if		0 == iconType then
	-- 		comment 	= "평균 거래가"
	-- 		baseIcon	= UiBase.averagePrice_Title
	-- 	elseif	1 == iconType then
	-- 		comment 	= "최근 거래가"
	-- 		baseIcon	= UiBase.recentPrice_Title
	-- 	elseif	2 == iconType then
	-- 		comment 	= "등록 최고가"
	-- 		baseIcon	= UiBase.registHighPrice_Title
	-- 	elseif	3 == iconType then
	-- 		comment 	= "등록 최저가"
	-- 		baseIcon	= UiBase.registLowPrice_Title
	-- 	elseif	4 == iconType then
	-- 		comment 	= "등록 건수"
	-- 		baseIcon	= UiBase.registListCount_Title
	-- 	elseif	5 == iconType then
	-- 		comment 	= "등록 개수"
	-- 		baseIcon	= UiBase.registItemCount_Title
	-- 	end

	-- 	local parents			= baseIcon:getParent()
	-- 	local parentsPosX		= parents:GetPosX()
	-- 	local parentsPosY		= parents:GetPosY()

	-- 	local grandParents		= parents:getParent()
	-- 	local grandParentsPosX	= grandParents:GetPosX()
	-- 	local grandParentsPosY	= grandParents:GetPosY()

	-- 	if 0 ~= listType then
	-- 		grandParentsPosX, grandParentsPosY = 0, 0
	-- 	end

	-- 	self.iconTooltip:SetPosX( (grandParentsPosX + parentsPosX + baseIcon:GetPosX()) - self.iconTooltip:GetSizeX() )
	-- 	self.iconTooltip:SetPosY( (grandParentsPosY + parentsPosY + baseIcon:GetPosY()) -  self.iconTooltip:GetSizeY() - 20 )
	-- 	self.iconTooltip:SetText( comment )
	-- 	self.iconTooltip:SetShow( true )
	-- else
	-- 	self.iconTooltip:SetShow( false )
	-- end
end
function _itemMarket_Search( bScrollReset )
	-- Proc_ShowMessage_Ack("아직 이용할 수 없습니다.")
	-- return
	
	local self = ItemMarket
	local text = self.edit_ItemName:GetEditText()
	if( nil == text or "" == text or "아이템명" == text ) then
		return ;
	end
	searchFilteredVector( self.curItemClassify , text );

	self:SetScroll()
	
	if nil == bScrollReset or bScrollReset then
		self.nowStartIdx = 0	
		self.scroll:SetControlTop()
	end
	
	self:Update( self.nowStartIdx )
end

function HandleClicked_ItemMarket_GroupItem( itemIdx, itemEnchantKeyRaw )
	local self = ItemMarket

	-- 해당 아이템의 sellInfo 요청
	if( ToClient_WorldMapIsShow() ) then
		requestItemMarketSellInfo( self.curTerritoryKeyRaw  , itemEnchantKeyRaw, true );
	else
		requestItemMarketSellInfo( self.curTerritoryKeyRaw  , itemEnchantKeyRaw, false );
	end
			
	self.isGrouplist = false
	self.nowStartIdx = 0
	self.sellInfoItemEnchantKeyRaw 	= itemEnchantKeyRaw
	self.curSummaryItemIndex		= itemIdx
	
	-- _PA_LOG("유흥신", "HandleClicked_ItemMarket_GroupItem " ..itemEnchantKeyRaw )
	
	self:SetScroll()
	self.scroll:SetControlTop()
	self:Update( self.nowStartIdx )

	if Panel_Tooltip_Item:GetShow() or Panel_Tooltip_Item_equipped:GetShow() then
		Panel_Tooltip_Item_hideTooltip()
	end
end

function HandleClicked_ItemMarket_SingleItem( slotidx , itemEnchantKeyRaw )
	local self = ItemMarket
	local itemCount	= self._registerCount
	self.buyItemKeyraw	= itemEnchantKeyRaw
	self.buyItemSlotidx	= slotidx

	local sellInfo			= getItemMarketSellInfoInClientByIndex( self.curTerritoryKeyRaw , self.sellInfoItemEnchantKeyRaw, slotidx )

	local masterInfo	= getItemMarketMasterByItemEnchantKey( itemEnchantKeyRaw )
	local itemName		= ""
	local itemBuyCount	= sellInfo:getCount()
	if(nil ~= masterInfo) then
		itemName = masterInfo:getItemEnchantStaticStatusWrapper():getName()
	end
	-- UI.debugMessage( Int64toInt32(itemBuyCount) )
	if Int64toInt32(itemBuyCount) == 1 then
		local messageBoxTitle	= PAGetString(Defines.StringSheet_GAME, "LUA_ITEMMARKET_MESSAGEBOX_ALERT")
		local messageBoxMemo	= PAGetStringParam1( Defines.StringSheet_GAME, "LUA_ITEMMARKET_MESSAGEBOX_BUYCONFIRM", "itemName", itemName ) -- itemName.. " 아이템을 구입하시겠습니까?"
		local messageBoxData = { title = messageBoxTitle, content = messageBoxMemo, functionYes = ItemMarket_SingleItemBuy, functionNo = MessageBox_Empty_function, priority = CppEnums.PAUIMB_PRIORITY.PAUIMB_PRIORITY_LOW}
		MessageBox.showMessageBox(messageBoxData)
		-- FGlobal_HandleClicked_ItemMarket_SingleItem_Do( Int64toInt32(itemBuyCount) )
	else
		FGlobal_ItemMarket_BuyConfirm_Open( itemName, itemBuyCount )
	end
end

function ItemMarket_SingleItemBuy()
	FGlobal_HandleClicked_ItemMarket_SingleItem_Do( 1 )
end
	
function ItemMarket_UpdateMoneyByWarehouse()
	local	self	= ItemMarket
	
	self.invenMoney:SetText( ": " .. makeDotMoney(getSelfPlayer():get():getInventory():getMoney_s64()) )
	self.warehouseMoney:SetText( "창고에 보유하고 있는 금액" )
	self.warehouseMoney:SetText( ": " .. makeDotMoney(warehouse_moneyFromNpcShop_s64()) )
end

function FGlobal_HandleClicked_ItemMarket_SingleItem_Do( itemCount )
	local	self			= ItemMarket
	local	fromWhereType	= CppEnums.ItemWhereType.eInventory
	if( self.radioBtn_Warehouse:IsCheck() )	then
		fromWhereType	= CppEnums.ItemWhereType.eWarehouse
	end
	
	requestBuyItemForItemMarket( fromWhereType, self.buyItemKeyraw, self.buyItemSlotidx, itemCount )
	if Panel_Window_ItemMarket_BuyConfirm:IsShow() then
		-- Proc_ShowMessage_Ack("아이템이 구입되었습니다.")
		FGlobal_ItemMarket_BuyConfirm_Close()
	end
end

function FromClient_notifyItemMarketMessage( msgType, strParam1, param1, param2, param3 )
	--[[
		msgType 0 : 아이템 구입 / param 없음
		msgType 1 : 아이템 최저가 등록 시, 유저들에게 알림 / strParam1 : 아이템 이름 , param1 : 인챈트레벨, param2 : TerritoryKey, param3 : 가격 
		msgType 2 : 내 물품 판매 / strParam1 : 아이템 이름, param1 : 판매된 수량, param2 : 아이템의 스택 가능 여부
	]]--
	if 0 == msgType then
		Proc_ShowMessage_Ack("아이템이 구입되었습니다.")
	elseif 1 == msgType then
		local territoryNameArray = {
			[0]	= tostring(PAGetString(Defines.StringSheet_GAME, "LUA_TERRITORYAUTHORITY_KEY_0")),		-- 발레노스령
			[1] = tostring(PAGetString(Defines.StringSheet_GAME, "LUA_TERRITORYAUTHORITY_KEY_1")),		-- 세렌디아령
			[2] = tostring(PAGetString(Defines.StringSheet_GAME, "LUA_TERRITORYAUTHORITY_KEY_2")),		-- 칼페온령
			[3] = tostring(PAGetString(Defines.StringSheet_GAME, "LUA_TERRITORYAUTHORITY_KEY_3")),		-- 메디아령
			--[4] = tostring(PAGetString(Defines.StringSheet_GAME, "LUA_TERRITORYAUTHORITY_KEY_")),		-- 발렌시아령(미정)
		}
		
		if param2 < 0 or 4 <= param2 then
			return
		end
		
		local territoryName = territoryNameArray[param2]
		
		if 0 < param1 then
			strParam1 = "+" .. param1 .. " " .. strParam1
		end
		
		local message = {main = "[" .. strParam1 .. "] " .. makeDotMoney(toInt64(0, param3)) .. " 은화", sub = "아이템 거래소 등록 대기" } 
		Proc_ShowMessage_Ack_For_RewardSelect( message, 5, 19 )
	elseif 2 == msgType then
		local message = ""
		if param2 == 1 then
			message = "[ " .. strParam1 .. " ] 아이템이 [ " .. param1 .. "개 ] 판매되었습니다."
		else
			message = "[ " .. strParam1 .. " ] 아이템이 판매되었습니다."
		end
		Proc_ShowMessage_Ack( message )
	end
	
end

function HandleClicked_ItemMarket_UnSetGroupItem()
	local self = ItemMarket
	if not self.static_SlotBg:GetShow() then
		return
	end
	self.isGrouplist = true
	self.nowStartIdx = 0

	self:SetScroll()
	self.scroll:SetControlTop()
	self:Update( self.nowStartIdx )

	if Panel_Tooltip_Item:GetShow() or Panel_Tooltip_Item_equipped:GetShow() then
		Panel_Tooltip_Item_hideTooltip()
	end
end

function HandleClicked_ItemMarket_SelectCategory( categoryIdx )
	local self = ItemMarket
	
	requestItemMarketSummaryInfo(self.curTerritoryKeyRaw, self.isWorldMapOpen, true)
	
	self.curItemClassify = categoryIdx;
	self.isGrouplist = true

	self.curClassType		= -1;
	self.curServantType		= -1;
	
	if( -1 < self.curFilterIndex ) then
		if( self.curFilterIndex < 5 ) then
			self.curClassType = convertFilterIndexToClassType( self.curFilterIndex )
		else
			self.curServantType = convertFilterIndexToServanType(self.curFilterIndex )
		end	
	end
	
	makeFilteredVector( self.curItemClassify , self.curClassType, self.curServantType )
	
	-- self:SetPosition()
	self:SetScroll()
	self.scroll:SetControlTop()

	self.nowStartIdx = 0
	self.edit_ItemName:SetEditText("아이템명", false)
	self:Update( self.nowStartIdx )
end
function ShowTooltip_ItemMarket_Category( isShow, index )
	local self = ItemMarket
		name = DummyData.Category[index]
		desc = nil
		uiControl = self.categoryUiPool[index]

	if isShow == true then
		TooltipSimple_Show( uiControl, name, desc )
	else
		TooltipSimple_Hide()
	end


	-- local self = ItemMarket
	-- if ( nil == index ) then
	-- 	self.iconTooltip:SetShow( false )
	-- 	return
	-- end
	
	-- self.iconTooltip:SetText( DummyData.Category[index] )
	-- self.iconTooltip:SetPosX( self.categoryUiPool[index]:GetPosX() )
	-- self.iconTooltip:SetPosY( self.categoryUiPool[index]:GetPosY() + self.iconTooltip:GetSizeY() )
	-- self.iconTooltip:SetShow( true )
	
end

function HandleClicked_ItemMarket_SelectFilter( filterIdx )
	local self = ItemMarket
	if( self.curFilterIndex == filterIdx ) then
		ItemMarket.filterUiPool[filterIdx]:SetCheck(false)
		self.curFilterIndex = -1
	else	
		self.curFilterIndex = filterIdx
	end
		
	local classType		= -1;
	local servantType	= -1;
	
	if( -1 < self.curFilterIndex ) then
		if( self.curFilterIndex < 5 ) then
			classType = convertFilterIndexToClassType( self.curFilterIndex )
		else
			servantType = convertFilterIndexToServanType(self.curFilterIndex )
		end	
	end
	
	-- _PA_LOG( "luadebug", "HandleClicked_ItemMarket_SelectFilter " .. classType .. " " ..servantType)
	
	self.isGrouplist = true
	
	makeFilteredVector( self.curItemClassify, classType, servantType )
	
	-- self:SetPosition()
	self.edit_ItemName:SetEditText("아이템명", false)
	self:SetScroll()
	self.scroll:SetControlTop()

	self.nowStartIdx = 0
	self:Update( self.nowStartIdx )
end

function HandleClicked_ItemMarket_ItemSort( sortTarget )
	local self = ItemMarket

	-- {텍스쳐 초기화.	-- todo : 구조 변경이 필요함. 150122 창욱
		_itemMarket_ChangeTextureBySort( self.btn_Sort_ItemName,			0, true )
		_itemMarket_ChangeTextureBySort( self.btn_Sort_RecentPrice,			1, true )
		_itemMarket_ChangeTextureBySort( self.btn_Sort_RegistItemCount,		2, true )
		_itemMarket_ChangeTextureBySort( self.btn_Sort_AverageTradePrice,	3, true )
		_itemMarket_ChangeTextureBySort( self.btn_Sort_RecentRegistDate,	4, true )
	-- }
	
	local sortValue = false
	local control	= nil
	
	if 0 == sortTarget then
		self.isSort_ItemName			= not self.isSort_ItemName
		self.isSort_RecentPrice			= true
		self.isSort_RegistItemCount		= true
		self.isSort_AverageTradePrice	= true
		self.isSort_RecentRegistDate	= true

		sortValue						= self.isSort_ItemName
		control							= self.btn_Sort_ItemName
	elseif 1 == sortTarget then
		self.isSort_ItemName			= true
		self.isSort_RecentPrice			= not self.isSort_RecentPrice
		self.isSort_RegistItemCount		= true
		self.isSort_AverageTradePrice	= true
		self.isSort_RecentRegistDate	= true

		sortValue						= self.isSort_RecentPrice
		control							= self.btn_Sort_RecentPrice
	elseif 2 == sortTarget then
		self.isSort_ItemName			= true
		self.isSort_RecentPrice			= true
		self.isSort_RegistItemCount		= not self.isSort_RegistItemCount
		self.isSort_AverageTradePrice	= true
		self.isSort_RecentRegistDate	= true

		sortValue						= self.isSort_RegistItemCount
		control							= self.btn_Sort_RegistItemCount
	elseif 3 == sortTarget then
		self.isSort_ItemName			= true
		self.isSort_RecentPrice			= true
		self.isSort_RegistItemCount		= true
		self.isSort_AverageTradePrice	= not self.isSort_AverageTradePrice
		self.isSort_RecentRegistDate	= true

		sortValue						= self.isSort_AverageTradePrice
		control							= self.btn_Sort_AverageTradePrice
	elseif 4 == sortTarget then
		self.isSort_ItemName			= true
		self.isSort_RecentPrice			= true
		self.isSort_RegistItemCount		= true
		self.isSort_AverageTradePrice	= true
		self.isSort_RecentRegistDate	= not self.isSort_RecentRegistDate

		sortValue						= self.isSort_RecentRegistDate
		control							= self.btn_Sort_RecentRegistDate
	end
	
	isChangeSort		= true
	self.curSortTarget	= sortTarget
	self.curSortValue	= sortValue

	_itemMarket_doSortList( sortTarget, sortValue )
	_itemMarket_ChangeTextureBySort( control, sortTarget, sortValue )
end

function HandleClicked_ItemMarket_Close()
	FGolbal_ItemMarket_Close()
end
function HandleClicked_ItemMarket_Search()
	_itemMarket_Search()
end
function HandleClicked_ItemMarket_SetScrollIndexByLClick()
	local self				= ItemMarket
	local maxInterval		= self.scrollInverVal
	local posByInterval		= 1 / maxInterval

	local currentInterval	= math.floor( (self.scroll:GetControlPos() / posByInterval) + 0.5 )
	self.nowStartIdx		= currentInterval
	self:Update( self.nowStartIdx )
end
function HandleClicked_ItemMarket_EditText()
	local self				= ItemMarket
	self.edit_ItemName:SetEditText("", true)
	SetFocusEdit( self.edit_ItemName )
end

function FGolbal_ItemMarket_Search()
	_itemMarket_Search()
	ClearFocusEdit()
end

-- 거래소 오픈
function FGlobal_ItemMarket_Open()
	local self = ItemMarket
	
	if true == Panel_Window_ItemMarket:GetShow() then
		return
	end
	
	if true == Panel_Window_ItemMarket_ItemSet:GetShow() then
		FGlobal_ItemMarketItemSet_Close()
	end
	
	if Panel_Window_ItemMarket_RegistItem:GetShow() then
		FGlobal_ItemMarketRegistItem_Close()
	end
	
	--창고 돈을 보여 줘야 함으로, UI를 열때 정보를 요청한다.
	--{
		warehouse_requestInfoFromNpc()
		self.invenMoney:SetShow(true)
		self.warehouseMoney:SetShow(true)
		self.radioBtn_Inven:SetShow(true)
		self.radioBtn_Warehouse:SetShow(true)
		self.static_Inven:SetShow(true)
		self.static_Warehouse:SetShow(true)
		
		self.radioBtn_Inven:SetCheck(true)
		self.radioBtn_Warehouse:SetCheck(false)
	--}

	UI.Set_ProcessorInputMode(IM.eProcessorInputMode_ChattingInputMode)
	self.btn_MyList:SetShow( false )

	Panel_Window_ItemMarket:SetShow( true, true )
	
	-- 영지 키 입력
	local selfPlayer = getSelfPlayer();
	local regionInfoWrapper = getRegionInfoWrapper(selfPlayer:getRegionKeyRaw())
	if (nil == regionInfoWrapper) then
		Proc_ShowMessage_Ack("플레이어의 현재위치가 비정상적입니다")
		return
	end	
	
	self.curTerritoryKeyRaw = regionInfoWrapper:getTerritoryKeyRaw()
	-- _PA_LOG("luadebug", "FGlobal_ItemMarket_Open" ..tostring( self.curTerritoryKeyRaw ) );

	self.panelTitle:SetText( "아이템 거래소" )
	
	--[[
	local dialogData = ToClient_GetCurrentDialogData()
	if (nil == dialogData) then
		return
	end
	
	local npcShopType = dialogData:getShopType()
	local classify = ItemClassify.eItemClassify_Etc
	local isStable = dialogData:isStable()
	
	if shopType.eShopType_Potion == npcShopType then
		classify = ItemClassify.eItemClassify_Potion
	elseif shopType.eShopType_Weapon == npcShopType then
		classify = ItemClassify.eItemClassify_MainWeapon
	elseif shopType.eShopType_Jewel == npcShopType then
		classify = ItemClassify.eItemClassify_Jewel
	elseif shopType.eShopType_Furniture == npcShopType then
		classify = ItemClassify.eItemClassify_Housing
	elseif isStable then
		classify = ItemClassify.eItemClassify_Vehicle
	end	
	]]--
	
	self.curItemClassify = ItemClassify.eItemClassify_Etc
	self.curClassType	= -1
	self.curServantType	= -1
	self.curFilterIndex	= -1
	self.isGrouplist = true
	self.nowStartIdx = 0
	self.isWorldMapOpen	= false
	self.isChangeSort	= false
	self.curSortTarget	= -1
	self.curSortValue	= false
	
	--requestItemMarketMasterInfo(false);	-- 마스터 정보와
	requestItemMarketSummaryInfo(self.curTerritoryKeyRaw, false, false); -- 종합 정보를 같이 요ㄱ청

	makeFilteredVector( self.curItemClassify , -1, -1 )
	
	self.edit_ItemName:SetEditText( "아이템명", false )
	ClearFocusEdit()

	self.ResetFilterBtn()
	self:SetPosition()
	self:SetScroll()
	self.scroll:SetControlTop()
	self:Update( self.nowStartIdx )
end

-- 거래소 오픈
function FGlobal_ItemMarket_Open_ForWorldMap( territoryKeyRaw )
	local self = ItemMarket
	
	if true == Panel_Window_ItemMarket:GetShow() then
		return
	end
	
	if true == Panel_Window_ItemMarket_ItemSet:GetShow() then
		FGlobal_ItemMarketItemSet_Close()
	end
	
	if Panel_Window_ItemMarket_RegistItem:GetShow() then
		FGlobal_ItemMarketRegistItem_Close()
	end
	
	--월드맵을 통한 거래소는 구매가 현재 지원되지 않음으로 UI를 안보여준다.
	--{
		self.invenMoney:SetShow(false)
		self.warehouseMoney:SetShow(false)
		self.radioBtn_Inven:SetShow(false)
		self.radioBtn_Warehouse:SetShow(false)
		self.static_Inven:SetShow(false)
		self.static_Warehouse:SetShow(false)
	--}
	
	-- 영지 키 입력
	self.curTerritoryKeyRaw = territoryKeyRaw
	-- _PA_LOG("luadebug", "FGlobal_ItemMarket_Open_ForWorldMap" ..tostring( self.curTerritoryKeyRaw ) );
	self.isWorldMapOpen = true
	
	local rv = requestItemMarketSummaryInfo(self.curTerritoryKeyRaw, true, false); -- 종합 정보를 같이 요ㄱ청
	if( 0 ~= rv ) then
		return
	end
	--requestItemMarketMasterInfo(true);	-- 마스터 정보 요청
	
	self.curItemClassify = ItemClassify.eItemClassify_Etc
	self.curClassType	= -1
	self.curServantType	= -1
	self.curFilterIndex	= -1
	self.isGrouplist = true
	self.nowStartIdx = 0
	self.isChangeSort	= false
	self.curSortTarget	= -1
	self.curSortValue	= false
	
	-- 출력해줄 리스트 만들기
	makeFilteredVector( self.curItemClassify , -1, -1 )
	ClearFocusEdit()
	
	-- 월드맵 모드이면 내 목록을 보이게 한다.
	self.btn_MyList						:SetShow( true )
	self.edit_ItemName:SetEditText( "아이템명", false )
	self.panelTitle:SetText( "아이템 거래소" )
	Panel_Window_ItemMarket					:SetShow( true, true )
	
	self.ResetFilterBtn()
	self:SetPosition()
	self:SetScroll()
	self.scroll:SetControlTop()
	self:Update( self.nowStartIdx )
end

-- 내 리스트 오픈
--[[function FGlobal_ItemMarketItemSet_Open()

	if itemMarket_Window:GetShow() then 
		itemMarket_Window:SetShow( false )
	end
	
	if Panel_Window_ItemMarket_RegistItem:GetShow() then
		FGlobal_ItemMarketRegistItem_Close()
	end

	UI.Set_ProcessorInputMode(IM.eProcessorInputMode_ChattingInputMode)

	ItemMarket:SetPosition()
	ClearFocusEdit()
	ItemMarketItemSet_Open()

	Panel_ItemMarket_CombineWindow:SetShow( true )
	itemMarket_MyList_Window:SetShow( true )
end--]]

-- 패널 꺼주기
function FGolbal_ItemMarket_Close()
	if false == Panel_Window_ItemMarket:GetShow() then
		return
	end
	_itemMarket_ShowIconToolTip( false )
	ClearFocusEdit()
	UI.Set_ProcessorInputMode(IM.eProcessorInputMode_UiMode)
	_itemMarket_HideToolTip()
	Panel_Window_ItemMarket:SetShow( false, false )
end

--[[function FGlobal_ItemMarketItemSet_Close()
	_ItemMarketItemSet_HideToolTip()
	UI.Set_ProcessorInputMode(IM.eProcessorInputMode_UiMode)
	Panel_Window_ItemMarket_ItemSet:SetShow( false, false )
end

function Panel_ItemMarket_CombineWindow_Close()
	if Panel_ItemMarket_CombineWindow:GetShow() then
		Panel_ItemMarket_CombineWindow:SetShow( false, false )
		itemMarket_Window:SetShow( false )
		itemMarket_MyList_Window:SetShow( false )
	end
end--]]

-------------------------------------------------------
-- 서버에서의 응답
----------------------------------------------------------
function 	Update_ItemMarketMasterInfo()

	-- _PA_LOG("luadebug", "Update_ItemMarketMasterInfo" )
	local self = ItemMarket
	
	ItemMarket:Update(self.nowStartIdx);
end

function	Update_ItemMarketSummaryInfo()

	-- _PA_LOG("luadebug", "Update_ItemMarketSummaryInfo" )
	local self = ItemMarket
	
	self.curClassType		= -1;
	self.curServantType		= -1;
	
	if( -1 < self.curFilterIndex ) then
		if( self.curFilterIndex < 5 ) then
			self.curClassType = convertFilterIndexToClassType( self.curFilterIndex )
		else
			self.curServantType = convertFilterIndexToServanType(self.curFilterIndex )
		end	
	end
	
	makeFilteredVector( self.curItemClassify , self.curClassType, self.curServantType )
	_itemMarket_Search( false )
	
	if self.isChangeSort then
		_itemMarket_doSortList( self.curSortTarget, self.curSortValue, false )
	end
	
	ItemMarket:Update(self.nowStartIdx);
end

function	Update_ItemMarketSellInfo()

	-- _PA_LOG("luadebug", "Update_ItemMarketSellInfo" )
	
	-- 컨트롤들의 정보만 업데이트 
	local self = ItemMarket
	
	self.nowStartIdx = 0
	self:SetScroll()
	self.scroll:SetControlTop()
	
	ItemMarket:Update(self.nowStartIdx);
end
-------------------------------------------------------------

function ItemMarket:registEventHandler()
	self.static_ItemListBG			:addInputEvent("Mouse_DownScroll",	"ItemMarket_ScrollUpdate( true )")
	self.static_ItemListBG			:addInputEvent("Mouse_UpScroll",	"ItemMarket_ScrollUpdate( false )")
	self.selectSingleSlot.icon		:addInputEvent("Mouse_RUp",			"HandleClicked_ItemMarket_UnSetGroupItem()")
	self.static_ListHeadBG			:addInputEvent("Mouse_RUp",			"HandleClicked_ItemMarket_UnSetGroupItem()")

	self.edit_ItemName				:addInputEvent("Mouse_LUp",			"HandleClicked_ItemMarket_EditText()")

	self.btn_Sort_ItemName			:addInputEvent("Mouse_LUp",			"HandleClicked_ItemMarket_ItemSort( " .. 0 .. " )")
	self.btn_Sort_RecentPrice		:addInputEvent("Mouse_LUp",			"HandleClicked_ItemMarket_ItemSort( " .. 1 .. " )")
	self.btn_Sort_RegistItemCount	:addInputEvent("Mouse_LUp",			"HandleClicked_ItemMarket_ItemSort( " .. 2 .. " )")
	self.btn_Sort_AverageTradePrice	:addInputEvent("Mouse_LUp",			"HandleClicked_ItemMarket_ItemSort( " .. 3 .. " )")
	self.btn_Sort_RecentRegistDate	:addInputEvent("Mouse_LUp",			"HandleClicked_ItemMarket_ItemSort( " .. 4 .. " )")
	
	self.btn_Close					:addInputEvent("Mouse_LUp",			"HandleClicked_ItemMarket_Close()")
	self.btn_Search					:addInputEvent("Mouse_LUp",			"HandleClicked_ItemMarket_Search()")

	self.averagePrice_Title			:addInputEvent("Mouse_On",	"_itemMarket_ShowIconToolTip( true, " .. 1 .. ", " .. 0 .. ")")
	self.averagePrice_Title			:addInputEvent("Mouse_Out",	"_itemMarket_ShowIconToolTip( false )")
	self.recentPrice_Title			:addInputEvent("Mouse_On",	"_itemMarket_ShowIconToolTip( true, " .. 1 .. ", " .. 1 .. ")")
	self.recentPrice_Title			:addInputEvent("Mouse_Out",	"_itemMarket_ShowIconToolTip( false )")
	self.registHighPrice_Title		:addInputEvent("Mouse_On",	"_itemMarket_ShowIconToolTip( true, " .. 1 .. ", " .. 2 .. ")")
	self.registHighPrice_Title		:addInputEvent("Mouse_Out",	"_itemMarket_ShowIconToolTip( false )")
	self.registLowPrice_Title		:addInputEvent("Mouse_On",	"_itemMarket_ShowIconToolTip( true, " .. 1 .. ", " .. 3 .. ")")
	self.registLowPrice_Title		:addInputEvent("Mouse_Out",	"_itemMarket_ShowIconToolTip( false )")
	self.registListCount_Title		:addInputEvent("Mouse_On",	"_itemMarket_ShowIconToolTip( true, " .. 1 .. ", " .. 4 .. ")")
	self.registListCount_Title		:addInputEvent("Mouse_Out",	"_itemMarket_ShowIconToolTip( false )")
	self.registItemCount_Title		:addInputEvent("Mouse_On",	"_itemMarket_ShowIconToolTip( true, " .. 1 .. ", " .. 5 .. ")")
	self.registItemCount_Title		:addInputEvent("Mouse_Out",	"_itemMarket_ShowIconToolTip( false )")

	self.scrollCtrlBTN				:addInputEvent("Mouse_LPress",		"HandleClicked_ItemMarket_SetScrollIndexByLClick()")
	self.scroll						:addInputEvent("Mouse_LUp",			"HandleClicked_ItemMarket_SetScrollIndexByLClick()")
	self.scroll						:addInputEvent("Mouse_DownScroll",	"HandleClicked_ItemMarket_SetScrollIndexByLClick()")
	self.scroll						:addInputEvent("Mouse_UpScroll",	"HandleClicked_ItemMarket_SetScrollIndexByLClick()")
	self.btn_MyList					:addInputEvent("Mouse_LUp", 		"FGlobal_ItemMarketItemSet_Open_ForWorldMap()" )
	
	self._buttonQuestion:addInputEvent( "Mouse_LUp", "Panel_WebHelper_ShowToggle( \"ItemMarket\" )" )								-- 물음표 좌클릭
	self._buttonQuestion:addInputEvent( "Mouse_On", "HelpMessageQuestion_Show( \"ItemMarket\", \"true\")" )				-- 물음표 마우스오버
	self._buttonQuestion:addInputEvent( "Mouse_Out", "HelpMessageQuestion_Show( \"ItemMarket\", \"false\")" )			-- 물음표 마우스오버
	
end
function ItemMarket:registMessageHandler()
	registerEvent("FromClient_notifyItemMarketMessage", "FromClient_notifyItemMarketMessage")
	registerEvent("FromClient_InventoryUpdate",			"ItemMarket_UpdateMoneyByWarehouse")
	registerEvent("EventWarehouseUpdate",				"ItemMarket_UpdateMoneyByWarehouse")
end

ItemMarket:Initialize()
ItemMarket:registEventHandler()
ItemMarket:registMessageHandler()
