local UI_TM			= CppEnums.TextMode

value_Panel_MovieTheater_320_IsCheckedShow = false

Panel_MovieTheater_320:ActiveMouseEventEffect( true )
Panel_MovieTheater_320:setGlassBackground( true )

Panel_MovieTheater_320:SetShow( false, false )
		-- 초기엔 반드시 셋팅 해줘야한다!

Panel_MovieTheater_320:RegisterShowEventFunc( true, 'Panel_MovieTheater320_ShowAni()' )
Panel_MovieTheater_320:RegisterShowEventFunc( false, 'PanelMovieTheater320_HideAni()' )
-----------------------------------------------------------
--					창 애니메이션 처리
-----------------------------------------------------------
function Panel_MovieTheater320_ShowAni()
	UIAni.AlphaAnimation( 1, Panel_MovieTheater_320, 0.0, 0.15 )
	Panel_MovieTheater_320:SetShow(true)
end

function Panel_MovieTheater320_HideAni()
	local aniInfo = UIAni.AlphaAnimation( 0, Panel_MovieTheater_320, 0.0, 0.1 )
	aniInfo:SetHideAtEnd(true)
end


------------------------------------------------------------------------------------------------------------------------------------------------------------
------------------------------------------------------------------------------------------------------------------------------------------------------------
local _btn_Close 			= UI.getChildControl ( Panel_MovieTheater_320, "Button_Close" )
local _btn_Replay 			= UI.getChildControl ( Panel_MovieTheater_320, "Button_Replay" )
local _btn_Nomore 			= UI.getChildControl ( Panel_MovieTheater_320, "Button_Nomore" )
local _txt_Title 			= UI.getChildControl ( Panel_MovieTheater_320, "StaticText_Title" )
local _movieTheater_320		= UI.createControl( CppEnums.PA_UI_CONTROL_TYPE.PA_UI_CONTROL_WEBCONTROL, Panel_MovieTheater_320, 'WebControl_SkillGuide' )

local helpBubble			= UI.getChildControl ( Panel_MovieTheater_320, "Static_HelpBubble" )
local helpMsg				= UI.getChildControl ( Panel_MovieTheater_320, "StaticText_HelpMsg" )

local _comboList			= UI.getChildControl ( Panel_MovieTheater_320, "StaticText_ComboList" )

local messageUI = {
	_messageBox 			= UI.getChildControl ( Panel_MovieTheater_MessageBox, "Static_MessageBox" ),
	_message_Title 			= UI.getChildControl ( Panel_MovieTheater_MessageBox, "Static_Text_Title" ),
	_messageText 			= UI.getChildControl ( Panel_MovieTheater_MessageBox, "Static_Text" ),
	_btn_Yes 				= UI.getChildControl ( Panel_MovieTheater_MessageBox, "Button_Yes" ),
	_btn_No 				= UI.getChildControl ( Panel_MovieTheater_MessageBox, "Button_No" ),
}

_btn_Close:addInputEvent( "Mouse_LUp", "Panel_MovieTheater320_JustClose()" )
_btn_Replay:addInputEvent( "Mouse_LUp", "Panel_MovieTheater320_Replay()" )
_btn_Nomore:addInputEvent( "Mouse_LUp", "Panel_MovieTheater320_MessageBox()" )
------------------------------------------------------------------------------------------------------------------------------------------------------------
------------------------------------------------------------------------------------------------------------------------------------------------------------

------------------------------------------------------------
--					최초 초기화 함수
------------------------------------------------------------
function Panel_MovieTheater320_Initialize()
	_movieTheater_320:SetPosX( 5 )
	_movieTheater_320:SetPosY( 38 )
	_movieTheater_320:SetUrl(320, 240, "coui://UI_Data/UI_Html/UI_Guide_Movie.html")
	
	Panel_MovieTheater_320:SetSize( Panel_MovieTheater_320:GetSizeX(), 317 )
	
	Panel_MovieTheater_MessageBox:SetShow( false )
	for _, v in pairs ( messageUI ) do
		v:SetShow( false )
	end
end

function Panel_MovieTheater320_ResetMessageBox()
	Panel_MovieTheater_MessageBox:SetShow( false )
	for _, v in pairs ( messageUI ) do
		v:SetShow( false )
	end
end

-- local ComboMovieName = skillTypeSS:getComboMoviePath()

------------------------------------------------------------
--						기타 변수
------------------------------------------------------------
local playedNo = 0
local warriorText 		= "워리어 : "
local rangerText 		= "레인저 : "
local sorcererText 		= "소서러 : "
local giantText 		= "자이언트 : "
local tamerText			= "금수랑 : "

---------------------------------------------------------------------------------------
local comboDesc = {
	[0] = "<PAColor0xFFFFD450> 강타 <PAOldColor> > <PAColor0xFFFFD450> 전진 검술<PAOldColor>",
	[1] = "<PAColor0xFFFFD450> 잡아 메치기 <PAOldColor> > <PAColor0xFFFFD450> 전진 검술 <PAOldColor> > <PAColor0xFFFFD450> 지면 가르기<PAOldColor>",
	[2] = "<PAColor0xFFFFD450> 반격 태세 <PAOldColor> > <PAColor0xFFFFD450> 깊게 찌르기 <PAOldColor> > <PAColor0xFFFFD450> 돌진 찌르기 <PAOldColor> > <PAColor0xFFFFD450> 회전 가르기<PAOldColor>",
	[3] = "<PAColor0xFFFFD450> 반격 태세 <PAOldColor> > <PAColor0xFFFFD450> 돌개 강타<PAOldColor> > <PAColor0xFFFFD450> 돌개 가르기<PAOldColor>",
	[16] = "<PAColor0xFFFFD450> 방패 진공 <PAOldColor> > <PAColor0xFFFFD450> 극:찍어 차기 <PAOldColor> > <PAColor0xFFFFD450> 돌개 베기 <PAOldColor> > <PAColor0xFFFFD450> 돌개 가르기 <PAOldColor> > <PAColor0xFFFFD450> 극:깊게 찌르기 <PAOldColor> > <PAColor0xFFFFD450> 점프 찌르기 <PAOldColor> > <PAColor0xFFFFD450> 연속 점프 찌르기 <PAOldColor> > <PAColor0xFFFFD450> 방패 진공 <PAOldColor> > <PAColor0xFFFFD450> 잡아 매치기 <PAOldColor> > <PAColor0xFFFFD450> 발차기 <PAOldColor> > <PAColor0xFFFFD450> 전진 검술 2타격 <PAOldColor> > <PAColor0xFFFFD450> 회전 가르기 <PAOldColor> > <PAColor0xFFFFD450> 극:회전 가르기 <PAOldColor> > <PAColor0xFFFFD450> 점프 가르기 <PAOldColor> > <PAColor0xFFFFD450> 지면강타<PAOldColor>",
	
	[4] = "<PAColor0xFFFFD450> 활 숙련도 <PAOldColor> > <PAColor0xFFFFD450> 회피 사격 <PAOldColor> > <PAColor0xFFFFD450> 약점 노리기 <PAOldColor> > <PAColor0xFFFFD450> 회피 사격<PAOldColor> > <PAColor0xFFFFD450> 약점 노리기<PAOldColor> - 반복",
	[5] = "<PAColor0xFFFFD450> 활 숙련도 <PAOldColor> > <PAColor0xFFFFD450> 약점 노리기 <PAOldColor> > <PAColor0xFFFFD450> 바람 모아쏘기<PAOldColor>",
	[6] = "<PAColor0xFFFFD450> 활 숙련도 <PAOldColor> > <PAColor0xFFFFD450> 회피 사격 <PAOldColor> > <PAColor0xFFFFD450> 약점 노리기 <PAOldColor> > <PAColor0xFFFFD450> 회피 사격 <PAOldColor> > <PAColor0xFFFFD450> 약점 노리기 <PAOldColor> > <PAColor0xFFFFD450> 바람 모아쏘기<PAOldColor>",
	[7] = "<PAColor0xFFFFD450> 돌진 차기 <PAOldColor> > <PAColor0xFFFFD450> 반달 차기 <PAOldColor> > <PAColor0xFFFFD450> 회피 폭발사격(흐름) <PAOldColor> > <PAColor0xFFFFD450> 활 숙련도(공중)<PAOldColor>",
	[17] = "<PAColor0xFFFFD450> 우직한 칼날 바람 <PAOldColor> > <PAColor0xFFFFD450> 전력 질주 중 활 숙련도 <PAOldColor> > <PAColor0xFFFFD450> 수호의 검 <PAOldColor> > <PAColor0xFFFFD450> 반달 차기 <PAOldColor> > <PAColor0xFFFFD450>길을 여는 바람 (흐름)<PAOldColor>",
	
	[8] = "<PAColor0xFFFFD450> 해방된 어둠 <PAOldColor> > <PAColor0xFFFFD450> 어둠의 연격<PAOldColor>",
	[9] = "<PAColor0xFFFFD450> 어둠 가르기 <PAOldColor> > <PAColor0xFFFFD450> 하단 차기 <PAOldColor> > <PAColor0xFFFFD450> 해방된 어둠(후방) <PAOldColor> > <PAColor0xFFFFD450> 까마귀 돌진 <PAOldColor> > <PAColor0xFFFFD450> 하단 차기<PAOldColor>",
	[10] = "<PAColor0xFFFFD450> 사악한 기운 <PAOldColor> > <PAColor0xFFFFD450> 사악한 그림자 <PAOldColor> > <PAColor0xFFFFD450> 응축된 어둠 <PAOldColor> > <PAColor0xFFFFD450> 심연의 불꽃<PAOldColor>",
	[11] = "<PAColor0xFFFFD450> 긴밤 지르기 <PAOldColor> > <PAColor0xFFFFD450> 까마귀 불꽃 <PAOldColor> > <PAColor0xFFFFD450> 부리 차기 <PAOldColor> > <PAColor0xFFFFD450> 어둠의 연격<PAOldColor>",
	[18] = "<PAColor0xFFFFD450> 고통의 표식 <PAOldColor> > <PAColor0xFFFFD450> 조각 폭발 <PAOldColor> > <PAColor0xFFFFD450> 극:긴밤 지르기 <PAOldColor> > <PAColor0xFFFFD450> 그림자 차기 <PAOldColor> > <PAColor0xFFFFD450> 어둠의 연격 <PAOldColor> > <PAColor0xFFFFD450> 어둠의 업화 <PAOldColor> > <PAColor0xFFFFD450> 그림자 분출 <PAOldColor> > <PAColor0xFFFFD450> 극:그림자 분출 <PAOldColor> > <PAColor0xFFFFD450> 멸망의 꿈 (당겨진 멸망)<PAOldColor>",
	
	[12] = "<PAColor0xFFFFD450> 힘의 탄력(전진) <PAOldColor> > <PAColor0xFFFFD450> 박치기(모으기) <PAOldColor> > <PAColor0xFFFFD450> 힘의 탄력(전진) <PAOldColor> > <PAColor0xFFFFD450> 박치기<PAOldColor>",
	[13] = "<PAColor0xFFFFD450> 찍어 메치기 <PAOldColor> > <PAColor0xFFFFD450> 힘의 탄력(전진) <PAOldColor> > <PAColor0xFFFFD450> 맹수의 습격<PAOldColor>",
	[14] = "<PAColor0xFFFFD450> 박치기 <PAOldColor> > <PAColor0xFFFFD450> 맹수의 습격 <PAOldColor> > <PAColor0xFFFFD450> 날짐승 바람 가르기 <PAOldColor> > <PAColor0xFFFFD450> 힘의 탄력(전진)<PAOldColor>",
	[15] = "<PAColor0xFFFFD450> 회피 이동 <PAOldColor> > <PAColor0xFFFFD450> 날짐승 바람 가르기 <PAOldColor> > <PAColor0xFFFFD450> 몰아치는 벼락<PAOldColor>",
	[19] = "<PAColor0xFFFFD450> 힘의 탄력 (전진) <PAOldColor> > <PAColor0xFFFFD450> 박치기 <PAOldColor> > <PAColor0xFFFFD450> 맹수의 습격 <PAOldColor> > <PAColor0xFFFFD450> 맹렬한 공격 2타 <PAOldColor> > <PAColor0xFFFFD450> 박치기 2타 <PAOldColor> > <PAColor0xFFFFD450> 맹수의 습격 <PAOldColor> > <PAColor0xFFFFD450> 찍어 메치기 <PAOldColor> > <PAColor0xFFFFD450> 시체 운반자 <PAOldColor> > <PAColor0xFFFFD450> 힘의 탄력 (전진) <PAOldColor> > <PAColor0xFFFFD450> 날짐승 바람 가르기 <PAOldColor> > <PAColor0xFFFFD450> 몰아치는 벼락<PAOldColor>",
	
	[20] = "<PAColor0xFFFFD450> 낙엽 베기 <PAOldColor> > <PAColor0xFFFFD450> 벽력장 <PAOldColor> > <PAColor0xFFFFD450> 붕격 <PAOldColor> > <PAColor0xFFFFD450> 흑랑 : 즈려밟기<PAOldColor>",
	[21] = "<PAColor0xFFFFD450> 회피 공격 <PAOldColor> > <PAColor0xFFFFD450> 벽력장 <PAOldColor> > <PAColor0xFFFFD450> 흑랑 : 발톱 올려치기 <PAOldColor> > <PAColor0xFFFFD450> 벽력장<PAOldColor>",
	[22] = "<PAColor0xFFFFD450> 섬광 <PAOldColor> > <PAColor0xFFFFD450> 하늘 차기 <PAOldColor> > <PAColor0xFFFFD450> 흑랑 : 땅의 벼락 <PAOldColor> > <PAColor0xFFFFD450> 흑랑 : 즈려밟기<PAOldColor>",
	[23] = "<PAColor0xFFFFD450> 회피 이동 <PAOldColor> > <PAColor0xFFFFD450> 낙엽 베기 (전진) <PAOldColor> > <PAColor0xFFFFD450> 흑랑 : 땅의 벼락 <PAOldColor> > <PAColor0xFFFFD450> 흑랑 : 즈려밟기 <PAOldColor> > <PAColor0xFFFFD450> 벽력장 <PAOldColor> > <PAColor0xFFFFD450> 붕격<PAOldColor>",
	[24] = "<PAColor0xFFFFD450> 회피 공격 <PAOldColor> > <PAColor0xFFFFD450> 흑랑 : 할퀴기 <PAOldColor> > <PAColor0xFFFFD450> 물의 흐름 I <PAOldColor> > <PAColor0xFFFFD450> 물의 흐름 II <PAOldColor> > <PAColor0xFFFFD450> 흑랑 : 즈려밟기 <PAOldColor> > <PAColor0xFFFFD450> 흑랑 : 땅의 벼락 <PAOldColor> > <PAColor0xFFFFD450> 흑랑 : 즈려밟기 <PAOldColor> > <PAColor0xFFFFD450> 하늘 차기 <PAOldColor> > <PAColor0xFFFFD450> 흑랑 : 밀려오는 파도<PAOldColor>",
}


---------------------------------------------------------------------------------------

function Panel_MovieTheater320_JustClose()
	Panel_MovieTheater_320:SetShow ( false )
end

------------------------------------------------------------
--					흑정령 위젯용 영상
------------------------------------------------------------
function Panel_MovieTheater320_ShowToggle()
	if ( Panel_MovieTheater_MessageBox:IsShow() == true ) then
		return
	end

	-- if (not _movieTheater_320:isReadyView()) then
	-- 	return
	-- end
	
	value_Panel_MovieTheater_320_IsCheckedShow = true
	
	local player = getSelfPlayer()
	if( nil == player ) then
		return
	end
	
	local UI_classType 	= CppEnums.ClassType
	local isWarrior 	= UI_classType.ClassType_Warrior == player:getClassType()
	local isRanger 		= UI_classType.ClassType_Ranger == player:getClassType()
	local isSorcerer 	= UI_classType.ClassType_Sorcerer == player:getClassType()
	local isGiant 		= UI_classType.ClassType_Giant == player:getClassType()
	local isTamer 		= UI_classType.ClassType_Tamer == player:getClassType()
	
	local playerGet = player:get()
	local playerLevel = playerGet:getLevel()
	local isShow = Panel_MovieTheater_320:IsShow()
	
	helpBubble:SetShow( true )
	helpMsg:SetShow( true )

	helpMsg:SetAutoResize( true )
	helpMsg:SetTextMode( UI_TM.eTextMode_AutoWrap )
	
	if ( isWarrior == true ) then
		helpMsg:SetText( "발크스 교관 추천 교본, '전장의 불꽃 연속 기술'!\n[기술] 창에서 더 큰 영상으로 확인할 수 있습니다." )
	elseif ( isRanger == true ) then
		helpMsg:SetText( "마가렛 교관 추천 교본, '바람 정령의 연속 기술'!\n[기술] 창에서 더 큰 영상으로 확인할 수 있습니다." )
	elseif ( isSorcerer == true ) then
		helpMsg:SetText( "엘라 세르빈 교관 추천 교본, '깊은 어둠의 연속 기술'!\n[기술] 창에서 더 큰 영상으로 확인할 수 있습니다." )
	elseif ( isGiant == true ) then
		helpMsg:SetText( "타크로스 교관 추천 교본, '사나운 짐승의 연속 기술'!\n[기술] 창에서 더 큰 영상으로 확인할 수 있습니다." )
	elseif ( isTamer == true ) then
		helpMsg:SetText( "타크로스 교관 추천 교본, '사나운 짐승의 연속 기술'!\n[기술] 창에서 더 큰 영상으로 확인할 수 있습니다." )
	end
	
	helpBubble:SetSize( helpBubble:GetSizeX(), ( helpMsg:GetTextSizeY() + 35 ) )

	_movieTheater_320:SetSize( 320, 240 )
	
	Panel_MovieTheater_320:SetShow( true, false )
	
	_comboList:SetSize( 315, _comboList:GetTextSizeY() + 7 )
	_comboList:SetTextMode( UI_TM.eTextMode_AutoWrap )
	
	if ( isWarrior ) then		-- 워리어
		if ( playerLevel <= 6 ) then
			Panel_MovieTheater_320:SetShow( false, false )
			helpBubble:SetShow( false )
			helpMsg:SetShow( false )
		elseif ( playerLevel >= 7 ) and ( playerLevel <= 15 ) then
			_txt_Title:SetText( warriorText .. "기술 연계 가이드 - 중급" )
			_movieTheater_320:TriggerEvent("PlayMovie", "coui://UI_Movie/Movie_Pc_Skill/11_Common_ComboGuide/100.webm")
			_comboList:SetText( comboDesc[0] )
			playedNo = 100
		elseif ( playerLevel >= 16 ) and ( playerLevel <= 20 ) then
			_txt_Title:SetText( warriorText .. "기술 연계 가이드 - 중급" )
			_movieTheater_320:TriggerEvent("PlayMovie", "coui://UI_Movie/Movie_Pc_Skill/11_Common_ComboGuide/101.webm")
			_comboList:SetText( comboDesc[1] )
			playedNo = 101
		elseif ( playerLevel >= 21 ) and ( playerLevel <= 25 ) then
			_txt_Title:SetText( warriorText .. "기술 연계 가이드 - 상급" )
			_movieTheater_320:TriggerEvent("PlayMovie", "coui://UI_Movie/Movie_Pc_Skill/11_Common_ComboGuide/102.webm")
			_comboList:SetText( comboDesc[2] )
			playedNo = 102
		elseif ( playerLevel >= 26 ) and ( playerLevel <= 30 ) then
			_txt_Title:SetText( warriorText .. "기술 연계 가이드 - 최상급" )
			_movieTheater_320:TriggerEvent("PlayMovie", "coui://UI_Movie/Movie_Pc_Skill/11_Common_ComboGuide/103.webm")
			_comboList:SetText( comboDesc[3] )
			playedNo = 103
		elseif ( playerLevel >= 31 ) and ( playerLevel <= 35 ) then
			_txt_Title:SetText( warriorText .. "기술 연계 가이드 - 최상급" )
			_movieTheater_320:TriggerEvent("PlayMovie", "coui://UI_Movie/Movie_Pc_Skill/11_Common_ComboGuide/104.webm")
			_comboList:SetText( comboDesc[16] )
			playedNo = 104
		elseif ( playerLevel >= 36 ) then
			Panel_MovieTheater_320:SetShow( false, false )
			helpBubble:SetShow( false )
			helpMsg:SetShow( false )
		end
		
	elseif ( isRanger ) then	-- 레인저
		if ( playerLevel <= 6 ) then
			Panel_MovieTheater_320:SetShow( false, false )
			helpBubble:SetShow( false )
			helpMsg:SetShow( false )
		elseif ( playerLevel >= 7 ) and ( playerLevel <= 15 ) then
			_txt_Title:SetText( rangerText .. "기술 연계 가이드 - 중급" )
			_movieTheater_320:TriggerEvent("PlayMovie", "coui://UI_Movie/Movie_Pc_Skill/11_Common_ComboGuide/200.webm")
			_comboList:SetText( comboDesc[4] )
			playedNo = 200
		elseif ( playerLevel >= 16 ) and ( playerLevel <= 20 ) then
			_txt_Title:SetText( rangerText .. "기술 연계 가이드 - 중급" )
			_movieTheater_320:TriggerEvent("PlayMovie", "coui://UI_Movie/Movie_Pc_Skill/11_Common_ComboGuide/201.webm")
			_comboList:SetText( comboDesc[5] )
			playedNo = 201
		elseif ( playerLevel >= 21 ) and ( playerLevel <= 25 ) then
			_txt_Title:SetText( rangerText .. "기술 연계 가이드 - 상급" )
			_movieTheater_320:TriggerEvent("PlayMovie", "coui://UI_Movie/Movie_Pc_Skill/11_Common_ComboGuide/202.webm")
			_comboList:SetText( comboDesc[6] )
			playedNo = 202
		elseif ( playerLevel >= 26 ) and ( playerLevel <= 30 ) then
			_txt_Title:SetText( rangerText .. "기술 연계 가이드 - 최상급" )
			_movieTheater_320:TriggerEvent("PlayMovie", "coui://UI_Movie/Movie_Pc_Skill/11_Common_ComboGuide/203.webm")
			_comboList:SetText( comboDesc[7] )
			playedNo = 203
		elseif ( playerLevel >= 31 ) and ( playerLevel <= 35 ) then
			_txt_Title:SetText( rangerText .. "기술 연계 가이드 - 최상급" )
			_movieTheater_320:TriggerEvent("PlayMovie", "coui://UI_Movie/Movie_Pc_Skill/11_Common_ComboGuide/204.webm")
			_comboList:SetText( comboDesc[17] )
			playedNo = 204
		elseif ( playerLevel >= 36 ) then
			Panel_MovieTheater_320:SetShow( false, false )
			helpBubble:SetShow( false )
			helpMsg:SetShow( false )
		end
		
	elseif ( isSorcerer ) then	-- 소서러
		if ( playerLevel <= 6 ) then
			Panel_MovieTheater_320:SetShow( false, false )
			helpBubble:SetShow( false )
			helpMsg:SetShow( false )
		elseif ( playerLevel >= 7 ) and ( playerLevel <= 15 ) then
			_txt_Title:SetText( sorcererText .. "기술 연계 가이드 - 중급" )
			_movieTheater_320:TriggerEvent("PlayMovie", "coui://UI_Movie/Movie_Pc_Skill/11_Common_ComboGuide/300.webm")
			_comboList:SetText( comboDesc[8] )
			playedNo = 300
		elseif ( playerLevel >= 16 ) and ( playerLevel <= 20 ) then
			_txt_Title:SetText( sorcererText .. "기술 연계 가이드 - 중급" )
			_movieTheater_320:TriggerEvent("PlayMovie", "coui://UI_Movie/Movie_Pc_Skill/11_Common_ComboGuide/301.webm")
			_comboList:SetText( comboDesc[9] )
			playedNo = 301
		elseif ( playerLevel >= 21 ) and ( playerLevel <= 25 ) then
			_txt_Title:SetText( sorcererText .. "기술 연계 가이드 - 상급" )
			_movieTheater_320:TriggerEvent("PlayMovie", "coui://UI_Movie/Movie_Pc_Skill/11_Common_ComboGuide/302.webm")
			_comboList:SetText( comboDesc[10] )
			playedNo = 302
		elseif ( playerLevel >= 26 ) and ( playerLevel <= 30 ) then
			_txt_Title:SetText( sorcererText .. "기술 연계 가이드 - 최상급" )
			_movieTheater_320:TriggerEvent("PlayMovie", "coui://UI_Movie/Movie_Pc_Skill/11_Common_ComboGuide/303.webm")
			_comboList:SetText( comboDesc[11] )
			playedNo = 303
		elseif ( playerLevel >= 31 ) and ( playerLevel <= 35 ) then
			_txt_Title:SetText( sorcererText .. "기술 연계 가이드 - 최상급" )
			_movieTheater_320:TriggerEvent("PlayMovie", "coui://UI_Movie/Movie_Pc_Skill/11_Common_ComboGuide/304.webm")
			_comboList:SetText( comboDesc[18] )
			playedNo = 304
		elseif ( playerLevel >= 36 ) then
			Panel_MovieTheater_320:SetShow( false, false )
			helpBubble:SetShow( false )
			helpMsg:SetShow( false )
		end

	elseif ( isGiant ) then	-- 자이언트
		if ( playerLevel <= 6 ) then
			Panel_MovieTheater_320:SetShow( false, false )
			helpBubble:SetShow( false )
			helpMsg:SetShow( false )
		elseif ( playerLevel >= 7 ) and ( playerLevel <= 15 ) then
			_txt_Title:SetText( giantText .. "기술 연계 가이드 - 중급" )
			_movieTheater_320:TriggerEvent("PlayMovie", "coui://UI_Movie/Movie_Pc_Skill/11_Common_ComboGuide/400.webm")
			_comboList:SetText( comboDesc[12] )
			playedNo = 400
		elseif ( playerLevel >= 16 ) and ( playerLevel <= 20 ) then
			_txt_Title:SetText( giantText .. "기술 연계 가이드 - 중급" )
			_movieTheater_320:TriggerEvent("PlayMovie", "coui://UI_Movie/Movie_Pc_Skill/11_Common_ComboGuide/401.webm")
			_comboList:SetText( comboDesc[13] )
			playedNo = 401
		elseif ( playerLevel >= 21 ) and ( playerLevel <= 25 ) then
			_txt_Title:SetText( giantText .. "기술 연계 가이드 - 상급" )
			_movieTheater_320:TriggerEvent("PlayMovie", "coui://UI_Movie/Movie_Pc_Skill/11_Common_ComboGuide/402.webm")
			_comboList:SetText( comboDesc[14] )
			playedNo = 402
		elseif ( playerLevel >= 26 ) and ( playerLevel <= 30 ) then
			_txt_Title:SetText( giantText .. "기술 연계 가이드 - 상급" )
			_movieTheater_320:TriggerEvent("PlayMovie", "coui://UI_Movie/Movie_Pc_Skill/11_Common_ComboGuide/403.webm")
			_comboList:SetText( comboDesc[15] )
			playedNo = 403
		elseif ( playerLevel >= 31 ) and ( playerLevel <= 35 ) then
			_txt_Title:SetText( giantText .. "기술 연계 가이드 - 상급" )
			_movieTheater_320:TriggerEvent("PlayMovie", "coui://UI_Movie/Movie_Pc_Skill/11_Common_ComboGuide/404.webm")
			_comboList:SetText( comboDesc[19] )
			playedNo = 404
		elseif ( playerLevel >= 36 ) then
			Panel_MovieTheater_320:SetShow( false, false )
			helpBubble:SetShow( false )
			helpMsg:SetShow( false )
		end

	elseif ( isTamer ) then	-- 금수랑
		if ( playerLevel <= 6 ) then
			Panel_MovieTheater_320:SetShow( false, false )
			helpBubble:SetShow( false )
			helpMsg:SetShow( false )
		elseif ( playerLevel >= 7 ) and ( playerLevel <= 15 ) then
			playedNo = 500
			_txt_Title:SetText( tamerText .. "기술 연계 가이드 - 중급" )
			_movieTheater_320:TriggerEvent("PlayMovie", "coui://UI_Movie/Movie_Pc_Skill/11_Common_ComboGuide/" .. playedNo .. ".webm")
			_comboList:SetText( comboDesc[20] )
		elseif ( playerLevel >= 16 ) and ( playerLevel <= 20 ) then
			playedNo = 501
			_txt_Title:SetText( tamerText .. "기술 연계 가이드 - 중급" )
			_movieTheater_320:TriggerEvent("PlayMovie", "coui://UI_Movie/Movie_Pc_Skill/11_Common_ComboGuide/" .. playedNo  ..".webm")
			_comboList:SetText( comboDesc[21] )
		elseif ( playerLevel >= 21 ) and ( playerLevel <= 25 ) then
			playedNo = 502
			_txt_Title:SetText( tamerText .. "기술 연계 가이드 - 상급" )
			_movieTheater_320:TriggerEvent("PlayMovie", "coui://UI_Movie/Movie_Pc_Skill/11_Common_ComboGuide/" .. playedNo  ..".webm")
			_comboList:SetText( comboDesc[22] )
		elseif ( playerLevel >= 26 ) and ( playerLevel <= 30 ) then
			playedNo = 503
			_txt_Title:SetText( tamerText .. "기술 연계 가이드 - 상급" )
			_movieTheater_320:TriggerEvent("PlayMovie", "coui://UI_Movie/Movie_Pc_Skill/11_Common_ComboGuide/" .. playedNo  ..".webm")
			_comboList:SetText( comboDesc[23] )
		elseif ( playerLevel >= 31 ) and ( playerLevel <= 35 ) then
			playedNo = 504
			_txt_Title:SetText( tamerText .. "기술 연계 가이드 - 최상급" )
			_movieTheater_320:TriggerEvent("PlayMovie", "coui://UI_Movie/Movie_Pc_Skill/11_Common_ComboGuide/" .. playedNo  ..".webm")
			_comboList:SetText( comboDesc[24] )
		elseif ( playerLevel >= 36 ) then
			Panel_MovieTheater_320:SetShow( false, false )
			helpBubble:SetShow( false )
			helpMsg:SetShow( false )
		end
		
	elseif ( classNo == 5 ) then	-- 무사
		-- null
	end

	_comboList:SetPosY( 283 )
	_comboList:SetSize( 315, _comboList:GetTextSizeY() + 7 )
	
	_btn_Replay:SetPosY( _comboList:GetSizeY() + _comboList:GetSpanSize().y + 3 )
	_btn_Nomore:SetPosY( _comboList:GetSizeY() + _comboList:GetSpanSize().y + 3 )
	Panel_MovieTheater_320:SetSize( 330, _comboList:GetSizeY() + _btn_Replay:GetSizeY() + _comboList:GetSpanSize().y + 10 )
	Panel_MovieTheater_320:SetPosX( getScreenSizeX() - Panel_MovieTheater_320:GetSizeX() - 7 )
	Panel_MovieTheater_320:SetPosY( getScreenSizeY() - Panel_MovieTheater_320:GetSizeY() - Panel_QuickSlot:GetSizeY() )
	
	_txt_Title:SetSize( Panel_MovieTheater_320:GetSizeX(), _txt_Title:GetSizeY() )
	_txt_Title:ComputePos()
	_btn_Close:ComputePos()
	_btn_Replay:SetPosX( ( Panel_MovieTheater_320:GetSizeX() / 2 ) - ( _btn_Replay:GetSizeX() / 2 ) + 70 )
	_btn_Replay:addInputEvent( "Mouse_LUp", "Panel_MovieTheater320_Replay()" )
	
	_btn_Nomore:SetShow( true )
	_btn_Nomore:SetPosX( ( Panel_MovieTheater_320:GetSizeX() / 2 ) - ( _btn_Replay:GetSizeX() / 2 ) - 70 )
end


----------------------------------------------------------------
--				처음부터 버튼을 눌렀을 때!
----------------------------------------------------------------
function Panel_MovieTheater320_Replay()
	-- 워리어
	if ( playedNo == 100 ) then
		_movieTheater_320:TriggerEvent("PlayMovie", "coui://UI_Movie/Movie_Pc_Skill/11_Common_ComboGuide/" .. playedNo  ..".webm")
	elseif ( playedNo == 101 ) then
		_movieTheater_320:TriggerEvent("PlayMovie", "coui://UI_Movie/Movie_Pc_Skill/11_Common_ComboGuide/" .. playedNo  ..".webm")
	elseif ( playedNo == 102 ) then
		_movieTheater_320:TriggerEvent("PlayMovie", "coui://UI_Movie/Movie_Pc_Skill/11_Common_ComboGuide/" .. playedNo  ..".webm")
	elseif ( playedNo == 103 ) then
		_movieTheater_320:TriggerEvent("PlayMovie", "coui://UI_Movie/Movie_Pc_Skill/11_Common_ComboGuide/" .. playedNo  ..".webm")
	elseif ( playedNo == 104 ) then
		_movieTheater_320:TriggerEvent("PlayMovie", "coui://UI_Movie/Movie_Pc_Skill/11_Common_ComboGuide/" .. playedNo  ..".webm")

	-- 레인저
	elseif ( playedNo == 200 ) then
		_movieTheater_320:TriggerEvent("PlayMovie", "coui://UI_Movie/Movie_Pc_Skill/11_Common_ComboGuide/" .. playedNo  ..".webm")
	elseif ( playedNo == 201 ) then
		_movieTheater_320:TriggerEvent("PlayMovie", "coui://UI_Movie/Movie_Pc_Skill/11_Common_ComboGuide/" .. playedNo  ..".webm")
	elseif ( playedNo == 202 ) then
		_movieTheater_320:TriggerEvent("PlayMovie", "coui://UI_Movie/Movie_Pc_Skill/11_Common_ComboGuide/" .. playedNo  ..".webm")
	elseif ( playedNo == 203 ) then
		_movieTheater_320:TriggerEvent("PlayMovie", "coui://UI_Movie/Movie_Pc_Skill/11_Common_ComboGuide/" .. playedNo  ..".webm")
	elseif ( playedNo == 204 ) then
		_movieTheater_320:TriggerEvent("PlayMovie", "coui://UI_Movie/Movie_Pc_Skill/11_Common_ComboGuide/" .. playedNo  ..".webm")

	-- 소서러
	elseif ( playedNo == 300 ) then
		_movieTheater_320:TriggerEvent("PlayMovie", "coui://UI_Movie/Movie_Pc_Skill/11_Common_ComboGuide/" .. playedNo  ..".webm")
	elseif ( playedNo == 301 ) then
		_movieTheater_320:TriggerEvent("PlayMovie", "coui://UI_Movie/Movie_Pc_Skill/11_Common_ComboGuide/" .. playedNo  ..".webm")
	elseif ( playedNo == 302 ) then
		_movieTheater_320:TriggerEvent("PlayMovie", "coui://UI_Movie/Movie_Pc_Skill/11_Common_ComboGuide/" .. playedNo  ..".webm")
	elseif ( playedNo == 303 ) then
		_movieTheater_320:TriggerEvent("PlayMovie", "coui://UI_Movie/Movie_Pc_Skill/11_Common_ComboGuide/" .. playedNo  ..".webm")
	elseif ( playedNo == 304 ) then
		_movieTheater_320:TriggerEvent("PlayMovie", "coui://UI_Movie/Movie_Pc_Skill/11_Common_ComboGuide/" .. playedNo  ..".webm")

	-- 자이언트
	elseif ( playedNo == 400 ) then
		_movieTheater_320:TriggerEvent("PlayMovie", "coui://UI_Movie/Movie_Pc_Skill/11_Common_ComboGuide/" .. playedNo  ..".webm")
	elseif ( playedNo == 401 ) then
		_movieTheater_320:TriggerEvent("PlayMovie", "coui://UI_Movie/Movie_Pc_Skill/11_Common_ComboGuide/" .. playedNo  ..".webm")
	elseif ( playedNo == 402 ) then
		_movieTheater_320:TriggerEvent("PlayMovie", "coui://UI_Movie/Movie_Pc_Skill/11_Common_ComboGuide/" .. playedNo  ..".webm")
	elseif ( playedNo == 403 ) then
		_movieTheater_320:TriggerEvent("PlayMovie", "coui://UI_Movie/Movie_Pc_Skill/11_Common_ComboGuide/" .. playedNo  ..".webm")
	elseif ( playedNo == 404 ) then
		_movieTheater_320:TriggerEvent("PlayMovie", "coui://UI_Movie/Movie_Pc_Skill/11_Common_ComboGuide/" .. playedNo  ..".webm")
		
	-- 금수랑
	elseif ( playedNo == 500 ) then
		_movieTheater_320:TriggerEvent("PlayMovie", "coui://UI_Movie/Movie_Pc_Skill/11_Common_ComboGuide/" .. playedNo  ..".webm")
	elseif ( playedNo == 501 ) then
		_movieTheater_320:TriggerEvent("PlayMovie", "coui://UI_Movie/Movie_Pc_Skill/11_Common_ComboGuide/" .. playedNo  ..".webm")
	elseif ( playedNo == 502 ) then
		_movieTheater_320:TriggerEvent("PlayMovie", "coui://UI_Movie/Movie_Pc_Skill/11_Common_ComboGuide/" .. playedNo  ..".webm")
	elseif ( playedNo == 503 ) then
		_movieTheater_320:TriggerEvent("PlayMovie", "coui://UI_Movie/Movie_Pc_Skill/11_Common_ComboGuide/" .. playedNo  ..".webm")
	elseif ( playedNo == 504 ) then
		_movieTheater_320:TriggerEvent("PlayMovie", "coui://UI_Movie/Movie_Pc_Skill/11_Common_ComboGuide/" .. playedNo  ..".webm")
		
	end
end

----------------------------------------------------------------
--				7번 껐으니까, 미래를 선택하여라
----------------------------------------------------------------
function Panel_MovieTheater320_MessageBox()
	Panel_MovieTheater_320:SetShow( true )
	isComboMovieClosedCount = 0
	value_Panel_MovieTheater_320_IsCheckedShow = false
	
	Panel_MovieTheater_MessageBox:SetPosX( getScreenSizeX() - Panel_MovieTheater_MessageBox:GetSizeX() - 7 )
	Panel_MovieTheater_MessageBox:SetPosY( getScreenSizeY() - Panel_MovieTheater_320:GetSizeY() - Panel_QuickSlot:GetSizeY() )

	Panel_MovieTheater_MessageBox:SetShow( true )
	
	for _, v in pairs ( messageUI ) do
		v:SetShow( true )
		v:ComputePos()
	end

	messageUI._btn_Yes:addInputEvent( "Mouse_LUp", "Panel_MovieTheater320_Clicked_Func( true )" )
	messageUI._btn_No:addInputEvent( "Mouse_LUp", "Panel_MovieTheater320_Clicked_Func( false )" )
end

function Panel_MovieTheater320_Clicked_Func( isYes )
	if ( isYes == true ) then
		value_GameOption_Check_ComboGuide:SetCheck( false )
		_currentSpiritGuideCheck = false
		
		Panel_MovieTheater_320:SetShow( false )
		Panel_MovieTheater_MessageBox:SetShow( false )
	else
		Panel_MovieTheater_320:SetShow( false )
		Panel_MovieTheater_MessageBox:SetShow( false )
	end
end
------------------------------------------------------------------------------------------------------------------------------------------------------------
------------------------------------------------------------------------------------------------------------------------------------------------------------
Panel_MovieTheater320_Initialize()