Panel_HorseMp:SetShow(false, false)
local staminaAlert		= UI.getChildControl( Panel_HorseMp, "StaticText_AlertStamina")
local repair_AutoNavi	= UI.getChildControl( Panel_HorseMp, "CheckButton_Repair_AutoNavi" )
local repair_Navi		= UI.getChildControl( Panel_HorseMp, "Checkbox_Repair_Navi" )
staminaAlert:SetShow( false )
repair_AutoNavi:SetShow( false )
repair_Navi:SetShow( false )
--local panel = UI.createPanel("Virtual_MPPanel", Defines.UIGroup.PAGameUIGroup_Widget )				-- 시간 체크용 가상 패널
--panel:SetIgnore(true)
--panel:SetShow(false, false)


local	servantMpBar	= {
	_staticBar		= UI.getChildControl( Panel_HorseMp, "HorseMpBar" ),
	_staticText		= UI.getChildControl( Panel_HorseMp, "StaticText_Mp" ),
	_actorKeyRaw	= 0
}

repair_AutoNavi	:addInputEvent(	"Mouse_LUp", "HandleClick_Horse_Repair_Navi(true)" )
repair_Navi		:addInputEvent(	"Mouse_LUp", "HandleClick_Horse_Repair_Navi(false)" )

function HorseMP_init()
	Panel_HorseMp:ComputePos()
end

function	HorseMP_Update()
	local	self			= servantMpBar
	local	temporaryWrapper= getTemporaryInformationWrapper()

	local	unsealCacheData	= temporaryWrapper:getUnsealVehicleByActorKeyRaw( self._actorKeyRaw )
	if	(nil == unsealCacheData)	then
		return
	end
	
	self._staticBar	:SetProgressRate( unsealCacheData:getMp() / unsealCacheData:getMaxMp() * 100 )	
	self._staticText:SetText( tostring(unsealCacheData:getMp()) .. "/" .. tostring(unsealCacheData:getMaxMp()) )	
	
	-- 탈것 스태미너 알림
	local staminaPercent = nil
	local alertText = ""
	-- local landVehicleWrapper = temporaryWrapper:getUnsealVehicle( CppEnums.ServantType.Type_Vehicle )
	-- if ( nil == landVehicleWrapper ) then
	-- 	return
	-- end

	if ( CppEnums.VehicleType.Type_Carriage == unsealCacheData:getVehicleType() ) or ( unsealCacheData:getVehicleType() == CppEnums.VehicleType.Type_CowCarriage ) then
		alertText = PAGetString(Defines.StringSheet_GAME, "LUA_SERVANT_STAMINA_ALERT_1")		-- 수명이 얼마 남지 않았습니다.\n마구간에서 폐기해야 합니다.
	elseif ( CppEnums.VehicleType.Type_Boat == unsealCacheData:getVehicleType() ) or ( unsealCacheData:getVehicleType() == CppEnums.VehicleType.Type_Raft ) or ( unsealCacheData:getVehicleType() == CppEnums.VehicleType.Type_FishingBoat ) or ( unsealCacheData:getVehicleType() == CppEnums.VehicleType.Type_SailingBoat ) then
		alertText = PAGetString(Defines.StringSheet_GAME, "LUA_SERVANT_STAMINA_ALERT_3")		-- 수명이 얼마 남지 않았습니다.\n선착장에서 폐기해야 합니다.
	else
		alertText = PAGetString(Defines.StringSheet_GAME, "LUA_SERVANT_STAMINA_ALERT_2")		-- 기력이 얼마 남지 않아 속도가 느려집니다.\n당근을 먹이거나 마구간에 들러 회복시켜 주세요.
	end
	staminaAlert:SetAutoResize()
	staminaAlert:SetText( alertText )
	staminaPercent = unsealCacheData:getMp() / unsealCacheData:getMaxMp() * 100
	repair_AutoNavi:SetShow( true )
	repair_Navi:SetShow( true )
	-- repair_AutoNavi:SetPosX(staminaAlert:GetSizeX() - (staminaAlert:GetPosX() /7) )
	-- repair_Navi:SetPosX(repair_AutoNavi:GetPosX()+20)

	if ( CppEnums.VehicleType.Type_Carriage ~= unsealCacheData:getVehicleType() ) or ( unsealCacheData:getVehicleType() ~= CppEnums.VehicleType.Type_CowCarriage ) or ( unsealCacheData:getVehicleType() ~= CppEnums.VehicleType.Type_Boat ) or ( unsealCacheData:getVehicleType() ~= CppEnums.VehicleType.Type_Raft ) then
		if 30 > staminaPercent then			-- 30% 미만이 되면 경고문을 띄워준다!!
			staminaAlert:SetShow( true )
			repair_AutoNavi:SetShow( true )
			repair_Navi:SetShow( true )
		else
			staminaAlert:SetShow( false )
			repair_AutoNavi:SetShow( false )
			repair_Navi:SetShow( false )
		end
	-- elseif ( CppEnums.VehicleType.Type_Carriage == unsealCacheData:getVehicleType() ) or ( unsealCacheData:getVehicleType() == CppEnums.VehicleType.Type_CowCarriage ) or ( unsealCacheData:getVehicleType() == CppEnums.VehicleType.Type_Boat ) or ( unsealCacheData:getVehicleType() == CppEnums.VehicleType.Type_Raft ) then
	-- 	if 0 == staminaPercent then -- 생명력이 없는 탑승물이면서 MP가 0일 때 경고문을 띄워준다.
	-- 		staminaAlert:SetShow( true )
	-- 		repair_AutoNavi:SetShow( false )
	-- 		repair_Navi:SetShow( false )
	-- 	end
	end
end

servantMpBar._staticBar			:addInputEvent( "Mouse_On",			"HandleOn_HorseMp_Bar()" )
servantMpBar._staticBar			:addInputEvent( "Mouse_Out",		"HandleOut_HorseMp_Bar()" )

function HandleOn_HorseMp_Bar()
	-- _PA_LOG("LUA","HandleOn_HorseMp_Bar")
	servantMpBar._staticText:SetShow(true)
end

function HandleOut_HorseMp_Bar()
-- _PA_LOG("LUA","HandleOut_HorseMp_Bar")
	servantMpBar._staticText:SetShow(false)
end

--[[
local 	_timer = 0							-- 스태미너 부족 시 20초에 한 번씩 띄워주기 위한 변수
local	_minimumStamina = 7					-- 스태미너 최소치
local	_alertStaminaPercent = 0.2			-- 스태미너 경고 표시 수치

function PerFrame_Stamina_Alert( deltaTime )
	if not Panel_HorseMp:IsShow() then
		return
	end
	
	_timer = _timer + deltaTime
	if ( 30 < _timer ) then
		_timer = 0
	else
		return
	end
	
	local self			= servantMpBar
	local temporaryWrapper= getTemporaryInformationWrapper()
	local	unsealCacheData	= temporaryWrapper:getUnsealVehicleByActorKeyRaw( self._actorKeyRaw )
	if	(nil == unsealCacheData)	then
		return
	end
	
	local horseStamina = unsealCacheData:getMp();
	local staminaPercent = horseStamina / unsealCacheData:getMaxMp()

	if horseStamina <= _minimumStamina then				-- 스태미너가 0일 때,
		local strDesc = "탈것의 스태미너가 바닥나 빠르게 움직일 수 없습니다. 스태미너를 회복시켜 주세요."
		Proc_ShowMessage_Ack(strDesc)
	elseif staminaPercent < _alertStaminaPercent then						-- 스태미너가 20% 미만일 때,
		local strDesc = "탈것의 스태미너가 얼마 남지 않았습니다. 스태미너를 회복시켜 주세요."
		Proc_ShowMessage_Ack(strDesc)
	end
end
--]]

function	HorseMP_OpenByInteraction()
	local	self		= servantMpBar
	local	selfPlayer		= getSelfPlayer()
	local	selfProxy		= selfPlayer:get()
	local	actorKeyRaw		= selfProxy:getRideVehicleActorKeyRaw()
	local	temporaryWrapper= getTemporaryInformationWrapper()
	local	servantInfo		= temporaryWrapper:getUnsealVehicleByActorKeyRaw( actorKeyRaw )
	if	( nil == servantInfo )	then
		return
	end
		
	self._actorKeyRaw	= actorKeyRaw
		
	HorseMP_Open()
	
	-- 말 탈 때 말 아이콘 이펙트 꺼줌
	FGlobal_ServantIcon_IsNearMonster_Effect( false )
end

function	HorseMP_Open()
	if	( Panel_HorseMp:GetShow() )	then
		return
	end
	-- FGlobal_ServantEnduaranceInfo_PerFrameUpdate()
	HorseMP_Update()
	Panel_HorseMp:SetShow( true )
end

function	HorseMP_Close()
	if	( not Panel_HorseMp:GetShow() )	then
		return
	end
	
	Panel_HorseMp:SetShow( false )
end

function HandleClick_Horse_Repair_Navi( isAuto )
	local player	= getSelfPlayer()
	if nil == player then
		return
	end

 	-- 네비 세팅
	ToClient_DeleteNaviGuideByGroup(0);
	
	if(	ToClient_IsShowNaviGuideGroup(0) ) then
		if true == isAuto and true == repair_AutoNavi:IsCheck() then
			repair_Navi		:SetCheck(true)
			repair_AutoNavi	:SetCheck(true)
		else
			repair_Navi		:SetCheck(false)
			repair_AutoNavi	:SetCheck(false)
			audioPostEvent_SystemUi(00,15)
			return
		end
	else
		if true == isAuto then
			repair_Navi		:SetCheck(true)
			repair_AutoNavi	:SetCheck(true)
		else
		    repair_Navi		:SetCheck(true)
			repair_AutoNavi	:SetCheck(false)
		end
	end

	local position		= player:get3DPos() -- 기준이 되는 위치
	local spawnType 	= CppEnums.SpawnType.eSpawnType_Stable -- 마굿간 NPC
	
	local nearNpcInfo 	= getNearNpcInfoByType( spawnType, position )
	if nil ~=  nearNpcInfo then
		local pos = nearNpcInfo:getPosition()
		local repairNaviKey = ToClient_WorldMapNaviStart( pos, NavigationGuideParam(), isAuto, true )
		audioPostEvent_SystemUi(00,14)
		
		local selfPlayer = getSelfPlayer():get()
		selfPlayer:setNavigationMovePath(repairNaviKey)
		selfPlayer:checkNaviPathUI(repairNaviKey)
	end
end

--[[
function FromClient_HorseMpAlert()
	if not Panel_HorseMp:IsShow() then
		return
	end

	local self				= servantMpBar
	local temporaryWrapper	= getTemporaryInformationWrapper()
	local	unsealCacheData	= temporaryWrapper:getUnsealVehicleByActorKeyRaw( self._actorKeyRaw )
	if	(nil == unsealCacheData)	then
		return
	end
	
	local horseStamina = unsealCacheData:getMp();
	local staminaPercent = horseStamina / unsealCacheData:getMaxMp()
	
	if horseStamina <= _minimumStamina then				-- 스태미너가 0일 때,
		local strDesc = "탈것의 스태미너가 바닥나 빠르게 움직일 수 없습니다. 스태미너를 회복시켜 주세요."
		Proc_ShowMessage_Ack(strDesc)
	end
end--]]

registerEvent("EventSelfServantUpdate",			"HorseMP_Update")
registerEvent("EventSelfPlayerRideOff",			"HorseMP_Close")
registerEvent("EventSelfPlayerRideOn",			"HorseMP_OpenByInteraction")
HorseMP_init()
--registerEvent("FromClient_RideVehicleMpUpdate",	"FromClient_HorseMpAlert")
--panel:RegisterUpdateFunc("PerFrame_Stamina_Alert")