Panel_manageWorker:setMaskingChild(true)
Panel_manageWorker:setGlassBackground(true)
Panel_manageWorker:ActiveMouseEventEffect( true )

local UI_TYPE 	= CppEnums.PA_UI_CONTROL_TYPE
local UI_TM 	= CppEnums.TextMode
local UI_PP 	= CppEnums.PAUIMB_PRIORITY

local plantKey = nil

local Control_WorkerList = {}
local Control_RestoreItem = {}
local Worker_Table = {}
local RestoreItem_Table = {}
local WorkerTooltip_Index = nil
local ItemTooltip_Index = nil

eWorkerStateType = 
{
	waiting				= 0,
	working				= 1,
	transfer			= 2,
}
local defaul_Control =
{	
	_Title					= UI.getChildControl(Panel_manageWorker, "titlebar_manageWorker"),
		
	_List_BG 				= UI.getChildControl(Panel_manageWorker, "Static_WorkerList_BG"),
	_List_Scroll 			= UI.getChildControl(Panel_manageWorker, "WorkerList_ScrollBar"),
		
	_worker_BG	 			= UI.getChildControl(Panel_manageWorker, "Static_workerBG"),
	_worker_CheckBox		= UI.getChildControl(Panel_manageWorker, "button_workerList_checkBox"),
	_worker_Name			= UI.getChildControl(Panel_manageWorker, "workerManage_workerName"),
	_worker_State			= UI.getChildControl(Panel_manageWorker, "Button_workerState"),
	_worker_Redo			= UI.getChildControl(Panel_manageWorker, "Button_React"),
	_worker_RestorePoint	= UI.getChildControl(Panel_manageWorker, "Progress2_RestorePoint"),
	_worker_CurrentPoint	= UI.getChildControl(Panel_manageWorker, "Progress2_CurrentPoint"),
	_List_Empty				= UI.getChildControl(Panel_manageWorker, "StaticText_EmptySlot"),
		
	_buttonQuestion 		= UI.getChildControl( Panel_manageWorker, "Button_Question"),
	_closeButton 			= UI.getChildControl( Panel_manageWorker, "Button_Close"),
		
	_Item_BG	 			= UI.getChildControl( Panel_manageWorker, "Static_Restore_Item_BG"),
	_Item_Slider 			= UI.getChildControl( Panel_manageWorker, "Slider_Restore_Item"),
	_Item_SliderBG 			= UI.getChildControl( Panel_manageWorker, "Static_Item_SliderBG"),
	_Btn_CloseItem 			= UI.getChildControl( Panel_manageWorker, "Button_Close_Item"),
	_Item_IconBG 			= UI.getChildControl( Panel_manageWorker, "Static_Restore_Item_Icone_BG"),
	_Item_Icone 			= UI.getChildControl( Panel_manageWorker, "Static_Restore_Item_Icone"),
	_Item_Count 			= UI.getChildControl( Panel_manageWorker, "StaticText_Item_Count"),
	_Item_RestoreValue		= UI.getChildControl( Panel_manageWorker, "StaticText_Item_Restore_Value"),
	
	_Guide_Restore			= UI.getChildControl( Panel_manageWorker, "StaticText_Guide_Restore"),
		


	_Slot_MaxCount			= 5,
	_Slot_MinCount			= 3,
	_Slot_GapY				= 45,
	_Scroll_GapX			= 7,
		
	_Item_MaxCount			= 5,
	_Item_GapX				= 49,
}

local btnControl =
{
	_Fire 		= UI.getChildControl( Panel_manageWorker, "button_doWorkerFire"),
}


local scroll_Param =
{
	_offsetIndex 	= 0,
	_offsetMax 		= 0,	
	_slotMax 		= 0,	
	_contentCount	= 0,	
}

local slider_Param =
{
	_offsetIndex 	= 0,
	_offsetMax 		= 0,	
	_slotMax 		= 0,	
	_contentCount	= 0,	
}
local default_Size_Pos =
{
	_Panel_SizeX 	= 0,
	_Panel_SizeY 	= 0,
	_Title_SizeX 	= 0,
	_List_BG_SpanX 	= 0,
	_List_BG_SpanY 	= 0,
	_List_BG_SizeY 	= 0,
	
	_Item_BG_SpanX = 0,
	_Item_BG_SpanY = 0,
}

function default_Size_Pos:Init()
	self._Panel_SizeX 	= Panel_manageWorker:GetSizeX()
	self._Panel_SizeY 	= Panel_manageWorker:GetSizeY()
	self._Title_SizeX 	= defaul_Control._Title:GetSizeX()
	self._List_BG_SpanX = defaul_Control._List_BG:GetSpanSize().x
	self._List_BG_SpanY = defaul_Control._List_BG:GetSpanSize().y
	self._List_BG_SizeY = defaul_Control._List_BG:GetSizeY()
	self._Item_BG_SpanX = defaul_Control._Item_BG:GetSpanSize().x
	self._Item_BG_SpanY	= defaul_Control._Item_BG:GetSpanSize().y
	
	defaul_Control._scroll_Button 		= UI.getChildControl(defaul_Control._List_Scroll,	 "Frame_ScrollBar_thumb")
end

default_Size_Pos:Init()

function defaul_Control:hide()
	self._worker_BG	 			:SetShow(false)
	self._worker_CheckBox		:SetShow(false)
	self._worker_Name			:SetShow(false)
	self._worker_State			:SetShow(false)
	self._worker_Redo			:SetShow(false)
	self._worker_RestorePoint	:SetShow(false)
	self._worker_CurrentPoint	:SetShow(false)
	self._List_Empty			:SetShow(false)
	
	self._Item_BG	 			:SetShow(false)
	self._Item_SliderBG 		:SetShow(false)
	self._Btn_CloseItem 		:SetShow(false)
	self._Item_IconBG 	    	:SetShow(false)
	self._Item_Icone 	    	:SetShow(false)
	self._Item_Count 	    	:SetShow(false)
	self._Item_RestoreValue 	:SetShow(false)
end

function WorldMapWindow_WaitWorkerFire()
	local _checked_Worker = {}
	for workerIndex, value in pairs(Worker_Table) do
		if true == value._isChecked then
			local index = #_checked_Worker + 1
			_checked_Worker[index] = value._WorkerNo
		end
	end
	for key, value in pairs (_checked_Worker) do
		local workerNo = value
		ToClient_requestDeleteMyWorker(workerNo);
	end
end

function HandleClick_WorkerCheckBox(workerIndex, idx)
	if Control_WorkerList._worker_CheckBox[idx]:IsCheck() and nil ~= Worker_Table[workerIndex] then
		Worker_Table[workerIndex]._isChecked = true
	elseif false == Control_WorkerList._worker_CheckBox[idx]:IsCheck() and nil ~= Worker_Table[workerIndex] then
		Worker_Table[workerIndex]._isChecked = false
	end
end

function Control_WorkerList:Init()

	defaul_Control._List_BG			:addInputEvent ( "Mouse_UpScroll",		"Control_Scroll(true, false)" )
	defaul_Control._List_BG			:addInputEvent ( "Mouse_DownScroll",	"Control_Scroll(false, false)" )
	defaul_Control._List_Scroll		:addInputEvent ( "Mouse_UpScroll",		"Control_Scroll(true, false)" )
	defaul_Control._List_Scroll		:addInputEvent ( "Mouse_DownScroll",	"Control_Scroll(false, false)" )	
	defaul_Control._List_Scroll		:addInputEvent ( "Mouse_LDown",			"Control_ScrollOnClick(false)" )
	defaul_Control._List_Scroll		:addInputEvent ( "Mouse_LUp",			"Control_ScrollOnClick(false)" )


	defaul_Control._scroll_Button	:addInputEvent ( "Mouse_LPress",		"Control_ScrollOnClick(false)" )
	
	defaul_Control._closeButton		:addInputEvent( "Mouse_LUp", 	"WorldMapWindow_CloseWaitWorkerManage()" )
	defaul_Control._buttonQuestion	:addInputEvent( "Mouse_LUp", 	"Panel_WebHelper_ShowToggle( \"Worker\" )" )
	defaul_Control._buttonQuestion	:addInputEvent( "Mouse_On", 	"HelpMessageQuestion_Show( \"Worker\", \"true\")" )
	defaul_Control._buttonQuestion	:addInputEvent( "Mouse_Out", 	"HelpMessageQuestion_Show( \"Worker\", \"false\")" )
		
	btnControl._Fire				:addInputEvent("Mouse_LUp",	"WorldMapWindow_WaitWorkerFire()")
	
	self._worker_BG 			= {}
	self._worker_CheckBox 		= {}
	self._worker_Name 			= {}
	self._worker_State 			= {}
	self._worker_Redo			= {}
	self._List_Empty 			= {}
	self._worker_RestorePoint	= {}
	self._worker_CurrentPoint	= {}



	
	for idx = 0, defaul_Control._Slot_MaxCount -1 do
		self._worker_BG[idx] 			= UI.createControl(UI_TYPE.PA_UI_CONTROL_STATIC,		defaul_Control._List_BG, "Worker_BG_".. tostring(idx))
		self._worker_RestorePoint[idx] 	= UI.createControl(UI_TYPE.PA_UI_CONTROL_PROGRESS2,		defaul_Control._List_BG, "Worker_RestorePoint_".. tostring(idx))
		self._worker_CurrentPoint[idx] 	= UI.createControl(UI_TYPE.PA_UI_CONTROL_PROGRESS2,		defaul_Control._List_BG, "Worker_CurrentPoint_".. tostring(idx))
		self._worker_CheckBox[idx] 		= UI.createControl(UI_TYPE.PA_UI_CONTROL_CHECKBUTTON,	defaul_Control._List_BG, "Worker_CheckBox_".. tostring(idx))
		self._worker_Name[idx] 			= UI.createControl(UI_TYPE.PA_UI_CONTROL_STATICTEXT,	defaul_Control._List_BG, "Worker_Name_".. tostring(idx))
		self._worker_State[idx] 		= UI.createControl(UI_TYPE.PA_UI_CONTROL_BUTTON,		defaul_Control._List_BG, "Worker_State_".. tostring(idx))
		self._worker_Redo[idx] 			= UI.createControl(UI_TYPE.PA_UI_CONTROL_BUTTON,		defaul_Control._List_BG, "Worker_ReDo_".. tostring(idx))
		self._List_Empty[idx] 			= UI.createControl(UI_TYPE.PA_UI_CONTROL_STATICTEXT,	defaul_Control._List_BG, "Worker_Empty_".. tostring(idx))
		
		CopyBaseProperty( defaul_Control._worker_BG	 			, self._worker_BG[idx])
		CopyBaseProperty( defaul_Control._worker_CheckBox		, self._worker_CheckBox[idx])
		CopyBaseProperty( defaul_Control._worker_Name			, self._worker_Name[idx])
		CopyBaseProperty( defaul_Control._worker_State			, self._worker_State[idx])
		CopyBaseProperty( defaul_Control._worker_Redo			, self._worker_Redo[idx])
		CopyBaseProperty( defaul_Control._worker_RestorePoint	, self._worker_RestorePoint[idx])
		CopyBaseProperty( defaul_Control._worker_CurrentPoint	, self._worker_CurrentPoint[idx])
		CopyBaseProperty( defaul_Control._List_Empty			, self._List_Empty[idx])
		
		self._worker_BG[idx] 			:SetSpanSize(self._worker_BG[idx] 			:GetSpanSize().x - default_Size_Pos._List_BG_SpanX, self._worker_BG[idx] 			:GetSpanSize().y - default_Size_Pos._List_BG_SpanY + defaul_Control._Slot_GapY*idx)
		self._worker_CheckBox[idx] 		:SetSpanSize(self._worker_CheckBox[idx] 	:GetSpanSize().x - default_Size_Pos._List_BG_SpanX, self._worker_CheckBox[idx]		:GetSpanSize().y - default_Size_Pos._List_BG_SpanY + defaul_Control._Slot_GapY*idx)
		self._worker_Name[idx] 			:SetSpanSize(self._worker_Name[idx] 		:GetSpanSize().x - default_Size_Pos._List_BG_SpanX, self._worker_Name[idx] 			:GetSpanSize().y - default_Size_Pos._List_BG_SpanY + defaul_Control._Slot_GapY*idx)
		self._worker_State[idx] 		:SetSpanSize(self._worker_State[idx] 		:GetSpanSize().x - default_Size_Pos._List_BG_SpanX, self._worker_State[idx] 		:GetSpanSize().y - default_Size_Pos._List_BG_SpanY + defaul_Control._Slot_GapY*idx)
		self._worker_Redo[idx]	 		:SetSpanSize(self._worker_Redo[idx] 		:GetSpanSize().x - default_Size_Pos._List_BG_SpanX, self._worker_Redo[idx] 			:GetSpanSize().y - default_Size_Pos._List_BG_SpanY + defaul_Control._Slot_GapY*idx)
		self._worker_RestorePoint[idx] 	:SetSpanSize(self._worker_RestorePoint[idx] :GetSpanSize().x - default_Size_Pos._List_BG_SpanX, self._worker_RestorePoint[idx] 	:GetSpanSize().y - default_Size_Pos._List_BG_SpanY + defaul_Control._Slot_GapY*idx +5)
		self._worker_CurrentPoint[idx] 	:SetSpanSize(self._worker_CurrentPoint[idx] :GetSpanSize().x - default_Size_Pos._List_BG_SpanX, self._worker_CurrentPoint[idx] 	:GetSpanSize().y - default_Size_Pos._List_BG_SpanY + defaul_Control._Slot_GapY*idx +5)
		self._List_Empty[idx] 			:SetSpanSize(self._List_Empty[idx] 			:GetSpanSize().x - default_Size_Pos._List_BG_SpanX, self._List_Empty[idx] 			:GetSpanSize().y - default_Size_Pos._List_BG_SpanY + defaul_Control._Slot_GapY*idx)				
		
		self._worker_BG[idx] 		:addInputEvent ( "Mouse_UpScroll", 		"Control_Scroll(true, false)" )
		self._worker_BG[idx] 		:addInputEvent ( "Mouse_DownScroll",	"Control_Scroll(false, false)" )
		self._worker_State[idx] 	:addInputEvent ( "Mouse_UpScroll", 		"Control_Scroll(true, false)" )
		self._worker_State[idx] 	:addInputEvent ( "Mouse_DownScroll",	"Control_Scroll(false, false)" )
		self._worker_Redo[idx]		:addInputEvent ( "Mouse_UpScroll", 		"Control_Scroll(true, false)" )
		self._worker_Redo[idx]		:addInputEvent ( "Mouse_DownScroll", 	"Control_Scroll(false, false)" )
		self._List_Empty[idx] 		:addInputEvent ( "Mouse_UpScroll",		"Control_Scroll(true, false)" )
		self._List_Empty[idx] 		:addInputEvent ( "Mouse_DownScroll",	"Control_Scroll(false, false)" )
		self._List_Empty[idx] 		:addInputEvent ( "Mouse_Out",			"HandleOut_WorkerTooltip(" .. idx .. ", false)" )
	end
	
	defaul_Control._Guide_Restore		:SetShow(false);
	defaul_Control._Guide_Restore		:SetTextMode( UI_TM.eTextMode_AutoWrap )
	defaul_Control._Guide_Restore		:SetText(PAGetString( Defines.StringSheet_GAME, "LUA_WORLD_MAP_TOWN_WORKER_RESTOREGUIDE" ))

end

Control_WorkerList:Init()

function Control_RestoreItem:Init()
	self._Item_BG 				= UI.createControl(UI_TYPE.PA_UI_CONTROL_STATIC,		defaul_Control._List_BG, "Item_SliderBG")
	CopyBaseProperty( defaul_Control._Item_BG	 		, self._Item_BG)
	self._Item_BG				:SetSpanSize(self._Item_BG:GetSpanSize().x - default_Size_Pos._List_BG_SpanX, self._Item_BG	:GetSpanSize().y - default_Size_Pos._List_BG_SpanY)
	self._Item_BG				:addInputEvent("Mouse_UpScroll", 	"Control_Scroll(true, true)" )
	self._Item_BG				:addInputEvent("Mouse_DownScroll", 	"Control_Scroll(false, true)" )
	self._Item_BG				:AddChild(defaul_Control._Item_Slider)
	Panel_manageWorker			:RemoveControl( defaul_Control._Item_Slider )
	
	self._Item_Slider	 		= defaul_Control._Item_Slider
	self._Btn_CloseItem 		= UI.createControl(UI_TYPE.PA_UI_CONTROL_BUTTON,		self._Item_BG, 		"Btn_CloseItem")
	self._Item_SliderBG 		= UI.createControl(UI_TYPE.PA_UI_CONTROL_STATIC,		self._Item_BG, 		"Item_SliderBG")
	
	CopyBaseProperty( defaul_Control._Btn_CloseItem	 		, self._Btn_CloseItem)
	CopyBaseProperty( defaul_Control._Item_SliderBG	 		, self._Item_SliderBG)
	
	self._Item_Slider	:SetSpanSize(self._Item_Slider:GetSpanSize().x - default_Size_Pos._Item_BG_SpanX,	self._Item_Slider	:GetSpanSize().y - default_Size_Pos._Item_BG_SpanY)
	self._Item_SliderBG	:SetSpanSize(self._Item_SliderBG:GetSpanSize().x - default_Size_Pos._Item_BG_SpanX, self._Item_SliderBG	:GetSpanSize().y - default_Size_Pos._Item_BG_SpanY)
	self._Btn_CloseItem	:SetSpanSize(self._Btn_CloseItem:GetSpanSize().x - default_Size_Pos._Item_BG_SpanX, self._Btn_CloseItem	:GetSpanSize().y - default_Size_Pos._Item_BG_SpanY)
	self._Btn_CloseItem	:addInputEvent("Mouse_LUp",	"Control_RestoreItem_Reset()")
	
	self._Item_Slider_Button = UI.getChildControl(self._Item_Slider,	 "Slider_Restore_Item_Button")
	
	self._Item_Slider 			:addInputEvent("Mouse_UpScroll", 	"Control_Scroll(true, true)" )
	self._Item_Slider			:addInputEvent("Mouse_DownScroll", 	"Control_Scroll(false, true)" )
	self._Item_Slider_Button	:addInputEvent("Mouse_UpScroll", 	"Control_Scroll(true, true)" )
	self._Item_Slider_Button	:addInputEvent("Mouse_DownScroll", 	"Control_Scroll(false, true)" )
	self._Item_Slider			:addInputEvent("Mouse_LDown",		"Control_ScrollOnClick(true)" )
	self._Item_Slider			:addInputEvent("Mouse_LUp",			"Control_ScrollOnClick(true)" )
	self._Item_Slider_Button	:addInputEvent("Mouse_LPress",		"Control_ScrollOnClick(true)" )

	self._Item_IconBG ={}
	self._Item_Icone ={}
	self._Item_Count ={}
	self._Item_RestoreValue ={}
	
	for idx = 0, defaul_Control._Item_MaxCount -1 do
		self._Item_IconBG[idx] 			= UI.createControl(UI_TYPE.PA_UI_CONTROL_STATIC,		self._Item_BG, "Item_Icon_BG_".. tostring(idx))
		self._Item_Icone[idx] 			= UI.createControl(UI_TYPE.PA_UI_CONTROL_STATIC,		self._Item_BG, "Item_Icon_".. tostring(idx))
		self._Item_Count[idx] 			= UI.createControl(UI_TYPE.PA_UI_CONTROL_STATICTEXT,	self._Item_BG, "Item_Count_".. tostring(idx))
		self._Item_RestoreValue[idx]	= UI.createControl(UI_TYPE.PA_UI_CONTROL_STATICTEXT,	self._Item_BG, "Item_RestoreValue_".. tostring(idx))
		
		CopyBaseProperty( defaul_Control._Item_IconBG	 		, self._Item_IconBG[idx])
		CopyBaseProperty( defaul_Control._Item_Icone	 		, self._Item_Icone[idx])
		CopyBaseProperty( defaul_Control._Item_Count	 		, self._Item_Count[idx])
		CopyBaseProperty( defaul_Control._Item_RestoreValue	 	, self._Item_RestoreValue[idx])
		
		self._Item_IconBG[idx]		 :SetSpanSize(self._Item_IconBG[idx]	   :GetSpanSize().x - default_Size_Pos._Item_BG_SpanX + defaul_Control._Item_GapX * idx, 	self._Item_IconBG[idx]		:GetSpanSize().y - default_Size_Pos._Item_BG_SpanY)
		self._Item_Icone[idx] 		 :SetSpanSize(self._Item_Icone[idx]		   :GetSpanSize().x - default_Size_Pos._Item_BG_SpanX + defaul_Control._Item_GapX * idx, 	self._Item_Icone[idx]		:GetSpanSize().y - default_Size_Pos._Item_BG_SpanY)
		self._Item_Count[idx] 		 :SetSpanSize(self._Item_Count[idx]		   :GetSpanSize().x - default_Size_Pos._Item_BG_SpanX + defaul_Control._Item_GapX * idx, 	self._Item_Count[idx]		:GetSpanSize().y - default_Size_Pos._Item_BG_SpanY)
		self._Item_RestoreValue[idx] :SetSpanSize(self._Item_RestoreValue[idx] :GetSpanSize().x - default_Size_Pos._Item_BG_SpanX + defaul_Control._Item_GapX * idx, 	self._Item_RestoreValue[idx]:GetSpanSize().y - default_Size_Pos._Item_BG_SpanY)
		
		self._Item_Icone[idx] 				:addInputEvent("Mouse_RUp",			"HandleClick_RestoreItem(" .. idx .. ")" )
		self._Item_Icone[idx] 				:addInputEvent("Mouse_On", 			"HandleOn_RestoreItemTooltip(" .. idx .. ")" )
		self._Item_Icone[idx] 				:addInputEvent("Mouse_Out", 		"HandleOut_RestoreItemTooltip(" .. idx .. ")" )
		self._Item_Icone[idx] 				:addInputEvent("Mouse_UpScroll", 	"Control_Scroll(true, true)" )
		self._Item_Icone[idx] 				:addInputEvent("Mouse_DownScroll", 	"Control_Scroll(false, true)" )
	end	
	
	self._saveIndex = nil
	self._Item_BG:SetShow(false)
end
Control_RestoreItem:Init()
defaul_Control:hide()

function Control_WorkerList:SetControl(waitWorkerCount, maxWorkerCount)	
	defaul_Control._Title:SetText( PAGetString( Defines.StringSheet_GAME, "LUA_WORLD_MAP_TOWN_WORKER_MANAGE" )..' (' .. waitWorkerCount .. '/' .. maxWorkerCount .. ')')
	scroll_Param._contentCount 	= maxWorkerCount
	scroll_Param._offsetMax		= maxWorkerCount - defaul_Control._Slot_MaxCount
	if scroll_Param._offsetMax < 0 then
		scroll_Param._offsetMax = 0
		scroll_Param._slotMax 	= maxWorkerCount
	else
		scroll_Param._slotMax 	= defaul_Control._Slot_MaxCount
	end
	
	local list_SizeY_Add = 0
	local panel_SizeX_Add = 0
	if ( maxWorkerCount > defaul_Control._Slot_MaxCount ) then
		list_SizeY_Add 	= defaul_Control._Slot_GapY * ( defaul_Control._Slot_MaxCount - defaul_Control._Slot_MinCount ) + 15
		panel_SizeX_Add = defaul_Control._Scroll_GapX
	elseif ( maxWorkerCount == defaul_Control._Slot_MaxCount ) then
		list_SizeY_Add 	= defaul_Control._Slot_GapY * ( defaul_Control._Slot_MaxCount - defaul_Control._Slot_MinCount ) + 15
	elseif ( maxWorkerCount < defaul_Control._Slot_MaxCount ) and ( maxWorkerCount > defaul_Control._Slot_MinCount ) then
		list_SizeY_Add = defaul_Control._Slot_GapY * ( maxWorkerCount - defaul_Control._Slot_MinCount ) + 15
	end
	
	Panel_manageWorker			:SetSize(default_Size_Pos._Panel_SizeX + panel_SizeX_Add, 	default_Size_Pos._Panel_SizeY + list_SizeY_Add)
	defaul_Control._List_BG		:SetSize(defaul_Control._List_BG:GetSizeX(), 				default_Size_Pos._List_BG_SizeY + list_SizeY_Add)
	defaul_Control._Title		:SetSize(default_Size_Pos._Title_SizeX + panel_SizeX_Add, 	defaul_Control._Title:GetSizeY())
	defaul_Control._List_Scroll	:SetSize(defaul_Control._List_Scroll:GetSizeX(), 			defaul_Control._List_BG:GetSizeY())
	
	btnControl._Fire				:ComputePos()
	--btnControl._Recovery			:ComputePos()
	defaul_Control._buttonQuestion	:ComputePos()
	defaul_Control._closeButton 	:ComputePos()
	Panel_manageWorker				:ComputePos()
end

function Control_RestoreItem_Reset()
	Control_RestoreItem._Item_BG	:SetShow(false)
	Control_RestoreItem._Item_Slider:SetShow(false)
	defaul_Control._Guide_Restore	:SetShow(false)
	btnControl._Fire				:SetShow(true)
	
	if (scroll_Param._contentCount < scroll_Param._offsetIndex + scroll_Param._slotMax) then
		scroll_Param._offsetIndex = scroll_Param._contentCount - scroll_Param._slotMax;
	end
	Control_WorkerList:UpdateSlot (0, false)
	Control_RestoreItem._saveIndex = nil
end

function Control_RestoreItem:InsertControl(idx, isRefresh)
	if slider_Param._contentCount == 0 then
		if self._Item_BG:GetShow() then
			Control_RestoreItem_Reset()
			Control_WorkerList._worker_State[idx]		:SetText("<PAColor0xffc4bebe>" .. PAGetString( Defines.StringSheet_GAME, "LUA_WORLD_MAP_TOWN_WORKER_WAIT" ).."<PAOldColor>")
			return
		else
			Proc_ShowMessage_Ack( PAGetString(Defines.StringSheet_GAME, "LUA_WORLD_MAP_TOWN_WORKER_NOITEM") )
			return
		end
	end
	if self._Item_BG:GetShow() and true ~= isRefresh then
		if idx == self._saveIndex then
			Control_RestoreItem_Reset()
			Control_WorkerList._worker_State[idx]		:SetText("<PAColor0xfffeff99>" .. PAGetString( Defines.StringSheet_GAME, "LUA_WORLD_MAP_TOWN_WORKER_RESTORE" ).."<PAOldColor>")
			return
		elseif idx > self._saveIndex then
			idx = idx - 2
		end
		Control_RestoreItem_Reset()
	elseif true == isRefresh then
		Control_WorkerList:UpdateSlot (0, false)
	end
	
	--if (scroll_Param._slotMax >= defaul_Control._Slot_MinCount) then
		if ( idx + 2 ) > ( scroll_Param._slotMax - 1 ) then
			local newPosition = math.max(defaul_Control._Slot_MinCount, scroll_Param._slotMax) - 3
			local adjust = idx - newPosition
			scroll_Param._offsetIndex = scroll_Param._offsetIndex + adjust;
			idx = newPosition
			Control_WorkerList:UpdateSlot (idx + 1, true)
		elseif ( idx + 2 ) < ( scroll_Param._slotMax - 1 ) then
			Control_WorkerList:UpdateSlot (idx + 1, true)
		else
			Control_WorkerList:clear(idx + 1)
		end
	--else
	--	-- 대호씨 여기 코드가 이상해요. 리스트 슬롯 갯수가 3개 이하일때 -_-;; 일단 루아가 멈추지는 않는 정도까지만 해놨습니다..
	--	Control_WorkerList:UpdateSlot (idx + 1, true)
	--end
	
	Control_WorkerList._worker_State[idx]		:SetText("<PAColor0xfffeff99>" .. PAGetString( Defines.StringSheet_GAME, "LUA_WORLD_MAP_TOWN_WORKER_RESTORE" ).."<PAOldColor>")
	Control_RestoreItem.Index = idx
	self._saveIndex = idx
	self._Item_BG:SetSpanSize(self._Item_BG:GetSpanSize().x, Control_WorkerList._worker_BG[idx + 1]:GetSpanSize().y + 5 )
	self._Item_BG:SetShow(true)
	defaul_Control._Guide_Restore	:SetShow(true)
	btnControl._Fire				:SetShow(false)
	defaul_Control._Guide_Restore	:ComputePos()
	
	self:UpdateItemList()
end
function Worker_Table_Set()	
	Worker_Table = {}
	
	local plant		= ToClient_getPlant(plantKey)
	
	if ( nil == plant ) or ( CppEnums.PlantType.ePlantType_Town ~= plant:getType() ) then
		return 
	end

	local waitWorkerCount = ToClient_getPlantWaitWorkerListCount(plantKey, 0)
	local maxWorkerCount = ToClient_getTownWorkerMaxCapacity(plantKey)
	
	for workerIndex = 0 , maxWorkerCount - 1  do
		Worker_Table[workerIndex] = {}
		if workerIndex < waitWorkerCount then
			Worker_Table[workerIndex]._isEmpty = false
			local workerData = ToClient_getPlantWaitWorkerByIndex( plantKey, workerIndex)
			local workerStaticStatus = workerData:getWorkerStaticStatus()

			Worker_Table[workerIndex]._WorkerNo = workerData:getWorkerNo()			
			Worker_Table[workerIndex]._Name = ToClient_getWorkerName(workerStaticStatus)
			Worker_Table[workerIndex]._MaxPoint = workerStaticStatus._actionPoint
			Worker_Table[workerIndex]._CurrentPoint = workerData:getActionPoint()
		
			if isWaitWorker(workerData) == true then
				Worker_Table[workerIndex]._State_Text = "<PAColor0xffc4bebe>" .. PAGetString( Defines.StringSheet_GAME, "LUA_WORLD_MAP_TOWN_WORKER_WAIT" ).."<PAOldColor>"
				Worker_Table[workerIndex]._State = eWorkerStateType.waiting -- 대기중
			else
				if  (workerData) == true then
					Worker_Table[workerIndex]._State_Text = "<PAColor0xffff8400>" .. PAGetString( Defines.StringSheet_GAME, "LUA_WORLD_MAP_TOWN_WORKER_TRANSFERING" ).."<PAOldColor>"
					Worker_Table[workerIndex]._State = eWorkerStateType.transfer -- 전출 중
				else
					Worker_Table[workerIndex]._State_Text = "<PAColor0xffde3900>" .. PAGetString( Defines.StringSheet_GAME, "LUA_WORLD_MAP_TOWN_WORKER_WORKING" ).."<PAOldColor>"
					Worker_Table[workerIndex]._State = eWorkerStateType.working -- 작업중
				end
			end
		else
			Worker_Table[workerIndex]._isEmpty = true
		end
	end
		
	Control_WorkerList:SetControl(waitWorkerCount, maxWorkerCount)
	Control_WorkerList:UpdateSlot (0, false)
end

function RestoreItem_Table_Set()
	local Cnt_RestoreItem = ToClient_getNpcRecoveryItemList()
	
	for idx = 0, Cnt_RestoreItem - 1 do
		RestoreItem_Table[idx] = {}
		local NpcRecoveryItem = ToClient_getNpcRecoveryItemByIndex(idx)
		
		RestoreItem_Table[idx]._slotNo = NpcRecoveryItem._slotNo
		RestoreItem_Table[idx]._itemKey = NpcRecoveryItem._itemEnchantKey
		RestoreItem_Table[idx]._itemCnt = NpcRecoveryItem._itemCount_s64
		RestoreItem_Table[idx]._restore = NpcRecoveryItem._contentsEventParam1
		local itemStatic = NpcRecoveryItem:getItemStaticStatus()
		RestoreItem_Table[idx]._itemIcon	= "icon/" .. getItemIconPath( itemStatic )
	end

	slider_Param._offsetIndex	= 0
	slider_Param._contentCount 	= Cnt_RestoreItem
	slider_Param._offsetMax		= Cnt_RestoreItem - defaul_Control._Item_MaxCount
	if slider_Param._offsetMax < 0 then
		slider_Param._offsetMax = 0
		slider_Param._slotMax 	= Cnt_RestoreItem
	else
		slider_Param._slotMax 	= defaul_Control._Item_MaxCount
	end
end

local workedWorker = {}
local reCall_RedoWork = false

function Recall_RedoWork()
	return reCall_RedoWork
end

function FGlobal_RedoWork( _workType, _houseInfoSS, _selectedWorker, _plantKey, _workKey, _selectedSubwork, _workingCount, _itemNoRaw, _houseHoldNo, _homeWaypoint)
	local plantKey = ToClient_convertWaypointKeyToPlantKey(_homeWaypoint)
	local waitWorkerCount = ToClient_getPlantWaitWorkerListCount(plantKey, 0)
	local maxWorkerCount = ToClient_getTownWorkerMaxCapacity(plantKey)
	
	workedWorker[_selectedWorker:get_s64()] = {
		_workType			= _workType,
		_houseInfoSS		= _houseInfoSS,
		_selectedWorker		= _selectedWorker,
		_plantKey			= _plantKey,
		_workKey			= _workKey,
		_selectedSubwork	= _selectedSubwork,
		_workingCount		= _workingCount,
		_itemNoRaw			= _itemNoRaw,
		_houseHoldNo		= _houseHoldNo,
		_redoWork			= true
	}
	reCall_RedoWork = true	
	
end

function HandleClick_ReDoAllWork()
	local _homeWaypoint = plantKey:getWaypointKey()
	local waitWorkerCount = ToClient_getPlantWaitWorkerListCount(plantKey, 0)
	local maxWorkerCount = ToClient_getTownWorkerMaxCapacity(plantKey)
	
	for workerIndex = 0 , maxWorkerCount - 1  do
		if workerIndex < waitWorkerCount then
			local workerNo = Worker_Table[workerIndex]._WorkerNo:get_s64()

			local workedWorkerData = nil
			for key, value in pairs(workedWorker) do
				if ( key == workerNo ) then
					workedWorkerData = value
					break
				end
			end
			if nil ~= workedWorkerData then
				if 0 == workedWorkerData._workType then			-- 렌드 하우스 제작
					ToClient_requestStartRentHouseWorkingToNpcWorker( workedWorkerData._houseInfoSS, workedWorkerData._selectedWorker, workedWorkerData._workKey, workedWorkerData._workingCount, workedWorkerData._itemNoRaw )
						
				elseif 2 == workedWorkerData._workType then		-- 채집
					ToClient_requestStartPlantWorkingToNpcWorker( workedWorkerData._selectedWorker, workedWorkerData._plantKey, workedWorkerData._workKey, workedWorkerData._workingCount )
						
				elseif 4 == workedWorkerData._workType then		-- 파이낸스
					ToClient_requestStartPlantWorkingToNpcWorker( workedWorkerData._selectedWorker, workedWorkerData._plantKey, workedWorkerData._workKey, workedWorkerData._workingCount )
						
				elseif 1 == workedWorkerData._workType then		-- 대규모 제작
					ToClient_requestStartLargeCraftToNpcWorker( workedWorkerData._houseInfoSS, workedWorkerData._selectedWorker, workedWorkerData._workKey, workedWorkerData._selectedSubwork, 1 )
						
				elseif 3 == workedWorkerData._workType then		-- 성채/지휘소
					requestStartHouseholdBuildingToNpcWorker( workedWorkerData._selectedWorker, workedWorkerData._plantKey, workedWorkerData._houseHoldNo, workedWorkerData._selectedSubwork, workedWorkerData._workingCount )
						
				end
				Control_WorkerList:UpdateSlot (0, false)
			end
		end
	end
end

function HandleClick_ReDoWork( workerIndex )
	local workerNo = Worker_Table[workerIndex]._WorkerNo:get_s64()
	for key, workedWorkerData in pairs(workedWorker) do
		if ( key == workerNo ) then
			if 0 == workedWorkerData._workType then			-- 렌드 하우스 제작
				ToClient_requestStartRentHouseWorkingToNpcWorker( workedWorkerData._houseInfoSS, workedWorkerData._selectedWorker, workedWorkerData._workKey, workedWorkerData._workingCount, workedWorkerData._itemNoRaw )
						
			elseif 2 == workedWorkerData._workType then		-- 채집
				ToClient_requestStartPlantWorkingToNpcWorker( workedWorkerData._selectedWorker, workedWorkerData._plantKey, workedWorkerData._workKey, workedWorkerData._workingCount )
						
			elseif 4 == workedWorkerData._workType then		-- 파이낸스
				ToClient_requestStartPlantWorkingToNpcWorker( workedWorkerData._selectedWorker, workedWorkerData._plantKey, workedWorkerData._workKey, workedWorkerData._workingCount )
						
			elseif 1 == workedWorkerData._workType then		-- 대규모 제작
				ToClient_requestStartLargeCraftToNpcWorker( workedWorkerData._houseInfoSS, workedWorkerData._selectedWorker, workedWorkerData._workKey, workedWorkerData._selectedSubwork, 1 )
						
			elseif 3 == workedWorkerData._workType then		-- 성채/지휘소
				requestStartHouseholdBuildingToNpcWorker( workedWorkerData._selectedWorker, workedWorkerData._plantKey, workedWorkerData._houseHoldNo, workedWorkerData._selectedSubwork, workedWorkerData._workingCount )
			
			end
			return
		end
	end
end

function Control_RestoreItem:clear()
	for key, value in pairs (Control_RestoreItem._Item_IconBG) do
		value:SetShow(false)
	end
	for key, value in pairs (Control_RestoreItem._Item_Icone) do
		value:SetShow(false)
	end
	for key, value in pairs (Control_RestoreItem._Item_Count) do
		value:SetShow(false)
	end
	for key, value in pairs (Control_RestoreItem._Item_RestoreValue) do
		value:SetShow(false)
	end
end

function UISlider_SetButtonSize( scroll, configSlotCount, contentsCount)
	if	configSlotCount < contentsCount	then
		local	size		= configSlotCount / contentsCount
		scroll:GetControlButton():SetSize( scroll:GetSizeX() * size, scroll:GetControlButton():GetSizeY() )
		scroll:SetShow(true)		
	else
		scroll:SetShow(false)
	end
end

function Control_RestoreItem:UpdateItemList()

	self:clear()
 
	for idx = 0, slider_Param._slotMax - 1 do
		local itemIndex = slider_Param._offsetIndex + idx 
		self._Item_Icone[idx] 			:ChangeTextureInfoName(RestoreItem_Table[itemIndex]._itemIcon)
		self._Item_Count[idx] 			:SetText(tostring(RestoreItem_Table[itemIndex]._itemCnt))
		self._Item_RestoreValue[idx]    :SetText("+" .. tostring(RestoreItem_Table[itemIndex]._restore))
		self._Item_IconBG[idx] 			:SetShow(true)
		self._Item_Icone[idx] 			:SetShow(true)
		self._Item_Count[idx] 			:SetShow(true)
		self._Item_RestoreValue[idx]    :SetShow(true)
	end
	UISlider_SetButtonSize( self._Item_Slider, defaul_Control._Item_MaxCount, slider_Param._contentCount )
	
	if self._Item_Slider:GetShow() then
		self._Item_SliderBG:SetShow(false)
	else
		self._Item_SliderBG:SetShow(true)
	end
	
	local _offsetMax = slider_Param._offsetMax
	if _offsetMax == 0 then
		_offsetMax = 1
	end
	self._Item_Slider:SetControlPos( slider_Param._offsetIndex / _offsetMax * 100 )
end

function Control_WorkerList:clear(idx)
	for key, value in pairs (self._worker_BG) do
		if key >= idx then
			value:SetShow(false)
		end
	end
	for key, value in pairs (self._worker_CheckBox) do
		if key >= idx then
			value:SetShow(false)
			value:SetCheck(false)
		end
	end
	for key, value in pairs (self._worker_Name) do
		if key >= idx then
			value:SetShow(false)
		end
	end
	for key, value in pairs (self._worker_State) do
		if key >= idx then
			value:SetShow(false)
		end
	end
	for key, value in pairs (self._worker_Redo) do
		if key >= idx then
			value:SetShow(false)
		end
	end
	for key, value in pairs (self._List_Empty) do
		if key >= idx then
			value:SetShow(false)
		end
	end
	for key, value in pairs (self._worker_RestorePoint) do
		if key >= idx then
			value:SetShow(false)
		end
	end
	for key, value in pairs (self._worker_CurrentPoint) do
		if key >= idx then
			value:SetShow(false)
		end
	end
end

function Control_WorkerList:UpdateSlot (_Index, isAdjust)
	local adjust = 0
	local index = 0
	if isAdjust then
		adjust = 2
		--index = _Index
	end
	self:clear(0)
	
	local _blank_Count = 0
	local workerIndex = scroll_Param._offsetIndex
	for idx = index, scroll_Param._slotMax - 1 do
		if nil ~= Worker_Table[workerIndex] and ( true ~= isAdjust or idx < _Index or _Index + adjust <= idx ) then
			if false == Worker_Table[workerIndex]._isEmpty then
				local progressRate = ( Worker_Table[workerIndex]._CurrentPoint / Worker_Table[workerIndex]._MaxPoint ) * 100
							
				self._worker_BG[idx]			:SetShow(true)
				self._worker_CheckBox[idx]		:SetShow(true)
				self._worker_Name[idx]			:SetText(Worker_Table[workerIndex]._Name)
				self._worker_Name[idx]			:SetShow(true)
				self._worker_RestorePoint[idx]	:SetProgressRate(progressRate)
				self._worker_RestorePoint[idx]	:SetShow(true)
				self._worker_CurrentPoint[idx]	:SetProgressRate(progressRate)
				self._worker_CurrentPoint[idx]	:SetShow(true)
				self._worker_State[idx]			:SetText(Worker_Table[workerIndex]._State_Text)
				self._worker_State[idx]			:SetShow(true)
				self._worker_State[idx]			:addInputEvent("Mouse_LUp", "HandleLClick_WorkerState_Button(" .. workerIndex .. ", " .. idx .. ")")
				self._worker_State[idx]			:addInputEvent("Mouse_On", "HandleOn_WorkerState_Button(" .. workerIndex .. ", " .. idx .. ")")
				self._worker_State[idx]			:addInputEvent("Mouse_Out","HandleOut_WorkerState_Button(" .. workerIndex .. ", " .. idx .. ")")
				-- self._worker_BG[idx]			:addInputEvent("Mouse_LUp", "HandleLClick_WorkerState_Button(" .. workerIndex .. ", " .. idx .. ")")
				self._worker_BG[idx]			:addInputEvent("Mouse_On", "HandleOn_WorkerState_Button(" .. workerIndex .. ", " .. idx .. ")")
				self._worker_BG[idx]			:addInputEvent("Mouse_Out", "HandleOut_WorkerState_Button(" .. workerIndex .. ", " .. idx .. ")")
--				self._worker_CheckBox[idx]		:addInputEvent("Mouse_On", "HandleOn_WorkerState_Button(" .. workerIndex .. ", " .. idx .. ")")
--				self._worker_CheckBox[idx]		:addInputEvent("Mouse_Out", "HandleOut_WorkerState_Button(" .. workerIndex .. ", "  .. idx .. ")")
				self._worker_CheckBox[idx]		:addInputEvent("Mouse_LUp", "HandleClick_WorkerCheckBox(" .. workerIndex .. ", " .. idx .. ")")
				
				
				if Worker_Table[workerIndex]._State == eWorkerStateType.waiting then
					local workerData = ToClient_getPlantWaitWorkerByIndex( plantKey, workerIndex )
					local _homeWaypoint = plantKey:getWaypointKey()
					
					if ( nil ~= workerData ) then
						local workerNo = workerData:getWorkerNo():get_s64()

						for key, value in pairs( workedWorker ) do
							if ( workerNo == key ) then
								self._worker_Redo[idx]		:SetShow(true)
								self._worker_Redo[idx]		:addInputEvent("Mouse_LUp", "HandleClick_ReDoWork(" .. workerIndex .. ")")
								break
							end
						end
					end
				end
				
				local _workerData		= ToClient_getPlantWaitWorkerByIndex( plantKey, workerIndex )
				if ( nil ~= _workerData ) then
					local _workerNo			= _workerData:getWorkerNo():get_s64()
					local _leftWorkCount	= ToClient_getNpcWorkerWorkingCount(_workerNo)
					if ( 0 < _leftWorkCount ) then
						self._worker_Name[idx]:SetText(Worker_Table[workerIndex]._Name .. " (" .. _leftWorkCount .. "회 남음)")
					end
				end
				
				if true == Worker_Table[workerIndex]._isChecked then
					self._worker_CheckBox[idx]		:SetCheck(true)
				else
					self._worker_CheckBox[idx]		:SetCheck(false)
				end
			else
				self._worker_BG[idx]		:SetShow(true)
				self._List_Empty[idx]		:SetShow(true)
			end
			workerIndex = workerIndex + 1
		else
			self._worker_BG[idx]			:SetShow(false)			
			self._worker_CheckBox[idx]		:SetShow(false)
			self._worker_Name[idx]			:SetShow(false)			
			self._worker_RestorePoint[idx]	:SetShow(false)			
			self._worker_CurrentPoint[idx]	:SetShow(false)			
			self._worker_State[idx]			:SetShow(false)
			self._worker_Redo[idx]			:SetShow(false)
			_blank_Count = _blank_Count + 1
		end
	end
	
	UIScroll.SetButtonSize( defaul_Control._List_Scroll, scroll_Param._slotMax, scroll_Param._contentCount + _blank_Count )
	local _offsetMax = scroll_Param._offsetMax
	if _offsetMax == 0 then
		_offsetMax = 1
	end
	local _offsetIndex = scroll_Param._offsetIndex
	if _offsetIndex > _offsetMax then
		_offsetIndex = _offsetMax
	end
	
	defaul_Control._List_Scroll:SetControlPos( _offsetIndex / _offsetMax)
end

local workerIndex_CancelWork = nil
function WorkerManage_CancelWork(workerIndex)
	workerIndex_CancelWork = workerIndex
	local _workerNo = Worker_Table[workerIndex]._WorkerNo:get_s64()
	local esSSW = ToClient_getItemExchangeSourceStaticStatusWrapperByWorker(_workerNo)
	local workName 	= "성채"
	if nil ~= esSSW then
		workName 	= esSSW:getDescription()
	end
	
	local cancelWorkContent = PAGetStringParam1(Defines.StringSheet_GAME, "LUA_WORKINGPROGRESS_CANCELWORK_CONTENT", "workName", workName)
	local messageboxData = { title = PAGetString(Defines.StringSheet_GAME, "LUA_WORKINGPROGRESS_CANCELWORK_TITLE" ), content = cancelWorkContent , functionYes = WorkerManage_CancelWork_Continue, functionCancel = MessageBox_Empty_function, priority = UI_PP.PAUIMB_PRIORITY_LOW }
	MessageBox.showMessageBox(messageboxData, "top")
end

function WorkerManage_CancelWork_Continue()
	local _workerNo = Worker_Table[workerIndex_CancelWork]._WorkerNo
	local isSuccess = ToClient_requestStopPlantWorking(_workerNo)
	if ( false == isSuccess ) then
	    Proc_ShowMessage_Ack( PAGetString(Defines.StringSheet_GAME, "Lua_RentHouseNoWorkingByWorkerNotSelect") )
	end
end

function HandleLClick_WorkerState_Button(workerIndex, idx)
	if Worker_Table[workerIndex]._State == eWorkerStateType.waiting then
		RestoreItem_Table_Set()
		Control_RestoreItem:InsertControl(idx, false)		
		Control_RestoreItem.workerIndex = workerIndex
	elseif Worker_Table[workerIndex]._State == eWorkerStateType.working then
		WorkerManage_CancelWork(workerIndex)
	elseif Worker_Table[workerIndex]._State == eWorkerStateType.transfer then
		-- 일단 아무것도 안함
	end
	HandleOut_WorkerTooltip(idx, true)
end

function HandleOn_WorkerState_Button(workerIndex, idx)
	if false == Panel_Worker_Tooltip:GetShow() then
		HandleOn_WorkerTooltip(idx)
	end
	if Worker_Table[workerIndex]._State == eWorkerStateType.waiting then
		Control_WorkerList._worker_State[idx]		:SetText("<PAColor0xfffeff99>" .. PAGetString( Defines.StringSheet_GAME, "LUA_WORLD_MAP_TOWN_WORKER_RESTORE" ).."<PAOldColor>")
	elseif Worker_Table[workerIndex]._State == eWorkerStateType.working then
		Control_WorkerList._worker_State[idx]		:SetText("<PAColor0xffde3900>" .. PAGetString( Defines.StringSheet_GAME, "LUA_WORLD_MAP_TOWN_WORKER_CANCELWORK" ).."<PAOldColor>")
	elseif Worker_Table[workerIndex]._State == eWorkerStateType.transfer then
	end	
end

function HandleOut_WorkerState_Button(workerIndex, idx)
	if( true == UI.isInPositionForLua(Control_WorkerList._worker_BG[idx], getMousePosX(), getMousePosY() ) ) then
		return
	end

	if Panel_Worker_Tooltip:GetShow() then
		HandleOut_WorkerTooltip(idx, false)
	end
	if nil == Worker_Table[workerIndex] then
		return
	end

	if Worker_Table[workerIndex]._State == eWorkerStateType.waiting or Worker_Table[workerIndex]._State == eWorkerStateType.working then
		if Control_RestoreItem._saveIndex == idx then
			return
		end
		Control_WorkerList._worker_State[idx]		:SetText(Worker_Table[workerIndex]._State_Text)
	elseif Worker_Table[workerIndex]._State == eWorkerStateType.transfer then
	
	end	
end

function Control_Scroll(isUp, isSlider)
	if Control_RestoreItem._Item_BG:GetShow() and false == isSlider then
		Control_RestoreItem_Reset()
	end
	
	local self = scroll_Param
	if true == isSlider then
		self = slider_Param
	end
	
	if self._offsetIndex == 0 and self._offsetMax == 0 then
		return
	end
	
	local save_offset = self._offsetIndex 
	
	if ( true == isUp ) then
		self._offsetIndex = self._offsetIndex - 1
		if self._offsetIndex < 0 then
			self._offsetIndex = 0
		end		
	else
		self._offsetIndex = self._offsetIndex + 1
		if self._offsetIndex > self._offsetMax then
			self._offsetIndex = self._offsetMax
		end
	end
	
	if save_offset ~= self._offsetIndex then
		if false == isSlider then
			Control_WorkerList:UpdateSlot (0, false)	
			if WorkerTooltip_Index ~= nil and Panel_Worker_Tooltip:GetShow() then
				HandleOn_WorkerTooltip(WorkerTooltip_Index)
			end
		elseif true == isSlider then
			Control_RestoreItem:UpdateItemList()
			if ItemTooltip_Index ~= nil and Panel_Tooltip_Item:GetShow() then
				HandleOn_RestoreItemTooltip(ItemTooltip_Index)
			end
		end
	end	
end

function Control_ScrollOnClick(isSlider)
	if Control_RestoreItem._Item_BG:GetShow() and false == isSlider then
		Control_RestoreItem_Reset()
	end
	
	local _scrollSize = defaul_Control._List_Scroll:GetSizeY() 
	local _buttonSize = defaul_Control._scroll_Button:GetSizeY() 
	local _buttonPos = defaul_Control._scroll_Button:GetPosY()
	local self = scroll_Param
	
	if true == isSlider then
		_scrollSize = Control_RestoreItem._Item_Slider:GetSizeX() 
		_buttonSize = Control_RestoreItem._Item_Slider_Button:GetSizeX() 
		_buttonPos = Control_RestoreItem._Item_Slider_Button:GetPosX()
		self = slider_Param
	end	
	
	local namnunSize = _scrollSize - _buttonSize
	local namnunPercents = _buttonPos / namnunSize
	if namnunPercents > 1 then
		namnunPercents = 1
	end
	self._offsetIndex = math.floor(namnunPercents * self._offsetMax)
		
	if false == isSlider then
		Control_WorkerList:UpdateSlot (0, false)
	elseif true == isSlider then
		Control_RestoreItem:UpdateItemList()
	end
end

function WorldMapWindow_OpenWaitWorkerManageByPlantKey( aPlantKey )
    plantKey = aPlantKey
	--[[
	local CheckControl = UI.getChildControl(Panel_Win_Worldmap, "Static_GuideBG")
	local PosX = CheckControl:GetPosX()
	local PosY = CheckControl:GetPosY()
	Panel_manageWorker:SetPosX(PosX)
	Panel_manageWorker:SetPosY(PosY)
	--]]
	scroll_Param._offsetIndex	= 0
	Control_RestoreItem_Reset()
	Worker_Table_Set()
	
--	Panel_manageWorker:SetShow(true);
end

function WorldMapWindow_OpenWaitWorkerManage( node )
    WorldMapWindow_OpenWaitWorkerManageByPlantKey(node:getPlantKey())
end

function WorldMapWindow_WorkerManage_Refresh()	
	_PA_LOG("WokerManage", "here" )
	if (false == ToClient_WorldMapIsShow() ) or plantKey == nil then
		_PA_LOG("WokerManage", "here11" )
		return
	end

	local _saveIndex = nil
	if Control_RestoreItem._Item_BG:GetShow() then
		_saveIndex = Control_RestoreItem._saveIndex
	end
	
	Control_RestoreItem_Reset()
	FGlobal_InitWorkerTooltip()
	Worker_Table_Set()

	if _saveIndex ~= nil then	
		RestoreItem_Table_Set()
		Control_RestoreItem:InsertControl(_saveIndex, true)
	end
end

function WorldMapWindow_CloseWaitWorkerManage()
	Panel_manageWorker:SetShow(false);	
	plantKey = nil
	Control_RestoreItem_Reset()
	FGlobal_InitWorkerTooltip()
end
--[[
function FromClient_WorkerDataUpdate_StopWorking(workerNo, isUserRequest)	
	for key, value in pairs (Worker_Table) do
		if nil ~= Worker_Table[key]._WorkerNo then
			if Worker_Table[key]._WorkerNo:get_s64() == workerNo then
				WorldMapWindow_WorkerManage_Refresh()
				return
			end
		end		
	end
end
--]]
-----------------------------------------------------------------------------
------------------- 일꾼 작업 관련 Message 함수 -----------------------------
-----------------------------------------------------------------------------

local workType =
{
	_HouseCraft = 0,
	_LargeCraft = 1,
	_PlantWork	= 2,
	_Building	= 3,
	_RegionWork	= 4,
}

function Push_Work_Start_Message(workerNo, _workType, buildingInfoSS)
	--[[
	local npcworkerworkingInclient = ToClient_getNpcWorkingByWorkerNo(workerNo) -- 값이 엉뚱하게 나오나?
	CppEnums.NpcWorkingType = 
	{
		eNpcWorkingType_PlantZone					= 0,				-- 농장 생산
		eNpcWorkingType_PlantHousehold				= 1,				-- 하우징 제조
		eNpcWorkingType_PlantRentHouse				= 2,				-- RentHouse 제조
		eNpcWorkingType_ChangeTown					= 3,				-- 전출
		eNpcWorkingType_PlantBuliding				= 4,				-- 건설
		eNpcWorkingType_RegionManaging				= 5,				-- 영지 관리
		eNpcWorkingType_PlantRentHouseLargeCraft	= 6,				-- RentHouse 대량제작
	
		eNpcWorkingType_Count						= 7,				-- Count
	}
	--]]
	if _workType == workType._HouseCraft then
		local esSSW = ToClient_getItemExchangeSourceStaticStatusWrapperByWorker(workerNo)
		if esSSW:isSet() then
			local workName		= esSSW:getDescription()
			Proc_ShowMessage_Ack( PAGetStringParam1(Defines.StringSheet_GAME, "LUA_WORLD_MAP_TOWN_WORKER_START_CRAFT", "workName", workName) )			
		end
	elseif _workType == workType._LargeCraft then 
		local esSSW = ToClient_getItemExchangeSourceStaticStatusWrapperByWorker(workerNo)
		if esSSW:isSet() then
			local workName						= esSSW:getDescription()
			local esSS							= esSSW:get()
			local eSSCount 						= getExchangeSourceNeedItemList(esSS, true)
			local resourceIndex 				= ToClient_getLargeCraftWorkIndexByWorker(workerNo)
			local itemStaticInfomationWrapper 	= getExchangeSourceNeedItemByIndex(resourceIndex)
			local itemStaticWrapper 			= itemStaticInfomationWrapper:getStaticStatus()
			local itemStatic 					= itemStaticWrapper:get()
			local subWorkName					= tostring(getItemName( itemStatic ))  -- 추후 수정 필요!
			Proc_ShowMessage_Ack( PAGetStringParam2(Defines.StringSheet_GAME, "LUA_WORLD_MAP_TOWN_WORKER_START_LARGECRAFT", "workName", workName, "subWorkName", subWorkName) )			
		end
	elseif _workType == workType._PlantWork then
		local esSSW = ToClient_getItemExchangeSourceStaticStatusWrapperByWorker(workerNo)
		if esSSW:isSet() then
			local workName		= esSSW:getDescription()
			Proc_ShowMessage_Ack( PAGetStringParam1(Defines.StringSheet_GAME, "LUA_WORLD_MAP_TOWN_WORKER_START_PLANTWORK", "workName", workName) )			
		end
	elseif _workType == workType._Building then
		if nil == buildingInfoSS then
			return
		end
		local workName				= ToClient_getBuildingName( buildingInfoSS )
		local subWorkIndex 			= ToClient_getBuildingWorkingIndex(workerNo)
		local workCount				= ToClient_getBuildingWorkableListCount(buildingInfoSS)
		local buildingStaticStatus 	= ToClient_getBuildingWorkableBuildingSourceUnitByIndex(buildingInfoSS ,subWorkIndex)
		local itemStatic 			= buildingStaticStatus:getItemStaticStatus();
		local subWorkName			= getItemName(itemStatic) -- 추후 수정 필요!
		Proc_ShowMessage_Ack( PAGetStringParam2(Defines.StringSheet_GAME, "LUA_WORLD_MAP_TOWN_WORKER_START_BUILDING", "workName", workName, "subWorkName", subWorkName) )			
	elseif _workType == workType._RegionWork then
		-- 추가 필요
	end
end

function Push_Work_ResultItem_Message(WorkerNoRaw)
	local result_Count = ToClient_getLastestWorkingResultCount(WorkerNoRaw)
		for idx = 1, result_Count do
		local itemWrapper = ToClient_getLastestWorkingResult( WorkerNoRaw, idx - 1 )
		if itemWrapper:isSet() then
			local ItemEnchantSSW = itemWrapper:getStaticStatus()
			local name	= ItemEnchantSSW:getName()
			local count = Int64toInt32(itemWrapper:get():getCount_s64())
			Proc_ShowMessage_Ack( PAGetStringParam2(Defines.StringSheet_GAME, "LUA_WORLD_MAP_TOWN_WORKER_GOT_RESULT", "name", name, "count", count) )			
		end
	end
end

function Push_Worker_StopWork_Message(workerNo, isUserRequest)
	local npcWorkerWrapper 	= ToClient_getNpcWorkerByWorkerNo(workerNo)
	local workerName 	= npcWorkerWrapper:getName()
	if true == isUserRequest then
		Proc_ShowMessage_Ack( PAGetStringParam1(Defines.StringSheet_GAME, "LUA_WORLD_MAP_TOWN_WORKER_FINISHWORK_2", "workerName", workerName) )			
	elseif false == isUserRequest then		
		Proc_ShowMessage_Ack( PAGetStringParam1(Defines.StringSheet_GAME, "LUA_WORLD_MAP_TOWN_WORKER_FINISHWORK_1", "workerName", workerName) )			
	end
end

-- function Push_Building_Complete_Message(buildingInfoSS)
	-- local workCount				= ToClient_getBuildingWorkableListCount(buildingInfoSS)
	
	-- if workCount <= 0 then
		-- return
	-- end
	
	-- local workingCout			= ToClient_getBuildingWorkingList( buildingInfoSS )
	
	-- if workingCout > 0 then
		-- return
	-- end
	
	-- for index = 1, workCount do
		-- local buildingStaticStatus 	= ToClient_getBuildingWorkableBuildingSourceUnitByIndex(buildingInfoSS ,index - 1)
		-- local count_Total 			= buildingStaticStatus._needBuildProgressPoint
		-- local count_Current 		= ToClient_getWorkableCurrentBuildingPoint(buildingInfoSS, index - 1)
		-- if (count_Total - count_Current) > 0 then
			-- return
		-- end
	-- end
	
	-- Proc_ShowMessage_Ack( PAGetStringParam1(Defines.StringSheet_GAME, "LUA_WORLD_MAP_TOWN_WORKER_FINISHWORK", "workerName", workerName) )			
-- end
-----------------------------------------------------------------------------
-------------------------- 일꾼 Event 관련 함수 -----------------------------
-----------------------------------------------------------------------------

local hasWorker = function(workerNo)
	for workerIndex, value in pairs(Worker_Table) do
		if (nil ~= value._WorkerNo) and ( value._WorkerNo:get_s64() == workerNo ) then
			return true;
		end
	end

	return false;
end

function FromClient_WorkerDataUpdate_HeadingPlant(ExplorationNode, workerNo)
	-- 특정 Node에서, 일꾼과 관련 된 변동 사항이 있는 경우!
	if 0 ~= Int64toInt32(workerNo) then -- 작업 시작 시에만 workerNo가 제대로 들어온다!
		Push_Work_Start_Message(workerNo, workType._PlantWork) 
	end
	
	local _plantKey 		= ExplorationNode:getPlantKey()
	local wayPlant 			= ToClient_getPlant(_plantKey)
	local plant             = getPlant(_plantKey)
	local affiliatedTownKey = ToClinet_getPlantAffiliatedWaypointKey(wayPlant)
	
	if _plantKey:get() == 151 then
		FGlobal_MiniGame_RequestPlantWorking() -- 퀘스트 : 거점 생산 일 시키기 (로기아 농장 - 옥수수 재배)
	end

	if plantKey == nil then
		return	-- 최초 로딩 시에도 Event가 들어오므로 nil Check를 해야 한다.
	end
	
	if toInt64(0,0) == workerNo or hasWorker(workerNo) then
		-- 열려 있는 창과 매칭이 될 때만 Refresh
		WorldMapWindow_WorkerManage_Refresh()
	end
end

function FromClient_WorkerDataUpdate_HeadingHouse(rentHouseWrapper, workerNo)
	if 0 ~= Int64toInt32(workerNo) then -- 작업 시작 시에만 workerNo가 제대로 들어온다!
		local UseGroupType		= rentHouseWrapper:getHouseUseType()
		if UseGroupType == 12 or UseGroupType == 13 or UseGroupType == 14 then
			Push_Work_Start_Message(workerNo, workType._LargeCraft)
		else
			Push_Work_Start_Message(workerNo, workType._HouseCraft)
		end	
	end
	
	if plantKey == nil then
		return
	end
	local houseInfoSS 		= rentHouseWrapper:getStaticStatus():get()
	local affiliatedTownKey = ToClient_getHouseAffiliatedWaypointKey( houseInfoSS )
	
	if toInt64(0,0) == workerNo or hasWorker(workerNo) then
		-- 열려 있는 창과 매칭이 될 때만 Refresh
		WorldMapWindow_WorkerManage_Refresh()
	end
end

function FromClient_WorkerDataUpdate_HeadingBuilding(buildingInfoSS, workerNo)
	if 0 ~= Int64toInt32(workerNo) then -- 작업 시작 시에만 workerNo가 제대로 들어온다!
		Push_Work_Start_Message(workerNo, workType._Building, buildingInfoSS) 
	end
	
	if plantKey == nil then
		return
	end

	local affiliatedTownKey	= ToClient_getBuildingAffiliatedWaypointKey(buildingInfoSS)
	
	if toInt64(0,0) == workerNo or hasWorker(workerNo) then
		-- 열려 있는 창과 매칭이 될 때만 Refresh
		WorldMapWindow_WorkerManage_Refresh()
	end
end

function FromClient_WorkerDataUpdate_HeadingRegionManaging(regionGroupInfo, workerNo)
	if 0 ~= Int64toInt32(workerNo) then -- 작업 시작 시에만 workerNo가 제대로 들어온다!
		Push_Work_Start_Message(workerNo, workType._RegionWork) 
	end
	-- if plantKey == nil then
		-- return
	-- end
	
	-- local affiliatedTownKey = regionGroupInfo:getAffliatedTerritoryMainTownWaypointKey()
	
	-- if plantKey:getWaypointKey() == affiliatedTownKey then
		-- 열려 있는 창과 매칭이 될 때만 Refresh
		WorldMapWindow_WorkerManage_Refresh()
	-- end
end

function HandleOn_WorkerTooltip(idx)
	local adjust = 0
	if Control_RestoreItem._Item_BG:GetShow() and idx > Control_RestoreItem._saveIndex then
		adjust = 2
	end
	local workerIndex = scroll_Param._offsetIndex + idx - adjust
	local uiBase = Control_WorkerList._worker_BG[idx]
	if nil == Worker_Table[workerIndex] then
		return
	end
	if true == Worker_Table[workerIndex]._isEmpty then
		HandleOut_WorkerTooltip(idx, true)
	else
		local waitWorkerCount = ToClient_getPlantWaitWorkerListCount(plantKey, 0) -- 선행 함수가 어디선가 호출되나?
		HandleOnWorkerTooltip(ToClient_getPlantWaitWorkerByIndex( plantKey, workerIndex), uiBase )
		WorkerTooltip_Index = idx
	end	
end

function HandleOut_WorkerTooltip(idx, isReset)
	local MousePosX = getMousePosX()
	local MousePosY = getMousePosY()
	if WorkerTooltip_Index == idx then
		local uiBase = Control_WorkerList._worker_BG[idx]
		local checkX = MousePosX - uiBase:GetParentPosX()
		local checkY = MousePosY - uiBase:GetParentPosY()
		if 0 < checkX and 0 < checkY and checkX < uiBase:GetSizeX() and checkY < uiBase:GetSizeY() and false == isReset then
			return
		end
		HandleOutWorkerTooltip(uiBase)
		WorkerTooltip_Index = nil
	end
end

function HandleOn_RestoreItemTooltip(idx)
	local itemIndex = slider_Param._offsetIndex + idx 
	local staticStatusKey = RestoreItem_Table[itemIndex]._itemKey
	local staticStatusWrapper = getItemEnchantStaticStatus( staticStatusKey )
	local uiBase = Control_RestoreItem._Item_IconBG[idx]
	Panel_Tooltip_Item_Show(staticStatusWrapper, uiBase, true, false)
	ItemTooltip_Index = idx
	
	local itemIndex = slider_Param._offsetIndex + idx 
	local workerIndex = Control_RestoreItem.workerIndex
	local index = Control_RestoreItem.Index
	local restorePoint = RestoreItem_Table[itemIndex]._restore
	local progressRate = ( ( Worker_Table[workerIndex]._CurrentPoint + restorePoint ) / Worker_Table[workerIndex]._MaxPoint ) * 100
	Control_WorkerList._worker_RestorePoint[index]:SetProgressRate(progressRate)
end

function HandleOut_RestoreItemTooltip(idx)
	if ItemTooltip_Index == idx then
		Panel_Tooltip_Item_hideTooltip()
		local workerIndex = Control_RestoreItem.workerIndex
		local index = Control_RestoreItem.Index
		local progressRate = ( Worker_Table[workerIndex]._CurrentPoint / Worker_Table[workerIndex]._MaxPoint ) * 100
		Control_WorkerList._worker_RestorePoint[index]:SetProgressRate(progressRate)
	end
end

function HandleClick_RestoreItem(idx)
	local index = slider_Param._offsetIndex + idx
	local workerIndex = Control_RestoreItem.workerIndex
	local workerNo = Worker_Table[workerIndex]._WorkerNo
	local slotNo = RestoreItem_Table[index]._slotNo
		
	if Worker_Table[workerIndex]._MaxPoint == Worker_Table[workerIndex]._CurrentPoint then
		Proc_ShowMessage_Ack( PAGetString(Defines.StringSheet_GAME, "LUA_WORLD_MAP_TOWN_WORKER_RESTORE_MAX") )
		return
	end
	requestRecoveryWorker(workerNo, slotNo)
end

----------------------

registerEvent("FromClient_AppliedChangeUseType", 			"WorldMapWindow_WorkerManage_Refresh()")
registerEvent("FromClient_ReceiveReturnHouse", 				"WorldMapWindow_WorkerManage_Refresh()")
registerEvent("WorldMap_WorkerDataUpdate",					"FromClient_WorkerDataUpdate_HeadingPlant")
registerEvent("WorldMap_WorkerDataUpdateByHouse",			"FromClient_WorkerDataUpdate_HeadingHouse")
registerEvent("WorldMap_WorkerDataUpdateByBuilding",		"FromClient_WorkerDataUpdate_HeadingBuilding")
registerEvent("WorldMap_WorkerDataUpdateByRegionManaging",	"FromClient_WorkerDataUpdate_HeadingRegionManaging")
registerEvent("WorldMap_StopWorkerWorking",					"Push_Worker_StopWork_Message")
registerEvent("FromClient_UpdateLastestWorkingResult",		"Push_Work_ResultItem_Message")
-- registerEvent("WorldMap_StopWorkerWorking", 		"FromClient_WorkerDataUpdate_StopWorking")
