Panel_Finance_WorkManager:setMaskingChild(true)
Panel_Finance_WorkManager:setGlassBackground(true)
Panel_Finance_WorkManager:TEMP_UseUpdateListSwap(true)
Panel_Finance_WorkManager:ActiveMouseEventEffect( true )

local _position 			= nil
local _plantKey 			= nil
local wayPlant				= nil
local _affiliatedTownKey 	= 0
-----------------------------------------------------
-- 최초 'defalut_Control' Setting 관련 함수
-----------------------------------------------------

local defalut_Control =
{
	_title						= UI.getChildControl( Panel_Finance_WorkManager, "StaticText_Title" ),
	_btn_Close					= UI.getChildControl( Panel_Finance_WorkManager, "Button_Win_Close" ),
	_btn_Question				= UI.getChildControl( Panel_Finance_WorkManager, "Button_Question" ),
	_Button_DoWork         		= UI.getChildControl( Panel_Finance_WorkManager, "Button_doWork" ),
	_Button_NoResource     		= UI.getChildControl( Panel_Finance_WorkManager, "StaticText_NoResource" ),
	
	_workInfo_Default =
	{
		_BG						= UI.getChildControl( Panel_Finance_WorkManager, "Static_WorkInfo_Default_BG" ),
		_Icon_BG				= UI.getChildControl( Panel_Finance_WorkManager, "Static_WorkInfo_Default_Icon_BG" ),
		_Icon					= UI.getChildControl( Panel_Finance_WorkManager, "Static_WorkInfo_Default_Icon" ),
		_Type					= UI.getChildControl( Panel_Finance_WorkManager, "StaticText_WorkInfo_Default_Type" ),
		_Desc					= UI.getChildControl( Panel_Finance_WorkManager, "StaticText_WorkInfo_Default_Desc" ),	
	},
	
	_worker_List =	
	{	
		_BG						= UI.getChildControl( Panel_Finance_WorkManager, "Static_WorkerList_BG" ),
		_Title              	= UI.getChildControl( Panel_Finance_WorkManager, "StaticText_WorkerList_Title" ),
		_Scroll             	= UI.getChildControl( Panel_Finance_WorkManager, "Scroll_WorkerList" ),
		_No_Worker             	= UI.getChildControl( Panel_Finance_WorkManager, "StaticText_NoWorker" ),
		_Button             	= {},
		_Progress           	= {},
		_ActionPoint           	= {},
			
		_Template =	
		{	
			_Button				= UI.getChildControl( Panel_Finance_WorkManager, "RadioButton_Worker" ),
			_Progress       	= UI.getChildControl( Panel_Finance_WorkManager, "Progress2_Worker_ActionPoint" ),
			_ActionPoint       	= UI.getChildControl( Panel_Finance_WorkManager, "StaticText_Worker_ActionPoint" ),
			
			_rowMax = 11,
			_row_PosY_Gap = 2,
		},	
	},	
	
	_work_Info =	
	{	
		_BG						= UI.getChildControl( Panel_Finance_WorkManager, "Static_WorkDetail_BG" ),
		_Title              	= UI.getChildControl( Panel_Finance_WorkManager, "StaticText_WorkDetail_Title" ),
								
		_Resource_BG          	= UI.getChildControl( Panel_Finance_WorkManager, "Static_WorkDetail_Resource_BG" ),
		_Resource_Title         = UI.getChildControl( Panel_Finance_WorkManager, "StaticText_WorkDetail_Resource_Title" ),
		_Resource_Line_1      	= UI.getChildControl( Panel_Finance_WorkManager, "Static_WorkDetail_Resource_Line_1" ),
		_Resource_Line_2      	= UI.getChildControl( Panel_Finance_WorkManager, "Static_WorkDetail_Resource_Line_2" ),
		_Resource_Icon_BG	    = {},
		_Resource_Icon_Border   = {},
		_Resource_Icon_Over    	= {},
		_Resource_Icon        	= {},
		_Resource_Count        	= {},

		_Template =	
		{	
			_Resource_Icon_BG	    = UI.getChildControl( Panel_Finance_WorkManager, "StaticText_WorkDetail_Resource_Icon_BG" ),
			_Resource_Icon_Border   = UI.getChildControl( Panel_Finance_WorkManager, "StaticText_WorkDetail_Resource_Icon_Boder" ),
			_Resource_Icon_Over    	= UI.getChildControl( Panel_Finance_WorkManager, "StaticText_WorkDetail_Resource_Icon_Over" ),
			_Resource_Icon        	= UI.getChildControl( Panel_Finance_WorkManager, "StaticText_WorkDetail_Resource_Icon" ),
			_Resource_Count        	= UI.getChildControl( Panel_Finance_WorkManager, "StaticText_WorkDetail_Resource_Count" ),
			
			_collumMax = 6,
			_collum_PosX_Gap = 2,
		},	
		
		_Time_BG                = UI.getChildControl( Panel_Finance_WorkManager, "StaticText_Estimated_Time_BG" ),
		_Time_Value             = UI.getChildControl( Panel_Finance_WorkManager, "StaticText_Estimated_Time_Value" ),
		_Time_Line              = UI.getChildControl( Panel_Finance_WorkManager, "Static_Estimated_Time_Line" ),
		                        
		_Work_BG                = UI.getChildControl( Panel_Finance_WorkManager, "Static_Estimated_Work_BG" ),
		_Work_Line_1            = UI.getChildControl( Panel_Finance_WorkManager, "Static_Estimated_Work_Line_1" ),
		_Work_Line_2            = UI.getChildControl( Panel_Finance_WorkManager, "Static_Estimated_Work_Line_2" ),
		_Work_Volume_Text       = UI.getChildControl( Panel_Finance_WorkManager, "StaticText_Estimated_WorkVolum_Text" ),
		_Work_Volume_Value      = UI.getChildControl( Panel_Finance_WorkManager, "StaticText_Estimated_WorkVolum_Value" ),
		_Work_Speed_Text        = UI.getChildControl( Panel_Finance_WorkManager, "StaticText_Estimated_WorkSpeed_Text" ),
		_Work_Speed_Value       = UI.getChildControl( Panel_Finance_WorkManager, "StaticText_Estimated_WorkSpeed_Value" ),
		                        
		_Move_BG                = UI.getChildControl( Panel_Finance_WorkManager, "Static_Estimated_Move_BG" ),
		_Move_Line_1            = UI.getChildControl( Panel_Finance_WorkManager, "Static_Estimated_Move_Line_1" ),
		_Move_Line_2            = UI.getChildControl( Panel_Finance_WorkManager, "Static_Estimated_Move_Line_2" ),
		_Move_Distance_Text     = UI.getChildControl( Panel_Finance_WorkManager, "StaticText_Estimated_MoveDistance_Text" ),
		_Move_Distance_Value    = UI.getChildControl( Panel_Finance_WorkManager, "StaticText_Estimated_MoveDistance_Value" ),
		_Move_Speed_Text        = UI.getChildControl( Panel_Finance_WorkManager, "StaticText_Estimated_MoveSpeed_Text" ),
		_Move_Speed_Value       = UI.getChildControl( Panel_Finance_WorkManager, "StaticText_Estimated_MoveSpeed_Value" ),
		
		_Luck_BG                = UI.getChildControl( Panel_Finance_WorkManager, "Static_Estimated_Luck_BG" ),
		_Luck_Line	            = UI.getChildControl( Panel_Finance_WorkManager, "Static_Estimated_Luck_Line" ),
		_Luck_Text     		   = UI.getChildControl( Panel_Finance_WorkManager, "StaticText_Estimated_Luck_Text" ),
		_Luck_Value       = UI.getChildControl( Panel_Finance_WorkManager, "StaticText_Estimated_Luck_Value" ),
	},
}

defalut_Control._btn_Question:addInputEvent( "Mouse_LUp", "Panel_WebHelper_ShowToggle( \"HouseManageWork\" )" )				--물음표 좌클릭
defalut_Control._btn_Question:addInputEvent( "Mouse_On", "HelpMessageQuestion_Show( \"HouseManageWork\", \"true\")" )		--물음표 마우스오버
defalut_Control._btn_Question:addInputEvent( "Mouse_Out", "HelpMessageQuestion_Show( \"HouseManageWork\", \"false\")" )		--물음표 마우스아웃

function defalut_Control:Init_Control()	
	FGlobal_AddChild(Panel_Finance_WorkManager, self._workInfo_Default._BG, self._workInfo_Default._Icon_BG )
	FGlobal_AddChild(Panel_Finance_WorkManager, self._workInfo_Default._BG, self._workInfo_Default._Icon )
	FGlobal_AddChild(Panel_Finance_WorkManager, self._workInfo_Default._BG, self._workInfo_Default._Type )
	FGlobal_AddChild(Panel_Finance_WorkManager, self._workInfo_Default._BG, self._workInfo_Default._Desc )
	
	FGlobal_AddChild(Panel_Finance_WorkManager, self._worker_List._BG, self._worker_List._Title )
	FGlobal_AddChild(Panel_Finance_WorkManager, self._worker_List._BG, self._worker_List._Scroll )
	FGlobal_AddChild(Panel_Finance_WorkManager, self._worker_List._BG, self._worker_List._No_Worker )
	
	FGlobal_Set_Table_Control(self._worker_List, "_Button", "_Button", true, false)
	FGlobal_Set_Table_Control(self._worker_List, "_Progress", "_Button", true, false)
	FGlobal_Set_Table_Control(self._worker_List, "_ActionPoint", "_Button", true, false)				
	
	FGlobal_AddChild(Panel_Finance_WorkManager, self._work_Info._BG, self._work_Info._Resource_BG )
	FGlobal_AddChild(Panel_Finance_WorkManager, self._work_Info._BG, self._work_Info._Resource_Title )
	FGlobal_AddChild(Panel_Finance_WorkManager, self._work_Info._BG, self._work_Info._Resource_Line_1 )
	FGlobal_AddChild(Panel_Finance_WorkManager, self._work_Info._BG, self._work_Info._Resource_Line_2 )
	
	FGlobal_Set_Table_Control(self._work_Info, "_Resource_Icon_BG", 	"_Resource_Icon_BG", false, true)
	FGlobal_Set_Table_Control(self._work_Info, "_Resource_Icon_Border", "_Resource_Icon_BG", false, true)
	FGlobal_Set_Table_Control(self._work_Info, "_Resource_Icon_Over", 	"_Resource_Icon_BG", false, true)
	FGlobal_Set_Table_Control(self._work_Info, "_Resource_Icon", 		"_Resource_Icon_BG", false, true)
	FGlobal_Set_Table_Control(self._work_Info, "_Resource_Count", 		"_Resource_Icon_BG", false, true)	

	FGlobal_AddChild(Panel_Finance_WorkManager, self._work_Info._BG, self._work_Info._Time_BG )
	FGlobal_AddChild(Panel_Finance_WorkManager, self._work_Info._BG, self._work_Info._Time_Value )
	FGlobal_AddChild(Panel_Finance_WorkManager, self._work_Info._BG, self._work_Info._Time_Line )	
	
	FGlobal_AddChild(Panel_Finance_WorkManager, self._work_Info._BG, self._work_Info._Work_BG )
	FGlobal_AddChild(Panel_Finance_WorkManager, self._work_Info._BG, self._work_Info._Work_Line_1 ) 		
	FGlobal_AddChild(Panel_Finance_WorkManager, self._work_Info._BG, self._work_Info._Work_Line_2 ) 		
	FGlobal_AddChild(Panel_Finance_WorkManager, self._work_Info._BG, self._work_Info._Work_Volume_Text ) 	
	FGlobal_AddChild(Panel_Finance_WorkManager, self._work_Info._BG, self._work_Info._Work_Volume_Value ) 	
	FGlobal_AddChild(Panel_Finance_WorkManager, self._work_Info._BG, self._work_Info._Work_Speed_Text ) 	
	FGlobal_AddChild(Panel_Finance_WorkManager, self._work_Info._BG, self._work_Info._Work_Speed_Value ) 
	
	FGlobal_AddChild(Panel_Finance_WorkManager, self._work_Info._BG, self._work_Info._Move_BG )
	FGlobal_AddChild(Panel_Finance_WorkManager, self._work_Info._BG, self._work_Info._Move_Line_1 )			
	FGlobal_AddChild(Panel_Finance_WorkManager, self._work_Info._BG, self._work_Info._Move_Line_2 ) 		
	FGlobal_AddChild(Panel_Finance_WorkManager, self._work_Info._BG, self._work_Info._Move_Distance_Text )
	FGlobal_AddChild(Panel_Finance_WorkManager, self._work_Info._BG, self._work_Info._Move_Distance_Value ) 
	FGlobal_AddChild(Panel_Finance_WorkManager, self._work_Info._BG, self._work_Info._Move_Speed_Text ) 	
	FGlobal_AddChild(Panel_Finance_WorkManager, self._work_Info._BG, self._work_Info._Move_Speed_Value )
	
	FGlobal_AddChild(Panel_Finance_WorkManager, self._work_Info._BG, self._work_Info._Luck_BG )
	FGlobal_AddChild(Panel_Finance_WorkManager, self._work_Info._BG, self._work_Info._Luck_Line ) 
	FGlobal_AddChild(Panel_Finance_WorkManager, self._work_Info._BG, self._work_Info._Luck_Text ) 	
	FGlobal_AddChild(Panel_Finance_WorkManager, self._work_Info._BG, self._work_Info._Luck_Value ) 	
end
defalut_Control:Init_Control()
function defalut_Control:Init_Function()

	self._btn_Close								:addInputEvent("Mouse_LUp",			"FGlobal_Finance_WorkManager_Close()")
	self._Button_DoWork							:addInputEvent("Mouse_LUp",			"HandleClick_Finance_doWork()")	
	
	self._worker_List._BG						:addInputEvent("Mouse_UpScroll",	"HandleScroll_Finance_Worker_List_UpDown(true)")
	self._worker_List._BG						:addInputEvent("Mouse_DownScroll",	"HandleScroll_Finance_Worker_List_UpDown(false)")
	                                            
	self._worker_List._Scroll					:addInputEvent("Mouse_UpScroll",	"HandleScroll_Finance_Worker_List_UpDown(true)")
	self._worker_List._Scroll					:addInputEvent("Mouse_DownScroll",	"HandleScroll_Finance_Worker_List_UpDown(false)")
	self._worker_List._Scroll					:addInputEvent("Mouse_LDown",		"HandleScroll_Finance_Worker_List_OnClick()")
	self._worker_List._Scroll					:addInputEvent("Mouse_LUp",			"HandleScroll_Finance_Worker_List_OnClick()")
	self._worker_List._Scroll:GetControlButton():addInputEvent("Mouse_UpScroll",	"HandleScroll_Finance_Worker_List_UpDown(true)")
	self._worker_List._Scroll:GetControlButton():addInputEvent("Mouse_DownScroll",	"HandleScroll_Finance_Worker_List_UpDown(false)")
	self._worker_List._Scroll:GetControlButton():addInputEvent("Mouse_LDown",		"HandleScroll_Finance_Worker_List_OnClick()")
	self._worker_List._Scroll:GetControlButton():addInputEvent("Mouse_LUp",			"HandleScroll_Finance_Worker_List_OnClick()")
	self._worker_List._Scroll:GetControlButton():addInputEvent("Mouse_LPress",		"HandleScroll_Finance_Worker_List_OnClick()")	
	
	for key, value in pairs (self._worker_List._Button) do
		value:addInputEvent("Mouse_On",			"HandleOn_Finance_Worker_List(" .. key ..")")
		value:addInputEvent("Mouse_Out",		"HandleOut_Finance_Worker_List()")
		value:addInputEvent("Mouse_UpScroll",	"HandleScroll_Finance_Worker_List_UpDown(true)")
		value:addInputEvent("Mouse_DownScroll",	"HandleScroll_Finance_Worker_List_UpDown(false)")
	end	
	
	for key, value in pairs (self._work_Info._Resource_Icon_Over) do
		value:addInputEvent("Mouse_On",			"Item_Tooltip_Show_FinanceResource(" .. key ..")")
		value:addInputEvent("Mouse_Out",		"Panel_Tooltip_Item_hideTooltip()")
	end	

end
defalut_Control:Init_Function()
-----------------------------------------------------
-- 작업 목록(Work List) 관련 함수
-----------------------------------------------------

local Work_Info = 
{
	_plantKey		= nil,
	_workKey        = nil,
	_workableType	= nil,	
	_workVolum      = nil,
	_position		= nil,	

	_finance_Icon    = nil,
	_finance_Type   = nil,
	_finance_Des    = nil,
	
	_resource		= {},
	_isCraftable	= false,
}

function Work_Info:_setData()
	
	local workableCnt = ToClient_getPlantWorkableListCount(_plantKey)	
	-- Plant는 기본적으로 1개의 Work만 가진다! workableCnt 2 이상 나오면 문제가 있는 거다!
	for index = 1 , workableCnt do
		local _workKey 			= ToClient_getPlantWorkableItemExchangeKeyByIndex(_plantKey, index - 1)
		local _workName 		= ToClient_getPlantWorkableItemExchangeDescriptionByIndex(_plantKey, index - 1)	
		-- local esSS			 	= ToClient_getPlantWorkableItemExchangeByIndex(_plantKey, index - 1)
		local esSSW			 	= ToClient_getPlantWorkableItemExchangeWrapperByIndex(_plantKey, index - 1)
		if esSSW:isSet() then
			local esSS				= esSSW:get()
			local _workVolum 		= Int64toInt32(ToClient_getPlantCorpProductionApply(_plantKey, esSS._productTime)) / 1000;
			local _workableType 	= esSS._productCategory;			
			local itemStatic 		= esSS:getFirstDropGroup():getItemStaticStatus()			
			local _finance_Icon		= "icon/" .. esSSW:getIcon()		
			local _finance_Type		= esSSW:getDescription()			
			local _finance_Des 		= esSSW:getDetailDescription()
			
			self._plantKey		= _plantKey
			self._workKey      	= _workKey
			self._workableType	= _workableType	
			self._workVolum    	= _workVolum
			self._position		= float3(_position.x, _position.y, _position.z )
			
			self._finance_Icon  = _finance_Icon
			self._finance_Type  = _finance_Type
			self._finance_Des  	= _finance_Des
			
			self._isCraftable	= true
			self._resource		= {}
			
			local eSSCount 	= getExchangeSourceNeedItemList(esSS, true)

			for idx = 1, eSSCount do			
				local _idx = idx - 1
				local itemStaticInfomationWrapper = getExchangeSourceNeedItemByIndex(_idx)
				local itemStaticWrapper = itemStaticInfomationWrapper:getStaticStatus()
				local itemStatic = itemStaticWrapper:get()
				local itemKey = itemStaticInfomationWrapper:getKey()
				local _gradeType = itemStaticWrapper:getGradeType()
				local resourceKey = itemStatic._key
				local itemIcon = "icon/" .. getItemIconPath( itemStatic )
				local needCount = Int64toInt32( itemStaticInfomationWrapper:getCount_s64() )
				local haveCount = 0
				if ( 0 ~= _affiliatedTownKey ) then
					haveCount = Int64toInt32( warehouse_getItemCount( _affiliatedTownKey , itemKey ) )
				end
				self._resource[idx] = 
				{
					_itemKey		= itemKey,
					_resourceKey	= resourceKey,
					_itemIcon		= itemIcon,
					_needCount		= needCount,
					_haveCount		= haveCount,
					_gradeType		= _gradeType,
				}
				
				if haveCount < needCount then
					self._isCraftable = false
				end
			end	
		end
	end
	Work_Info:_Update()
end

function Work_Info:_Update()
	
	defalut_Control._workInfo_Default._Icon	:ChangeTextureInfoName(self._finance_Icon)
	defalut_Control._workInfo_Default._Type	:SetText(self._finance_Type)
	defalut_Control._workInfo_Default._Desc	:SetText(self._finance_Des)

	local _resource_SlotMax = defalut_Control._work_Info._Template._collumMax	

	for idx = 1, _resource_SlotMax do
		local _data = self._resource[idx]
		if nil ~= _data then
			local gradeType = _data._gradeType
			
			if (0 < gradeType) and (gradeType <= #UI.itemSlotConfig.borderTexture) then
				defalut_Control._work_Info._Resource_Icon_Border[idx]:ChangeTextureInfoName( UI.itemSlotConfig.borderTexture[gradeType].texture )			
				local x1, y1, x2, y2 = setTextureUV_Func( defalut_Control._work_Info._Resource_Icon_Border[idx], UI.itemSlotConfig.borderTexture[gradeType].x1, UI.itemSlotConfig.borderTexture[gradeType].y1, UI.itemSlotConfig.borderTexture[gradeType].x2, UI.itemSlotConfig.borderTexture[gradeType].y2 )
				defalut_Control._work_Info._Resource_Icon_Border[idx]:getBaseTexture():setUV(  x1, y1, x2, y2  )
				defalut_Control._work_Info._Resource_Icon_Border[idx]:setRenderTexture(defalut_Control._work_Info._Resource_Icon_Border[idx]:getBaseTexture())	
				defalut_Control._work_Info._Resource_Icon_Border[idx]:SetShow(true)
			else
				defalut_Control._work_Info._Resource_Icon_Border[idx]:SetShow(false)
			end

			defalut_Control._work_Info._Resource_Icon[idx]			:ChangeTextureInfoName(_data._itemIcon)
			--_data._haveCount = Int64toInt32( warehouse_getItemCount( _affiliatedTownKey , _data._itemKey ) )
			--_PA_LOG("LUA", "_affiliatedTownKey : " .. tostring( _affiliatedTownKey ) )
			--_PA_LOG("LUA", "_data._haveCount : " .. tostring( _data._haveCount ) )
			
			local resourceCount = tostring(_data._haveCount) .. "/" .. tostring(_data._needCount)
			if _data._haveCount < _data._needCount then
				resourceCount = "<PAColor0xFFDB2B2B>" .. resourceCount .. "<PAOldColor>"
			end
			defalut_Control._work_Info._Resource_Count[idx]      	:SetText(resourceCount)
				
			defalut_Control._work_Info._Resource_Icon_BG[idx]		:SetShow(true)
			defalut_Control._work_Info._Resource_Icon_Border[idx]	:SetShow(true)
			defalut_Control._work_Info._Resource_Icon_Over[idx]  	:SetShow(true)
			defalut_Control._work_Info._Resource_Icon[idx]       	:SetShow(true)
			defalut_Control._work_Info._Resource_Count[idx]      	:SetShow(true)
		elseif nil == _data then
			defalut_Control._work_Info._Resource_Icon_BG[idx]	  	:SetShow(false)
			defalut_Control._work_Info._Resource_Icon_Border[idx]  	:SetShow(false)
			defalut_Control._work_Info._Resource_Icon_Over[idx]    	:SetShow(false)
			defalut_Control._work_Info._Resource_Icon[idx]         	:SetShow(false)
			defalut_Control._work_Info._Resource_Count[idx]        	:SetShow(false)
		end
	end
	
	if true == self._isCraftable then
		defalut_Control._Button_DoWork     :SetShow(true)
		defalut_Control._Button_NoResource :SetShow(false)
	elseif false == self._isCraftable then
		defalut_Control._Button_DoWork     :SetShow(false)
		defalut_Control._Button_NoResource :SetShow(true)
	end
end
-----------------------------------------------------
-- 일꾼 목록(Worker List) 관련 함수
-----------------------------------------------------

local Worker_List =
{
	_data_Table 			= {},
			
	_rowMax 				= defalut_Control._worker_List._Template._rowMax,	
			
	_contentRow				= nil,	
	_offsetIndex 			= nil,
	_offset_Max 			= nil,
		
	_selected_Worker		= nil,
	_selected_Index			= nil,
	_over_Index				= nil,
}

-- 지역 별로 일꾼을 정렬해주자.
local workingTime = {}
local homeWayKey = {}
local sortDistanceValue = {}
local Worker_SortByRegionInfo = function()
	local workIndex			= 0 		-- 동일 House의 Work는 모두 동일한 Type이므로, 첫 Index만 Check 하면 된다.
	local esSSW		 		= ToClient_getPlantWorkableItemExchangeWrapperByIndex(_plantKey, workIndex)
	local esSS			 	= esSSW:get()
	local sortMethod 		= 0
	local waitingWorkerCount = ToClient_getPlantWaitWorkerListCount( Work_Info._plantKey, Work_Info._workableType, Work_Info._workKey, sortMethod )

	if ( 0 == waitingWorkerCount ) then
		return
	end

	local possibleWorkerIndex = 0
	for index = 1, waitingWorkerCount do
		local npcWaitingWorker = ToClient_getPlantWaitWorkerByIndex( Work_Info._plantKey, index - 1)
		if( true == ToClient_isWaitWorker( npcWaitingWorker ) ) then			
			possibleWorkerIndex = possibleWorkerIndex + 1
			local workVolume 	= Int64toInt32(esSS._productTime) / 1000
			local distance		= ToClient_getCalculateMoveDistance(Worker_List._data_Table[possibleWorkerIndex]._workerNo, Work_Info._position) / 100
			local workSpeed		= Worker_List._data_Table[possibleWorkerIndex]._workSpeed
			local moveSpeed		= Worker_List._data_Table[possibleWorkerIndex]._moveSpeed
			local luck			= Worker_List._data_Table[possibleWorkerIndex]._luck
			local workBaseTime 	= ToClient_getNpcWorkingBaseTime() / 1000
			local totalWorkTime	= math.ceil(workVolume/workSpeed) * workBaseTime + (distance/moveSpeed) * 2

			workingTime[possibleWorkerIndex]		= Int64toInt32(totalWorkTime)
			homeWayKey[possibleWorkerIndex]			= Worker_List._data_Table[possibleWorkerIndex]._homeWaypoint
			sortDistanceValue[possibleWorkerIndex]	= distance
		end
	end
	
	local possibleWorkerCount = possibleWorkerIndex
	
	local temp = nil
	local workerDataSwap = function( index, sortCount )
		if ( index ~= sortCount ) and ( Worker_List._data_Table[index]._homeWaypoint ~= Worker_List._data_Table[sortCount]._homeWaypoint ) then
			temp = Worker_List._data_Table[index]
			Worker_List._data_Table[index] = Worker_List._data_Table[sortCount]
			Worker_List._data_Table[sortCount] = temp
			temp = sortDistanceValue[index]
			sortDistanceValue[index] = sortDistanceValue[sortCount]
			sortDistanceValue[sortCount] = temp
		end
	end

	-- 우선 작업시간 별로 정렬
	for ii = 1, possibleWorkerCount do
		local temp = nil
		for i = possibleWorkerCount, 1, -1 do
			if 1 < i and workingTime[i] < workingTime[i-1] then
				temp = Worker_List._data_Table[i]
				Worker_List._data_Table[i] = Worker_List._data_Table[i-1]
				Worker_List._data_Table[i-1] = temp
				temp = workingTime[i]
				workingTime[i] = workingTime[i-1]
				workingTime[i-1] = temp
				temp = sortDistanceValue[i]
				sortDistanceValue[i] = sortDistanceValue[i-1]
				sortDistanceValue[i-1] = temp
			end
		end
		if nil == temp then
			break
		end
	end
	
	-- 이후 노드키 별로 정렬(같은 영지 내의 일꾼부터 표시)
	local territory = {}
	if 0 < FGlobal_WayPointKey_Return() and 300 >= FGlobal_WayPointKey_Return() then			-- 발레노스 영지
		territory[0] = true
		territory[1] = false
		territory[2] = false
	elseif 301 <= FGlobal_WayPointKey_Return() and 600 >= FGlobal_WayPointKey_Return() then		-- 세렌디아 영지
		territory[0] = false
		territory[1] = true
		territory[2] = false
	elseif 601 <= FGlobal_WayPointKey_Return() then												-- 칼페온 영지
		territory[0] = false
		territory[1] = false
		territory[2] = true
	end
	
	-- 작업시킬 거점에 속해 있는 일꾼부터 정렬
	local _sortCount = 0
	for ii = _sortCount + 1, possibleWorkerCount do
		if ( Worker_List._data_Table[ii]._homeWaypoint == FGlobal_WayPointKey_Return() ) then
			_sortCount = _sortCount + 1
			if ( ii ~= _sortCount ) then
				workerDataSwap( ii, _sortCount )
			end
		end
	end
	
	local sortByRegion = function( territoryKey )
		local sortTerritoryCount = 0
		local startValue = _sortCount + 1

		if ( possibleWorkerCount < startValue ) then
			return
		end
		if ( 0 == territoryKey ) then
			for jj = startValue, possibleWorkerCount do
				if 0 < Worker_List._data_Table[jj]._homeWaypoint and 300 >= Worker_List._data_Table[jj]._homeWaypoint then
					if startValue ~= jj then
						workerDataSwap( jj, startValue + sortTerritoryCount )
					end
					_sortCount = _sortCount + 1
					sortTerritoryCount = sortTerritoryCount + 1
				end
			end

		elseif ( 1 == territoryKey ) then
			for jj = startValue, possibleWorkerCount do
				if 301 <= Worker_List._data_Table[jj]._homeWaypoint and 600 >= Worker_List._data_Table[jj]._homeWaypoint then
					if startValue ~= jj then
						workerDataSwap( jj, startValue + sortTerritoryCount )
					end
					_sortCount = _sortCount + 1
					sortTerritoryCount = sortTerritoryCount + 1
				end
			end

		elseif ( 2 == territoryKey ) then
			for jj = startValue, possibleWorkerCount do
				if 601 <= Worker_List._data_Table[jj]._homeWaypoint then
					if startValue ~= jj then
						workerDataSwap( jj, startValue + sortTerritoryCount )
					end
					_sortCount = _sortCount + 1
					sortTerritoryCount = sortTerritoryCount + 1
				end
			end

		end
		
		-- 영지별로 분류했으면, 다시 거리로 정렬 / 거리가 같을 경우 이미 작업시간으로 분류돼 있다
		if ( 1 < sortTerritoryCount ) then
			for ii = 1, sortTerritoryCount - 1 do
				for jj = startValue + sortTerritoryCount - 1, startValue + 1, -1 do
					if ( sortDistanceValue[jj] < sortDistanceValue[jj-1] ) then
						workerDataSwap( jj, jj-1 )
					end
				end
			end
		end
	end
	
	if ( possibleWorkerCount ~= _sortCount ) then
		-- 발레노스 영지 작업관리
		if true == territory[0] then
			sortByRegion(0)
			sortByRegion(1)
			sortByRegion(2)

		-- 세렌디아 영지 작업관리
		elseif true == territory[1] then
			sortByRegion(1)
			sortByRegion(0)
			sortByRegion(2)

		-- 칼페온 영지 작업관리
		elseif true == territory[2] then
			sortByRegion(2)
			sortByRegion(1)
			sortByRegion(0)

		end
	end
			
end

function Worker_List:_setData()
	local sortMethod = 0
	local waitingWorkerCount = ToClient_getPlantWaitWorkerListCount( Work_Info._plantKey, Work_Info._workableType, Work_Info._workKey, sortMethod );

	-- if waitingWorkerCount <= 0 then
		-- return
	-- end
		
	self._data_Table = {}
	local _idx = 0
	for Index = 1, waitingWorkerCount do
		local npcWaitingWorker = ToClient_getPlantWaitWorkerByIndex( Work_Info._plantKey, Index - 1)
		if( true == ToClient_isWaitWorker( npcWaitingWorker ) ) then			
			_idx = _idx + 1
			if nil == self._data_Table[_idx]	then
				self._data_Table[_idx] = {}
			end
			
			local firstWorkerNo			= npcWaitingWorker:getWorkerNo();		
			local workerNoChar 			= firstWorkerNo:get_s64()		
			local npcWaitingWorkerSS 	= npcWaitingWorker:getWorkerStaticStatus();
			local workerNo 				= WorkerNo( workerNoChar )			
			local workSpeed				= npcWaitingWorkerSS:getEfficiency( Work_Info._workableType, ItemExchangeKey( Work_Info._workKey ) );
			local moveSpeed				= npcWaitingWorkerSS._moveSpeed / 100.0;	
			local luck					= npcWaitingWorkerSS._luck
			local maxPoint 				= npcWaitingWorkerSS._actionPoint
			local currentPoint 			= npcWaitingWorker:getActionPoint()
			local workerRegionWrapper	= ToClient_getRegionInfoWrapper( npcWaitingWorker )
			local name					= getWorkerName(npcWaitingWorkerSS) .. "(<PAColor0xff868686>" .. workerRegionWrapper:getAreaName() .. "<PAOldColor>)"
			local homeWaypoint			= npcWaitingWorker:getHomeWaypoint()

			self._data_Table[_idx] =
			{
				_workerNo		= workerNo,
				_workerNoChar	= Int64toInt32(workerNoChar),
				_name			= name,
				_workSpeed 		= math.floor(workSpeed / 1000000),
				_moveSpeed 		= moveSpeed,
				_luck			= math.floor(luck / 10000),
				_maxPoint 		= maxPoint,
				_currentPoint 	= currentPoint,
				_homeWaypoint	= homeWaypoint,
			}
		end
	end
	
	local _offset_Max = _idx - self._rowMax
	if _offset_Max < 0 then
		_offset_Max = 0
	end
	
	self._offset_Max 	= _offset_Max
	self._offsetIndex 	= 0
	self._contentRow	= _idx	
	
	UIScroll.SetButtonSize( defalut_Control._worker_List._Scroll, self._rowMax, self._contentRow ) -- 스크롤바 버튼의 크기를 조정한다.
	Worker_SortByRegionInfo()
end

function Worker_List:_updateSlot()
	FGlobal_Clear_Control(defalut_Control._worker_List._Button)
	FGlobal_Clear_Control(defalut_Control._worker_List._ActionPoint)
	FGlobal_Clear_Control(defalut_Control._worker_List._Progress)
	
	for index = 1, self._rowMax do
		local _dataIndex 	= self._offsetIndex + index
		local data 			= self._data_Table[_dataIndex]
		if nil == data then
			break
		end
		
		local name			= data._name
		local actionPoint	= tostring(data._currentPoint) .."/" .. tostring(data._maxPoint)
		local preogressRate = math.floor( (data._currentPoint / data._maxPoint) * 100)
		
		defalut_Control._worker_List._Button[index]		:SetText(name)
		defalut_Control._worker_List._Button[index]		:addInputEvent("Mouse_LUp","Finance_Worker_List_Select(" .. index .. ")")
		defalut_Control._worker_List._ActionPoint[index]:SetText(actionPoint)
		defalut_Control._worker_List._Progress[index]	:SetProgressRate(preogressRate)
		
		defalut_Control._worker_List._Button[index]		:SetShow(true)
		-- defalut_Control._worker_List._ActionPoint[index]:SetShow(true)
		defalut_Control._worker_List._Progress[index]	:SetShow(true)
		
		if Worker_List._selected_WorkerKey == data._workerNoChar then 
			defalut_Control._worker_List._Button[index]:SetCheck(true)
			defalut_Control._worker_List._ActionPoint[index]:SetShow(true)
		else
			defalut_Control._worker_List._Button[index]:SetCheck(false)
			defalut_Control._worker_List._ActionPoint[index]:SetShow(false)
		end
	end
	
	defalut_Control._worker_List._Scroll:SetControlPos( self._offsetIndex / self._offset_Max) -- 스크롤바 버튼의 위치를 조정한다.
	HandleOn_Finance_Worker_List_Refresh()
end

function Finance_Worker_List_Select(index)
	local selectedIndex						= Worker_List._offsetIndex + index
	if nil ~= Worker_List._data_Table[selectedIndex] then
		Worker_List._selected_Worker			= Worker_List._data_Table[selectedIndex]._workerNo
		Worker_List._selected_WorkerKey			= Worker_List._data_Table[selectedIndex]._workerNoChar

		Worker_List._selected_Index				= selectedIndex
		_affiliatedTownKey 	= Worker_List._data_Table[selectedIndex]._homeWaypoint
		warehouse_requestInfo(_affiliatedTownKey) -- 창고 Data를 가져온다!
		FGlobal_Finance_WorkManager_Refresh()
		defalut_Control._worker_List._No_Worker:SetShow(false)
	else
		defalut_Control._worker_List._No_Worker:SetShow(true)
	end	

	Worker_List:_updateSlot()
	Finance_Work_Info_Update()
end

function HandleOn_Finance_Worker_List(index)
	Worker_List._over_Index		= index
	defalut_Control._worker_List._ActionPoint[index]:SetShow(true)
	Finance_Work_Info_Update(true)
end

function HandleOut_Finance_Worker_List()
	Worker_List._over_Index		= nil
	Worker_List:_updateSlot()
	Finance_Work_Info_Update()
end

function HandleOn_Finance_Worker_List_Refresh()
	if nil ~= Worker_List._over_Index then
		HandleOn_Finance_Worker_List(Worker_List._over_Index)
	end
end
-----------------------------------------------------
-- 제작 상세 정보/제작 예상 시간 Update 관련 함수
-----------------------------------------------------

function Finance_Work_Info_Update(isWorkerOver)		
	local workVolume    = Work_Info._workVolum

	defalut_Control._work_Info._Work_Volume_Value		:SetText(workVolume)	
	
	local workerIndex	= Worker_List._selected_Index
	if true == isWorkerOver then
		workerIndex = Worker_List._offsetIndex + Worker_List._over_Index
	end
	
	if nil ~= Worker_List._data_Table[workerIndex] then
		local distance		= ToClient_getCalculateMoveDistance(Worker_List._data_Table[workerIndex]._workerNo, Work_Info._position) / 100
		local workSpeed		= Worker_List._data_Table[workerIndex]._workSpeed
		local moveSpeed		= Worker_List._data_Table[workerIndex]._moveSpeed
		local luck			= Worker_List._data_Table[workerIndex]._luck

		defalut_Control._work_Info._Move_Distance_Value		:SetText( string.format( "%.f", distance ) )
		defalut_Control._work_Info._Work_Speed_Value		:SetText(workSpeed)
		defalut_Control._work_Info._Move_Speed_Value		:SetText(moveSpeed)
		defalut_Control._work_Info._Luck_Value				:SetText(luck)
		
		local workBaseTime 	= ToClient_getNpcWorkingBaseTime() / 1000
		local totalWorkTime	= math.ceil(workVolume/workSpeed) * workBaseTime + (distance/moveSpeed) * 2

		defalut_Control._work_Info._Time_Value				:SetText(Util.Time.timeFormatting(math.floor(totalWorkTime)))		
	else
		defalut_Control._work_Info._Move_Distance_Value		:SetText("--")
		defalut_Control._work_Info._Work_Speed_Value		:SetText("--")
	    defalut_Control._work_Info._Move_Speed_Value		:SetText("--")
		defalut_Control._work_Info._Luck_Value				:SetText("--")
		defalut_Control._work_Info._Time_Value				:SetText("--")
	end
end

-----------------------------------------------------
-- Scroll 관련 함수
-----------------------------------------------------

local Scroll_UpDown = function(isUp, _target)
	if ( false == isUp ) then
		_target._offsetIndex = math.min(_target._offset_Max, _target._offsetIndex + 1)
	else
		_target._offsetIndex = math.max(0, _target._offsetIndex -1)
	end	
	
	_target:_updateSlot()
	-- HouseWorkListSection_ShowTooltip_Reflesh()
end

function HandleScroll_Finance_Worker_List_UpDown(isUp)
	Scroll_UpDown(isUp, Worker_List)
end

local ScrollOnClick = function(_target, _scroll)
	local _scroll_Button = _scroll:GetControlButton()
	local _scroll_Blank = _scroll:GetSizeY() - _scroll_Button:GetSizeY() 
	local _scroll_Percent = _scroll_Button:GetPosY() / _scroll_Blank
	_target._offsetIndex = math.floor(_scroll_Percent * _target._offset_Max)
	
	_target:_updateSlot()
end

function HandleScroll_Finance_Worker_List_OnClick()
	ScrollOnClick(Worker_List, defalut_Control._worker_List._Scroll)
end

-----------------------------------------------------
-- ToolTip 관련 함수
-----------------------------------------------------

function Item_Tooltip_Show_FinanceResource(idx)
	local staticStatusKey = Work_Info._resource[idx]._resourceKey
	local uiBase = defalut_Control._work_Info._Resource_Icon_Border[idx]
	if ( nil == staticStatusKey ) or ( nil == uiBase ) then
		return
	end
	
	local staticStatusWrapper = getItemEnchantStaticStatus( staticStatusKey )
	
	Panel_Tooltip_Item_Show(staticStatusWrapper, uiBase, true, false)
end

-----------------------------------------------------
-- Panel Open/Close 관련 함수
-----------------------------------------------------

function FGlobal_Finance_WorkManager_Open(node)
	WorldMapPopupManager:push( Panel_Finance_WorkManager, true )
	if nil == node then
		return
	end
	
	Worker_List._selected_Worker		= nil
	Worker_List._selected_WorkerKey		= nil
	Worker_List._selected_Index			= nil
	Worker_List._over_Index				= nil

	_position 			= node:getStaticStatus():getPosition()
	_plantKey 			= node:getPlantKey()
	wayPlant			= ToClient_getPlant(_plantKey)
	
	Work_Info:_setData()
	Worker_List:_setData()
	
	Worker_List:_updateSlot()
	Finance_Worker_List_Select(1)
	
	local nodeName = getExploreNodeName(node:getStaticStatus())
	defalut_Control._title:SetText(nodeName)
	
end

function FGlobal_Finance_WorkManager_Close()
--	Panel_Finance_WorkManager:SetShow(false)
	FGlobal_WorldMapWindowEscape()
end

function FGlobal_Finance_WorkManager_Reset_Pos()
	local PosX = ( getScreenSizeX() - Panel_Finance_WorkManager:GetSizeX() ) / 2
	local PosY = ( getScreenSizeY() - Panel_Finance_WorkManager:GetSizeY() ) / 2
	Panel_Finance_WorkManager:SetPosX(PosX)
	Panel_Finance_WorkManager:SetPosY(PosY)
end
-----------------------------------------------------
-- 작업 시작 Button 관련 함수
-----------------------------------------------------
function HandleClick_Finance_doWork()
	if ( nil == Worker_List._selected_Worker ) then
		Proc_ShowMessage_Ack( PAGetString(Defines.StringSheet_GAME, "Lua_RentHouseNoWorkingByWorkerNotSelect") )
		return
	end	

	local workingCount 	= 1	 -- 작업 횟수는 기본 1회

	local doWorkNow = ToClient_requestStartPlantWorkingToNpcWorker(Worker_List._selected_Worker, Work_Info._plantKey, Work_Info._workKey, workingCount)
	FGlobal_RedoWork( 4, nil, Worker_List._selected_Worker, Work_Info._plantKey, Work_Info._workKey, nil, workingCount, nil, nil, _affiliatedTownKey )
	if doWorkNow then
		Panel_Finance_WorkManager:SetShow(false)
		FGlobal_ShowWorkingProgress(FGlobal_SelectedNode(), 1)
	end
end

function FromClient_Finance_StopWork()
	if Panel_Finance_WorkManager:GetShow() then
		Worker_List:_setData()	
		Worker_List:_updateSlot()
		if nil == Worker_List._selected_Index then
			Finance_Worker_List_Select(1)
		end
	end
end

function FGlobal_Finance_WorkManager_Refresh()
	Work_Info:_setData()
	Worker_List:_setData()
	Work_Info:_Update()
	
	Worker_List:_updateSlot()
	Finance_Work_Info_Update()
end

function FromClient_WareHouse_Update_ForFinance(affiliatedTownKey)
	if affiliatedTownKey == _affiliatedTownKey and true == Panel_Finance_WorkManager:GetShow() then
		FGlobal_Finance_WorkManager_Refresh()
	end
end

registerEvent("EventWarehouseUpdate",					"FromClient_WareHouse_Update_ForFinance")
registerEvent("WorldMap_StopWorkerWorking",				"FromClient_Finance_StopWork")